-- need to create the options window
CustomThresholdWindow = class(Turbine.UI.Lotro.Window);
function CustomThresholdWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	local headingColor=Turbine.UI.Color(1,1,0);
	self:SetText(Resource[language][37]);
	self:SetVisible(false);
	self:SetSize(340,200);
	self:SetPosition((Turbine.UI.Display:GetWidth() - self:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - self:GetHeight()) / 2);
	self.HadErrors=false;
	self.ItemIndex=0;
	self.IsAllItem=false;

	self.ItemCaption=Turbine.UI.Label();
	self.ItemCaption:SetParent(self);
	self.ItemCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.ItemCaption:SetForeColor(fontColor);
	self.ItemCaption:SetSize(self:GetWidth()-30,18);
	self.ItemCaption:SetPosition(0,30);
	self.ItemCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.ItemCaption:SetText("")

--** Use Default Low Quantity
	self.UseDefaultLowCB=Turbine.UI.Lotro.CheckBox();
	self.UseDefaultLowCB:SetParent(self);
	self.UseDefaultLowCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.UseDefaultLowCB:SetForeColor(fontColor);
	self.UseDefaultLowCB:SetSize(self:GetWidth()-15,18);
	self.UseDefaultLowCB:SetPosition(10,self.ItemCaption:GetTop()+self.ItemCaption:GetHeight()+8);
	self.UseDefaultLowCB:SetText(Resource[language][38]);

	self.UseDefaultLowIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.UseDefaultLowIcon:SetParent(self);
	self.UseDefaultLowIcon:SetSize(self.UseDefaultLowCB:GetSize());
	self.UseDefaultLowIcon:SetPosition(self.UseDefaultLowCB:GetPosition());
	self.UseDefaultLowIcon.MouseClick=function()
		self.UseDefaultLowCB:SetChecked(not self.UseDefaultLowCB:IsChecked());
	end
	self.UseDefaultLowIcon:SetZOrder(self.UseDefaultLowCB:GetZOrder()+1);
	self.UseDefaultLowCB.CheckedChanged=function()
		self.LowQtyCaption:SetVisible(not self.UseDefaultLowCB:IsChecked());
		self.LowQty:SetVisible(not self.UseDefaultLowCB:IsChecked());
	end

--** Low Quantity Threshold
	self.LowQtyCaption=Turbine.UI.Label();
	self.LowQtyCaption:SetParent(self);
	self.LowQtyCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LowQtyCaption:SetForeColor(fontColor);
	self.LowQtyCaption:SetSize(self:GetWidth()-85,18);
	self.LowQtyCaption:SetPosition(27,self.UseDefaultLowCB:GetTop()+self.UseDefaultLowCB:GetHeight()+4);
	self.LowQtyCaption:SetText(Resource[language][40].." (1-9999):")

	self.LowQty=Turbine.UI.Lotro.TextBox();
	self.LowQty:SetParent(self);
	self.LowQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LowQty:SetSize(40,20);
	self.LowQty:SetPosition(self.LowQtyCaption:GetLeft()+self.LowQtyCaption:GetWidth(),self.LowQtyCaption:GetTop()-2);

--** Use Default Critical Quantity
	self.UseDefaultCriticalCB=Turbine.UI.Lotro.CheckBox();
	self.UseDefaultCriticalCB:SetParent(self);
	self.UseDefaultCriticalCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.UseDefaultCriticalCB:SetForeColor(fontColor);
	self.UseDefaultCriticalCB:SetSize(self:GetWidth()-15,18);
	self.UseDefaultCriticalCB:SetPosition(10,self.LowQtyCaption:GetTop()+self.LowQtyCaption:GetHeight()+8);
	self.UseDefaultCriticalCB:SetText(Resource[language][39]);

	self.UseDefaultCriticalIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.UseDefaultCriticalIcon:SetParent(self);
	self.UseDefaultCriticalIcon:SetSize(self.UseDefaultCriticalCB:GetSize());
	self.UseDefaultCriticalIcon:SetPosition(self.UseDefaultCriticalCB:GetPosition());
	self.UseDefaultCriticalIcon.MouseClick=function()
		self.UseDefaultCriticalCB:SetChecked(not self.UseDefaultCriticalCB:IsChecked());
	end
	self.UseDefaultCriticalIcon:SetZOrder(self.UseDefaultCriticalCB:GetZOrder()+1);
	self.UseDefaultCriticalCB.CheckedChanged=function()
		self.CriticalQtyCaption:SetVisible(not self.UseDefaultCriticalCB:IsChecked());
		self.CriticalQty:SetVisible(not self.UseDefaultCriticalCB:IsChecked());
	end

--** Critical Qty Threshold
	self.CriticalQtyCaption=Turbine.UI.Label();
	self.CriticalQtyCaption:SetParent(self);
	self.CriticalQtyCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.CriticalQtyCaption:SetForeColor(fontColor);
	self.CriticalQtyCaption:SetSize(self:GetWidth()-85,18);
	self.CriticalQtyCaption:SetPosition(27,self.UseDefaultCriticalCB:GetTop()+self.UseDefaultCriticalCB:GetHeight()+4);
	self.CriticalQtyCaption:SetText(Resource[language][41].." (0-9998):")

	self.CriticalQty=Turbine.UI.Lotro.TextBox();
	self.CriticalQty:SetParent(self);
	self.CriticalQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.CriticalQty:SetSize(40,20);
	self.CriticalQty:SetPosition(self.CriticalQtyCaption:GetLeft()+self.CriticalQtyCaption:GetWidth(),self.CriticalQtyCaption:GetTop()-2);

--** SAVE AND CANCEL
	self.SaveButton=Turbine.UI.Lotro.Button();
	self.SaveButton:SetParent(self);
	self.SaveButton:SetSize(100,20);
	self.SaveButton:SetPosition(20,self:GetHeight()-40);
	self.SaveButton:SetText(Resource[language][19]);
	self.SaveButton.Click=function()
		local hasError=false;
		-- validate thresholds
		local tmpVal=tonumber(self.CriticalQty:GetText());
		if tmpVal==nil then
			tmpVal=0;
			hasError=true;
			self.CriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal<0 then
			tmpVal=0;
			hasError=true;
			self.CriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal>9998 then
			tmpVal=9998;
			hasError=true;
			self.CriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		self.CriticalQty:SetText(tmpVal);

		tmpVal=tonumber(self.LowQty:GetText());
		if tmpVal==nil then
			tmpVal=0;
			hasError=true;
			self.LowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal<=tonumber(self.CriticalQty:GetText()) then
			tmpVal=tonumber(self.CriticalQty:GetText())+1;
			hasError=true;
			self.LowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal>9999 then
			tmpVal=9999;
			hasError=true;
			self.LowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		self.LowQty:SetText(tmpVal);

		if hasError then
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);
		else
			local low=tonumber(self.LowQty:GetText())
			if self.UseDefaultLowCB:IsChecked() then low=-1 end;
			local crit=tonumber(self.CriticalQty:GetText())
			if self.UseDefaultCriticalCB:IsChecked() then crit=-1 end;

			trackWindow:SetCustomThresholds(low, crit, self.ItemIndex, self.IsAllItem)
			if self.IsAllItem then
				trackWindow:RefreshAllStatus();
				trackWindow:RefreshAllList();
			else
				trackWindow:RefreshAllStatus();
				trackWindow:RefreshAllList();
			end
			self:SetVisible(false);
		end
	end

	self.CancelButton=Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent(self);
	self.CancelButton:SetSize(100,20);
	self.CancelButton:SetPosition(self:GetWidth()-20-self.CancelButton:GetWidth(),self:GetHeight()-40);
	self.CancelButton:SetText(Resource[language][20]);
	self.CancelButton.Click=function()
		self:SetVisible(false);
	end

	self.ErrorLabel=Turbine.UI.Label();
	self.ErrorLabel:SetParent(self);
	self.ErrorLabel:SetText("Adjusted Invalid Values")
	self.ErrorLabel:SetPosition(self.SaveButton:GetLeft()+self.SaveButton:GetWidth(),self.SaveButton:GetTop());
	self.ErrorLabel:SetSize(self.CancelButton:GetLeft()-(self.ErrorLabel:GetLeft()),self.SaveButton:GetHeight());
	self.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	self.ErrorLabel:SetVisible(false);
	self.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.Update=function(sender,args)
		if self.HadErrors then
			if Turbine.Engine:GetGameTime()>self.ErrorFadeTime then
				self:SetWantsUpdates(false);
				self.LowQtyCaption:SetForeColor(fontColor);
				self.CriticalQtyCaption:SetForeColor(fontColor);
				self.ErrorLabel:SetVisible(false);
				self.HadErrors=false
			end
		end
	end
	self.SetItem=function(sender,strItemName,index,applyToAll,low,crit)
		self.ItemCaption:SetText(strItemName)
		self.ItemIndex=index;
		self.IsAllItem=applyToAll;
		self.UseDefaultLowCB:SetChecked(low~=-1); -- force a checked changed event :p
		self.UseDefaultCriticalCB:SetChecked(crit~=-1);
		self.UseDefaultLowCB:SetChecked(low==-1);
		self.UseDefaultCriticalCB:SetChecked(crit==-1);
		if low==-1 then
			if applyToAll then
				self.LowQty:SetText(trackWindow:GetDefaultAllLowThreshold())
			else
				self.LowQty:SetText(trackWindow:GetDefaultCharLowThreshold())
			end
		else
			self.LowQty:SetText(low);
		end
		if crit==-1 then
			if applyToAll then
				self.CriticalQty:SetText(trackWindow:GetDefaultAllCriticalThreshold())
			else
				self.CriticalQty:SetText(trackWindow:GetDefaultCharCriticalThreshold())
			end
		else
			self.CriticalQty:SetText(crit);
		end
	end
	self.SetTrimColor=function()
	end
	self.SetBackColor=function()
	end
	self.SetFontColor=function()
		self.ItemCaption:SetForeColor(fontColor);
		self.UseDefaultLowCB:SetForeColor(fontColor);
		self.LowQtyCaption:SetForeColor(fontColor);
		self.UseDefaultCriticalCB:SetForeColor(fontColor);
		self.CriticalQtyCaption:SetForeColor(fontColor);
	end
	self.SetLanguage=function()
		self:SetText(Resource[language][37]);
		self.SaveButton:SetText(Resource[language][19]);
		self.CancelButton:SetText(Resource[language][20]);
		self.UseDefaultLowCB:SetText(Resource[language][38]);
		self.UseDefaultCriticalCB:SetText(Resource[language][39]);
		self.LowQtyCaption:SetText(Resource[language][40].." (1-9999):")
		self.CriticalQtyCaption:SetText(Resource[language][41].." (0-9998):")
	end
end
