-- to do

-- add the fixed string values (error messages) in Options Windows to Resource[] translations

-- enable "scaling" for the main window (and minimal view window) by holding down Ctrl when sizing
-- some child controls don't get positioned correctly :( not sure scaling is going to be a valid option
-- this also leads to some issues of how to turn scaling off...

-- show "move" border tab for minimized icon when Ctrl+\ is pressed to allow positioning the icon for people that have trouble dragging it

-- need to key the inventoryArray on the character name, not a numeric index so that deleted characters won't mess with the inventory - when we delete a character from the characterArray, their inventory will automagically disappear from totals :)

-- Client will crash if :GetAttributes is called and then the plugin is unloaded
-- -- add a warning about crashes when enabling the Enable Attributes option

-- need translations for "headings color" and "list text color" captions
-- add options error message,"Adjusted Invalid Values", to strings.lua

-- add "Data version" to the saved plugindata
-- need creep version of Stat View - attributes don't currently provide Creep data
-- remove all of the unused stat strings. remove unused stats from saved data
-- need a VScrollBar in ViewPanels when window is too short

-- VScrollBar for Options panel? or Tabs?
-- options panel sizing needs to be overhauled

-- "Manual" Sort option? this would require making sure that Drag-drop operations can occur without conflict or loss...
-- implement any missing Item Categories that have been found since 2.02
-- get improved translations for the German and French UIs

-- popup needs to be dismissed on "Esc" and "F12"

import "GaranStuff.AltInventory.Class";
import "GaranStuff.AltInventory.VindarPatch";
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import "GaranStuff.AltInventory.Strings";
import "GaranStuff.AltInventory.Table";
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "GaranStuff.AltInventory.DropDownList";
import "GaranStuff.AltInventory.RadioButtonGroup";
import "GaranStuff.AltInventory.OptionsWindow";
import "GaranStuff.AltInventory.MinimizedWindow";
import "GaranStuff.AltInventory.TrackingWindow";
import "GaranStuff.AltInventory.CustomThresholdWindow";
import "GaranStuff.AltInventory.PopUpDialog";
import "GaranStuff.AltInventory.DebugWindow";

-- set the language and locale prior to loading the panels as some of them have language/locale specific functions
language=1;
euroFormat=(tonumber("1,000")==1);
_locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	_locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	_locale = "fr";
	language=2;
end

import "GaranStuff.AltInventory.InventoryPanel";
import "GaranStuff.AltInventory.StatsPanel";
import "GaranStuff.AltInventory.EquippedItemsPanel";
import "GaranStuff.AltInventory.CraftingPanel";
import "GaranStuff.AltInventory.NotesPanel";
import "GaranStuff.AltInventory.RepPanel";
import "GaranStuff.AltInventory.TraitsPanel";


characterListArray={};
inventoryArray={};
equipmentArray={};
-- note, Race and Class are not proper enumerations (you can't iterate through them sequentially), more like flag values
--classArray elements are{turbine.class, alignment, resource string}
classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
--raceArray elements are{turbine.race, resource string} (note, alignment doesn't make sense for race since we can have evil dwarves and men)
raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]},{74,Resource[language][298]}}
--race 74=Dunedain, class 191=Ranger
colorGold=Turbine.UI.Color(.80,.60,.1);
colorSilver=Turbine.UI.Color(.75,.75,.75);
colorDarkGrey=Turbine.UI.Color(.1,.1,.1);

trimColor=Turbine.UI.Color(.2,.5,.9);
fontColor=Turbine.UI.Color(1,.9,.5);
backColor=Turbine.UI.Color(.05,.05,.05);
headingsColor=Turbine.UI.Color(1,1,1);
listTextColor=Turbine.UI.Color(1,1,1);

fontFace=Turbine.UI.Lotro.Font.TrajanPro14;
dataLoadError=false;
saveSettings=true;
enableAttributes=false; -- default this to false until Turbine fixes the client crash
enableScaling=false;
scaleMult=1;

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");
currentCharIndex=1;

mainVisible=false;
minVisible=false;
iconVisible=false;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state

debug=false;

durabilitySortOrder={0,5,7,2,3,4,1,6} -- the sort values indexed by durability type ? not sure if this order is correct, especially on less than normal
qualitySortOrder={0,5,3,4,2,1} -- the sort values indexed by quality type
wearStateSortOrder={5,2,4,1,3} -- the sort values indexed by wear state type
categorySortOrder={} -- we fill this in after we load and sort the category list alphabetically
undefinedCategoryIndex=1;

-- This is the callback mechanism provided by Pengoros
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

QuantityChanged=function(sender,args)
	if debug then
		if sender.GetName~=nil then
			Turbine.Shell.WriteLine("QuantityChanged("..tostring(sender.BackpackIndex).."): "..sender:GetName())
		else
			Turbine.Shell.WriteLine("QuantityChanged("..tostring(sender.BackpackIndex).."): GetName()==nil")
		end
		Table.Dump(args)
	end
	if sender.GetName~=nil then
		trackWindow:UpdateQuantity(sender:GetName());
	end

	if (inventoryWindow:IsVisible() or minimalWindow:IsVisible()) then -- trying to reduce the lag issue by not updating unless we are visible since we reload upon changing visible to true
		inventoryWindow.NeedsRefresh=true;
		inventoryWindow:SetWantsUpdates(true);
	end
end
BackpackItemAdded = function( sender, args )
	if debug then
		Turbine.Shell.WriteLine("BackpackItemAdded: Index="..tostring(args.Index))
		Table.Dump(args)
	end
	trackWindow:UpdateQuantity(localPlayer:GetBackpack():GetItem(args.Index):GetName());
	if not inventoryWindow.LoadingInventory and (inventoryWindow:IsVisible() or minimalWindow:IsVisible()) then
		if (inventoryWindow.CharacterList:GetText()==currentCharacterName) then
			inventoryWindow.NeedsRefresh=true;
			inventoryWindow:SetWantsUpdates(true);
		end
	end
end
BackpackItemRemoved = function( sender, args )
	if debug then
		Turbine.Shell.WriteLine("BackpackItemRemoved: Index="..tostring(args.Index))
		Table.Dump(args)
	end
	local charIndex=2;
	local found=false;
	while charIndex<=#characterListArray and not found do
		if characterListArray[charIndex][1]==currentCharacterName then
			found=true;
		else
			charIndex=charIndex+1;
		end
	end
	if found then
		found=false;
		local lItemIndex=1;
		while lItemIndex<=#inventoryArray[charIndex] and not found do
			if inventoryArray[charIndex][lItemIndex][1]==args.Index then
				found=true;
				trackWindow:UpdateQuantity(inventoryArray[charIndex][lItemIndex][5]);
			else
				lItemIndex=lItemIndex+1;
			end
		end
	end
	if (inventoryWindow.CharacterList:GetText()==currentCharacterName) and (inventoryWindow:IsVisible() or minimalWindow:IsVisible()) then
		inventoryWindow.NeedsRefresh=true;
		inventoryWindow:SetWantsUpdates(true);
	end
end
BackpackItemMoved = function( sender, args )
	if debug then
		Turbine.Shell.WriteLine("BackpackItemMoved: ItemName: "..tostring(args.Item:GetName()))
		Turbine.Shell.WriteLine("OldIndex: "..tostring(args.OldIndex)..", NewIndex: "..tostring(args.NewIndex))
--		Table.Dump(args)
	end
	if (inventoryWindow.CharacterList:GetText()==currentCharacterName) and (inventoryWindow:IsVisible() or minimalWindow:IsVisible()) then inventoryWindow:LoadInventory(currentCharacterName) end;
end

GetEquipment=function()
	local tmpIndex;
	local equipment=localPlayer:GetEquipment();
	for tmpIndex=1,20 do
		tmpItem=equipment:GetItem(tmpIndex);
		if tmpItem~=nil then
			equipmentArray[currentCharacterName][tmpIndex]={tmpIndex,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
		else
			equipmentArray[currentCharacterName][tmpIndex]=nil;
		end
	end
end
-- use the Update event of the viewpanel to refresh the equipment list since the ItemUnequipped event fires before the
-- item actually gets removed
EquipmentItemEquipped=function(sender, args)
	-- args are Index and Item
	inventoryWindow.ViewPanel[2]:SetWantsUpdates(true);
end
EquipmentItemUnequipped=function(sender, args)
--Table.Dump(args)
	inventoryWindow.ViewPanel[2]:SetWantsUpdates(true);
end

function GetClassIndex(turbineClass)
	local classIndex=1;
	local tmpIndex;
	for tmpIndex=2, #classArray do
		if classArray[tmpIndex][1]==turbineClass then
			classIndex=tmpIndex;
			break;
		end
	end
	return classIndex;
end
function GetRaceIndex(turbineRace)
	local raceIndex=1;
	local tmpIndex;
	for tmpIndex=2, #raceArray do
		if raceArray[tmpIndex][1]==turbineRace then
			raceIndex=tmpIndex;
			break;
		end
	end
	return raceIndex;
end
function UnloadPlugin()
	inventoryWindow:SetPluginUnloading(true);
	if saveSettings then -- if there were errors loading data, the user can choose to abort saving as it would destroy their prior data
		SaveData();
	end

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	inventoryWindow:RemoveShellCommands();

	-- safely remove all callbacks
	if inventoryWindow.moneyChangeHandler~=nil then
		RemoveCallback(inventoryWindow.playerAttributes, "MoneyChanged", inventoryWindow.MoneyChanged);
	end

	for listIndex=1,#inventoryWindow.ViewPanel do
		if inventoryWindow.ViewPanel[listIndex].RemoveCallbacks~=nil then
			inventoryWindow.ViewPanel[listIndex]:RemoveCallbacks();
		end
	end

	RemoveCallback(inventoryWindow.Backpack,"ItemAdded",BackpackItemAdded)
	RemoveCallback(inventoryWindow.Backpack,"ItemRemoved",BackpackItemRemoved)
	RemoveCallback(inventoryWindow.Backpack,"ItemMoved",BackpackItemMoved)
	RemoveCallback(inventoryWindow.Equipment,"ItemEquipped",EquipmentItemEquipped)
	RemoveCallback(inventoryWindow.Equipment,"ItemUnequipped",EquipmentItemUnequipped)

	RemoveCallback(localPlayer,"LevelChanged","LevelChanged")
	RemoveCallback(localPlayer,"BaseMaxMoraleChanged","BaseMaxMoraleChanged")
	RemoveCallback(localPlayer,"BaseMaxPowerChanged","BaseMaxPowerChanged")


	Turbine.Shell.WriteLine("AltInventory "..Plugins["AltInventory"]:GetVersion()..Resource[language][250]);
	-- reenable the built in bags
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );

	inventoryWindow.Backpack=nil;
	inventoryWindow.Equipment=nil;
end
function GetAttributes(charIndex)
	if charIndex==nil then charIndex=currentCharIndex end
	if enableAttributes then
		local attributes=localPlayer:GetAttributes();
		-- money
		characterListArray[charIndex][11]=attributes:GetMoney();
		-- stats
		characterListArray[charIndex][12]=attributes:GetAcidMitigation();
		characterListArray[charIndex][13]=attributes:GetAgility();
		characterListArray[charIndex][14]=attributes:GetArmor();
		characterListArray[charIndex][15]=attributes:GetBaseAgility();
		characterListArray[charIndex][16]=attributes:GetBaseCriticalHitAvoidance();
		characterListArray[charIndex][17]=attributes:GetBaseCriticalHitChance();
		characterListArray[charIndex][18]=attributes:GetBaseFate();
		characterListArray[charIndex][19]=attributes:GetBaseMight();
		characterListArray[charIndex][20]=attributes:GetBaseResistance();
		characterListArray[charIndex][21]=attributes:GetBaseVitality();
		characterListArray[charIndex][22]=attributes:GetBaseWill();
		characterListArray[charIndex][23]=attributes:GetBlock();
		characterListArray[charIndex][24]=attributes:GetCommonMitigation();
		characterListArray[charIndex][25]=attributes:GetDiseaseResistance();
		characterListArray[charIndex][26]=attributes:GetEvade();
		characterListArray[charIndex][27]=attributes:GetFate();
		characterListArray[charIndex][28]=attributes:GetFearResistance();
		characterListArray[charIndex][29]=attributes:GetFinesse();
		characterListArray[charIndex][30]=attributes:GetFireMitigation();
		characterListArray[charIndex][31]=attributes:GetFrostMitigation();
		characterListArray[charIndex][32]=attributes:GetIncomingHealing();
		characterListArray[charIndex][33]=attributes:GetLightningMitigation();
		characterListArray[charIndex][34]=attributes:GetMeleeCriticalHitAvoidance();
		characterListArray[charIndex][35]=attributes:GetMeleeCriticalHitChance();
		characterListArray[charIndex][36]=attributes:GetMeleeDamage();
		characterListArray[charIndex][37]=attributes:GetMeleeDefence();
		characterListArray[charIndex][38]=attributes:GetMight();
		characterListArray[charIndex][39]=attributes:GetOutgoingHealing();
		characterListArray[charIndex][40]=attributes:GetParry();
		characterListArray[charIndex][41]=attributes:GetPhysicalMitigation();
		characterListArray[charIndex][42]=attributes:GetPoisonResistance();
		characterListArray[charIndex][43]=attributes:GetRangeCriticalHitAvoidance();
		characterListArray[charIndex][44]=attributes:GetRangeCriticalHitChance();
		characterListArray[charIndex][45]=attributes:GetRangeDamage();
		characterListArray[charIndex][46]=attributes:GetRangeDefence();
		characterListArray[charIndex][47]=attributes:GetShadowMitigation();
		characterListArray[charIndex][48]=attributes:GetTacticalCriticalHitAvoidance();
		characterListArray[charIndex][49]=attributes:GetTacticalCriticalHitChance();
		characterListArray[charIndex][50]=attributes:GetTacticalDamage();
		characterListArray[charIndex][51]=attributes:GetTacticalDefence();
		characterListArray[charIndex][52]=attributes:GetTacticalMitigation();
		characterListArray[charIndex][53]=attributes:GetVitality();
		characterListArray[charIndex][54]=attributes:GetWill();
		characterListArray[charIndex][55]=attributes:GetWoundResistance();
	else
		local attrIndex;
		for attrIndex=11,55 do
			characterListArray[charIndex][attrIndex]=0;
		end
	end
end
function SaveData()

	-- save the character scope settings
	local settings={};
	local tmpIndex;
	if inventoryWindow.MinimalHeader then
		settings[#settings+1]={"IWTop",minimalWindow:GetTop()};
		settings[#settings+1]={"IWLeft",minimalWindow:GetLeft()};
		if enableScaling then
			settings[#settings+1]={"IWHeight",minimalWindow:GetHeight()/scaleMult};
			settings[#settings+1]={"IWWidth",minimalWindow:GetWidth()/scaleMult};
		else
			settings[#settings+1]={"IWHeight",minimalWindow:GetHeight()};
			settings[#settings+1]={"IWWidth",minimalWindow:GetWidth()};
		end
	else
		settings[#settings+1]={"IWTop",inventoryWindow:GetTop()};
		settings[#settings+1]={"IWLeft",inventoryWindow:GetLeft()};
		if enableScaling then
			settings[#settings+1]={"IWHeight",inventoryWindow:GetHeight()/scaleMult};
			settings[#settings+1]={"IWWidth",inventoryWindow:GetWidth()/scaleMult};
		else
			settings[#settings+1]={"IWHeight",inventoryWindow:GetHeight()};
			settings[#settings+1]={"IWWidth",inventoryWindow:GetWidth()};
		end
	end
	settings[#settings+1]={"MWTop",minWindow:GetTop()};
	settings[#settings+1]={"MWLeft",minWindow:GetLeft()};
	settings[#settings+1]={"ITTop",trackWindow:GetTop()};
	settings[#settings+1]={"ITLeft",trackWindow:GetLeft()};
	settings[#settings+1]={"ITWidth",trackWindow:GetWidth()};
	settings[#settings+1]={"ITHeight",trackWindow:GetHeight()};
	settings[#settings+1]={"Sort",inventoryWindow.ViewPanel[1].SortList:GetValue()};
	settings[#settings+1]={"ReplaceBags",inventoryWindow:GetReplaceBags()};
	settings[#settings+1]={"View",inventoryWindow.GetView()};
	settings[#settings+1]={"ITShowIconsInList",trackWindow.GetShowIconsInList()};
	settings[#settings+1]={"ITDefaultCharLowThreshold",trackWindow.GetDefaultCharLowThreshold()};
	settings[#settings+1]={"ITDefaultCharCriticalThreshold",trackWindow.GetDefaultCharCriticalThreshold()};
	settings[#settings+1]={"fontColor",fontColor};
	settings[#settings+1]={"trimColor",trimColor};
	settings[#settings+1]={"backColor",backColor};
	settings[#settings+1]={"headingsColor",headingsColor};
	settings[#settings+1]={"listTextColor",listTextColor};
	settings[#settings+1]={"loadMinimized",inventoryWindow:GetLoadMinimized()};
	settings[#settings+1]={"language",language};
	settings[#settings+1]={"minimalHeader",inventoryWindow:GetMinimalHeader()};
	settings[#settings+1]={"showIconWhenMinimized",inventoryWindow:GetShowIconWhenMinimized()};
	settings[#settings+1]={"bagSeparator",inventoryWindow:GetBagSeparator()};
	settings[#settings+1]={"enableAttributes",enableAttributes};
	settings[#settings+1]={"enableScaling",enableScaling};
	settings[#settings+1]={"scaleMult",scaleMult};
	settings[#settings+1]={"version",Plugins["AltInventory"]:GetVersion()};

	local tmpvb
	for tmpvb=1,#inventoryWindow.ViewPanel do
		if inventoryWindow.ViewPanel[tmpvb].SaveData~=nil then
			inventoryWindow.ViewPanel[tmpvb]:SaveData();
		end
	end

	PatchDataSave( Turbine.DataScope.Character, "AltInventorySettings", settings );

	-- save the server scope settings
	settings={};
	settings[#settings+1]={"ITDefaultAllLowThreshold",trackWindow.GetDefaultAllLowThreshold()};
	settings[#settings+1]={"ITDefaultAllCriticalThreshold",trackWindow.GetDefaultAllCriticalThreshold()};
	settings[#settings+1]={"version",Plugins["AltInventory"]:GetVersion()};
	PatchDataSave( Turbine.DataScope.Server, "AltInventorySettings", settings );

	-- save the tracked items data
	trackWindow:SaveData()

	-- update the characterListArray entry dynamic data for the current character
	local index;
	for index=2,#characterListArray do
		if (characterListArray[index][1]==currentCharacterName) then
			currentCharIndex=index;
			characterListArray[index][2]=localPlayer:GetLevel();
			characterListArray[index][3]=localPlayer:GetMaxMorale();
			characterListArray[index][4]=localPlayer:GetMaxPower();
			GetAttributes();
			break;
		end
	end

	-- save the character list with attributes & vocation
	table.remove(characterListArray,1); -- remove the "ALL " entry
	-- add a version stamp entry
	characterListArray[#characterListArray+1]={"&version",Plugins["AltInventory"]:GetVersion()};

	PatchDataSave( Turbine.DataScope.Server, "CharacterList", characterListArray );

	-- now save the current character's inventory
	local backpackSize=localPlayer:GetBackpack():GetSize();
	local tmpInventory={{1,0,0,0,"",0}};
	local tmpItem;
	if (backpackSize~=nil) then
		local index=1;
		while (index<=backpackSize) do
			tmpItem=localPlayer:GetBackpack():GetItem(index);
			if (tmpItem~=nil)then
				tmpInventory[index]= {index,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
			else
				tmpInventory[index]={index,0,0,0,"",0,{},0,0,0,0,0,0};
			end
			index=index+1;
		end
	end
	tmpInventory[#tmpInventory+1]={"version",Plugins["AltInventory"]:GetVersion()};
	PatchDataSave( Turbine.DataScope.Server, "AltInv_"..currentCharacterName, tmpInventory);

	local equipment=localPlayer:GetEquipment();
	local tmpEquipment={}
	for index=1,20 do
		tmpItem=equipment:GetItem(index);
		tmpEquipment[index]={}
		if tmpItem~=nil then
			tmpEquipment[index]={index,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
		end
	end
	PatchDataSave( Turbine.DataScope.Server, "AltInv_EI_"..currentCharacterName, tmpEquipment);
end

function LoadData()
	local index;
	local tmpInventory={};	
	characterListArray=PatchDataLoad(Turbine.DataScope.Server, "CharacterList");
	-- detect and convert old style character lists
	if characterListArray~=nil then
		-- find and remove the "&version" entry
		local charListVersion; -- if we ever need to process version specific updates to the character list this is where we would do it
		index=1;
		while index<=#characterListArray do
			if type(characterListArray[index])=="table" and characterListArray[index][1]=="&version" then
				charListVersion=characterListArray[index][2];
				table.remove(characterListArray,index);
			else
				index=index+1;
			end
		end
		if type(characterListArray[1])=="string" then
			for index=1, #characterListArray do
				characterListArray[index]={characterListArray[index],nil};
			end
		end
	end

	if characterListArray==nil then
		characterListArray={}
	else
		local tmpAttribute
		for index=1,#characterListArray do
			if characterListArray[index]~=nil then
				for tmpAttribute=3,4 do
					if characterListArray[index][tmpAttribute]~=nil then
						if euroFormat then
							characterListArray[index][tmpAttribute]=tonumber((string.gsub(characterListArray[index][tmpAttribute],"%.",",")));
						else
							characterListArray[index][tmpAttribute]=tonumber((string.gsub(characterListArray[index][tmpAttribute],",",".")));
						end
					end
				end

				for tmpAttribute=11,55 do
					if characterListArray[index][tmpAttribute]~=nil then
						if euroFormat then
							characterListArray[index][tmpAttribute]=tonumber((string.gsub(characterListArray[index][tmpAttribute],"%.",",")));
						else
							characterListArray[index][tmpAttribute]=tonumber((string.gsub(characterListArray[index][tmpAttribute],",",".")));
						end
					end
				end
			end
		end
	end

	index=1;
	local found=false;
	while ((index<=#characterListArray) and (not found)) do
		if characterListArray[index]~=nil and (characterListArray[index][1]==currentCharacterName) then
			currentCharIndex=index;
			characterListArray[index][2]=localPlayer:GetLevel();
			characterListArray[index][3]=localPlayer:GetBaseMaxMorale();
			characterListArray[index][4]=localPlayer:GetBaseMaxPower();
			characterListArray[index][5]=localPlayer:GetRace();
			characterListArray[index][6]=localPlayer:GetClass();
			characterListArray[index][7]=localPlayer:GetRaceAttributes(); -- this currently seems to be a table with only an __Implementation member which is nil
			characterListArray[index][8]=localPlayer:GetClassAttributes();
			characterListArray[index][9]=localPlayer:GetAlignment(); -- 1=Freep
			-- characterListArray[index][10]=0; -- Vocation is manually entered and maintained
			GetAttributes();
			found=true;
		end
		index=index+1;
	end
	if (not found) then
		currentCharIndex=#characterListArray+1;
		characterListArray[currentCharIndex]={currentCharacterName,localPlayer:GetLevel(),localPlayer:GetBaseMaxMorale(),localPlayer:GetBaseMaxPower(),localPlayer:GetRace(),localPlayer:GetClass(),localPlayer:GetRaceAttributes(),localPlayer:GetClassAttributes(),localPlayer:GetAlignment(),0};
		GetAttributes();
	end

	table.sort(characterListArray,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end); -- sort the character list alphabetically BEFORE adding the "ALL " entry

	table.insert(characterListArray,1,{Resource[language][29].." ",nil}); -- force it to the first entry
	
	for index=2,#characterListArray do
		-- fix the Vocation
		if characterListArray[index][10]~=nil and type(characterListArray[index][10])~="number" then characterListArray[index][10]=nil end
		if (characterListArray[index][1]==currentCharacterName) then
			currentCharIndex=index; -- need to reestablish the index since the sort messes it up for new chars
--*** this may not be necessary... review where the inventory is accessed and determine if 'current' inventory is always rebuilt on the fly, if so, remove this initialization
			-- build the current character's inventory on the fly
			local backpackSize=localPlayer:GetBackpack():GetSize();
			tmpInventory={};
			local tmpItem;
			if (backpackSize~=nil) then
				local invIndex=1;
				while (invIndex<=backpackSize) do
					tmpItem=localPlayer:GetBackpack():GetItem(invIndex);
					if (tmpItem~=nil)then
						tmpInventory[invIndex]= {invIndex,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
					else
						tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
					end
					invIndex=invIndex+1;
				end
			end
			equipmentArray[currentCharacterName]={}
			GetEquipment()
		else
			tmpInventory = PatchDataLoad( Turbine.DataScope.Server, "AltInv_"..characterListArray[index][1]);
			if tmpInventory~=nil then
				local invVersion;
				local invIndex=1;
				while invIndex<=#tmpInventory do
					if type(tmpInventory[invIndex])=="table" and tmpInventory[invIndex][1]=="version" then
						invVersion=tmpInventory[invIndex][2];
						table.remove(tmpInventory,invIndex);
					else
						invIndex=invIndex+1;
					end
				end

			-- test for ver 1.01 files and convert if found
				if (type(tmpInventory[1])=="string") then
					local tmpRecord;
					local pos1=0; -- used for backward compatability with Ver 1.01 files
					local pos2=0; -- used for backward compatability with Ver 1.01 files
					local pos3=0; -- used for backward compatability with Ver 1.01 files
					for invIndex=1,#tmpInventory do
						-- ver 1.01 data is stored as ItemCategory/ItemQuality/ItemText/ItemQuantity
						tmpRecord=tmpInventory[invIndex];
						tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
						pos1=string.find (tmpRecord,"/",0,true);
						if (pos1~=nil)then
							pos2=string.find (tmpRecord,"/",pos1+1,true);
							if (pos2~=nil)then
								pos3=string.find (tmpRecord,"/",pos2+1,true);
								if (pos3~=nil)then
									tmpInventory[invIndex][13]=tonumber(string.sub(tmpRecord,1, pos1-1));
									tmpInventory[invIndex][3]=tonumber(string.sub(tmpRecord,pos1+1, pos2-1));
									tmpInventory[invIndex][4]=0
									tmpInventory[invIndex][5]=string.sub(tmpRecord,pos2+1, pos3-1);
									tmpInventory[invIndex][6]=tonumber(string.sub(tmpRecord,pos3+1));
									if tmpInventory[invIndex][6]==0 then tmpInventory[invIndex][6]=1 end; -- non-stacking items have a quantity of 0 for some weird reason
								end
							end
						end
					end
				end
			else
				tmpInventory={};
			end
			-- use character name to index the array
			equipmentArray[characterListArray[index][1]]=PatchDataLoad(Turbine.DataScope.Server,"AltInv_EI_"..characterListArray[index][1]);
		end
		inventoryArray[index]={};
		local tmpIndex;
		for tmpIndex=1,#tmpInventory do
			inventoryArray[index][tmpIndex]=tmpInventory[tmpIndex];
		end

	end
end

function InitSelections()
	local tmpIndex;
	-- populate the character list
	characterListArray[1][1]=Resource[language][29].." "; -- account for non-default language for "ALL "
	for tmpIndex = 1, #characterListArray do
		inventoryWindow.CharacterList:AddItem( characterListArray[tmpIndex][1],tmpIndex );
	end


	-- set the default selection list selected values.
	for tmpIndex=1,#characterListArray do
		if characterListArray[tmpIndex][1]==currentCharacterName then
			inventoryWindow.CharacterList:SetSelectedIndex(tmpIndex);
			inventoryWindow.CharacterList.SelectedIndexChanged(); -- force a refresh on the character info
		end
	end

	for tmpIndex=1,inventoryWindow.ViewPanel[1].SortList.ListData:GetItemCount() do
		if inventoryWindow.DefaultSort==inventoryWindow.ViewPanel[1].SortList.ListData:GetItem(tmpIndex).DataValue then
			inventoryWindow.ViewPanel[1].SortList:SetSelectedIndex(tmpIndex);
		end
	end
end

function RemoveCharacter(characterName)
	-- this function is used to remove character info for characters that have been deleted or changed servers or that you just don't want to see anymore
	local index=1;
	local found=false;
	while not found and index<=#characterListArray do
		if characterListArray[index][1]==characterName then
			found=true;
			table.remove(characterListArray,index);
			inventoryWindow.CharacterList:RemoveItemAt(index);
			table.remove(inventoryArray[index]);
-- need to remove from "all" tracking list in trackWindow... hmmm, that's gonna get complicated
			-- no need to remove from "all" inventory since it's recalculated on the fly before displaying each time
		else
			index=index+1;
		end
	end
	-- remove known recipes
	KnownRecipes[characterName]=nil
end

AltInvWindow = class( Turbine.UI.Lotro.Window );
MinInvWindow = class( Turbine.UI.Window );
function MinInvWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetText("");
	self:SetSize(400,400); -- completely bogus just to get a start
	self:SetBackColor(Turbine.UI.Color(0,0,0));
	self.MenuBar=Turbine.UI.Control()
	self.MenuBar:SetParent(self);
	self.MenuBar:SetPosition(0,2);
	self.MenuBar:SetSize(244,20);
	self.MenuBar.OptMenu=Turbine.UI.Label();
	self.MenuBar.OptMenu:SetParent(self.MenuBar);
	self.MenuBar.OptMenu:SetPosition(1,-4);
	self.MenuBar.OptMenu:SetSize(80,19);
	self.MenuBar.OptMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.OptMenu:SetText(Resource[language][49]);
	self.MenuBar.OptMenu:SetBackground(0x410fd9f6);
	self.MenuBar.OptMenu.MouseEnter=function()
		self.MenuBar.OptMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.OptMenu.MouseLeave=function()
		self.MenuBar.OptMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.OptMenu.MouseClick=function()
		inventoryWindow.OptionsButton:MouseClick()
	end
	self.MenuBar.TrackMenu=Turbine.UI.Label();
	self.MenuBar.TrackMenu:SetParent(self.MenuBar);
	self.MenuBar.TrackMenu:SetPosition(82,-4);
	self.MenuBar.TrackMenu:SetSize(80,19);
	self.MenuBar.TrackMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.TrackMenu:SetText(Resource[language][50]);
	self.MenuBar.TrackMenu:SetBackground(0x410fd9f6);
	self.MenuBar.TrackMenu.MouseEnter=function()
		self.MenuBar.TrackMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.TrackMenu.MouseLeave=function()
		self.MenuBar.TrackMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.TrackMenu.MouseClick=function()
		inventoryWindow.TrackingButton:MouseClick()
	end
	self.MenuBar.PanelMenu=Turbine.UI.Label();
	self.MenuBar.PanelMenu:SetParent(self.MenuBar);
	self.MenuBar.PanelMenu:SetPosition(164,-4);
	self.MenuBar.PanelMenu:SetSize(80,19);
	self.MenuBar.PanelMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.PanelMenu:SetText(Resource[language][54]);
	self.MenuBar.PanelMenu:SetBackground(0x410fd9f6);
	self.MenuBar.PanelMenu.MouseEnter=function()
		self.MenuBar.PanelMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.PanelMenu.MouseLeave=function()
		self.MenuBar.PanelMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.PanelMenu.MouseClick=function()
		self.DisplayMenu:ShowMenu();
	end
	self.DisplayMenu=Turbine.UI.ContextMenu()
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][51]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][52]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][53]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][323]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][333]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][335]));
	self.DisplayMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][336]));
	self.DisplayMenu:GetItems():Get(1).Click=function()
		inventoryWindow.ViewButton[2]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(2).Click=function()
		inventoryWindow.ViewButton[1]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(3).Click=function()
		inventoryWindow.ViewButton[3]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(4).Click=function()
		inventoryWindow.ViewButton[4]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(5).Click=function()
		inventoryWindow.ViewButton[5]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(6).Click=function()
		inventoryWindow.ViewButton[6]:MouseClick();
	end
	self.DisplayMenu:GetItems():Get(7).Click=function()
		inventoryWindow.ViewButton[7]:MouseClick();
	end
	
	self.MenuBar.CloseMenu=Turbine.UI.Label();
	self.MenuBar.CloseMenu:SetParent(self);
	self.MenuBar.CloseMenu:SetPosition(self:GetWidth()-15,-4);
	self.MenuBar.CloseMenu:SetSize(15,19);
	self.MenuBar.CloseMenu:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.MenuBar.CloseMenu:SetText("X");
	self.MenuBar.CloseMenu:SetBackground(0x410fd9f6);
	self.MenuBar.CloseMenu.MouseEnter=function()
		self.MenuBar.CloseMenu:SetBackground(0x410fd9fa);
	end
	self.MenuBar.CloseMenu.MouseLeave=function()
		self.MenuBar.CloseMenu:SetBackground(0x410fd9f6);
	end
	self.MenuBar.CloseMenu.MouseClick=function()
		self:SetVisible(false);
		inventoryWindow:VisibleChanged();
	end

	self.SetHeight=function(sender,height)
		if height<153 then height=153 end;
		Turbine.UI.Window.SetHeight(self,height);
		local panelIndex
		for panelIndex=1,#inventoryWindow.ViewPanel do
			inventoryWindow.ViewPanel[panelIndex]:SetHeight(height-43);
		end
		inventoryWindow.InvalidPanel:SetHeight(height-43);
		self.MovingIcon:SetTop(height-21);
	end

	self.SetWidth=function(sender,width)
		if width<414 then width=414 end;
		Turbine.UI.Window.SetWidth(self,width);
		self.MenuBar.CloseMenu:SetLeft(width-15);

		self.MovingIcon:SetLeft(width-21);

		-- in minimal mode, the width is already padded 10 pixels to account for normal mode, so just leave it.
		if width<414 then width=414 end;
		Turbine.UI.Window.SetWidth(self,width);
		local panelIndex;
		for panelIndex=1,#inventoryWindow.ViewPanel do
			inventoryWindow.ViewPanel[panelIndex]:SetWidth(width);
		end
		inventoryWindow.InvalidPanel:SetWidth(width);
		inventoryWindow.CharacterList:SetSize(self:GetWidth()-(inventoryWindow.SelCaption:GetWidth()+inventoryWindow.SelCaption:GetLeft())-65,inventoryWindow.CharacterList:GetHeight());
		inventoryWindow.RemoveCharButton:SetLeft(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+12);
		inventoryWindow.BottomPanelTiled:SetWidth(inventoryWindow:GetWidth()-20);
		inventoryWindow.BottomPanelCenter:SetLeft((inventoryWindow:GetWidth()-inventoryWindow.BottomPanelCenter:GetWidth())/2+1);
		inventoryWindow.BottomPanelRight:SetLeft(inventoryWindow:GetWidth()-inventoryWindow.BottomPanelRight:GetWidth()-4);
		inventoryWindow.MovingIcon:SetLeft(width-21);
		if inventoryWindow.CharacterList:GetValue()~=nil then
			inventoryWindow:LoadInventory(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
		end
	end

	self.Scaling=false;
	self.Moving=false;
	self.MoveX=-1;
	self.MoveY=-1;
	self.MovingIcon=Turbine.UI.Control();
	self.MovingIcon:SetParent(self);
	self.MovingIcon:SetSize(32,32);
	self.MovingIcon:SetBackground(0x410081c0)
	self.MovingIcon:SetStretchMode(2);
	-- for some reason, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
	self.MovingIcon:SetPosition(self:GetWidth()/2-15,self:GetHeight()-21);
	self.MovingIcon:SetVisible(false);
	self.MouseDown=function(sender,args)
		if enableScaling and args.Button==2 then
		else
			if (args.Y>self:GetHeight()-15) and (args.X>self:GetWidth()-15) then
				self.MoveX=args.X;
				self.MoveY=args.Y;
				self.MovingIcon:SetLeft(args.X-12);
				self.MovingIcon:SetTop(args.Y-12);
				self.MovingIcon:SetSize(32,32);
				self.MovingIcon:SetBackground(0x41007e20)
				self.MovingIcon:SetVisible(true);
			elseif (args.Y>self:GetHeight()-12) then
				self.MoveY=args.Y;
				self.MovingIcon:SetLeft(args.X-22);
				self.MovingIcon:SetTop(args.Y-12);
				self.MovingIcon:SetSize(32,32);
				self.MovingIcon:SetBackground(0x410081c0)
				self.MovingIcon:SetVisible(true);
			elseif (args.X>self:GetWidth()-12) then
				self.MoveX=args.X;
				self.MovingIcon:SetLeft(args.X-12);
				self.MovingIcon:SetTop(args.Y-22);
				self.MovingIcon:SetSize(32,32);
				self.MovingIcon:SetBackground(0x410081bf)
				self.MovingIcon:SetVisible(true);
			elseif (args.Y<16) then
				self.MoveX=args.X;
				self.MoveY=args.Y;
				self.MovingIcon:SetLeft(args.X-12);
				self.MovingIcon:SetTop(args.Y-12);
				self.MovingIcon:SetSize(32,32);
				self.MovingIcon:SetBackground(0x410000dd)
				self.MovingIcon:SetVisible(true);
			else
				self.MoveX=-1;
				self.MoveY=-1;
			end
		end
	end

	self.MouseMove=function(sender,args)
		if (self.MoveY>-1 and self.MoveY<16) then
			if (args.X~=self.MoveX or args.Y~= self.MoveY) then
				self.Moving=true;
				local newLeft=self:GetLeft()-(self.MoveX-args.X)
				local newTop=self:GetTop()-(self.MoveY-args.Y)
				if newLeft<0 then newLeft=0 end;
				if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
				if newTop<0 then newTop=0 end;
				if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
				self:SetPosition(newLeft,newTop);
			end
		else		
			if (self.MoveY>-1) then
				if args.Y~= self.MoveY then
					local newHeight=self:GetHeight()-(self.MoveY-args.Y);
					if newHeight<156 then newHeight=156 end;
					if newHeight>(Turbine.UI.Display.GetHeight()-self:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-self:GetTop() end;
					local newX=args.X-22;
					if newX<-13 then newX=-13 end
					if newX>(self:GetWidth()-18) then newX=self:GetWidth()-18 end
					self.MovingIcon:SetLeft(newX);
					self:SetHeight(newHeight);
					self.MoveY=args.Y;
				end
			end
			if (self.MoveX>-1) then
				if args.X~= self.MoveX then
					local newWidth=self:GetWidth()-(self.MoveX-args.X);
					if newWidth<414 then newWidth=414 end;
					if newWidth>(Turbine.UI.Display.GetWidth()-self:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-self:GetLeft() end;
					local newY=args.Y-22;
					if newY<-13 then newY=-13 end
					if newY>(self:GetHeight()-18) then newY=self:GetHeight()-18 end
					self.MovingIcon:SetTop(newY);
					self:SetWidth(newWidth);
					self.MoveX=args.X;
				end
			end
		end
	end
	self.MouseUp=function(sender,args)
		self.MovingIcon:SetVisible(false);
		self.Moving=false;
		self.MoveX=-1;
		self.MoveY=-1;
	end
end

function AltInvWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetSize(414,480);
	self.Loaded=false;
	-- load the settings and set the window position if possible, otherwise default to center
	local initHeight=480;
	local initWidth=414;
	local initLeft=(Turbine.UI.Display:GetWidth() - initWidth) / 2;
	local initTop=(Turbine.UI.Display:GetHeight() - initHeight) / 2;
	local tmpSettings={};
	local index;
	local equippedItemsIconPos=nil;
	local tmpIndex;
	local mannequinLeft=152;
	local mannequinTop=42;

	self.ReplaceBags=false;
	self.View=2;
	self.NeedsRefresh=false;
	self.PluginUnloading=false;
	self.Backpack=localPlayer:GetBackpack();
	self.Equipment=localPlayer:GetEquipment();
	self.DefaultSort=0;
	self.MoveX=-1;
	self.MoveY=-1;
	self.LoadMinimized=false;
	self.Filled=0;
	self.Capacity=0;
	self.MinimalHeader=false;
	self.BagSeparator=false;
	self.ShowIconWhenMinimized=true;

	self.PanelShowing=1;

	tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "AltInventorySettings");
	if (tmpSettings~=nil) then
		if tostring(type(tmpSettings))=="table" then
			for index=1,#tmpSettings do
				if tostring(type(tmpSettings[index]))=="table" then
					if (tmpSettings[index][1]=="IWTop") then
						initTop=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="IWLeft") then
						initLeft=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="IWHeight") then
						if euroFormat then
							initHeight=tonumber((string.gsub(tmpSettings[index][2],"%.",",")));
						else
							initHeight=tonumber((string.gsub(tmpSettings[index][2],",",".")));
						end
					elseif (tmpSettings[index][1]=="IWWidth") then
						if euroFormat then
							initWidth=tonumber((string.gsub(tmpSettings[index][2],"%.",",")));
						else
							initWidth=tonumber((string.gsub(tmpSettings[index][2],",",".")));
						end
					elseif (tmpSettings[index][1]=="Sort") then
						self.DefaultSort=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="enableAttributes") then
						enableAttributes=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="enableScaling") then
						enableScaling=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="scaleMult") then
						if euroFormat then
							scaleMult=tonumber((string.gsub(tmpSettings[index][2],"%.",",")));
						else
							scaleMult=tonumber((string.gsub(tmpSettings[index][2],",",".")));
						end
					elseif (tmpSettings[index][1]=="View") then
						self.View=tmpSettings[index][2];
						if self.View==0 then self.View=2 end; -- account for old bagView settings
					elseif (tmpSettings[index][1]=="trimColor") then
						-- check for number format changes
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							trimColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							trimColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="fontColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							fontColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							fontColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="backColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							backColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							backColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="headingsColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							headingsColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							headingsColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="listTextColor") then
						if euroFormat then
							-- replace "." with "," tonumber(string.gsub(tmpSettings[index][2].R,".",","))
							listTextColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].G,"%.",","))),tonumber((string.gsub(tmpSettings[index][2].B,"%.",","))));
						else
							listTextColor=Turbine.UI.Color(tonumber((string.gsub(tmpSettings[index][2].R,",","."))),tonumber((string.gsub(tmpSettings[index][2].G,",","."))),tonumber((string.gsub(tmpSettings[index][2].B,",","."))));
							-- replace "." with ","
						end
					elseif (tmpSettings[index][1]=="ReplaceBags") then
						self.ReplaceBags=tmpSettings[index][2];
						if self.ReplaceBags then
							Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
							Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
							Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
							Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
							Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );
						end
					elseif (tmpSettings[index][1]=="loadMinimized") then
						self.LoadMinimized=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="language") then
						if tonumber(tmpSettings[index][2])~=nil then
							language=tonumber(tmpSettings[index][2]);
						end
						classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
						raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]},{74,Resource[language][298]}}

					elseif (tmpSettings[index][1]=="minimalHeader") then
						self.MinimalHeader=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="bagSeparator") then
						self.BagSeparator=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="showIconWhenMinimized") then
						self.ShowIconWhenMinimized=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="EquippedItemsIconPos") then
						equippedItemsIconPos=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="MannequinPos") then
						mannequinLeft=tmpSettings[index][2][1];
						mannequinTop=tmpSettings[index][2][2];
					end
				end
			end
		else
			-- data was unreadable, we need to display a message to the user that the data could not be read
			dataLoadError=true
		end
		-- account for changed resolution
		if initWidth>Turbine.UI.Display:GetWidth() then initWidth=Turbine.UI.Display:GetWidth() end
		if initHeight>Turbine.UI.Display:GetHeight() then initHeight=Turbine.UI.Display:GetHeight() end
		if initLeft>(Turbine.UI.Display.GetWidth()-initWidth) then initLeft=Turbine.UI.Display.GetWidth()-initWidth end;
		if initLeft<0 then initLeft=0 end;
		if initWidth>(Turbine.UI.Display.GetWidth()-initLeft) then initWidth=Turbine.UI.Display.GetWidth()-initLeft end;
		if initTop>(Turbine.UI.Display.GetHeight()-initHeight) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
		if initTop<0 then initTop=0 end;
		if initHeight>(Turbine.UI.Display.GetHeight()-initTop) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
	end

	if enableAttributes then
		self.playerAttributes=localPlayer:GetAttributes();
	end

	self:SetPosition( initLeft, initTop );
	self:SetHeight(initHeight);
	self:SetWidth(initWidth);
	self:SetOpacity( 1 );
	self:SetVisible(false);

	self.TitleIcon=Turbine.UI.Control();
	self.TitleIcon:SetParent(self);
	self.TitleIcon:SetSize(30,25);
	if language==1 then
		self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
	elseif language==2 then
		self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
	else
		self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
	end
	self.TitleIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TitleIcon:SetBackground("GaranStuff/AltInventory/Resources/title_icon.tga");
	self.TitleIcon:SetMouseVisible(false);

	-- now that we allow resizing width like the Turbine Vault window, we have to have multiple panels in the top and bottom that can seperate the way the turbine ones do..
	self.TopPanelTiled=Turbine.UI.Control();
	self.TopPanelTiled:SetParent(self);
	self.TopPanelTiled:SetZOrder(self:GetZOrder()-1);
	self.TopPanelTiled:SetSize(self:GetWidth()-30,111); --115
	self.TopPanelTiled:SetPosition(6,29);
	self.TopPanelTiled:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelTiled:SetBackground("GaranStuff/AltInventory/Resources/background_toptiled.jpg");
	self.TopPanelTiled:SetMouseVisible(false);

	self.TopPanelLeft=Turbine.UI.Control();
	self.TopPanelLeft:SetParent(self);
	self.TopPanelLeft:SetZOrder(self:GetZOrder()-1);
	self.TopPanelLeft:SetSize(86,118);
	self.TopPanelLeft:SetPosition(5,22);
	self.TopPanelLeft:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelLeft:SetBackground("GaranStuff/AltInventory/Resources/background_top_left.tga");
	self.TopPanelLeft:SetMouseVisible(false);

	self.TopPanelCenter=Turbine.UI.Control();
	self.TopPanelCenter:SetParent(self);
	self.TopPanelCenter:SetSize(382,106);
	self.TopPanelCenter:SetPosition((self:GetWidth()-self.TopPanelCenter:GetWidth())/2-3,30);
	self.TopPanelCenter:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelCenter:SetBackground("GaranStuff/AltInventory/Resources/background_top_center.tga");
	self.TopPanelCenter:SetMouseVisible(false);

	self.TopPanelRight=Turbine.UI.Control();
	self.TopPanelRight:SetParent(self);
	self.TopPanelRight:SetZOrder(-1);
	self.TopPanelRight:SetSize(86,118);
	self.TopPanelRight:SetPosition(self:GetWidth()-self.TopPanelRight:GetWidth()-5,22);
	self.TopPanelRight:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TopPanelRight:SetBackground("GaranStuff/AltInventory/Resources/background_top_right.tga");
	self.TopPanelRight:SetMouseVisible(false);

	self:SetText("      "..Resource[language][2].."      ");
	self.SetPluginUnloading = function(value)
		self.PluginUnloading=value;
	end
	self.VisibleChanged=function()
		if (not self.PluginUnloading) then
			if (not self:IsVisible() and not minimalWindow:IsVisible()) then
				self.ViewPanel[1].SearchText:SetWantsUpdates(false);
				minWindow:SetVisible(true);
				if optWindow~=nil then optWindow:SetVisible(false) end;
				if trackWindow~=nil then trackWindow:SetVisible(false) end;
			else
				if self.CharacterList:GetValue()~=nil then
					self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
				end
			end
			inventoryWindow.ViewPanel[3]:SetWantsUpdates(inventoryWindow.ViewPanel[3]:GetParent():IsVisible())
		end
	end

	self.SelCaption=Turbine.UI.Label();
	self.SelCaption:SetParent(self);
	self.SelCaption:SetPosition(15,39);
	self.SelCaption:SetSize(78,20);
	self.SelCaption:SetFont(fontFace);
	self.SelCaption:SetForeColor(fontColor);
	self.SelCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SelCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SelCaption:SetText(Resource[language][15]..":");

	self.CharacterList=DropDownList();
	self.CharacterList:SetParent(self);
	self.CharacterList:SetPosition(self.SelCaption:GetLeft()+self.SelCaption:GetWidth()+2,self.SelCaption:GetTop()-3);
	self.CharacterList:SetSize(self:GetWidth()-(self.SelCaption:GetWidth()+self.SelCaption:GetLeft())-65,20);
	self.CharacterList:SetBorderColor(trimColor);
	self.CharacterList:SetBackColor(backColor);
	self.CharacterList:SetTextColor(listTextColor);
	self.CharacterList:SetCurrentBackColor(backColor);
	self.CharacterList:SetDropRows(8);

	self.CharacterList.SelectedIndexChanged = function ()
		self.RemoveCharButton:SetVisible(self.CharacterList:GetValue()~=1 and self.CharacterList:GetText()~=currentCharacterName);
		self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
		local panelIndex
		for panelIndex=1,#self.ViewPanel do
			if self.ViewPanel[panelIndex].LoadPanelData ~= nil then
				self.ViewPanel[panelIndex]:LoadPanelData(characterListArray[self.CharacterList:GetValue()][1]);
			end
		end
		self.RefreshWallet(characterListArray[self.CharacterList:GetValue()][1]);
	end

	self.RemoveCharButton=Turbine.UI.Control();
	self.RemoveCharButton:SetParent(self);
	self.RemoveCharButton:SetPosition(self.CharacterList:GetLeft()+self.CharacterList:GetWidth()+12,self.CharacterList:GetTop());
	self.RemoveCharButton:SetSize(20,20);
	self.RemoveCharButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	self.RemoveCharButton:SetVisible(false);
	self.RemoveCharButton.MouseEnter = function()
		self.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull_hover.tga");
	end
	self.RemoveCharButton.MouseLeave = function()
		self.RemoveCharButton:SetBackground("GaranStuff/AltInventory/Resources/skull.tga");
	end
	self.RemoveCharButton.MouseClick = function()
		-- display confirmation
		self:SetEnabled(false);
		self.RemoveConfirmation:SetPosition((self.RemoveConfirmation:GetParent():GetWidth()-self.RemoveConfirmation:GetWidth())/2,(self.RemoveConfirmation:GetParent():GetHeight()-self.RemoveConfirmation:GetHeight())/2);
		self.RemoveConfirmation:SetVisible(true);
	end

	self.RemoveConfirmation=Turbine.UI.Label();
	self.RemoveConfirmation:SetParent(self);
	self.RemoveConfirmation:SetSize(200,200);
	self.RemoveConfirmation:SetPosition((self:GetWidth()-self.RemoveConfirmation:GetWidth())/2,(self:GetHeight()-self.RemoveConfirmation:GetHeight())/2);
	self.RemoveConfirmation:SetBackColor(trimColor);
	self.RemoveConfirmation.Text=Turbine.UI.Label();
	self.RemoveConfirmation.Text:SetParent(self.RemoveConfirmation)
	self.RemoveConfirmation.Text:SetSize(self.RemoveConfirmation:GetWidth()-2,self.RemoveConfirmation:GetHeight()-2);
	self.RemoveConfirmation.Text:SetPosition(1,1);
	self.RemoveConfirmation.Text:SetBackColor(backColor);
	self.RemoveConfirmation.Text:SetForeColor(fontColor);
	self.RemoveConfirmation.Text:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.RemoveConfirmation.Text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.RemoveConfirmation.Text:SetText("Are you sure you wish to remove this character's inventory information?");
	self.RemoveConfirmation.OK=Turbine.UI.Lotro.Button();
	self.RemoveConfirmation.OK:SetParent(self.RemoveConfirmation.Text);
	self.RemoveConfirmation.OK:SetSize(80,20);
	self.RemoveConfirmation.OK:SetPosition(10,self.RemoveConfirmation.Text:GetHeight()-25);
	self.RemoveConfirmation.OK:SetText("OK");
	self.RemoveConfirmation.OK.Click=function()
		RemoveCharacter(self.CharacterList:GetText());
		self:SetEnabled(true);
		self.RemoveConfirmation:SetVisible(false);
	end
	self.RemoveConfirmation.Cancel=Turbine.UI.Lotro.Button();
	self.RemoveConfirmation.Cancel:SetParent(self.RemoveConfirmation.Text);
	self.RemoveConfirmation.Cancel:SetSize(80,20);
	self.RemoveConfirmation.Cancel:SetPosition(self.RemoveConfirmation.Text:GetWidth()-self.RemoveConfirmation.Cancel:GetWidth()-10,self.RemoveConfirmation.Text:GetHeight()-25);
	self.RemoveConfirmation.Cancel:SetText("Cancel");
	self.RemoveConfirmation.Cancel.Click=function()
		self:SetEnabled(true);
		self.RemoveConfirmation:SetVisible(false);
	end
	self.RemoveConfirmation:SetVisible(false);

	self.CapacityPanel=Turbine.UI.Control();
	self.CapacityPanel:SetParent(self);
	self.CapacityPanel.MaxWidth=376;
	self.CapacityPanel:SetPosition((self:GetWidth()-self.CapacityPanel.MaxWidth)/2,65);
	self.CapacityPanel:SetSize(self.CapacityPanel.MaxWidth,17);

	self.CapacityPanel.Empty=Turbine.UI.Label();
	self.CapacityPanel.Empty:SetParent(self);
	self.CapacityPanel.Empty:SetPosition(self.CapacityPanel:GetLeft()+3,64);
	self.CapacityPanel.Empty:SetSize(60,20);
	self.CapacityPanel.Empty:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	self.CapacityPanel.Empty:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.CapacityPanel.Empty:SetForeColor(Turbine.UI.Color(0,.7,0));
	self.CapacityPanel.Empty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.CapacityPanel.Empty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.CapacityPanel.Empty:SetText(Resource[language][21]);

	self.CapacityPanel.Display=Turbine.UI.Label();
	self.CapacityPanel.Display:SetParent(self);
	self.CapacityPanel.Display:SetSize(368,20);
	self.CapacityPanel.Display:SetPosition((self:GetWidth()-self.CapacityPanel.Display:GetWidth())/2,64);
	self.CapacityPanel.Display:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.CapacityPanel.Display:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.CapacityPanel.Display:SetForeColor(fontColor);
	self.CapacityPanel.Display:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.CapacityPanel.Display:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.CapacityPanel.Display:SetText(Resource[language][22]);

	self.CapacityPanel.Full=Turbine.UI.Label();
	self.CapacityPanel.Full:SetParent(self);
	self.CapacityPanel.Full:SetSize(60,20);
	self.CapacityPanel.Full:SetPosition(self:GetWidth()-self.CapacityPanel.Empty:GetLeft()-66,64);
	self.CapacityPanel.Full:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);
	self.CapacityPanel.Full:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.CapacityPanel.Full:SetForeColor(Turbine.UI.Color(.75,0,0));
	self.CapacityPanel.Full:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.CapacityPanel.Full:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.CapacityPanel.Full:SetText(Resource[language][23]);

	self.ViewButton={};
	self.ViewPanel={};
	self.ViewButton[1]=Turbine.UI.Control();
	self.ViewButton[1]:SetParent(self);
	self.ViewButton[1]:SetSize(32,32);
	self.ViewButton[1]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[1]:SetBackground("GaranStuff/AltInventory/Resources/Inventory.tga");
	self.ViewButton[1].GreyIcon="GaranStuff/AltInventory/Resources/Inventory_grey.tga";
	self.ViewButton[1].Icon="GaranStuff/AltInventory/Resources/Inventory.tga";
	self.ViewButton[1].Index=1;
	self.ViewButton[1].HoverName=Resource[language][52];

	self.ViewButton[2]=Turbine.UI.Control();
	self.ViewButton[2]:SetParent(self);
	self.ViewButton[2]:SetSize(32,32);
	self.ViewButton[2]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[2]:SetBackground("GaranStuff/AltInventory/Resources/EquippedItems_grey.tga");
	self.ViewButton[2].GreyIcon="GaranStuff/AltInventory/Resources/EquippedItems_grey.tga";
	self.ViewButton[2].Icon="GaranStuff/AltInventory/Resources/EquippedItems.tga";
	self.ViewButton[2].Index=2;
	self.ViewButton[2].HoverName=Resource[language][51];

	self.ViewButton[3]=Turbine.UI.Control();
	self.ViewButton[3]:SetParent(self);
	self.ViewButton[3]:SetSize(32,32);
	self.ViewButton[3]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[3]:SetBackground("GaranStuff/AltInventory/Resources/Statistics_grey.tga");
	self.ViewButton[3].GreyIcon="GaranStuff/AltInventory/Resources/Statistics_grey.tga";
	self.ViewButton[3].Icon="GaranStuff/AltInventory/Resources/Statistics.tga";
	self.ViewButton[3].Index=3;
	self.ViewButton[3].HoverName=Resource[language][53];

	self.ViewButton[4]=Turbine.UI.Control();
	self.ViewButton[4]:SetParent(self);
	self.ViewButton[4]:SetSize(32,32);
	self.ViewButton[4]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[4]:SetBackground("GaranStuff/AltInventory/Resources/Crafting_grey.tga");
	self.ViewButton[4].GreyIcon="GaranStuff/AltInventory/Resources/Crafting_grey.tga";
	self.ViewButton[4].Icon="GaranStuff/AltInventory/Resources/Crafting.tga";
	self.ViewButton[4].Index=4;
	self.ViewButton[4].HoverName=Resource[language][323];

	self.ViewButton[5]=Turbine.UI.Control();
	self.ViewButton[5]:SetParent(self);
	self.ViewButton[5]:SetSize(32,32);
	self.ViewButton[5]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[5]:SetBackground("GaranStuff/AltInventory/Resources/Notes_grey.tga");
	self.ViewButton[5].GreyIcon="GaranStuff/AltInventory/Resources/Notes_grey.tga";
	self.ViewButton[5].Icon="GaranStuff/AltInventory/Resources/Notes.tga";
	self.ViewButton[5].Index=5;
	self.ViewButton[5].HoverName=Resource[language][333];

	self.ViewButton[6]=Turbine.UI.Control();
	self.ViewButton[6]:SetParent(self);
	self.ViewButton[6]:SetSize(32,32);
	self.ViewButton[6]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[6]:SetBackground("GaranStuff/AltInventory/Resources/Reputation_grey.tga");
	self.ViewButton[6].GreyIcon="GaranStuff/AltInventory/Resources/Reputation_grey.tga";
	self.ViewButton[6].Icon="GaranStuff/AltInventory/Resources/Reputation.tga";
	self.ViewButton[6].Index=6;
	self.ViewButton[6].HoverName=Resource[language][335];

	self.ViewButton[7]=Turbine.UI.Control();
	self.ViewButton[7]:SetParent(self);
	self.ViewButton[7]:SetSize(32,32);
	self.ViewButton[7]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ViewButton[7]:SetBackground("GaranStuff/AltInventory/Resources/Pennon_grey.tga");
	self.ViewButton[7].GreyIcon="GaranStuff/AltInventory/Resources/Pennon_grey.tga";
	self.ViewButton[7].Icon="GaranStuff/AltInventory/Resources/Pennon.tga";
	self.ViewButton[7].Index=7;
	self.ViewButton[7].HoverName=Resource[language][336];

	self.ViewButtonMenu=Turbine.UI.ContextMenu()
	self.ViewButtonMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][52]));

	local vbleft=(self:GetWidth()-32*#self.ViewButton-4*(#self.ViewButton-1))/2;

	for tmpIndex=1,#self.ViewButton do
		self.ViewButton[tmpIndex]:SetPosition(vbleft+(tmpIndex-1)*36,87); --96

		self.ViewButton[tmpIndex].MouseEnter=function(button)
			if self.PanelShowing~=button.Index then
				button:SetBackground(button.Icon);
			end
		end
		self.ViewButton[tmpIndex].MouseHover=function(button)
			self.ViewButtonMenu:GetItems():Get(1):SetText(button.HoverName)
			self.ViewButtonMenu:GetItems():Get(1).Click=function() button.MouseClick(button) end
			self.ViewButtonMenu:ShowMenu()
		end
		self.ViewButton[tmpIndex].MouseLeave=function(button)
			if self.PanelShowing~=button.Index then
				button:SetBackground(button.GreyIcon);
			end
		end
		self.ViewButton[tmpIndex].MouseClick=function(button)
			if self.PanelShowing~=button.Index then
				self.PanelShowing=button.Index;
				local panelIndex;
				for panelIndex=1,#self.ViewButton do
					if panelIndex==button.Index then
						self.ViewButton[panelIndex]:SetBackground(self.ViewButton[panelIndex].Icon);
						if self.ViewPanel[panelIndex].IsValid~=nil then
							if self.ViewPanel[panelIndex]:IsValid() then
								self.ViewPanel[panelIndex]:SetVisible(true);
							end
						else
							self.ViewPanel[panelIndex]:SetVisible(true);
						end
					else
						self.ViewButton[panelIndex]:SetBackground(self.ViewButton[panelIndex].GreyIcon);
						self.ViewPanel[panelIndex]:SetVisible(false);
					end
				end
			end
		end
	end

-- Create the money display
	self.WalletPanel=Turbine.UI.Control();
	self.WalletPanel:SetParent(self);
	self.WalletPanel:SetSize(193,20);
	self.WalletPanel:SetPosition((self:GetWidth()-self.WalletPanel:GetWidth())/2,119);
	self.WalletPanel:SetMouseVisible(false);
	self.WalletPanel:SetVisible(enableAttributes);
	self.GPText=Turbine.UI.Label();
	self.GPText:SetParent(self.WalletPanel);
	self.GPText:SetSize(50,20);
	self.GPText:SetPosition(0,0);
	self.GPText:SetMultiline(false);
	self.GPText:SetFont(fontFace);
	self.GPText:SetForeColor(fontColor);
	self.GPText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.GPText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.GPText:SetText("");
	self.GPText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.GPText:SetMouseVisible(false);
	self.GPText.HScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.GPText.HScrollBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.GPText.HScrollBar:SetParent(self); -- see if the scrollbar will trigger "IsVisible()" even if it has no parent
	self.GPText.HScrollBar:SetHeight(12);
	self.GPText.HScrollBar:SetPosition(0,-13); -- position it off canvas so it won't ever actually display
	self.GPText:SetHorizontalScrollBar(self.GPText.HScrollBar);
	self.GPIcon=Turbine.UI.Control();
	self.GPIcon:SetParent(self.WalletPanel);
	self.GPIcon:SetSize(27,21);
	self.GPIcon:SetPosition(50,0);
	self.GPIcon:SetBlendMode(5);
	self.GPIcon:SetBackground(0x41007e7b);
	self.GPIcon:SetZOrder(1);
	self.GPIcon:SetMouseVisible(false);

	self.SPText=Turbine.UI.Label();
	self.SPText:SetParent(self.WalletPanel);
	self.SPText:SetSize(30,20);
	self.SPText:SetPosition(82,0);
	self.SPText:SetFont(fontFace);
	self.SPText:SetForeColor(fontColor);
	self.SPText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SPText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SPText:SetText("");
	self.SPText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.SPText:SetMouseVisible(false);
	self.SPIcon=Turbine.UI.Control();
	self.SPIcon:SetParent(self.WalletPanel);
	self.SPIcon:SetSize(27,21);
	self.SPIcon:SetPosition(112,0);
	self.SPIcon:SetBlendMode(5);
	self.SPIcon:SetBackground(0x41007e7c);
	self.SPIcon:SetZOrder(1);
	self.SPIcon:SetMouseVisible(false);

	self.CPText=Turbine.UI.Label();
	self.CPText:SetParent(self.WalletPanel);
	self.CPText:SetSize(22,20);
	self.CPText:SetPosition(144,0);
	self.CPText:SetFont(fontFace);
	self.CPText:SetForeColor(fontColor);
	self.CPText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.CPText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.CPText:SetText("");
	self.CPText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.CPText:SetMouseVisible(false);
	self.CPIcon=Turbine.UI.Control();
	self.CPIcon:SetParent(self.WalletPanel);
	self.CPIcon:SetSize(27,21);
	self.CPIcon:SetPosition(166,0);
	self.CPIcon:SetBlendMode(5);
	self.CPIcon:SetBackground(0x41007e7d);
	self.CPIcon:SetMouseVisible(false);
	self.CPIcon:SetZOrder(1);

	self.RefreshWallet=function(characterName)
		local money;
		if self.CharacterList:GetSelectedIndex()==1 and enableAttributes then
			money=localPlayer:GetAttributes():GetMoney();
			local tmpIndex;
			for tmpIndex=2,#characterListArray do
				if characterListArray[tmpIndex][1]~=currentCharacterName and characterListArray[tmpIndex][11]~=nil then
					money=money+characterListArray[tmpIndex][11]
				end
			end
		else
			if characterName==currentCharacterName and enableAttributes then
				money=localPlayer:GetAttributes():GetMoney();
			else
				money=characterListArray[self.CharacterList:GetValue()][11];
			end
		end
		if money==nil then
			-- we tried to get the money value from a character that was stored in a previous data format
			self.GPText:SetText("");
			self.SPText:SetText("");
			self.CPText:SetText("");
		else
			local cp=math.fmod(money,100);
			money=(money-cp)/100;
			local sp=math.fmod(money,1000);
			local gp=(money-sp)/1000;
			self.GPText:SetWidth(50);
			self.GPText:SetText(gp);

			local maxWidth=self:GetWidth()/2;
			while self.GPText.HScrollBar:IsVisible() and self.GPText:GetWidth()<maxWidth do
				self.GPText:SetWidth(self.GPText:GetWidth()+10)
			end

			local offset=self.GPText:GetWidth()-50;
			if offset<0 then offset=0 end
			self.WalletPanel:SetWidth(193+offset)
			self.WalletPanel:SetLeft((self:GetWidth()-self.WalletPanel:GetWidth())/2);
			self.GPIcon:SetLeft(offset+50);
			self.SPText:SetLeft(offset+82);
			self.SPIcon:SetLeft(offset+112);
			self.CPText:SetLeft(offset+144);
			self.CPIcon:SetLeft(offset+166);

			self.SPText:SetText(sp);
			self.CPText:SetText(cp);
		end
	end

	self.MoneyChanged=function(sender, args)
		inventoryWindow.RefreshWallet(currentCharacterName);
	end

	self.InvalidPanel=Turbine.UI.Label();
	self.InvalidPanel:SetParent(self);
	self.InvalidPanel:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.InvalidPanel:SetPosition((self:GetWidth()-self.InvalidPanel:GetWidth())/2,140);
	self.InvalidPanel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.InvalidPanel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36);
	self.InvalidPanel:SetText("n/a");

-- Create the Equipped Items Panel
	self.ViewPanel[2]=EquippedItemsPanel();
	self.ViewPanel[2]:SetParent(self);
	self.ViewPanel[2]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[2]:SetPosition((self:GetWidth()-self.ViewPanel[2]:GetWidth())/2,140);
	self.ViewPanel[2]:LoadPanelData(currentCharacterName);
	self.ViewPanel[2].Index=2;

-- Stats Panel
	self.ViewPanel[3]=StatsPanel();
	self.ViewPanel[3]:SetParent(self);
	self.ViewPanel[3]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[3]:SetPosition((self:GetWidth()-self.ViewPanel[3]:GetWidth())/2,140);
	self.ViewPanel[3]:LoadPanelData(currentCharacterName);
	self.ViewPanel[3].Index=3;

-- Crafting Panel
	self.ViewPanel[4]=CraftingPanel();
	self.ViewPanel[4]:SetParent(self);
	self.ViewPanel[4]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[4]:SetPosition((self:GetWidth()-self.ViewPanel[4]:GetWidth())/2,140);
	self.ViewPanel[4]:LoadPanelData(currentCharacterName);
	self.ViewPanel[4].Index=4;

-- Notes Panel
	self.ViewPanel[5]=NotesPanel();
	self.ViewPanel[5]:SetParent(self);
	self.ViewPanel[5]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[5]:SetPosition((self:GetWidth()-self.ViewPanel[5]:GetWidth())/2,140);
	self.ViewPanel[5]:LoadPanelData(currentCharacterName);
	self.ViewPanel[5].Index=5;

-- Reputation Panel
	self.ViewPanel[6]=RepPanel();
	self.ViewPanel[6]:SetParent(self);
	self.ViewPanel[6]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[6]:SetPosition((self:GetWidth()-self.ViewPanel[6]:GetWidth())/2,140);
	self.ViewPanel[6]:LoadPanelData(currentCharacterName);
	self.ViewPanel[6].Index=6;

-- Traits Panel
	self.ViewPanel[7]=TraitsPanel();
	self.ViewPanel[7]:SetParent(self);
	self.ViewPanel[7]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[7]:SetPosition((self:GetWidth()-self.ViewPanel[7]:GetWidth())/2,140);
	self.ViewPanel[7]:LoadPanelData(currentCharacterName);
	self.ViewPanel[7].Index=7;

-- Inventory Panel
	self.ViewPanel[1]=InventoryPanel();
	self.ViewPanel[1]:SetParent(self);
	self.ViewPanel[1]:SetSize(self:GetWidth()-10,self:GetHeight()-183);
	self.ViewPanel[1]:SetPosition((self:GetWidth()-self.ViewPanel[1]:GetWidth())/2,140);
	self.ViewPanel[1]:SetMouseVisible(false);
	self.ViewPanel[1]:SetVisible(true);
	self.ViewPanel[1].SetView(self.View);
	self.ViewPanel[1].Index=1;

	self.BottomPanelTiled=Turbine.UI.Control();
	self.BottomPanelTiled:SetParent(self);
	self.BottomPanelTiled:SetSize(self:GetWidth()-20,40);
	self.BottomPanelTiled:SetPosition(10,self:GetHeight()-47);
	self.BottomPanelTiled:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelTiled:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_tiled.jpg");
	self.BottomPanelTiled:SetMouseVisible(false);

	self.BottomPanelLeft=Turbine.UI.Control();
	self.BottomPanelLeft:SetParent(self);
	self.BottomPanelLeft:SetSize(151,40);
	self.BottomPanelLeft:SetPosition(5,self:GetHeight()-47);
	self.BottomPanelLeft:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelLeft:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_left.tga");
	self.BottomPanelLeft:SetMouseVisible(false);

	self.BottomPanelCenter=Turbine.UI.Control();
	self.BottomPanelCenter:SetParent(self);
	self.BottomPanelCenter:SetSize(121,40);
	self.BottomPanelCenter:SetPosition((self:GetWidth()-self.BottomPanelCenter:GetWidth())/2+1,self:GetHeight()-47);
	self.BottomPanelCenter:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelCenter:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_center.tga");
	self.BottomPanelCenter:SetMouseVisible(false);

	self.BottomPanelRight=Turbine.UI.Control();
	self.BottomPanelRight:SetParent(self);
	self.BottomPanelRight:SetSize(151,40);
	self.BottomPanelRight:SetPosition(self:GetWidth()-self.BottomPanelRight:GetWidth()-4,self:GetHeight()-47);
	self.BottomPanelRight:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.BottomPanelRight:SetBackground("GaranStuff/AltInventory/Resources/background_bottom_right.tga");
	self.BottomPanelRight:SetMouseVisible(false);

	self.MovingIcon=Turbine.UI.Control();
	self.MovingIcon:SetParent(self);
	self.MovingIcon:SetSize(32,32);
	self.MovingIcon:SetStretchMode(1);
	self.MovingIcon:SetBackground(0x410081c0)
	-- for some reason, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
	self.MovingIcon:SetPosition(self:GetWidth()/2-15,self:GetHeight()-21);
	self.MovingIcon:SetVisible(false);

	self.TrackMenu=Turbine.UI.ContextMenu()
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][42]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][43]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem("------------------------------------------------------"));
	self.TrackMenu:GetItems():Get(3):SetEnabled(false);
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][44]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][45]));

	self.QuantityMenu=Turbine.UI.ContextMenu()

	self.ItemControl={};
	self.ItemIcon={};
	self.ItemCol={};
	self.QtyCol={};
	self.SeparatorCol={};

	self.LoadingInventory=false;
	self.LoadInventory = function (sender, characterName)
		if not self.LoadingInventory then -- prevent any accidental recursion from quantity changes that also trigger item add/remove/move
			self.LoadingInventory=true;

			if (characterName==Resource[language][29].." ") or (characterName==currentCharacterName) then
				-- create the current character inventory on the fly so we catch any changes
				-- we need to do this BEFORE we check for BuildAllInventory so that it gets the latest inventory
				local backpackSize=self.Backpack:GetSize();
				tmpInventory={};
				if (backpackSize~=nil) then
					local invIndex=1;
					local tmpItem;
					while (invIndex<=backpackSize) do
						tmpItem=self.Backpack:GetItem(invIndex);
						if (tmpItem~=nil)then
							tmpInventory[invIndex]= {invIndex,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
						else
							tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
						end
						invIndex=invIndex+1;
					end
				end
				inventoryArray[currentCharIndex]=tmpInventory;
			end
			self.ViewPanel[1].InventoryListBackground.InventoryList:SetAllowDrop( characterName==currentCharacterName );
			if (characterName==Resource[language][29].." ")then
				BuildAllInventory();
			end
			for index=1, self.CharacterList.ListData:GetItemCount() do
				if (self.CharacterList.ListData:GetItem(index):GetText()==characterName) then
					tmpInventory = inventoryArray[index];
				end
			end
			local filterIndex;
			for filterIndex=2,self.ViewPanel[1].FilterList.ListData:GetItemCount() do
				self.ViewPanel[1].FilterList:HideEntry(filterIndex);
			end

			for listIndex=1,#self.ItemCol do
				self.ItemCol[listIndex].MouseEnter=nil
				self.ItemCol[listIndex].Update=nil
				self.ItemCol[listIndex].MouseLeave=nil
				self.ItemCol[listIndex].MouseClick=nil
				self.QtyCol[listIndex].MouseClick=nil
				self.QtyCol[listIndex].MouseEnter=nil
				self.QtyCol[listIndex].Update=nil
				self.QtyCol[listIndex].MouseLeave=nil
			end

			for listIndex=1,self.ViewPanel[1].InventoryListBackground.InventoryList:GetItemCount() do
				-- first thing we need to do is unregister the old event handlers, since they don't automatically go away when they item does
				if self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(listIndex).IconCol~=nil and self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(listIndex).IconCol.GetItem~=nil then
					-- it's an item control that has an item
					RemoveCallback(self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(listIndex).IconCol:GetItem(),"QuantityChanged",QuantityChanged)
				end
				self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(listIndex):SetHeight(0); -- we no longer remove the entry, we just recycle them ourselves to eliminate issues with garbage collection
			end

			if (tmpInventory~=nil) then
				local tmpCategory=0;
				local tmpDurability=0;
				local tmpQuality=0;
				local tmpIndex;
				if (#tmpInventory>0) then
					-- apply the current sort
					if (self.ViewPanel[1].SortList:GetValue()==0) then
						-- sort on bag Index
						table.sort(tmpInventory,function(arg1,arg2) if (arg1[1]<arg2[1]) then return(true) end end);
					elseif (self.ViewPanel[1].SortList:GetValue()==1) then
						-- sort on Name A-Z
						table.sort(tmpInventory,function(arg1,arg2) if (arg1[5]<arg2[5]) then return(true) end end);
					elseif (self.ViewPanel[1].SortList:GetValue()==2) then
						-- sort on Name Z-A
						table.sort(tmpInventory,function(arg1,arg2) if (arg1[5]>arg2[5]) then return(true) end end);
					elseif (self.ViewPanel[1].SortList:GetValue()==3) then
						-- sort on Category
						-- we have to be careful that the category exists since there are holes in the enumeration. if it doesn't exist, assign it the same order as "Undefined"
						for tmpIndex=1,#tmpInventory do
							if categorySortOrder[tmpInventory[tmpIndex][13]]==nil then
							-- set it to the same sort order as the Undefined category
								categorySortOrder[tmpInventory[tmpIndex][13]]=categorySortOrder[Turbine.Gameplay.ItemCategory.Undefined];
							end
						end
						table.sort(tmpInventory,function(arg1,arg2) if (categorySortOrder[arg1[13]]<categorySortOrder[arg2[13]]) then return(true) elseif (arg1[13]==arg2[13] and arg1[5]<arg2[5]) then return (true) end end);
					elseif (self.ViewPanel[1].SortList:GetValue()==4) then
						-- sort on Quality
						table.sort(tmpInventory,function(arg1,arg2) if (qualitySortOrder[(arg1[3]+1)]<qualitySortOrder[(arg2[3]+1)]) then return(true) elseif (arg1[3]==arg2[3] and arg1[5]<arg2[5]) then return (true) end end);
					elseif (self.ViewPanel[1].SortList:GetValue()==5) then
						-- sort on WearState  wearStateSortOrder
						table.sort(tmpInventory,function(arg1,arg2) if (wearStateSortOrder[(arg1[4]+1)]<wearStateSortOrder[(arg2[4]+1)]) then return(true) elseif (arg1[4]==arg2[4] and arg1[5]<arg2[5]) then return (true) end end);
					end
				end
				local displayCol=0;
				local displayRow=1;
				local separatorIndex=1;
				local newRow=true;
				local elementWidth;
				self.Filled=0;
				self.Capacity=0;
				if self.View==1 then
					elementWidth=399;
				elseif self.View==2 then
					elementWidth=193;
				else
					elementWidth=34;
				end
				local maxCols=math.floor((self.ViewPanel[1].InventoryListBackground:GetWidth()-17)/(elementWidth+1));
				for index=1,self.ViewPanel[1].InventoryListBackground.InventoryList:GetItemCount() do
					self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(index):SetHeight(0);
					self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(index).DefaultHeight=0;
				end
				for index=1,#self.ItemControl do
					self.ItemControl[index]:SetSize(0,0);
					if self.ItemControl[index]:GetItem()~=nil and self.ItemControl[index]:GetItem().QuantityChanged~=nil then
						RemoveCallback(self.ItemControl[index]:GetItem(),"QuantityChanged",QuantityChanged);
					end
				end
				for index=1,#self.ItemIcon do
					self.ItemIcon[index]:SetSize(0,0);
					self.ItemCol[index]:SetSize(0,0);
					self.QtyCol[index]:SetSize(0,0);
				end

				for index=1,#tmpInventory do
					local showUndefined=true;
					for filterIndex=2,self.ViewPanel[1].FilterList.ListData:GetItemCount() do
						if tmpInventory[index][5]~="" and tmpInventory[index][13]~=nil and tmpInventory[index][13]==self.ViewPanel[1].FilterList.ListData:GetItem(filterIndex).DataValue then
							self.ViewPanel[1].FilterList:ShowEntry(filterIndex);
							showUndefined =false;
							break;
						end
					end

					if showUndefined and tmpInventory[index][5]~="" then
						-- the item category was not found, show the Undefined entry
						if debug then
							Turbine.Shell.WriteLine("Item with unrecognized Category code:"..tostring(tmpInventory[index][13])..", "..tmpInventory[index][5]);
						end
						self.ViewPanel[1].FilterList:ShowEntry(undefinedCategoryIndex);
					end

					self.Capacity=self.Capacity+1;
					if index>#self.ItemControl then
						self.ItemControl[index]=Turbine.UI.Lotro.ItemControl();
						self.ItemControl[index]:SetBackColor(self.ViewPanel[1].InventoryListBackground:GetBackColor());
					end
					if index>#self.ItemIcon then
						self.ItemIcon[index]=Turbine.UI.Control();
						self.ItemIcon[index]:SetOpacity(1);
						self.ItemIcon[index].IconImage=Turbine.UI.Control();
						self.ItemIcon[index].IconImage:SetParent(self.ItemIcon[index]);
						self.ItemIcon[index].IconImage:SetBlendMode(Turbine.UI.BlendMode.Overlay);
						self.ItemIcon[index].QtyText=Turbine.UI.Label();
						self.ItemIcon[index].QtyText:SetParent(self.ItemIcon[index]);
						self.ItemIcon[index].QtyText:SetFontStyle(Turbine.UI.FontStyle.Outline);
						self.ItemIcon[index].QtyText:SetTextAlignment( Turbine.UI.ContentAlignment.BottomRight );
						self.ItemCol[index]=Turbine.UI.Label();
						self.ItemCol[index]:SetParent(tmpRow);
						self.ItemCol[index]:SetLeft(41);
						self.ItemCol[index]:SetMultiline(false);
						self.ItemCol[index]:SetSize(self.ViewPanel[1].InventoryListBackground.InventoryList:GetWidth()-53,17);
						self.ItemCol[index]:SetBackColor(Turbine.UI.Color(.05,.07,.09));
						self.ItemCol[index]:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
						self.ItemCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
						self.QtyCol[index]=Turbine.UI.Label();
						self.QtyCol[index]:SetParent(tmpRow);
						self.QtyCol[index]:SetSize(0,17);
						self.QtyCol[index]:SetLeft(0);
						self.QtyCol[index]:SetBackColor(Turbine.UI.Color(.05,.07,.09));
						self.QtyCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
					end

					local tmpRow;
					if self.BagSeparator and (characterName~=Resource[language][29].." ") and (self.ViewPanel[1].SortList:GetValue()==0) and ((index-1)/15==math.floor((index-1)/15)) then
						if displayCol>0 then
							displayRow=displayRow+1;
						end
						-- insert a Bag Separator every 15 items when sorting by "Location in Bag"
						if displayRow<=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItemCount() then 
							tmpRow=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(displayRow);
						else
							tmpRow=Turbine.UI.Control();
							tmpRow:SetLeft(1);
							self.ViewPanel[1].InventoryListBackground.InventoryList:AddItem(tmpRow);
						end
						tmpRow:SetBackColor(self.ViewPanel[1].InventoryListBackground:GetBackColor());
						tmpRow:SetSize(self.ViewPanel[1].InventoryListBackground.InventoryList:GetWidth()-2,20);
						tmpRow.DefaultHeight=20;
						tmpRow.Separator=true;
						if separatorIndex>#self.SeparatorCol then
							self.SeparatorCol[separatorIndex]=Turbine.UI.Label();
						end
						self.SeparatorCol[separatorIndex]:SetParent(tmpRow);
						self.SeparatorCol[separatorIndex]:SetFont(fontFace);
						self.SeparatorCol[separatorIndex]:SetForeColor(fontColor);
						self.SeparatorCol[separatorIndex]:SetSize(tmpRow:GetWidth(),20)
						self.SeparatorCol[separatorIndex]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
						self.SeparatorCol[separatorIndex]:SetText(Resource[language][256].." "..separatorIndex);
						separatorIndex=separatorIndex+1;
						newRow=true;
						displayCol=0;
						displayRow=displayRow+1;
					end

					if self.View==3 then
						if not(tmpInventory[index][5]==nil or tmpInventory[index][5]=="") then
							self.Filled=self.Filled+1;
							if (self.ViewPanel[1].FilterList:GetValue()==-1 or (tmpInventory[index][13]~=nil and tmpInventory[index][13]==self.ViewPanel[1].FilterList:GetValue()) or (self.ViewPanel[1].FilterList:GetValue()==Turbine.Gameplay.ItemCategory.Undefined and showUndefined==true)) and (self.ViewPanel[1].SearchText:GetText()=="" or string.find(string.lower(tostring(tmpInventory[index][5])),string.lower(self.ViewPanel[1].SearchText:GetText()),nil,true)~=nil ) then
								if newRow then
									newRow=false;
									if displayRow<=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItemCount() then 
										tmpRow=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(displayRow);
									else
										tmpRow=Turbine.UI.Control();
										tmpRow:SetLeft(1);
										self.ViewPanel[1].InventoryListBackground.InventoryList:AddItem(tmpRow);
									end
									tmpRow:SetBackColor(self.ViewPanel[1].InventoryListBackground:GetBackColor());
									tmpRow:SetSize(self.ViewPanel[1].InventoryListBackground.InventoryList:GetWidth()-2,32);
									tmpRow.DefaultHeight=32;
									tmpRow.Separator=false;
								else
									tmpRow=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(displayRow);
								end
								self.ItemControl[index]:SetParent(tmpRow);
								self.ItemControl[index]:SetPosition((elementWidth+1)*(displayCol)-1,-3);
								self.ItemIcon[index]:SetParent(tmpRow);
								self.ItemIcon[index]:SetPosition(2+(elementWidth+1)*(displayCol),0);
								self.ItemCol[index]:SetParent(tmpRow);
								self.QtyCol[index]:SetParent(tmpRow);
								if (characterName==currentCharacterName) then
									self.ItemControl[index]:SetSize(34,34);

									local tmpItem=self.Backpack:GetItem(tmpInventory[index][1])
									if tmpItem~=nil then
										tmpItem.Row=tmpRow;
										tmpItem.BackpackIndex=tmpInventory[index][1];
										AddCallback(tmpItem,"QuantityChanged",QuantityChanged);
									end
									self.ItemControl[index]:SetItem(tmpItem);
									self.ItemIcon[index]:SetSize(0,32);
									self.ItemIcon[index]:SetPosition(0,0);
									self.ItemIcon[index]:SetBackground(0);
									self.ItemIcon[index].IconImage:SetSize(0,32);
									self.ItemIcon[index].IconImage:SetPosition(0,0);
									self.ItemIcon[index].IconImage:SetBackground(0);
								else
									if tmpInventory[index][8]~=nil and tmpInventory[index][8]~=0 then
										-- create the icon image...
										self.ItemIcon[index]:SetSize(32,32);
										self.ItemIcon[index]:SetBackground(tmpInventory[index][8]);
										self.ItemIcon[index].IconImage:SetSize(32,32);
										self.ItemIcon[index].IconImage:SetPosition(0,0);
										self.ItemIcon[index].IconImage:SetBackground(tmpInventory[index][9]);
										self.ItemIcon[index].QtyText:SetText("");
										if tmpInventory[index][6]~=nil and tmpInventory[index][6]>1 then
											self.ItemIcon[index].QtyText:SetSize(32,27);
											self.ItemIcon[index].QtyText:SetPosition(0,0);
											if tmpInventory[index][6]<10000 then
												self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
											else
												self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
											end
											self.ItemIcon[index].QtyText:SetText(tmpInventory[index][6].." ");
										end
									end
									self.ItemControl[index]:SetItem(nil);
									self.ItemControl[index]:SetSize(0,0);
								end

								displayCol=displayCol+1;
								if displayCol>=maxCols then
									newRow=true;
									displayCol=0;
									displayRow=displayRow+1;
								end
							end
						else
							-- we need to hide the prior view of this item index
							self.ItemControl[index]:SetItem(nil);
							self.ItemControl[index]:SetSize(0,0);
						end
					else
						-- view=1 or 2
						if not(tmpInventory[index][5]==nil or tmpInventory[index][5]=="") then
							self.Filled=self.Filled+1;
							if (self.ViewPanel[1].FilterList:GetValue()==-1 or (tmpInventory[index][13]~=nil and tmpInventory[index][13]==self.ViewPanel[1].FilterList:GetValue()) or (self.ViewPanel[1].FilterList:GetValue()==Turbine.Gameplay.ItemCategory.Undefined and showUndefined==true)) and (self.ViewPanel[1].SearchText:GetText()=="" or string.find(string.lower(tostring(tmpInventory[index][5])),string.lower(self.ViewPanel[1].SearchText:GetText()),1,true)~=nil ) then
								if newRow then
									newRow=false;
									if displayRow<=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItemCount() then 
										tmpRow=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(displayRow);
									else
										tmpRow=Turbine.UI.Control();
										tmpRow:SetLeft(1);
										self.ViewPanel[1].InventoryListBackground.InventoryList:AddItem(tmpRow);
									end
									tmpRow.Separator=false;
								else
									tmpRow=self.ViewPanel[1].InventoryListBackground.InventoryList:GetItem(displayRow);
								end
								self.ItemCol[index]:SetParent(tmpRow);
								self.QtyCol[index]:SetParent(tmpRow);
								if self.View==1 then
									self.ItemCol[index]:SetMultiline(false);
									self.ItemCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
									self.QtyCol[index]:SetSize(40,17);
									self.QtyCol[index]:SetLeft((elementWidth+1)*(displayCol))
									self.ItemCol[index]:SetLeft((elementWidth+1)*(displayCol)+42);
									self.ItemCol[index]:SetSize(elementWidth-42,17);
								else
									self.ItemCol[index]:SetMultiline(true);
									self.ItemCol[index]:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft);
									self.QtyCol[index]:SetSize(0,17);
									self.QtyCol[index]:SetLeft((elementWidth+1)*(displayCol))
									self.ItemCol[index]:SetLeft((elementWidth+1)*(displayCol)+33);
									self.ItemCol[index]:SetSize(elementWidth-33,31);
								end
								tmpRow:SetBackColor(self.ViewPanel[1].InventoryListBackground:GetBackColor());
								tmpRow:SetSize(self.ViewPanel[1].InventoryListBackground.InventoryList:GetWidth()-2,18);
								tmpRow.DefaultHeight=18;
								tmpRow.WearState=0;

								-- default the row cell widths to the size without images
								self.ItemControl[index]:SetParent(tmpRow);
								self.ItemControl[index]:SetSize(0,34);
								self.ItemControl[index]:SetPosition((elementWidth+1)*(displayCol)-3,-3);
								self.ItemIcon[index]:SetParent(tmpRow);
								self.ItemIcon[index]:SetSize(0,32);
								self.ItemIcon[index]:SetPosition((elementWidth+1)*(displayCol)-2,0);
								self.ItemIcon[index]:SetBackground(0);
								self.ItemIcon[index].IconImage:SetSize(0,32);
								self.ItemIcon[index].IconImage:SetPosition(0,0);
								self.ItemIcon[index].IconImage:SetBackground(0);

								if (characterName==currentCharacterName) then
									-- adjust the fields to make room for the icon
									local tmpItem=self.Backpack:GetItem(tmpInventory[index][1])
									if tmpItem~=nil then
										tmpItem.Row=tmpRow
										tmpItem.BackpackIndex=tmpInventory[index][1]
										AddCallback(tmpItem,"QuantityChanged",QuantityChanged);
									end
									self.ItemControl[index]:SetItem(tmpItem);
									if self.View==2 then
										self.ItemControl[index]:SetWidth(34);
										tmpRow:SetHeight(32);
										tmpRow.DefaultHeight=32;
									end
								end
	
								self.ItemCol[index]:SetText("");
								self.QtyCol[index]:SetText("");
								if tmpInventory[index][5]==nil or tmpInventory[index][5]=="" then
									-- blank item
									self.ItemCol[index]:SetText("");
									tmpRow:SetHeight(0);
									self.ItemCol[index]:SetHeight(0);
									self.QtyCol[index]:SetHeight(0);
									tmpRow.DefaultHeight=0;
									self.ItemControl[index]:SetSize(0,0);
									self.ItemIcon[index]:SetSize(0,0);
									self.ItemIcon[index].IconImage:SetSize(0,0);
								else
									if (characterName~=currentCharacterName) and tmpInventory[index][8]~=nil and tmpInventory[index][8]~=0 and self.View==2 then
										-- create the icon image...
										self.ItemIcon[index]:SetSize(32,32);
										self.ItemIcon[index]:SetPosition((elementWidth+1)*(displayCol)-2,0);
										self.ItemIcon[index]:SetBackground(tmpInventory[index][8]);
										self.ItemIcon[index].IconImage:SetSize(32,32);
										self.ItemIcon[index].IconImage:SetPosition(0,0);
										self.ItemIcon[index].IconImage:SetBackground(tmpInventory[index][9]);
										self.ItemIcon[index].QtyText:SetText("");
										if tmpInventory[index][6]~=nil and tmpInventory[index][6]>1 then
											self.ItemIcon[index].QtyText:SetSize(32,27);
											self.ItemIcon[index].QtyText:SetPosition(0,0);
											if tmpInventory[index][6]<10000 then
												self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
											else
												self.ItemIcon[index].QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
											end
											self.ItemIcon[index].QtyText:SetText(tmpInventory[index][6].." ");
										end
										tmpRow:SetHeight(32);
										tmpRow.DefaultHeight=32;
									end
									self.ItemCol[index]:SetText(tmpInventory[index][5]);
									if tmpInventory[index][13]~=nil then
										tmpCategory=tonumber(tmpInventory[index][13]);
									else
										tmpCategory=0;
									end
									if tmpInventory[index][2]~=nil then
										tmpDurability=tonumber(tmpInventory[index][2]);
									else
										tmpDurability=0;
									end
									if tmpInventory[index][3]~=nil then
										tmpQuality=tonumber(tmpInventory[index][3]);
									else
										tmpQuality=0;
									end
									if tmpInventory[index][4]~=nil then
										tmpRow.WearState=tonumber(tmpInventory[index][4]);
									else
										tmpRow.WearState=0;
									end
									if tmpInventory[index][6]~=nil and tmpInventory[index][6]~=0 then
										self.QtyCol[index]:SetText(tmpInventory[index][6]);
									else
										self.QtyCol[index]:SetText("");
									end
								end

								if tmpQuality==Turbine.Gameplay.ItemQuality.Common then
									self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.95,.95,.95));
								elseif tmpQuality==Turbine.Gameplay.ItemQuality.Incomparable then
									self.ItemCol[index]:SetForeColor(Turbine.UI.Color(0,.8,.75));
								elseif tmpQuality==Turbine.Gameplay.ItemQuality.Legendary then
									self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.8,.5,.2));
								elseif tmpQuality==Turbine.Gameplay.ItemQuality.Rare then
									self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.75,0,.75));
								elseif tmpQuality==Turbine.Gameplay.ItemQuality.Uncommon then
									self.ItemCol[index]:SetForeColor(Turbine.UI.Color(.75,.85,.1));
								end
								tmpRow.DataValue=tmpCategory;
								if (characterName==Resource[language][29].." ") then
									self.ItemCol[index].MouseEnter=function(sender,args)
										self.ItemHoverTimer=Turbine.Engine.GetGameTime()+.5;
										self.ItemCol[index]:SetWantsUpdates(true)
									end
									self.ItemCol[index].Update=function(sender,args)
										if Turbine.Engine.GetGameTime()>self.ItemHoverTimer then
											self.ItemCol[index]:SetWantsUpdates(false);
											local tmpMenu=self.QuantityMenu:GetItems()
											local tmpItem=nil;
											local menuIndex=1;
											local menuItem=nil;
											tmpMenu:Clear();
												for menuIndex=1,#tmpInventory[index][7] do
												tmpItem=Turbine.UI.MenuItem();
												tmpItem:SetText(characterListArray[tmpInventory[index][7][menuIndex][1]][1].." "..tmpInventory[index][7][menuIndex][2]);
												tmpItem:SetEnabled(false);
												tmpMenu:Add(tmpItem);
											end
											self.QuantityMenu:ShowMenu();
										end
									end
									self.ItemCol[index].MouseLeave=function(sender,args)
										self.ItemCol[index]:SetWantsUpdates(false)
									end
									-- the popup for detail info
									self.ItemCol[index].MouseClick=function(sender,args)
										if args.Button==2 then
											self.TrackMenu:GetItems():Get(1):SetEnabled(trackWindow:CharListIndexOf(tmpInventory[index][5])==0);
											self.TrackMenu:GetItems():Get(2):SetEnabled(not self.TrackMenu:GetItems():Get(1):IsEnabled());
											self.TrackMenu:GetItems():Get(4):SetEnabled(trackWindow:AllListIndexOf(tmpInventory[index][5])==0);
											self.TrackMenu:GetItems():Get(5):SetEnabled(not self.TrackMenu:GetItems():Get(4):IsEnabled());
											self.TrackMenu:GetItems():Get(1).Click=function()
												trackWindow:CharAddItem(tmpInventory[index][5]);
											end
											self.TrackMenu:GetItems():Get(2).Click=function()
												trackWindow:CharRemoveItem(tmpInventory[index][5]);
											end
											self.TrackMenu:GetItems():Get(4).Click=function()
												trackWindow:AllAddItem(tmpInventory[index][5]);
											end
											self.TrackMenu:GetItems():Get(5).Click=function()
												trackWindow:AllRemoveItem(tmpInventory[index][5]);
											end
											self.TrackMenu:ShowMenu()
										else
											local tmpMenu=self.QuantityMenu:GetItems()
											local tmpItem=nil;
											local menuIndex=1;
											local menuItem=nil;
											tmpMenu:Clear();

											for menuIndex=1,#tmpInventory[index][7] do
												tmpItem=Turbine.UI.MenuItem();
												tmpItem:SetText(characterListArray[tmpInventory[index][7][menuIndex][1]][1].." "..tmpInventory[index][7][menuIndex][2]);
												tmpItem:SetEnabled(false);
												tmpMenu:Add(tmpItem);
											end
											self.QuantityMenu:ShowMenu();
										end
									end
									self.QtyCol[index].MouseClick=function(sender,args)
										local tmpMenu=self.QuantityMenu:GetItems()
										local tmpItem=nil;
										local menuIndex=1;
										local menuItem=nil;
										tmpMenu:Clear();
										for menuIndex=1,#tmpInventory[index][7] do
											tmpItem=Turbine.UI.MenuItem();
											tmpItem:SetText(characterListArray[tmpInventory[index][7][menuIndex][1]][1].." "..tmpInventory[index][7][menuIndex][2]);
											tmpItem:SetEnabled(false);
											tmpMenu:Add(tmpItem);
										end
										self.QuantityMenu:ShowMenu();
									end

									self.QtyCol[index].MouseEnter=function(sender,args)
										self.ItemHoverTimer=Turbine.Engine.GetGameTime()+.5;
										self.QtyCol[index]:SetWantsUpdates(true)
									end
									self.QtyCol[index].Update=function(sender,args)
										if Turbine.Engine.GetGameTime()>self.ItemHoverTimer then
											self.QtyCol[index]:SetWantsUpdates(false);
											local tmpMenu=self.QuantityMenu:GetItems()
											local tmpItem=nil;
											local menuIndex=1;
											local menuItem=nil;
											tmpMenu:Clear();
											for menuIndex=1,#tmpInventory[index][7] do
												tmpItem=Turbine.UI.MenuItem();
												tmpItem:SetText(characterListArray[tmpInventory[index][7][menuIndex][1]][1].." "..tmpInventory[index][7][menuIndex][2]);
												tmpItem:SetEnabled(false);
												tmpMenu:Add(tmpItem);
											end
											self.QuantityMenu:ShowMenu();
										end
									end
									self.QtyCol[index].MouseLeave=function(sender,args)
										self.QtyCol[index]:SetWantsUpdates(false)
									end
								else -- {if (characterName==Resource[language][29].." ") then}
									self.ItemCol[index].MouseClick=function(sender,args)
										if args.Button==2 then
											self.TrackMenu:GetItems():Get(1):SetEnabled(trackWindow:CharListIndexOf(tmpInventory[index][5])==0);
											self.TrackMenu:GetItems():Get(2):SetEnabled(not self.TrackMenu:GetItems():Get(1):IsEnabled());
											self.TrackMenu:GetItems():Get(4):SetEnabled(trackWindow:AllListIndexOf(tmpInventory[index][5])==0);
											self.TrackMenu:GetItems():Get(5):SetEnabled(not self.TrackMenu:GetItems():Get(4):IsEnabled());
											self.TrackMenu:GetItems():Get(1).Click=function()
												trackWindow:CharAddItem(tmpInventory[index][5]);
											end
											self.TrackMenu:GetItems():Get(2).Click=function()
												trackWindow:CharRemoveItem(tmpInventory[index][5]);
											end
											self.TrackMenu:GetItems():Get(4).Click=function()
												trackWindow:AllAddItem(tmpInventory[index][5]);
											end
											self.TrackMenu:GetItems():Get(5).Click=function()
												trackWindow:AllRemoveItem(tmpInventory[index][5]);
											end
											self.TrackMenu:ShowMenu()
										end
									end
								end -- {if (characterName==Resource[language][29].." ") then}

								displayCol=displayCol+1;
								if displayCol>=maxCols then
									newRow=true;
									displayCol=0;
									displayRow=displayRow+1;
								end
							end
						end
					end -- {if self.View==3}
				end -- end for index=1,#tmpInventory do
				self.ViewPanel[1].InventoryListBackground.InventoryList:SetVerticalScrollBar(self.ViewPanel[1].InventoryListBackground.InventoryList.VScrollBar)
				if characterName==Resource[language][29].." " then
					self.CapacityPanel.Display:SetText("N/A")
					self.CapacityPanel:SetVisible(false);
				else
					self.CapacityPanel.Display:SetText(Resource[language][22].." ("..self.Filled.."/"..self.Capacity..")")
					self.CapacityPanel:SetSize(self.CapacityPanel.MaxWidth*(self.Filled/self.Capacity),17);
					self.CapacityPanel:SetBackColor(Turbine.UI.Color(0,.3,0))
					if (self.Filled/self.Capacity)>=.75 then
						self.CapacityPanel:SetBackColor(Turbine.UI.Color(.3,0,0))
					elseif (self.Filled/self.Capacity)>=.5 then
						self.CapacityPanel:SetBackColor(Turbine.UI.Color(.75,.65,0))
					end
					self.CapacityPanel:SetVisible(true);
				end
			end -- {if (tmpInventory~=nil) then}
			self.LoadingInventory=false;
		end
	end

	self.KeyDown=function(sender, args)
--Turbine.Shell.WriteLine("KeyDown Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			minimalWindow:SetVisible( false );
			inventoryWindow:SetVisible( false );
			minWindow:SetVisible( true );
		end
		if ( args.Action == 268435579 ) then -- reposition UI
-- need to show a "move" tab on the top of the minimized icon
-- and display/hide the minimized icon
-- show a "move" tab for the minimal window too?
		end

		if ( args.Action == 268435635 ) then -- toggle HUD
			hudVisible=not hudVisible;
			if hudVisible then
				inventoryWindow:SetVisible(mainVisible);
				minimalWindow:SetVisible(minVisible);
				minWindow:SetVisible(iconVisible);
			else
				mainVisible=inventoryWindow:IsVisible();
				minVisible=minimalWindow:IsVisible();
				iconVisible=minWindow:IsVisible();
				inventoryWindow:SetVisible(false);
				minimalWindow:SetVisible(false);
				minWindow:SetVisible(false);
			end
		end
		if self.ReplaceBags and ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 )
		then
			if inventoryWindow.MinimalHeader then
				minimalWindow:SetVisible(not minimalWindow:IsVisible());
				minWindow:SetVisible(not minimalWindow:IsVisible());
			else
				inventoryWindow:SetVisible(not inventoryWindow:IsVisible());
				minWindow:SetVisible(not inventoryWindow:IsVisible());
			end
		end
	end


	AddCallback(self.Backpack,"ItemAdded",BackpackItemAdded)
	AddCallback(self.Backpack,"ItemRemoved",BackpackItemRemoved)
	AddCallback(self.Backpack,"ItemMoved",BackpackItemMoved)
	AddCallback(self.Equipment,"ItemEquipped",EquipmentItemEquipped)
	AddCallback(self.Equipment,"ItemUnequipped",EquipmentItemUnequipped)

	self.SetHeight=function(sender,height)
		if height<297 then height=297 end;
		Turbine.UI.Lotro.Window.SetHeight(self,height);
		self:SetSize(self:GetWidth(),height)
		-- now move/resize all the controls
		local panelIndex;
		for panelIndex=1,#self.ViewPanel do
			self.ViewPanel[panelIndex]:SetHeight(height-183);
		end
		self.InvalidPanel:SetHeight(height-183);
		self.BottomPanelTiled:SetTop(height-47);
		self.BottomPanelLeft:SetTop(height-47);
		self.BottomPanelCenter:SetTop(height-47);
		self.BottomPanelRight:SetTop(height-47);
		self.MovingIcon:SetTop(height-21);
		self.OptionsButton:SetTop(self.BottomPanelLeft:GetTop()+4);
		self.TrackingButton:SetTop(self.BottomPanelLeft:GetTop()+4);
	end

	self.SetWidth=function(sender,width)
		-- in minimal mode, the width is already padded 10 pixels to account for normal mode, so just leave it.
		if width<414 then width=414 end;
		Turbine.UI.Lotro.Window.SetWidth(self,width);
		if language==1 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
		elseif language==2 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
		else
			self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
		end
		self.TopPanelTiled:SetWidth(width-30);
		self.TopPanelCenter:SetLeft((self:GetWidth()-self.TopPanelCenter:GetWidth())/2-3);
		self.TopPanelRight:SetLeft(self:GetWidth()-self.TopPanelRight:GetWidth()-5);

		local panelIndex;
		for panelIndex=1,#self.ViewPanel do
			self.ViewPanel[panelIndex]:SetWidth(width-10);
		end
		self.InvalidPanel:SetWidth(width-10);

		self.CharacterList:SetSize(self:GetWidth()-(self.SelCaption:GetWidth()+self.SelCaption:GetLeft())-65,self.CharacterList:GetHeight());
		self.RemoveCharButton:SetLeft(self.CharacterList:GetLeft()+self.CharacterList:GetWidth()+12);

		self.CapacityPanel:SetLeft((self:GetWidth()-self.CapacityPanel.MaxWidth)/2);
		self.CapacityPanel.Empty:SetLeft(self.CapacityPanel:GetLeft()+3)
		self.CapacityPanel.Full:SetLeft(self:GetWidth()-self.CapacityPanel.Empty:GetLeft()-self.CapacityPanel.Full:GetWidth()-6,64)
		self.CapacityPanel.Display:SetLeft((self:GetWidth()-self.CapacityPanel.Display:GetWidth())/2)

		local vbleft=(self:GetWidth()-32*#self.ViewButton-4*(#self.ViewButton-1))/2;
		local tmpIndex;
		for tmpIndex=1,#self.ViewButton do
			self.ViewButton[tmpIndex]:SetLeft(vbleft+(tmpIndex-1)*36);
		end
		self.WalletPanel:SetLeft((self:GetWidth()-self.WalletPanel:GetWidth())/2);

		self.BottomPanelTiled:SetWidth(self:GetWidth()-20);
		self.BottomPanelCenter:SetLeft((self:GetWidth()-self.BottomPanelCenter:GetWidth())/2+1);
		self.BottomPanelRight:SetLeft(self:GetWidth()-self.BottomPanelRight:GetWidth()-4);
		self.MovingIcon:SetLeft(width-21);
		self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
	end

	self.MouseDown=function(sender,args)
		if (args.Y>self:GetHeight()-15) and (args.X>self:GetWidth()-15) then
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetBackground(0x41007e20)
			self.MovingIcon:SetVisible(true);
		elseif (args.Y>self:GetHeight()-12) then
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-22);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetBackground(0x410081c0)
			self.MovingIcon:SetVisible(true);
		elseif (args.X>self:GetWidth()-12) then
			self.MoveX=args.X;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-22);
			self.MovingIcon:SetBackground(0x410081bf)
			self.MovingIcon:SetVisible(true);
		else
			self.MoveX=-1;
			self.MoveY=-1;
		end
	end

	self.MouseMove=function(sender,args)
		if (self.MoveY>-1) then
			if args.Y~= self.MoveY then
				local newHeight=self:GetHeight()-(self.MoveY-args.Y);
				if newHeight<215 then newHeight=215 end;
				if newHeight>(Turbine.UI.Display.GetHeight()-self:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-self:GetTop() end;
				local newX=args.X-22;
				if newX<-13 then newX=-13 end
				if newX>(self:GetWidth()-18) then newX=self:GetWidth()-18 end
				self.MovingIcon:SetLeft(newX);
				self:SetHeight(newHeight);
				self.MoveY=args.Y;
			end
		end
		if (self.MoveX>-1) then
			if args.X~= self.MoveX then
				local newWidth=self:GetWidth()-(self.MoveX-args.X);
				if newWidth<414 then newWidth=414 end;
				if newWidth>(Turbine.UI.Display.GetWidth()-self:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-self:GetLeft() end;
				local newY=args.Y-22;
				if newY<-13 then newY=-13 end
				if newY>(self:GetHeight()-18) then newY=self:GetHeight()-18 end
				self.MovingIcon:SetTop(newY);
				self:SetWidth(newWidth);
				self.MoveX=args.X;
			end
		end
	end
	self.MouseUp=function(sender,args)
		self.MovingIcon:SetVisible(false);
		self.MoveX=-1;
		self.MoveY=-1;
	end
	self.OptionsButton=Turbine.UI.Control();
	self.OptionsButton:SetParent(self);
	self.OptionsButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options.tga");
	self.OptionsButton:SetSize(32,32);
	self.OptionsButton:SetTop(self.BottomPanelLeft:GetTop()+4);
	self.OptionsButton:SetLeft(self.BottomPanelLeft:GetLeft()+18);
	self.OptionsButton.MouseEnter = function()
		self.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options_hover.tga");
	end
	self.OptionsButton.MouseLeave = function()
		self.OptionsButton:SetBackground("GaranStuff/AltInventory/Resources/options.tga");
	end
	self.OptionsButton.MouseClick=function()
		optWindow:SetVisible(true);
	end

	self.TrackingButton=Turbine.UI.Control();
	self.TrackingButton:SetParent(self);
	self.TrackingButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.TrackingButton:SetBackground("GaranStuff/AltInventory/Resources/itemtrack.tga");
	self.TrackingButton:SetSize(32,32);
	self.TrackingButton:SetTop(self.BottomPanelLeft:GetTop()+4);
	self.TrackingButton:SetLeft(self.BottomPanelLeft:GetLeft()+55);
	self.TrackingButton.MouseEnter = function()
		self.TrackingButton:SetBackground("GaranStuff/AltInventory/Resources/itemtrack_hover.tga");
	end
	self.TrackingButton.MouseLeave = function()
		self.TrackingButton:SetBackground("GaranStuff/AltInventory/Resources/itemtrack.tga");
	end
	self.TrackingButton.MouseClick=function()
		trackWindow:SetVisible(true);
	end

-- set ZOrder so that the drop downs can cover other items, etc
	self.ViewPanel[5]:SetZOrder(1);
	self.ViewPanel[4]:SetZOrder(1);
	self.ViewPanel[3]:SetZOrder(1);
	self.ViewPanel[2]:SetZOrder(2);
	self.ViewPanel[1]:SetZOrder(3);
	self.TopPanelCenter:SetZOrder(8);
	self.TitleIcon:SetZOrder(9);
	self.BottomPanelTiled:SetZOrder(10);
	self.BottomPanelLeft:SetZOrder(11);
	self.BottomPanelCenter:SetZOrder(12);
	self.BottomPanelRight:SetZOrder(13);
	self.OptionsButton:SetZOrder(14);
	self.TrackingButton:SetZOrder(15);
	self.MovingIcon:SetZOrder(17);
	self.SelCaption:SetZOrder(18);
	self.CapacityPanel:SetZOrder(20);
	self.CapacityPanel.Empty:SetZOrder(22)
	self.CapacityPanel.Display:SetZOrder(24);
	self.CapacityPanel.Full:SetZOrder(26)
	local tmpvb
	for tmpvb=1,#self.ViewButton do
		self.ViewButton[tmpvb]:SetZOrder(28);
	end
	self.WalletPanel:SetZOrder(28);
	self.CharacterList:SetZOrder(52);
	self.RemoveCharButton:SetZOrder(54);
	self.RemoveConfirmation:SetZOrder(56);

	self:SetWantsKeyEvents(true);
	self:SetWantsUpdates(true)

	self.RemoveShellCommands=function(sender,args)
		Turbine.Shell.RemoveCommand(self.shellCmd)
	end
	self.shellCmd=Turbine.ShellCommand();
	local numberOfCommandsRegistered = Turbine.Shell.AddCommand("AltInventory",self.shellCmd);

	self.shellCmd.Execute = function(sender, cmd, args)
		if (string.lower(cmd) == "altinventory") then
			if (string.lower(args)=="show") then
				minWindow:SetVisible(false);
				if self.MinimalHeader then
					minimalWindow:SetVisible(true);
				else
					self:SetVisible(true);
				end
			elseif (string.lower(args)=="hide") then
				minimalWindow:SetVisible(false);
				self:SetVisible(false);
				minWindow:SetVisible(true);
			elseif (string.lower(args)=="toggle") then
				if self.MinimalHeader then
					minimalWindow:SetVisible(not minimalWindow:IsVisible());
				else
					inventoryWindow:SetVisible(not inventoryWindow:IsVisible());
				end
				minWindow:SetVisible(not minWindow:IsVisible());
			else
				Turbine.Shell.WriteLine("usage:");
				Turbine.Shell.WriteLine("  /AltInventory show");
				Turbine.Shell.WriteLine("       Displays the Alt Inventory main window.");
				Turbine.Shell.WriteLine("  /AltInventory hide");
				Turbine.Shell.WriteLine("       Hides the Alt Inventory main window.");
				Turbine.Shell.WriteLine("  /AltInventory toggle");
				Turbine.Shell.WriteLine("       Toggles the Alt Inventory main window (shows it if it was hidden, hides it if it was showing).");
			end
		end
	end
	self.shellCmd.GetHelp = function(sender, cmd)
		return("usage:\n  /AltInventory show\n       Displays the Alt Inventory main window.\n  /AltInventory hide\n       Hides the Alt Inventory main window.\n  /AltInventory toggle\n       Toggles the Alt Inventory main window (shows it if it was hidden, hides it if it was showing).");
	end

	self.shellCmd.GetShortHelp = function(sender, cmd)
		return("AltInventory - usage: /AltInventory show | hide | toggle");
	end
	self.Closing=function()
	end

	self.SetReplaceBags=function(sender,value)
		self.ReplaceBags=value;
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, not self.ReplaceBags );
		Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, not self.ReplaceBags );
	end

	self.GetReplaceBags=function()
		return self.ReplaceBags;
	end

	self.GetShowIconWhenMinimized=function()
		return self.ShowIconWhenMinimized;
	end
	self.SetShowIconWhenMinimized=function(sender,value)
		self.ShowIconWhenMinimized=value;
		if value then
			minWindow:SetSize(32,32);
		else
			minWindow:SetSize(0,0);
		end
	end

	self.SetView=function(sender,value)
		self.View=value;
	end
	self.GetView=function()
		return self.View;
	end
	self.GetCharItemInfo=function(sender,itemName)
		-- get the quantity of the specified item for the current character
		local charIndex;
		local itemIndex;
		local node=nil;
		local totalQty=0;
		for charIndex=2,#inventoryArray do
			if characterListArray[charIndex][1]==currentCharacterName then
				for itemIndex=1,#inventoryArray[charIndex] do
					if inventoryArray[charIndex][itemIndex][5]==itemName then
						if inventoryArray[charIndex][itemIndex][6]==nil or inventoryArray[charIndex][itemIndex][6]==0 then
							totalQty=totalQty+1;
						else
							totalQty=totalQty+inventoryArray[charIndex][itemIndex][6];
						end
						node={inventoryArray[charIndex][itemIndex][5],inventoryArray[charIndex][itemIndex][6],{},inventoryArray[charIndex][itemIndex][8],inventoryArray[charIndex][itemIndex][9],inventoryArray[charIndex][itemIndex][10],inventoryArray[charIndex][itemIndex][11],inventoryArray[charIndex][itemIndex][12],inventoryArray[charIndex][itemIndex][13],inventoryArray[charIndex][itemIndex][3]};
					end
				end
			end
		end
		if node~=nil then
			node[2]=totalQty; -- might have had more than one stack...
		end
		return(node);
	end
	self.GetAllItemInfo=function(sender,itemName)
		-- returns a table with the first entry being the itemquantity, and the second entry being a table of all of the users and their qty's
		BuildAllInventory(); -- rebuild the inventory to get the current qty in case the current char has this item
		local itemIndex;
		local node=nil;
		for itemIndex=1,#inventoryArray[1] do
			if inventoryArray[1][itemIndex][5]==itemName then
				node={inventoryArray[1][itemIndex][5],inventoryArray[1][itemIndex][6],inventoryArray[1][itemIndex][7],inventoryArray[1][itemIndex][8],inventoryArray[1][itemIndex][9],inventoryArray[1][itemIndex][10],inventoryArray[1][itemIndex][11],inventoryArray[1][itemIndex][12],inventoryArray[1][itemIndex][13],inventoryArray[1][itemIndex][3]};
				if node[2]==nil or node[2]==0 then
					node[2]=1;
				end
			end
		end
		return(node);
	end
	self.SetTrimColor=function()
		self.CharacterList:SetBorderColor(trimColor);
		self.RemoveConfirmation:SetBackColor(trimColor);
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetTrimColor ~= nil then
				self.ViewPanel[tmpIndex]:SetTrimColor();
			end
		end
	end
	self.SetBackColor=function()
		self.CharacterList:SetBackColor(backColor);
		self.CharacterList:SetCurrentBackColor(backColor);
		self.RemoveConfirmation.Text:SetBackColor(backColor);
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetBackgroundColor ~= nil then
				self.ViewPanel[tmpIndex]:SetBackgroundColor();
			end
		end
	end
	self.SetListTextColor=function()
		self.CharacterList:SetTextColor( listTextColor );
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetListTextColor ~= nil then
				self.ViewPanel[tmpIndex]:SetListTextColor();
			end
		end
	end
	self.SetFontColor=function()
		self.SelCaption:SetForeColor(fontColor);
		self.RemoveConfirmation.Text:SetForeColor(fontColor);
		self.CapacityPanel.Display:SetForeColor(fontColor);
		-- Bag Separator columns
		local tmpIndex;
		for tmpIndex=1,#self.SeparatorCol do
			self.SeparatorCol[tmpIndex]:SetForeColor(fontColor);
		end
		self.GPText:SetForeColor(fontColor);
		self.SPText:SetForeColor(fontColor);
		self.CPText:SetForeColor(fontColor);

		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetFontColor ~= nil then
				self.ViewPanel[tmpIndex]:SetFontColor();
			end
		end
	end
	self.SetHeadingsColor=function()
		self.ViewPanel[3]:SetHeadingsColor();
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetHeadingsColor ~= nil then
				self.ViewPanel[tmpIndex]:SetHeadingsColor();
			end
		end
	end
	self.SetLanguage=function()
		classArray={{0,3,Resource[language][84]},{194,3,Resource[language][72]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][75]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][71]},{Turbine.Gameplay.Class.Captain,1,Resource[language][65]},{Turbine.Gameplay.Class.Champion,1,Resource[language][66]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][80]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][79]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][67]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][69]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][70]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][68]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][82]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][74]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][73]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][77]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][76]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][78]},{195,3,Resource[language][83]}};
		raceArray={{0,Resource[language][84]},{Turbine.Gameplay.Race.Dwarf,Resource[language][56]},{Turbine.Gameplay.Race.Elf,Resource[language][58]},{Turbine.Gameplay.Race.Hobbit,Resource[language][57]},{Turbine.Gameplay.Race.Man,Resource[language][55]},{66,Resource[language][61]},{7,Resource[language][59]},{12,Resource[language][62]},{6,Resource[language][60]},{27,Resource[language][63]}}
		self:SetText("      "..Resource[language][2].."      ");
		if language==1 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-104,5);
		elseif language==2 then
			self.TitleIcon:SetPosition(self:GetWidth()/2-119,5);
		else
			self.TitleIcon:SetPosition(self:GetWidth()/2-100,5);
		end
		self.SelCaption:SetText(Resource[language][15]..":");
		self.CapacityPanel.Empty:SetText(Resource[language][21]);
		self.CapacityPanel.Display:SetText(Resource[language][22].." ("..self.Filled.."/"..self.Capacity..")")
		self.CapacityPanel.Full:SetText(Resource[language][23]);
		self.CharacterList.ListData:GetItem(1):SetText(Resource[language][29].." ");
		if self.CharacterList.ListData:GetSelectedIndex()==1 then self.CharacterList.CurrentValue:SetText(Resource[language][29].." ") end;
		self.TrackMenu:GetItems():Get(1):SetText(Resource[language][42]);
		self.TrackMenu:GetItems():Get(2):SetText(Resource[language][43]);
		self.TrackMenu:GetItems():Get(4):SetText(Resource[language][44]);
		self.TrackMenu:GetItems():Get(5):SetText(Resource[language][45]);

		-- Bag Separator columns
		for tmpIndex=1,#self.SeparatorCol do
			self.SeparatorCol[tmpIndex]:SetText(Resource[language][256].." "..tmpIndex);
		end
		-- Minimal Window texts
		minimalWindow.MenuBar.OptMenu:SetText(Resource[language][49]);
		minimalWindow.MenuBar.TrackMenu:SetText(Resource[language][50]);
		minimalWindow.MenuBar.PanelMenu:SetText(Resource[language][54]);
		minimalWindow.DisplayMenu:GetItems():Get(1):SetText(Resource[language][51]);
		minimalWindow.DisplayMenu:GetItems():Get(2):SetText(Resource[language][52]);
		minimalWindow.DisplayMenu:GetItems():Get(3):SetText(Resource[language][53]);
		local tmpIndex;
		for tmpIndex=1,#self.ViewPanel do
			if self.ViewPanel[tmpIndex].SetLanguage ~= nil then
				self.ViewPanel[tmpIndex]:SetLanguage();
			end
		end
		self.ViewButton[1].HoverName=Resource[language][52];
		self.ViewButton[2].HoverName=Resource[language][51];
		self.ViewButton[3].HoverName=Resource[language][53];
		self.ViewButton[4].HoverName=Resource[language][323];
		self.ViewButton[5].HoverName=Resource[language][333];
		self.ViewButton[6].HoverName=Resource[language][335];
		self.ViewButton[7].HoverName=Resource[language][336];
	end
end

function AltInvWindow:SetLoadMinimized(value)
	if value==nil then value=false end;
	self.LoadMinimized=(value==true);
end
function AltInvWindow:GetLoadMinimized()
	return (self.LoadMinimized);
end
function AltInvWindow:SetMinimalHeader(value)
	if value==nil then value=false end;
	self.MinimalHeader=(value==true);
	if self.MinimalHeader then
		if inventoryWindow:IsVisible() then
			inventoryWindow.SelCaption:SetParent(minimalWindow);
			inventoryWindow.SelCaption:SetPosition(0,24);
			inventoryWindow.CharacterList:SetParent(minimalWindow);
			inventoryWindow.CharacterList:SetPosition(inventoryWindow.SelCaption:GetLeft()+inventoryWindow.SelCaption:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
			local panelIndex;
			for panelIndex=1,#inventoryWindow.ViewPanel do
				inventoryWindow.ViewPanel[panelIndex]:SetParent(minimalWindow);
				inventoryWindow.ViewPanel[panelIndex]:SetPosition(0,40);
			end
			inventoryWindow.RemoveCharButton:SetParent(minimalWindow);
			inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
			inventoryWindow.RemoveConfirmation:SetParent(minimalWindow);
			minimalWindow:SetPosition(inventoryWindow:GetPosition());
			minimalWindow:SetWidth(inventoryWindow:GetWidth());
			minimalWindow:SetHeight(inventoryWindow:GetHeight());
			-- we have to use the ancestor function to avoid triggering the minWindow and other problems from the overridden function
			Turbine.UI.Lotro.Window.SetVisible( inventoryWindow, false );
			minimalWindow:SetVisible(true);
		end
	else
		if minimalWindow:IsVisible() then
			minimalWindow:SetVisible(false);
			inventoryWindow.SelCaption:SetParent(inventoryWindow);
			inventoryWindow.SelCaption:SetPosition(15,39);
			inventoryWindow.CharacterList:SetParent(inventoryWindow);
			inventoryWindow.CharacterList:SetPosition(inventoryWindow.SelCaption:GetLeft()+inventoryWindow.SelCaption:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
			local panelIndex;
			for panelIndex=1,#inventoryWindow.ViewPanel do
				inventoryWindow.ViewPanel[panelIndex]:SetParent(inventoryWindow);
				inventoryWindow.ViewPanel[panelIndex]:SetPosition(5,139);
			end

			inventoryWindow.RemoveCharButton:SetParent(inventoryWindow);
			inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+12,inventoryWindow.CharacterList:GetTop());
			inventoryWindow.RemoveConfirmation:SetParent(inventoryWindow);
			inventoryWindow:SetPosition(minimalWindow:GetPosition());
			inventoryWindow:SetWidth(inventoryWindow:GetWidth());
			inventoryWindow:SetHeight(inventoryWindow:GetHeight());
			inventoryWindow:SetVisible(true);
		end
	end
end
function AltInvWindow:GetMinimalHeader()
	return (self.MinimalHeader);
end

function AltInvWindow:SetBagSeparator(value)
	if value==nil then value=false end;
	self.BagSeparator=(value==true);
end
function AltInvWindow:GetBagSeparator()
	return (self.BagSeparator);
end
function AltInvWindow:SetEnabled(state)
	self.CharacterList:SetEnabled(state);
	self.RemoveCharButton:SetMouseVisible(state);
	local panelIndex;
	for panelIndex=1,#self.ViewPanel do
		if self.ViewPanel[panelIndex].SetEnabled~=nil then
			self.ViewPanel[panelIndex]:SetEnabled(state)
		end
	end
	self.OptionsButton:SetMouseVisible(state);
	self.TrackingButton:SetMouseVisible(state);
end

function AltInvWindow:SetVisible(value)
	if self.MinimalHeader and minimalWindow~= nil then
		Turbine.UI.Window.SetVisible( minimalWindow, value );
	else
		Turbine.UI.Lotro.Window.SetVisible( self, value );
	end
	if ( value == true ) then
		if (self.CharacterList:GetText()==currentCharacterName) then self:LoadInventory(currentCharacterName) end;
	end
end

function AltInvWindow:Update( sender, args )
	if (Plugins["AltInventory"] ~= nil) and (not self.Loaded) then
		self.Loaded=true;
		Turbine.Shell.WriteLine("AltInventory "..Plugins["AltInventory"]:GetVersion()..Resource[language][47]);
		Plugins["AltInventory"].Unload = function(self,sender,args)
			UnloadPlugin();
		end
	end
	if self.NeedsRefresh==true then -- for some reason trying to use the value as a boolean sometimes fails.. must not be being set somewhere
		-- updates were just turned on so that we could handle an item quantity change asynchronously
		self:SetWantsUpdates(false);
		self.NeedsRefresh=false;
		self:LoadInventory(characterListArray[self.CharacterList:GetValue()][1]);
	end
end
function BuildCurrentInventory()
	local tmpBackpack=localPlayer:GetBackpack()
	local backpackSize=tmpBackpack:GetSize();
	local tmpInventory={};
	if (backpackSize~=nil) then
		local invIndex=1;
		local tmpItem;
		while (invIndex<=backpackSize) do
			tmpItem=tmpBackpack:GetItem(invIndex);
			if (tmpItem~=nil)then
				if tmpItem:GetName()==nil then
					tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
				else
					tmpInventory[invIndex]= {invIndex,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
				end
			else
				tmpInventory[invIndex]={invIndex,0,0,0,"",0,{},0,0,0,0,0,0};
			end
			invIndex=invIndex+1;
		end
	end
	for index=1, inventoryWindow.CharacterList.ListData:GetItemCount() do
		if (inventoryWindow.CharacterList.ListData:GetItem(index):GetText()==currentCharacterName) then
			inventoryArray[index]={};
			local tmpIndex;
			for tmpIndex=1,#tmpInventory do
				inventoryArray[index][tmpIndex]=tmpInventory[tmpIndex];
			end
		end
	end
end
function BuildAllInventory()
	-- note, inventoryArray[1] is ALWAYS the "ALL " entry
	-- each subvalue will be in the form {index,durability,quality,0,name,totqty,{{characterid,qty}...{characterid,qty}},BackgroundImageID,IconImageID,QualityImageID,ShadowImageID,UnderlayImageID,Category} where characterid is the index to characterListArray
	local charIndex,itemIndex,allIndex,charSubIndex;
	local found,tmpQty;
	inventoryArray[1]={};
	for charIndex=2,#characterListArray do
		for itemIndex=1,#inventoryArray[charIndex] do
			if  (inventoryArray[charIndex][itemIndex][5]~="") then
				tmpQty=0+inventoryArray[charIndex][itemIndex][6];
				if (tmpQty==0) then
					tmpQty=1;
				end
				-- we ignore blank items for this
				if #inventoryArray[1]==0 then
					-- first item of first char, just add it
					inventoryArray[1][1]={1,inventoryArray[charIndex][itemIndex][2],inventoryArray[charIndex][itemIndex][3],0,inventoryArray[charIndex][itemIndex][5],tmpQty,{{charIndex,tmpQty}},inventoryArray[charIndex][itemIndex][8],inventoryArray[charIndex][itemIndex][9],inventoryArray[charIndex][itemIndex][10],inventoryArray[charIndex][itemIndex][11],inventoryArray[charIndex][itemIndex][12],inventoryArray[charIndex][itemIndex][13]};
				else
					allIndex=1;
					found=false;
					-- check if the item already exists
					while (not found and allIndex<=#inventoryArray[1]) do
						if (inventoryArray[1][allIndex][5]==inventoryArray[charIndex][itemIndex][5]) then
							found=true;
						else
							allIndex=allIndex+1;
						end
					end
					if found then
						-- add the current number to the item total
						inventoryArray[1][allIndex][6]=inventoryArray[1][allIndex][6]+tmpQty;
						charSubIndex=1
						found=false
						while (not found and charSubIndex<=#inventoryArray[1][allIndex][7]) do
							if (inventoryArray[1][allIndex][7][charSubIndex][1]==charIndex) then
								found=true;
							else
								charSubIndex=charSubIndex+1;
							end
						end
						if found then
							inventoryArray[1][allIndex][7][charSubIndex][2]=inventoryArray[1][allIndex][7][charSubIndex][2]+tmpQty;
							--if so, add to the qty
						else
							inventoryArray[1][allIndex][7][#inventoryArray[1][allIndex][7]+1]={charIndex,tmpQty};
						end
						if (inventoryArray[1][allIndex][8]==nil or inventoryArray[1][allIndex][8]==0) then
							if inventoryArray[charIndex][itemIndex][8]~=nil and inventoryArray[charIndex][itemIndex][8]>0 then
								-- prior entries didn't have a valid icon but this one does, use it's icon instead
								inventoryArray[1][allIndex][8]=inventoryArray[charIndex][itemIndex][8];
								inventoryArray[1][allIndex][9]=inventoryArray[charIndex][itemIndex][9];
								inventoryArray[1][allIndex][10]=inventoryArray[charIndex][itemIndex][10];
								inventoryArray[1][allIndex][11]=inventoryArray[charIndex][itemIndex][11];
								inventoryArray[1][allIndex][12]=inventoryArray[charIndex][itemIndex][12];
								inventoryArray[1][allIndex][13]=inventoryArray[charIndex][itemIndex][13];
							end
						end
					else
						inventoryArray[1][#inventoryArray[1]+1]={#inventoryArray[1],inventoryArray[charIndex][itemIndex][2],inventoryArray[charIndex][itemIndex][3],0,inventoryArray[charIndex][itemIndex][5],tmpQty,{{charIndex,tmpQty}},inventoryArray[charIndex][itemIndex][8],inventoryArray[charIndex][itemIndex][9],inventoryArray[charIndex][itemIndex][10],inventoryArray[charIndex][itemIndex][11],inventoryArray[charIndex][itemIndex][12],inventoryArray[charIndex][itemIndex][13]};
					end
				end
			end
		end
	end
end

LoadData();

inventoryWindow=AltInvWindow();
minimalWindow=MinInvWindow();
minimalWindow:SetPosition(inventoryWindow:GetPosition());
minimalWindow:SetSize(inventoryWindow:GetSize());

minWindow=MinimizedWindow();
if inventoryWindow:GetShowIconWhenMinimized() then
	minWindow:SetSize(32,32);
else
	minWindow:SetSize(0,0);
end

trackWindow=TrackingWindow();
customThresholdWindow=CustomThresholdWindow();
if inventoryWindow.MinimalHeader then
-- need to move the characterlist and viewpanels to an minimal sized window and only show that
	inventoryWindow.SelCaption:SetParent(minimalWindow);
	inventoryWindow.SelCaption:SetPosition(0,24);
	inventoryWindow.CharacterList:SetParent(minimalWindow);
	inventoryWindow.CharacterList:SetPosition(inventoryWindow.SelCaption:GetLeft()+inventoryWindow.SelCaption:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
	local panelIndex;
	for panelIndex=1,#inventoryWindow.ViewPanel do
		inventoryWindow.ViewPanel[panelIndex]:SetParent(minimalWindow);
		inventoryWindow.ViewPanel[panelIndex]:SetPosition(0,40);
	end
	inventoryWindow.RemoveCharButton:SetParent(minimalWindow);
	inventoryWindow.RemoveCharButton:SetPosition(inventoryWindow.CharacterList:GetLeft()+inventoryWindow.CharacterList:GetWidth()+2,inventoryWindow.SelCaption:GetTop()-3);
	inventoryWindow.RemoveConfirmation:SetParent(minimalWindow);
	minimalWindow:SetWidth(inventoryWindow:GetWidth());
	minimalWindow:SetHeight(inventoryWindow:GetHeight());
end
if inventoryWindow.LoadMinimized then
	minWindow:SetVisible(true);
else
	if inventoryWindow.MinimalHeader then
		minimalWindow:SetVisible(true);
	else
		inventoryWindow:SetVisible(true);
	end
end

optWindow=OptionsWindow();

InitSelections()

inventoryWindow.ViewPanel[1].FilterList.CurrentValue:SetText(inventoryWindow.ViewPanel[1].FilterList.ListData:GetItem(1):GetText());
inventoryWindow.ViewPanel[1].FilterList.CurrentValue.DataValue=inventoryWindow.ViewPanel[1].FilterList.ListData:GetItem(1).DataValue;
inventoryWindow:LoadInventory(currentCharacterName);

trackWindow:SetZOrder(inventoryWindow:GetZOrder()+1);
customThresholdWindow:SetZOrder(trackWindow:GetZOrder()+1);
optWindow:SetZOrder(customThresholdWindow:GetZOrder()+1);

trackWindow:LoadData();

-- wallet money changed event handler
if enableAttributes then
	-- set the money event handler
	inventoryWindow.moneyChangedHandler = AddCallback(inventoryWindow.playerAttributes, "MoneyChanged", inventoryWindow.MoneyChanged)
end

-- get player changes
LevelChanged=function()
	characterListArray[currentCharIndex][2]=localPlayer:GetLevel();
end
BaseMaxMoraleChanged=function()
	characterListArray[currentCharIndex][3]=localPlayer:GetBaseMaxMorale();
end
BaseMaxPowerChanged=function()
	characterListArray[currentCharIndex][4]=localPlayer:GetBaseMaxPower();
end
AddCallback(localPlayer,"LevelChanged","LevelChanged")
AddCallback(localPlayer,"BaseMaxMoraleChanged","BaseMaxMoraleChanged")
AddCallback(localPlayer,"BaseMaxPowerChanged","BaseMaxPowerChanged")

--**** ItemUnequipped is firing BEFORE the Equipment list is updated so instead of refreshing the equipement list
--**** the ItemUnequipped event just enables the Update event handler so it refreshes asynchronously AFTER the ItemUnequipped event finishes
inventoryWindow.ViewPanel[2].Update=function()
	GetEquipment();
	if (inventoryWindow.CharacterList:GetText()==currentCharacterName) then
		inventoryWindow.ViewPanel[2]:LoadPanelData(currentCharacterName);
	end
	inventoryWindow.ViewPanel[2]:SetWantsUpdates(false);
end

--**** Turbine does not fire events for the other attributes :(
--**** we can temporarily handle this with a timed (1/second) refresh of the attributes
--**** this routine may cause excessive load when running in a raid so it is only enabled when the inventory window is visible
inventoryWindow.ViewPanel[3].timer=Turbine.Engine.GetGameTime()+1
inventoryWindow.ViewPanel[3].Update=function()
	if Turbine.Engine.GetGameTime()>=inventoryWindow.ViewPanel[3].timer then
		GetAttributes();
		inventoryWindow.ViewPanel[3]:LoadPanelData(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
		inventoryWindow.ViewPanel[3].timer=Turbine.Engine.GetGameTime()+1
	end
end
inventoryWindow.ViewPanel[3]:SetWantsUpdates(inventoryWindow.ViewPanel[3]:GetParent():IsVisible())

if dataLoadError then
	-- warn the user and give them the opportunity to exit without saving
end

-- apply scaling
if enableScaling then
	inventoryWindow:SetStretchMode(1);
	inventoryWindow:SetSize(inventoryWindow:GetWidth()*scaleMult,inventoryWindow:GetHeight()*scaleMult);
	minimalWindow:SetStretchMode(1);
	minimalWindow:SetSize(minimalWindow:GetWidth()*scaleMult,minimalWindow:GetHeight()*scaleMult);
end


-- inventory tables have the following structure
-- -- [1] index in backpack
-- -- [2] item durability
-- -- [3] item quality
-- -- [4] item wearstate
-- -- [5] item Name (singular name, we don't have access to plurals yet)
-- -- [6] item quantity
-- -- [7] table of individual quantities (only valid for AllItemArray
-- -- [7][x][1] Character Index - index into characterListArray
-- -- [7][x][2] Quantity
-- -- [8] icon background resource id
-- -- [9] icon image resource id
-- -- [10] icon quality resource id (not currently used)
-- -- [11] icon shadow resource id (not currently used)
-- -- [12] icon underlay image resource id (not currently used)
-- -- [13] image category

-- the character table has the following structure
-- -- [1]==Character Name
-- -- [2]=Level
-- -- [3]=Max Morale
-- -- [4]=Max Power
-- -- [5]=Race
-- -- [6]=Class
-- -- [7]=Race Attributes();
-- -- [8]=Class Attributes
-- -- [9]=Alignment(); -- 1=Freep
-- -- [10]=Vocation -- manually entered and maintained
-- -- [11]=attributes:GetMoney();
-- -- [12]=attributes:GetAcidMitigation();
-- -- [13]=attributes:GetAgility();
-- -- [14]=attributes:GetArmor();
-- -- [15]=attributes:GetBaseAgility();
-- -- [16]=attributes:GetBaseCriticalHitAvoidance();
-- -- [17]=attributes:GetBaseCriticalHitChance();
-- -- [18]=attributes:GetBaseFate();
-- -- [19]=attributes:GetBaseMight();
-- -- [20]=attributes:GetBaseResistance();
-- -- [21]=attributes:GetBaseVitality();
-- -- [22]=attributes:GetBaseWill();
-- -- [23]=attributes:GetBlock();
-- -- [24]=attributes:GetCommonMitigation();
-- -- [25]=attributes:GetDiseaseResistance();
-- -- [26]=attributes:GetEvade();
-- -- [27]=attributes:GetFate();
-- -- [28]=attributes:GetFearResistance();
-- -- [29]=attributes:GetFinesse();
-- -- [30]=attributes:GetFireMitigation();
-- -- [31]=attributes:GetFrostMitigation();
-- -- [32]=attributes:GetIncomingHealing();
-- -- [33]=attributes:GetLightningMitigation();
-- -- [34]=attributes:GetMeleeCriticalHitAvoidance();
-- -- [35]=attributes:GetMeleeCriticalHitChance();
-- -- [36]=attributes:GetMeleeDamage();
-- -- [37]=attributes:GetMeleeDefence();
-- -- [38]=attributes:GetMight();
-- -- [39]=attributes:GetOutgoingHealing();
-- -- [40]=attributes:GetParry();
-- -- [41]=attributes:GetPhysicalMitigation();
-- -- [42]=attributes:GetPoisonResistance();
-- -- [43]=attributes:GetRangeCriticalHitAvoidance();
-- -- [44]=attributes:GetRangeCriticalHitChance();
-- -- [45]=attributes:GetRangeDamage();
-- -- [46]=attributes:GetRangeDefence();
-- -- [47]=attributes:GetShadowMitigation();
-- -- [48]=attributes:GetTacticalCriticalHitAvoidance();
-- -- [49]=attributes:GetTacticalCriticalHitChance();
-- -- [50]=attributes:GetTacticalDamage();
-- -- [51]=attributes:GetTacticalDefence();
-- -- [52]=attributes:GetTacticalMitigation();
-- -- [53]=attributes:GetVitality();
-- -- [54]=attributes:GetWill();
-- -- [55]=attributes:GetWoundResistance();

--GaranStuff.AltInventory.Table.Dump(Turbine)
--testdialog=PopUpDialog("test1","just testing with a really long message to see how multiple lines are handled. let's see how it handles 3 lines. and now, the coup-de-gras, let's give it 4 lines :)",3,"abcdefghi","just testing","hmmmm")
--testdialog=PopUpDialog("test1","just testing",3,"abcdefghi","just testing","hmmmm")
--testdialog.Buttons[2].Click=function(sender)
--	Turbine.Shell.WriteLine("button 2 pressed");
--	sender:GetParent():SetVisible(false);
--end
-- if we had the itemID and name for items, we could create popups for the offline items
--<Examine:IIDDID:0x0000000000000000:0xitemID>[name]<\Examine>

--debugWindow=DebugWindow();
--debugWindow:SetVisible(true);
