MinimizedWindow = class(Turbine.UI.Window);
function MinimizedWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetVisible(false);
-- replace with an appropriate image
	self:SetBackground("GaranStuff/AltInventory/Resources/bags_up.jpg");
	self:SetSize(32,32);
	self:SetOpacity(.3);

	local left=1;
	local top=Turbine.UI.Display.GetHeight()-self:GetHeight()-1;
	local tmpSettings={};	
	tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "AltInventorySettings");
	if (tmpSettings~=nil) then
		local index;
		for index=1,#tmpSettings do
			if tmpSettings[index]~=nil then
				if (tmpSettings[index][1]=="MWTop") then
					top=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="MWLeft") then
					left=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="CWTop") then -- old version of settings
					top=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="CWLeft") then -- old version of settings
					left=tmpSettings[index][2];
				end
			end
		end
		-- account for changed resolution
		if left<0 then left=0 end;
		if left>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then left=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
		if top<0 then top=0 end;
		if top>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then top=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
	end
	self:SetPosition( left, top );

	self.MouseClick = function(sender,args)
		self:SetBackground("GaranStuff/AltInventory/Resources/bags_up.jpg");
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		else
			self:SetVisible(false);
			inventoryWindow:SetVisible(true);
		end
	end

	self.MoveX=-1;
	self.MoveY=0;
	self.Moving=false;

	self.MouseDown=function(sender,args)
		self:SetBackground("GaranStuff/AltInventory/Resources/bags_down.jpg");
		self.MoveX=args.X;
		self.MoveY=args.Y;
	end
	self.MouseUp=function(sender,args)
		self:SetBackground("GaranStuff/AltInventory/Resources/bags_up.jpg");
		self.MoveX=-1;
		self.MoveY=0;
	end

	self.MouseEnter=function(sender,args)
		self:SetOpacity(1);
	end

	self.MouseLeave=function(sender,args)
		self:SetOpacity(.3);
	end

	self.MouseMove=function(sender,args)
		if self.MoveX~=-1 and (args.X~=self.MoveX or args.Y~= self.MoveY) then
			self:SetBackground("GaranStuff/AltInventory/Resources/bags_drag.jpg");
			self.Moving=true;
			local newLeft=self:GetLeft()-(self.MoveX-args.X)
			local newTop=self:GetTop()-(self.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			self:SetPosition(newLeft,newTop);
		end
	end
	self.Flashing=false;
	self.FlashCount=0;
	self.FlashYellow=function()
		if not self.Flashing then
			self:SetWantsUpdates(true);
			self.Flashing=true;
			self.FlashCount=0;
			self.FlashBackground="GaranStuff/AltInventory/Resources/bags_yellow.jpg"
			self.FlashState=1;
			self.FlashTimer=Turbine.Engine:GetGameTime()+.2;
			self:SetBackground(self.FlashBackground);
			self:SetOpacity(1)
			self:SetVisible(true);
		end
	end
	self.FlashRed=function()
		if not self.Flashing then
			self:SetWantsUpdates(true);
			self.Flashing=true;
			self.FlashCount=0;
			self.FlashBackground="GaranStuff/AltInventory/Resources/bags_red.jpg"
			self.FlashState=1;
			self.FlashTimer=Turbine.Engine:GetGameTime()+.2;
			self:SetBackground(self.FlashBackground);
			self:SetOpacity(1)
			self:SetVisible(true);
		end
	end
	self.Update=function(sender,args)
		if self.Flashing then
			if Turbine.Engine:GetGameTime()>self.FlashTimer then
				if self.FlashState==0 then
					self:SetBackground(self.FlashBackground);
					self.FlashState=1;
					self.FlashTimer=Turbine.Engine:GetGameTime()+.2;
				else
					self:SetBackground("GaranStuff/AltInventory/Resources/bags_up.jpg");
					self.FlashCount=self.FlashCount+1;
					if self.FlashCount>3 then
						self.Flashing=false;
						self:SetOpacity(.3);
						self:SetWantsUpdates(false);
						if inventoryWindow:IsVisible() then
							self:SetVisible(false);
						end
					else
						self.FlashState=0;
						self.FlashTimer=Turbine.Engine:GetGameTime()+.2;
					end
				end
			end
		else
			self.SetWantsUpdates(false); -- turn updates off... no need to waste machine cycles on this
		end
	end
end       
