-- Free form notes per character

euroFormat=(tonumber("1,000")==1); -- redundant but harmless

function LoadData()
	-- load saved settings
	CharNotes=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_CharNotes");
	if CharNotes==nil then
		CharNotes={};
	end
end
LoadData()

NotesPanel=class(Turbine.UI.Control)
function NotesPanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);
	self:SetBackColor(backColor);
	self:SetSize(200,200);
	self.characterIndex=1;
	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end
	self.characterName=currentCharacterName;

	self.NoteCaption=Turbine.UI.Label();
	self.NoteCaption:SetParent(self);
	self.NoteCaption:SetSize(100,20);
	self.NoteCaption:SetPosition(0,0);
	self.NoteCaption:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.NoteCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.NoteCaption:SetText(Resource[language][333]);

	self.NotePad=Turbine.UI.Lotro.TextBox();
	self.NotePad:SetParent(self);
	self.NotePad:SetSize(200,200);
	self.NotePad:SetPosition(0,25);
	self.NotePad:SetMultiline(true);
	self.NotePad:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.NotePad:SetText(CharNotes[currentCharacterName]);

	self.NoteVScroll=Turbine.UI.Lotro.ScrollBar();
	self.NoteVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.NoteVScroll:SetParent(self);
	self.NoteVScroll:SetBackColor(backColor);
	self.NoteVScroll:SetPosition(self.NotePad:GetWidth(),25);
	self.NoteVScroll:SetWidth(12);
	self.NoteVScroll:SetHeight(200);
	self.NotePad:SetVerticalScrollBar(self.NoteVScroll);

	self:SetVisible(false);

	self.LoadPanelData=function(sender, characterName)
		if self.characterName~=nil then
			CharNotes[self.characterName]=self.NotePad:GetText();
		end
		self.characterName=characterName;
		-- routine to set the recipe lists and known recipes for the selected character
		self.NotePad:SetText(CharNotes[characterName]);
	end

	self.SaveData=function()
		if self.characterName~=nil then
			CharNotes[self.characterName]=self.NotePad:GetText();
		end
		PatchDataSave( Turbine.DataScope.Server, "AltInventory_CharNotes",CharNotes);
	end
	self.RemoveCallbacks=function()
	end
	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth();
		local newHeight=self:GetHeight();
		self.NotePad:SetSize(newWidth-12,newHeight-35);
		self.NoteVScroll:SetLeft(newWidth-12);
		self.NoteVScroll:SetHeight(newHeight-35);
		self.NoteCaption:SetWidth(newWidth);
	end
	self.SetLanguage=function()
		self.NoteCaption:SetText(Resource[language][333]);
	end
	self.SetTrimColor=function()
	end
	self.SetBackgroundColor=function()
	end
	self.SetListTextColor=function()
	end
	self.SetFontColor=function()
	end
	self.SetHeadingsColor=function()
	end
end
