import "GaranStuff.AltInventory.ColorPicker"
-- need to create the options window
OptionsWindow = class(Turbine.UI.Lotro.Window);
function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetText(Resource[language][3]);
	self:SetVisible(false);
	self:SetSize(450,675);
	self:SetPosition((Turbine.UI.Display:GetWidth() - self:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - self:GetHeight()) / 2);

	self.HadErrors=false;
	self.OptionsPanel=Turbine.UI.Control();
	self.OptionsPanel:SetParent(self);
	self.OptionsPanel:SetSize(self:GetWidth()-30,self:GetHeight()-80);
	self.OptionsPanel:SetPosition(15,40);
	self.OptionsPanel:SetBackColor(backColor);

	self.OptionsCaption=Turbine.UI.Label();
	self.OptionsCaption:SetParent(self.OptionsPanel);
	self.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.OptionsCaption:SetForeColor(headingsColor);
	self.OptionsCaption:SetSize(self.OptionsPanel:GetWidth(),20);
	self.OptionsCaption:SetPosition(0,0);
	self.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.OptionsCaption:SetText(Resource[language][4]..":");

	self.LanguageCaption=Turbine.UI.Label();
	self.LanguageCaption:SetParent(self.OptionsPanel);
	self.LanguageCaption:SetPosition(10,self.OptionsCaption:GetTop()+self.OptionsCaption:GetHeight()+9);
	self.LanguageCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LanguageCaption:SetForeColor(fontColor);
	self.LanguageCaption:SetText(Resource[language][5]..":");

	self.LanguageList=GaranStuff.AltInventory.DropDownList();
	self.LanguageList:SetParent(self.OptionsPanel);
	self.LanguageList:SetPosition(self.LanguageCaption:GetLeft()+self.LanguageCaption:GetWidth()+2,self.LanguageCaption.GetTop()-3);
	self.LanguageList:SetSize(self.OptionsPanel:GetWidth()-(self.LanguageCaption:GetWidth()+self.LanguageCaption:GetLeft())-65,20);
	self.LanguageList:SetBorderColor(trimColor);
	self.LanguageList:SetCurrentBackColor(colorDarkGrey);
	self.LanguageList:SetBackColor(backColor);
	self.LanguageList:SetCurrentBackColor(backColor);
	self.LanguageList:SetDropRows(5);

	local tmpLanguage;
	for tmpLanguage in pairs(Resource) do
		self.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	self.LanguageList.SelectedIndexChanged = function ()
		self:SetLanguage(self.LanguageList:GetValue());
	end

-- trim color
	self.TrimCaption=Turbine.UI.Label();
	self.TrimCaption:SetParent(self.OptionsPanel);
	self.TrimCaption:SetPosition(10,self.LanguageCaption:GetTop()+self.LanguageCaption:GetHeight()+9);
	self.TrimCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.TrimCaption:SetForeColor(fontColor);
	self.TrimCaption:SetText(Resource[language][6]..":");
	self.TrimColor=GaranStuff.AltInventory.ColorPicker();
	self.TrimColor:SetParent(self.OptionsPanel);
	self.TrimColor:SetPosition(self.TrimCaption:GetLeft()+self.TrimCaption:GetWidth()+5,self.TrimCaption:GetTop()-1);
	self.TrimColor:SetTrimColor(trimColor);
	self.TrimColor:SetColor(trimColor);
	self.TrimColor.ColorChanged=function()
		self:SetTrimColor(self.TrimColor:GetColor());
	end

	self.BackCaption=Turbine.UI.Label();
	self.BackCaption:SetParent(self.OptionsPanel);
	self.BackCaption:SetPosition(10,self.TrimColor:GetTop()+self.TrimColor:GetHeight()+9);
	self.BackCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.BackCaption:SetForeColor(fontColor);
	self.BackCaption:SetText(Resource[language][7]..":");
	self.BackColor=GaranStuff.AltInventory.ColorPicker();
	self.BackColor:SetParent(self.OptionsPanel);
	self.BackColor:SetPosition(self.BackCaption:GetLeft()+self.BackCaption:GetWidth()+5,self.BackCaption:GetTop()-1);
	self.BackColor:SetTrimColor(trimColor);
	self.BackColor:SetColor(backColor);
	self.BackColor.ColorChanged=function()
		self:SetBackColor(self.BackColor:GetColor());
	end

	self.FontCaption=Turbine.UI.Label();
	self.FontCaption:SetParent(self.OptionsPanel);
	self.FontCaption:SetPosition(10,self.BackColor:GetTop()+self.BackColor:GetHeight()+9);
	self.FontCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FontCaption:SetForeColor(fontColor);
	self.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
	self.FontColor=GaranStuff.AltInventory.ColorPicker();
	self.FontColor:SetParent(self.OptionsPanel);
	self.FontColor:SetPosition(self.FontCaption:GetLeft()+self.FontCaption:GetWidth()+5,self.FontCaption:GetTop()-1);
	self.FontColor:SetTrimColor(trimColor);
	self.FontColor:SetColor(fontColor);
	self.FontColor.ColorChanged=function()
		self:SetFontColor(self.FontColor:GetColor());
	end

	self.HeadingsCaption=Turbine.UI.Label();
	self.HeadingsCaption:SetParent(self.OptionsPanel);
	self.HeadingsCaption:SetPosition(10,self.FontColor:GetTop()+self.FontColor:GetHeight()+9);
	self.HeadingsCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.HeadingsCaption:SetForeColor(fontColor);
	self.HeadingsCaption:SetText(Resource[language][296]..":");
	self.HeadingsColor=GaranStuff.AltInventory.ColorPicker();
	self.HeadingsColor:SetParent(self.OptionsPanel);
	self.HeadingsColor:SetPosition(self.HeadingsCaption:GetLeft()+self.HeadingsCaption:GetWidth()+5,self.HeadingsCaption:GetTop()-1);
	self.HeadingsColor:SetTrimColor(trimColor);
	self.HeadingsColor:SetColor(headingsColor);
	self.HeadingsColor.ColorChanged=function()
		self:SetHeadingsColor(self.HeadingsColor:GetColor());
	end

	self.ListTextCaption=Turbine.UI.Label();
	self.ListTextCaption:SetParent(self.OptionsPanel);
	self.ListTextCaption:SetPosition(10,self.HeadingsColor:GetTop()+self.HeadingsColor:GetHeight()+9);
	self.ListTextCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ListTextCaption:SetForeColor(fontColor);
	self.ListTextCaption:SetText(Resource[language][297]..":");
	self.ListTextColor=GaranStuff.AltInventory.ColorPicker();
	self.ListTextColor:SetParent(self.OptionsPanel);
	self.ListTextColor:SetPosition(self.ListTextCaption:GetLeft()+self.ListTextCaption:GetWidth()+5,self.ListTextCaption:GetTop()-1);
	self.ListTextColor:SetTrimColor(trimColor);
	self.ListTextColor:SetColor(listTextColor);
	self.ListTextColor.ColorChanged=function()
		self:SetListTextColor(self.ListTextColor:GetColor());
	end

	self.ResetColors=Turbine.UI.Lotro.Button();
	self.ResetColors:SetParent(self.OptionsPanel);
	self.ResetColors:SetSize(160,20);
	self.ResetColors:SetPosition((self.OptionsPanel:GetWidth()-self.ResetColors:GetWidth())/2,self.ListTextColor:GetTop()+self.ListTextColor:GetHeight()+9);
	self.ResetColors:SetText(Resource[language][9]);
	self.ResetColors.Click=function()
		trimColor=Turbine.UI.Color(.2,.5,.9);
		fontColor=Turbine.UI.Color(1,.9,.5);
		backColor=Turbine.UI.Color(.05,.05,.05);
		headingsColor=Turbine.UI.Color(1,1,1);
		listTextColor=Turbine.UI.Color(1,1,1);
		self.TrimColor:SetColor(trimColor);
		self.FontColor:SetColor(fontColor);
		self.BackColor:SetColor(backColor);
		self.HeadingsColor:SetColor(headingsColor);
		self.ListTextColor:SetColor(listTextColor);
	end

	self.InventoryOptionsCaption=Turbine.UI.Label();
	self.InventoryOptionsCaption:SetParent(self.OptionsPanel);
	self.InventoryOptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.InventoryOptionsCaption:SetForeColor(headingsColor);
	self.InventoryOptionsCaption:SetSize(self.OptionsPanel:GetWidth(),20);
	self.InventoryOptionsCaption:SetPosition(0,self.ResetColors:GetTop()+self.ResetColors:GetHeight()+19);
	self.InventoryOptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.InventoryOptionsCaption:SetText(Resource[language][10]);

-- **** There's a MAJOR BUG with checkboxes, they don't always change Checked value when you click IN the box, only on the label :(
-- so we implement the base checkbox class and provide our own image that we can forward mouse clicks on to here...
-- yeah, it's hokey, but it works as a place holder until Turbine fixes their Checkboxes

--** Replace Bags
	self.ReplaceBagsCB=Turbine.UI.Lotro.CheckBox();
	self.ReplaceBagsCB:SetParent(self.OptionsPanel);
	self.ReplaceBagsCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ReplaceBagsCB:SetForeColor(fontColor);
	self.ReplaceBagsCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.ReplaceBagsCB:SetPosition(10,self.InventoryOptionsCaption:GetTop()+self.InventoryOptionsCaption:GetHeight()+4);
	self.ReplaceBagsCB:SetText(Resource[language][11]);


-- Load Minimized
	self.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
	self.LoadMinimizedCB:SetParent(self.OptionsPanel);
	self.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LoadMinimizedCB:SetForeColor(fontColor);
	self.LoadMinimizedCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.LoadMinimizedCB:SetPosition(10,self.ReplaceBagsCB:GetTop()+self.ReplaceBagsCB:GetHeight()+4);
	self.LoadMinimizedCB:SetText(Resource[language][12]);

-- Show Icon when Minimized
	self.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	self.ShowIconWhenMinimizedCB:SetParent(self.OptionsPanel);
	self.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ShowIconWhenMinimizedCB:SetForeColor(fontColor);
	self.ShowIconWhenMinimizedCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.ShowIconWhenMinimizedCB:SetPosition(10,self.LoadMinimizedCB:GetTop()+self.LoadMinimizedCB:GetHeight()+4);
	self.ShowIconWhenMinimizedCB:SetText(Resource[language][252]);

-- Minimal Header/Footer
	self.MinimalHeaderCB=Turbine.UI.Lotro.CheckBox();
	self.MinimalHeaderCB:SetParent(self.OptionsPanel);
	self.MinimalHeaderCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.MinimalHeaderCB:SetForeColor(fontColor);
	self.MinimalHeaderCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.MinimalHeaderCB:SetPosition(10,self.ShowIconWhenMinimizedCB:GetTop()+self.ShowIconWhenMinimizedCB:GetHeight()+4);
	self.MinimalHeaderCB:SetText(Resource[language][48]);

-- Bag Separator when sorting by Position in Bag
	self.BagSeparatorCB=Turbine.UI.Lotro.CheckBox();
	self.BagSeparatorCB:SetParent(self.OptionsPanel);
	self.BagSeparatorCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.BagSeparatorCB:SetForeColor(fontColor);
	self.BagSeparatorCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.BagSeparatorCB:SetPosition(10,self.MinimalHeaderCB:GetTop()+self.MinimalHeaderCB:GetHeight()+4);
	self.BagSeparatorCB:SetText(Resource[language][255]);

--enableAttributes
	self.EnableAttributesCB=Turbine.UI.Lotro.CheckBox();
	self.EnableAttributesCB:SetParent(self.OptionsPanel);
	self.EnableAttributesCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.EnableAttributesCB:SetForeColor(fontColor);
	self.EnableAttributesCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.EnableAttributesCB:SetPosition(10,self.BagSeparatorCB:GetTop()+self.BagSeparatorCB:GetHeight()+4);
	self.EnableAttributesCB:SetText(Resource[language][303]);

--enableScaling
	self.EnableScalingCB=Turbine.UI.Lotro.CheckBox();
	self.EnableScalingCB:SetParent(self.OptionsPanel);
	self.EnableScalingCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.EnableScalingCB:SetForeColor(fontColor);
	self.EnableScalingCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.EnableScalingCB:SetPosition(10,self.EnableAttributesCB:GetTop()+self.EnableAttributesCB:GetHeight()+4);
	self.EnableScalingCB:SetText(Resource[language][340]);
	self.EnableScalingCB:SetVisible(false); -- not safe to enable yet

-- Tracking Options
	self.TrackingOptionsCaption=Turbine.UI.Label();
	self.TrackingOptionsCaption:SetParent(self.OptionsPanel);
	self.TrackingOptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.TrackingOptionsCaption:SetForeColor(headingsColor);
	self.TrackingOptionsCaption:SetSize(self.OptionsPanel:GetWidth(),20);
	self.TrackingOptionsCaption:SetPosition(0,self.EnableAttributesCB:GetTop()+self.EnableAttributesCB:GetHeight()+19);
	self.TrackingOptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.TrackingOptionsCaption:SetText(Resource[language][13]);

--** Show Icons In Tracking List
	self.IITVCB=Turbine.UI.Lotro.CheckBox();
	self.IITVCB:SetParent(self.OptionsPanel);
	self.IITVCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.IITVCB:SetForeColor(fontColor);
	self.IITVCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.IITVCB:SetPosition(10,self.TrackingOptionsCaption:GetTop()+self.TrackingOptionsCaption:GetHeight()+4);
	self.IITVCB:SetText(Resource[language][14]);

	self.CharacterCaption=Turbine.UI.Label();
	self.CharacterCaption:SetParent(self.OptionsPanel);
	self.CharacterCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.CharacterCaption:SetForeColor(fontColor);
	self.CharacterCaption:SetSize(self.OptionsPanel:GetWidth()-85,18);
	self.CharacterCaption:SetPosition(10,self.IITVCB:GetTop()+self.IITVCB:GetHeight()+9);
	self.CharacterCaption:SetText(Resource[language][15]);

--** Default Character Low Quantity Threshold
	self.DefCharLowQtyCaption=Turbine.UI.Label();
	self.DefCharLowQtyCaption:SetParent(self.OptionsPanel);
	self.DefCharLowQtyCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefCharLowQtyCaption:SetForeColor(fontColor);
	self.DefCharLowQtyCaption:SetSize(self.OptionsPanel:GetWidth()-85,18);
	self.DefCharLowQtyCaption:SetPosition(20,self.CharacterCaption:GetTop()+self.CharacterCaption:GetHeight()+4);
	self.DefCharLowQtyCaption:SetText(Resource[language][16].."(1-9999):");

	self.DefCharLowQty=Turbine.UI.Lotro.TextBox();
	self.DefCharLowQty:SetParent(self.OptionsPanel);
	self.DefCharLowQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefCharLowQty:SetSize(40,20);
	self.DefCharLowQty:SetPosition(self.DefCharLowQtyCaption:GetLeft()+self.DefCharLowQtyCaption:GetWidth(),self.DefCharLowQtyCaption:GetTop()-2);

--** Default Character Critical Qty Threshold
	self.DefCharCriticalQtyCaption=Turbine.UI.Label();
	self.DefCharCriticalQtyCaption:SetParent(self.OptionsPanel);
	self.DefCharCriticalQtyCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefCharCriticalQtyCaption:SetForeColor(fontColor);
	self.DefCharCriticalQtyCaption:SetSize(self.OptionsPanel:GetWidth()-85,18);
	self.DefCharCriticalQtyCaption:SetPosition(20,self.DefCharLowQtyCaption:GetTop()+self.DefCharLowQtyCaption:GetHeight()+4);
	self.DefCharCriticalQtyCaption:SetText(Resource[language][17].."(0-9998):");

	self.DefCharCriticalQty=Turbine.UI.Lotro.TextBox();
	self.DefCharCriticalQty:SetParent(self.OptionsPanel);
	self.DefCharCriticalQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefCharCriticalQty:SetSize(40,20);
	self.DefCharCriticalQty:SetPosition(self.DefCharCriticalQtyCaption:GetLeft()+self.DefCharCriticalQtyCaption:GetWidth(),self.DefCharCriticalQtyCaption:GetTop()-2);

	self.TotalCaption=Turbine.UI.Label();
	self.TotalCaption:SetParent(self.OptionsPanel);
	self.TotalCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.TotalCaption:SetForeColor(fontColor);
	self.TotalCaption:SetSize(self.OptionsPanel:GetWidth()-85,18);
	self.TotalCaption:SetPosition(10,self.DefCharCriticalQtyCaption:GetTop()+self.DefCharCriticalQtyCaption:GetHeight()+4);
	self.TotalCaption:SetText(Resource[language][18]);

--** Default Total Low Quantity Threshold
	self.DefAllLowQtyCaption=Turbine.UI.Label();
	self.DefAllLowQtyCaption:SetParent(self.OptionsPanel);
	self.DefAllLowQtyCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefAllLowQtyCaption:SetForeColor(fontColor);
	self.DefAllLowQtyCaption:SetSize(self.OptionsPanel:GetWidth()-85,18);
	self.DefAllLowQtyCaption:SetPosition(20,self.TotalCaption:GetTop()+self.TotalCaption:GetHeight()+4);
	self.DefAllLowQtyCaption:SetText(Resource[language][16].."(1-9999):");

	self.DefAllLowQty=Turbine.UI.Lotro.TextBox();
	self.DefAllLowQty:SetParent(self.OptionsPanel);
	self.DefAllLowQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefAllLowQty:SetSize(40,20);
	self.DefAllLowQty:SetPosition(self.DefAllLowQtyCaption:GetLeft()+self.DefAllLowQtyCaption:GetWidth(),self.DefAllLowQtyCaption:GetTop()-2);

--** Default Total Critical Qty Threshold
	self.DefAllCriticalQtyCaption=Turbine.UI.Label();
	self.DefAllCriticalQtyCaption:SetParent(self.OptionsPanel);
	self.DefAllCriticalQtyCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefAllCriticalQtyCaption:SetForeColor(fontColor);
	self.DefAllCriticalQtyCaption:SetSize(self.OptionsPanel:GetWidth()-85,18);
	self.DefAllCriticalQtyCaption:SetPosition(20,self.DefAllLowQtyCaption:GetTop()+self.DefAllLowQtyCaption:GetHeight()+4);
	self.DefAllCriticalQtyCaption:SetText(Resource[language][17].."(0-9998):");

	self.DefAllCriticalQty=Turbine.UI.Lotro.TextBox();
	self.DefAllCriticalQty:SetParent(self.OptionsPanel);
	self.DefAllCriticalQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DefAllCriticalQty:SetSize(40,20);
	self.DefAllCriticalQty:SetPosition(self.DefAllCriticalQtyCaption:GetLeft()+self.DefAllCriticalQtyCaption:GetWidth(),self.DefAllCriticalQtyCaption:GetTop()-2);

--** SAVE AND CANCEL
	self.SaveButton=Turbine.UI.Lotro.Button();
	self.SaveButton:SetParent(self);
	self.SaveButton:SetSize(100,20);
	self.SaveButton:SetPosition(20,self:GetHeight()-40);
	self.SaveButton:SetText(Resource[language][19]);
	self.SaveButton.Click=function()
		local hasError=false;
		-- validate thresholds
		local tmpVal=tonumber(self.DefCharCriticalQty:GetText());
		if tmpVal==nil then
			tmpVal=0;
			hasError=true;
			self.DefCharCriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal<0 then
			tmpVal=0;
			hasError=true;
			self.DefCharCriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal>9998 then
			tmpVal=9998;
			hasError=true;
			self.DefCharCriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		self.DefCharCriticalQty:SetText(tmpVal);

		tmpVal=tonumber(self.DefCharLowQty:GetText());
		if tmpVal==nil then
			tmpVal=0;
			hasError=true;
			self.DefCharLowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal<=tonumber(self.DefCharCriticalQty:GetText()) then
			tmpVal=tonumber(self.DefCharCriticalQty:GetText())+1;
			hasError=true;
			self.DefCharLowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal>9999 then
			tmpVal=9999;
			hasError=true;
			self.DefCharLowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		self.DefCharLowQty:SetText(tmpVal);

		tmpVal=tonumber(self.DefAllCriticalQty:GetText());
		if tmpVal==nil then
			tmpVal=0;
			hasError=true;
			self.DefAllCriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal<0 then
			tmpVal=0;
			self.DefAllCriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal>9998 then
			tmpVal=9998;
			hasError=true;
			self.DefAllCriticalQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		self.DefAllCriticalQty:SetText(tmpVal);

		tmpVal=tonumber(self.DefAllLowQty:GetText());
		if tmpVal==nil then
			tmpVal=0;
			hasError=true;
			self.DefAllLowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal<=tonumber(self.DefAllCriticalQty:GetText()) then
			tmpVal=tonumber(self.DefAllCriticalQty:GetText())+1;
			hasError=true;
			self.DefAllLowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		if tmpVal>9999 then
			tmpVal=9999;
			hasError=true;
			self.DefAllLowQtyCaption:SetForeColor(Turbine.UI.Color(1,0,0));
		end
		self.DefAllLowQty:SetText(tmpVal);

		if hasError then
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);
		else
			local rb=self.ReplaceBagsCB:IsChecked();
			inventoryWindow:SetReplaceBags(rb);
			rb=self.LoadMinimizedCB:IsChecked();
			inventoryWindow:SetLoadMinimized(rb);
			rb=self.ShowIconWhenMinimizedCB:IsChecked();
			inventoryWindow:SetShowIconWhenMinimized(rb);
			rb=self.MinimalHeaderCB:IsChecked();
			inventoryWindow:SetMinimalHeader(rb);
			rb=self.BagSeparatorCB:IsChecked();
			inventoryWindow:SetBagSeparator(rb);
			enableAttributes=self.EnableAttributesCB:IsChecked();
			enableScaling=self.EnableScalingCB:IsChecked();
			inventoryWindow.WalletPanel:SetVisible(enableAttributes);

			if enableAttributes then
				inventoryWindow.ViewPanel[3].Attributes=localPlayer:GetAttributes();
			else
				inventoryWindow.ViewPanel[3].Attributes=inventoryWindow.ViewPanel[3].BogusAttributes;
			end

			if enableAttributes then
				if inventoryWindow.playerAttributes==nil then
					inventoryWindow.playerAttributes=localPlayer:GetAttributes();
				end
				inventoryWindow.RefreshWallet(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
				GetAttributes();
				inventoryWindow.ViewPanel[3]:LoadPanelData(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
				if inventoryWindow.moneyChangedHandler==nil then
					-- set the money event handler
					inventoryWindow.moneyChangedHandler = AddCallback(inventoryWindow.playerAttributes, "MoneyChanged", inventoryWindow.MoneyChanged)
				end
			else
				if inventoryWindow.moneyChangedHandler~=nil then
					-- remove the money event handler
					RemoveCallback(inventoryWindow.playerAttributes, "MoneyChanged", inventoryWindow.MoneyChanged);
					inventoryWindow.moneyChangedHandler = nil;
				end
			end
			if not enableScaling then
				if scaleMult~=1 then
					inventoryWindow:SetSize(inventoryWindow:GetWidth()/scaleMult,inventoryWindow:GetHeight()/scaleMult);
					minimalWindow:SetSize(minimalWindow:GetWidth()/scaleMult,minimalWindow:GetHeight()/scaleMult);
					inventoryWindow:SetStretchMode(5);
					minimalWindow:SetStretchMode(5);
				else
					inventoryWindow:SetStretchMode(1);
					minimalWindow:SetStretchMode(1);
				end
				scaleMult=1;
			end

			rb=self.IITVCB:IsChecked();
			trackWindow:SetShowIconsInList(rb);
			trackWindow:SetDefaultCharLowThreshold(self.DefCharLowQty:GetText());
			trackWindow:SetDefaultCharCriticalThreshold(self.DefCharCriticalQty:GetText());
			trackWindow:SetDefaultAllLowThreshold(self.DefAllLowQty:GetText());
			trackWindow:SetDefaultAllCriticalThreshold(self.DefAllCriticalQty:GetText());
			trackWindow:RefreshCharStatus()
			trackWindow:RefreshAllStatus()
			if trackWindow:IsVisible() then
				trackWindow:RefreshCharList()
				trackWindow:RefreshAllList()
			end
			fontColor=self.FontColor:GetColor();
			trimColor=self.TrimColor:GetColor();
			backColor=self.BackColor:GetColor();
			headingsColor=self.HeadingsColor:GetColor();
			listTextColor=self.ListTextColor:GetColor();

			language=self.LanguageList:GetValue();
			trackWindow:SetFontColor();
			trackWindow:SetTrimColor();
			trackWindow:SetBackColor();
			customThresholdWindow:SetFontColor();
			customThresholdWindow:SetTrimColor();
			customThresholdWindow:SetBackColor();
			inventoryWindow:SetFontColor();
			inventoryWindow:SetTrimColor();
			inventoryWindow:SetBackColor();
			inventoryWindow:SetHeadingsColor();
			inventoryWindow:SetLanguage();
			inventoryWindow:SetListTextColor();
			trackWindow:SetLanguage();
			customThresholdWindow:SetLanguage();
			self:SetVisible(false);
			inventoryWindow.NeedsRefresh=true;
			inventoryWindow:SetWantsUpdates(true);
			inventoryWindow.ViewPanel[3].AP:SetVisible(enableAttributes);

		end
	end

	self.CancelButton=Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent(self);
	self.CancelButton:SetSize(100,20);
	self.CancelButton:SetPosition(self:GetWidth()-20-self.CancelButton:GetWidth(),self:GetHeight()-40);
	self.CancelButton:SetText(Resource[language][20]);
	self.CancelButton.Click=function()
		self.FontColor:SetColor(fontColor);
		self.TrimColor:SetColor(trimColor);
		self.BackColor:SetColor(backColor);
		self.HeadingsColor:SetColor(headingsColor);
		self:SetVisible(false);
	end

	self.ErrorLabel=Turbine.UI.Label();
	self.ErrorLabel:SetParent(self);
	self.ErrorLabel:SetText("Adjusted Invalid Values")
	self.ErrorLabel:SetPosition(self.SaveButton:GetLeft()+self.SaveButton:GetWidth(),self.SaveButton:GetTop());
	self.ErrorLabel:SetSize(self.CancelButton:GetLeft()-(self.ErrorLabel:GetLeft()),self.SaveButton:GetHeight());
	self.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	self.ErrorLabel:SetVisible(false);
	self.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.LanguageList:SetZOrder(self.ErrorLabel:GetZOrder()+1);

	self.VisibleChanged=function(sender,args)
		if self:IsVisible() then
			-- refresh the options status to reflect current values
			self.ReplaceBagsCB:SetChecked(inventoryWindow:GetReplaceBags());
			self.LoadMinimizedCB:SetChecked(inventoryWindow:GetLoadMinimized());
			self.ShowIconWhenMinimizedCB:SetChecked(inventoryWindow:GetShowIconWhenMinimized());
			self.MinimalHeaderCB:SetChecked(inventoryWindow:GetMinimalHeader());
			self.BagSeparatorCB:SetChecked(inventoryWindow:GetBagSeparator());
			self.EnableAttributesCB:SetChecked(enableAttributes);
			self.EnableScalingCB:SetChecked(enableScaling);
			self.IITVCB:SetChecked(trackWindow:GetShowIconsInList());
			self.DefCharLowQty:SetText(trackWindow:GetDefaultCharLowThreshold());
			self.DefCharCriticalQty:SetText(trackWindow:GetDefaultCharCriticalThreshold());
			self.DefAllLowQty:SetText(trackWindow:GetDefaultAllLowThreshold());
			self.DefAllCriticalQty:SetText(trackWindow:GetDefaultAllCriticalThreshold());
			local index;
			for index=1,self.LanguageList.ListData:GetItemCount() do
				if self.LanguageList.ListData:GetItem(index):GetValue()==language then
					self.LanguageList:SetSelectedIndex(index);
					break;
				end
			end
			self:SetLanguage(language);
		end
	end
	self.Update=function(sender,args)
		if self.HadErrors then
			if Turbine.Engine:GetGameTime()>self.ErrorFadeTime then
				self:SetWantsUpdates(false);
				self.DefAllLowQtyCaption:SetForeColor(self.FontColor:GetColor());
				self.DefAllCriticalQtyCaption:SetForeColor(self.FontColor:GetColor());
				self.DefCharLowQtyCaption:SetForeColor(self.FontColor:GetColor());
				self.DefCharCriticalQtyCaption:SetForeColor(self.FontColor:GetColor());
				self.ErrorLabel:SetVisible(false);
				self.HadErrors=false
			end
		end
	end
	self.SetTrimColor=function(sender,color)
		self.LanguageList:SetBorderColor(color);
		self.FontColor:SetTrimColor(color);
		self.TrimColor:SetTrimColor(color);
		self.BackColor:SetTrimColor(color);
		self.HeadingsColor:SetTrimColor(color);
		self.ListTextColor:SetTrimColor(color);
	end
	self.SetBackColor=function(sender,color)
		self.LanguageList:SetBackColor(color);
		self.LanguageList:SetCurrentBackColor(color);
		self.OptionsPanel:SetBackColor(color);
		self.FontColor:SetBackColor(color);
		self.TrimColor:SetBackColor(color);
		self.BackColor:SetBackColor(color);
		self.HeadingsColor:SetBackColor(color);
		self.ListTextColor:SetBackColor(color);
	end
	self.SetFontColor=function(sender,color)
		self.LanguageCaption:SetForeColor(color);
		self.LoadMinimizedCB:SetForeColor(color);
		self.ShowIconWhenMinimizedCB:SetForeColor(color);
		self.MinimalHeaderCB:SetForeColor(color);
		self.ReplaceBagsCB:SetForeColor(color);
		self.BagSeparatorCB:SetForeColor(color);
		self.EnableAttributesCB:SetForeColor(color);
		self.EnableScalingCB:SetForeColor(color);
		self.TrimCaption:SetForeColor(color);
		self.FontCaption:SetForeColor(color);
		self.BackCaption:SetForeColor(color);
		self.HeadingsCaption:SetForeColor(color);
		self.ListTextCaption:SetForeColor(color);
		self.IITVCB:SetForeColor(color);
		self.CharacterCaption:SetForeColor(color);
		self.TotalCaption:SetForeColor(color);
		self.DefCharLowQtyCaption:SetForeColor(color);
		self.DefCharCriticalQtyCaption:SetForeColor(color);
		self.DefAllLowQtyCaption:SetForeColor(color);
		self.DefAllCriticalQtyCaption:SetForeColor(color);
	end
	self.SetHeadingsColor=function(sender,color)
		self.OptionsCaption:SetForeColor(color);
		self.InventoryOptionsCaption:SetForeColor(color);
		self.TrackingOptionsCaption:SetForeColor(color);
	end
	self.SetListTextColor=function(sender,color)
		self.LanguageList:SetTextColor(color);
	end

	self.SetLanguage=function(sender,tmpLanguage)
		self:SetText(Resource[tmpLanguage][3]);
		self.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
		self.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		self.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		self.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		self.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		self.HeadingsCaption:SetText(Resource[language][296]..":");
		self.ListTextCaption:SetText(Resource[language][297]..":");
		self.ResetColors:SetText(Resource[tmpLanguage][9]);
		self.InventoryOptionsCaption:SetText(Resource[tmpLanguage][10]);
		self.ReplaceBagsCB:SetText(Resource[tmpLanguage][11]);
		self.LoadMinimizedCB:SetText(Resource[tmpLanguage][12]);
		self.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][252]);
		self.MinimalHeaderCB:SetText(Resource[tmpLanguage][48]);
		self.BagSeparatorCB:SetText(Resource[tmpLanguage][255]);
		self.EnableAttributesCB:SetText(Resource[tmpLanguage][303]);
		self.EnableScalingCB:SetText(Resource[tmpLanguage][340]);
		self.TrackingOptionsCaption:SetText(Resource[tmpLanguage][13]);
		self.IITVCB:SetText(Resource[tmpLanguage][14]);
		self.CharacterCaption:SetText(Resource[tmpLanguage][15]);
		self.DefCharLowQtyCaption:SetText(Resource[tmpLanguage][16].."(1-9999):");
		self.DefCharCriticalQtyCaption:SetText(Resource[tmpLanguage][17].."(0-9998):");
		self.TotalCaption:SetText(Resource[tmpLanguage][18]);
		self.DefAllLowQtyCaption:SetText(Resource[tmpLanguage][16].."(1-9999):");
		self.DefAllCriticalQtyCaption:SetText(Resource[tmpLanguage][17].."(0-9998):");
		self.SaveButton:SetText(Resource[tmpLanguage][19]);
		self.CancelButton:SetText(Resource[tmpLanguage][20]);
	end
end
