-- to do:
-- compare to xls to verify that all entries were applied and all discrepancies resolved

-- contains all identified recipes as of Feb 16th 2012

-- the recipe IDs refer to the actual recipe item that the recipe is learned from, thus default recipes do not have a recipe ID
-- this ID is used to create a popup tool tip

-- most duplicated recipes are the result of old versions that used to use special trophies as ingredients these recipes are included
-- because they are distinct and can exist alongside the new versions if already memorized
-- there are a couple of recipes that appear to be duplicates but actually either come from different sources (like the High-quality Calenard Ingots), have different tiers (like the Officer's armour) or other distinctions
-- they are all distinctly different in some way even if they have the same names.

-- Note, the recipe list is a MESS.
-- The lorebook has multiple duplicates, probably due to "old" version multi-use recipes that were supposed to have gotten rolled into multi-output recipes.
-- Most 3rd party sites incorretly removed the "old" single-use recipes that got rolled into multi-output since the actual old single-use recipes exist in some character's lists of know recipes (for instance, my jeweller still has the one-shot versions of some "Tactics" rings).
-- Some sites aren't fully updated for the new Westfold recipes.
-- Other sites don't include all of the oddball/transient categories like Crafting Expertise (for what it's worth, I didn't include Crafting Expertise either :p ).
-- For this reason, I've done my best to clean up the data from the lorebook and added what westfold categories & recipes I could account for (sadly, I haven't had the time to level all of my crafting alts in all of the guilds).
-- There may be still be some duplicated recipes, missing categories and/or missing recipes (the duplicate High-quality Calenard Ingot is legit as it exists in two categories for some reason). I will correct these inconsistant/missing categories & recipes in future updates

-- expert jeweller expertise missing from XML
-- reforged captain's mace of the second age (lvl 65) is missing -- need artisan of the guild weaponsmith to get in-game copy and find ID

-- westfold book - doesn't seem to be in lorebook and missing from XML
-- peerless thain's halberd - not in lorebook and missing from XML

Profession={};
Profession[1]={"Cook",305};
Profession[2]={"Farmer",306};
Profession[3]={"Forester",307};
Profession[4]={"Jeweller",308};
Profession[5]={"Metalsmith",309};
Profession[6]={"Prospector",310};
Profession[7]={"Scholar",311};
Profession[8]={"Tailor",312};
Profession[9]={"Weaponsmith",313};
Profession[10]={"Woodworker",314};

Vocation={};
Vocation[1]={};
Vocation[2]={};
Vocation[3]={};
Vocation[4]={};
Vocation[5]={};
Vocation[6]={};
Vocation[7]={};

Vocation[1]["Name"]={"Armourer",316};
Vocation[1]["Profession1"]=6;
Vocation[1]["Profession2"]=5;
Vocation[1]["Profession3"]=8;
Vocation[2]["Name"]={"Armsman",317};
Vocation[2]["Profession1"]=9;
Vocation[2]["Profession2"]=10;
Vocation[2]["Profession3"]=6;
Vocation[3]["Name"]={"Explorer",318};
Vocation[3]["Profession1"]=8;
Vocation[3]["Profession2"]=3;
Vocation[3]["Profession3"]=6;
Vocation[4]["Name"]={"Historian",319};
Vocation[4]["Profession1"]=2;
Vocation[4]["Profession2"]=7;
Vocation[4]["Profession3"]=9;
Vocation[5]["Name"]={"Tinker",320};
Vocation[5]["Profession1"]=4;
Vocation[5]["Profession2"]=6;
Vocation[5]["Profession3"]=1;
Vocation[6]["Name"]={"Woodsman",321};
Vocation[6]["Profession1"]=2;
Vocation[6]["Profession2"]=3;
Vocation[6]["Profession3"]=10;
Vocation[7]["Name"]={"Yeoman",322};
Vocation[7]["Profession1"]=2;
Vocation[7]["Profession2"]=1;
Vocation[7]["Profession3"]=8;

Tier={};
Tier[1]={"Apprentice",326};
Tier[2]={"Journeyman",327};
Tier[3]={"Expert",328};
Tier[4]={"Artisan",329};
Tier[5]={"Master",330};
Tier[6]={"Supreme",331};
Tier[7]={"Westfold",332};

CraftStr={}
CraftStr[1]={}
CraftStr[2]={}
CraftStr[3]={}

CraftStr[1][1]="Armour (Draigoch)"
CraftStr[1][2]="Backpacks"
CraftStr[1][3]="Battle Lore"
CraftStr[1][4]="Burglar Signals"
CraftStr[1][5]="Burglar Throwing Weapons"
CraftStr[1][6]="Burglar Tools"
CraftStr[1][7]="Burglar Tricks"
CraftStr[1][8]="Campfire"
CraftStr[1][9]="Captain Armaments"
CraftStr[1][10]="Captain Emblems"
CraftStr[1][11]="Captain Tonics"
CraftStr[1][12]="Champion Horns"
CraftStr[1][13]="Champion Potions"
CraftStr[1][14]="Champion Runes"
CraftStr[1][15]="Cloaks"
CraftStr[1][16]="Cloaks (Guild)"
CraftStr[1][17]="Clothing"
CraftStr[1][18]="Components"
CraftStr[1][19]="Components (Guild)"
CraftStr[1][20]="Compost"
CraftStr[1][21]="Cook's Guild"
CraftStr[1][22]="Cooked Food"
CraftStr[1][23]="Cooked Food (Guild)"
CraftStr[1][24]="Cooked Food (Galadhrim)"
CraftStr[1][25]="Cooked Food (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][26]="Council of the North"
CraftStr[1][27]="Crafted Relics"
CraftStr[1][28]="Crafting Journals"
CraftStr[1][29]="Crafting Lore"
CraftStr[1][30]="Crafting Tools"
CraftStr[1][31]="Decorations"
CraftStr[1][32]="Dyes"
CraftStr[1][33]="Dyes (Guild)"
CraftStr[1][34]="Elves of Rivendell"
CraftStr[1][35]="Examination"
CraftStr[1][36]="Extract"
CraftStr[1][37]="Fine Drinks (Guild)"
CraftStr[1][38]="Fishing Rods"
CraftStr[1][39]="Flowers"
CraftStr[1][40]="Fortifying Food"
CraftStr[1][41]="Gemstones"
CraftStr[1][42]="Gemstones (Guild)"
CraftStr[1][43]="Grains"
CraftStr[1][44]="Guardian Tactics"
CraftStr[1][45]="Guardian/Warden Shield-spikes"
CraftStr[1][46]="Heavy Armour (Guild)"
CraftStr[1][47]="Heavy Armour (Level 15)"
CraftStr[1][48]="Heavy Armour (Level 16)"
CraftStr[1][49]="Heavy Armour (Level 17)"
CraftStr[1][50]="Heavy Armour (Level 18)"
CraftStr[1][51]="Heavy Armour (Level 19)"
CraftStr[1][52]="Heavy Armour (Level 20)"
CraftStr[1][53]="Heavy Armour (Level 22)"
CraftStr[1][54]="Heavy Armour (Level 25)"
CraftStr[1][55]="Heavy Armour (Level 28)"
CraftStr[1][56]="Heavy Armour (Level 31)"
CraftStr[1][57]="Heavy Armour (Level 32)"
CraftStr[1][58]="Heavy Armour (Level 35)"
CraftStr[1][59]="Heavy Armour (Level 38)"
CraftStr[1][60]="Heavy Armour (Level 41)"
CraftStr[1][61]="Heavy Armour (Level 42)"
CraftStr[1][62]="Heavy Armour (Level 45)"
CraftStr[1][63]="Heavy Armour (Level 48)"
CraftStr[1][64]="Heavy Armour (Level 50)"
CraftStr[1][65]="Heavy Armour (Level 51)"
CraftStr[1][66]="Heavy Armour (Level 54)"
CraftStr[1][67]="Heavy Armour (Level 56)"
CraftStr[1][68]="Heavy Armour (Level 58)"
CraftStr[1][69]="Heavy Armour (Level 60, Galadhrim)"
CraftStr[1][70]="Heavy Armour (Level 65, Malledhrim)"
CraftStr[1][71]="Heavy Armour (Lossoth)"
CraftStr[1][72]="Hops"
CraftStr[1][73]="Hunter Books"
CraftStr[1][74]="Hunter Bow Chants"
CraftStr[1][75]="Hunter Potions"
CraftStr[1][76]="Hunter Traps"
CraftStr[1][77]="Hunter/Warden Oils"
CraftStr[1][78]="Ingredients"
CraftStr[1][79]="Ingredients (Guild)"
CraftStr[1][80]="Jeweller's Guild"
CraftStr[1][81]="Jewellery"
CraftStr[1][82]="Jewellery (Galadhrim)"
CraftStr[1][83]="Jewellery (Guild)"
CraftStr[1][84]="Jewellery (Level 7)"
CraftStr[1][85]="Jewellery (Level 10)"
CraftStr[1][86]="Jewellery (Level 12)"
CraftStr[1][87]="Jewellery (Level 14)"
CraftStr[1][88]="Jewellery (Level 16)"
CraftStr[1][89]="Jewellery (Level 18)"
CraftStr[1][90]="Jewellery (Level 20)"
CraftStr[1][91]="Jewellery (Level 22)"
CraftStr[1][92]="Jewellery (Level 25)"
CraftStr[1][93]="Jewellery (Level 28)"
CraftStr[1][94]="Jewellery (Level 31)"
CraftStr[1][95]="Jewellery (Level 32)"
CraftStr[1][96]="Jewellery (Level 35)"
CraftStr[1][97]="Jewellery (Level 38)"
CraftStr[1][98]="Jewellery (Level 41)"
CraftStr[1][99]="Jewellery (Level 42)"
CraftStr[1][100]="Jewellery (Level 45)"
CraftStr[1][101]="Jewellery (Level 48)"
CraftStr[1][102]="Jewellery (Level 50)"
CraftStr[1][103]="Jewellery (Level 51)"
CraftStr[1][104]="Jewellery (Level 54)"
CraftStr[1][105]="Jewellery (Level 56)"
CraftStr[1][106]="Jewellery (Level 58)"
CraftStr[1][107]="Jewellery (Level 60, Galadhrim)"
CraftStr[1][108]="Jewellery (Level 66)"
CraftStr[1][109]="Jewellery (Level 68)"
CraftStr[1][110]="Jewellery (Level 72)"
CraftStr[1][111]="Jewellery (Level 75)"
CraftStr[1][112]="Jewellery (Malledhrim)"
CraftStr[1][113]="Jewellery (Men of Dunland)"
CraftStr[1][114]="Jewellery (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][115]="Leather"
CraftStr[1][116]="Leather (Bulk)"
CraftStr[1][117]="Legendary Burglar Tools (Level 60)"
CraftStr[1][118]="Legendary Burglar Tools (Level 65)"
CraftStr[1][119]="Legendary Burglar Tools (Level 75)"
CraftStr[1][120]="Legendary Burglar Weapons (Level 60)"
CraftStr[1][121]="Legendary Burglar Weapons (Level 65)"
CraftStr[1][122]="Legendary Burglar Weapons (Level 75)"
CraftStr[1][123]="Legendary Captain Emplems (Level 60)"
CraftStr[1][124]="Legendary Captain Emplems (Level 65)"
CraftStr[1][125]="Legendary Captain Emplems (Level 75)"
CraftStr[1][126]="Legendary Captain Weapons (Level 60)"
CraftStr[1][127]="Legendary Captain Weapons (Level 65)"
CraftStr[1][128]="Legendary Captain Weapons (Level 75)"
CraftStr[1][129]="Legendary Champion Runes (Level 60)"
CraftStr[1][130]="Legendary Champion Runes (Level 65)"
CraftStr[1][131]="Legendary Champion Runes (Level 75)"
CraftStr[1][132]="Legendary Champion Weapons (Level 60)"
CraftStr[1][133]="Legendary Champion Weapons (Level 65)"
CraftStr[1][134]="Legendary Champion Weapons (Level 75)"
CraftStr[1][135]="Legendary Guardian Belts (Level 60)"
CraftStr[1][136]="Legendary Guardian Belts (Level 65)"
CraftStr[1][137]="Legendary Guardian Belts (Level 75)"
CraftStr[1][138]="Legendary Guardian Weapons (Level 60)"
CraftStr[1][139]="Legendary Guardian Weapons (Level 65)"
CraftStr[1][140]="Legendary Guardian Weapons (Level 75)"
CraftStr[1][141]="Legendary Hunter Weapons (Level 60)"
CraftStr[1][142]="Legendary Hunter Weapons (Level 65)"
CraftStr[1][143]="Legendary Hunter Weapons (Level 75)"
CraftStr[1][144]="Legendary Lore-master Books (Level 60)"
CraftStr[1][145]="Legendary Lore-master Books (Level 65)"
CraftStr[1][146]="Legendary Lore-master Books (Level 75)"
CraftStr[1][147]="Legendary Lore-master Weapons (Level 60)"
CraftStr[1][148]="Legendary Lore-master Weapons (Level 65)"
CraftStr[1][149]="Legendary Lore-master Weapons (Level 75)"
CraftStr[1][150]="Legendary Minstrel Books (Level 60)"
CraftStr[1][151]="Legendary Minstrel Books (Level 65)"
CraftStr[1][152]="Legendary Minstrel Books (Level 75)"
CraftStr[1][153]="Legendary Minstrel Weapons (Level 60)"
CraftStr[1][154]="Legendary Minstrel Weapons (Level 65)"
CraftStr[1][155]="Legendary Minstrel Weapons (Level 75)"
CraftStr[1][156]="Legendary Rune-keeper Rune-bags (Level 60)"
CraftStr[1][157]="Legendary Rune-keeper Rune-bags (Level 65)"
CraftStr[1][158]="Legendary Rune-keeper Rune-bags (Level 75)"
CraftStr[1][159]="Legendary Rune-keeper Weapons (Level 60)"
CraftStr[1][160]="Legendary Rune-keeper Weapons (Level 65)"
CraftStr[1][161]="Legendary Rune-keeper Weapons (Level 75)"
CraftStr[1][162]="Legendary Warden Weapons (Level 60)"
CraftStr[1][163]="Legendary Warden Weapons (Level 65)"
CraftStr[1][164]="Legendary Warden Weapons (Level 75)"
CraftStr[1][165]="Light Armour"
CraftStr[1][166]="Light Armour (Guild)"
CraftStr[1][167]="Light Armour (Level 7)"
CraftStr[1][168]="Light Armour (Level 12)"
CraftStr[1][169]="Light Armour (Level 14)"
CraftStr[1][170]="Light Armour (Level 16)"
CraftStr[1][171]="Light Armour (Level 18)"
CraftStr[1][172]="Light Armour (Level 20)"
CraftStr[1][173]="Light Armour (Level 22)"
CraftStr[1][174]="Light Armour (Level 25)"
CraftStr[1][175]="Light Armour (Level 28)"
CraftStr[1][176]="Light Armour (Level 31)"
CraftStr[1][177]="Light Armour (Level 32)"
CraftStr[1][178]="Light Armour (Level 35)"
CraftStr[1][179]="Light Armour (Level 38)"
CraftStr[1][180]="Light Armour (Level 41)"
CraftStr[1][181]="Light Armour (Level 42)"
CraftStr[1][182]="Light Armour (Level 45)"
CraftStr[1][183]="Light Armour (Level 48)"
CraftStr[1][184]="Light Armour (Level 50)"
CraftStr[1][185]="Light Armour (Level 51)"
CraftStr[1][186]="Light Armour (Level 54)"
CraftStr[1][187]="Light Armour (Level 56)"
CraftStr[1][188]="Light Armour (Level 58)"
CraftStr[1][189]="Light Armour (Level 60, Galadhrim)"
CraftStr[1][190]="Light Armour (Level 65, Malledhrim)"
CraftStr[1][191]="Light Armour (Lossoth)"
CraftStr[1][192]="Light Armour (Men of Dunland)"
CraftStr[1][193]="Light Armour (Quest)"
CraftStr[1][194]="Light Armour (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][195]="Lore-master Books"
CraftStr[1][196]="Lore-master Pet Food"
CraftStr[1][197]="Lore-master Talismans"
CraftStr[1][198]="Lore-master Talismans (Lossoth)"
CraftStr[1][199]="Medium Armour (Guild)"
CraftStr[1][200]="Medium Armour (Level 7)"
CraftStr[1][201]="Medium Armour (Level 12)"
CraftStr[1][202]="Medium Armour (Level 14)"
CraftStr[1][203]="Medium Armour (Level 16)"
CraftStr[1][204]="Medium Armour (Level 18)"
CraftStr[1][205]="Medium Armour (Level 20)"
CraftStr[1][206]="Medium Armour (Level 22)"
CraftStr[1][207]="Medium Armour (Level 25)"
CraftStr[1][208]="Medium Armour (Level 28)"
CraftStr[1][209]="Medium Armour (Level 31)"
CraftStr[1][210]="Medium Armour (Level 32)"
CraftStr[1][211]="Medium Armour (Level 35)"
CraftStr[1][212]="Medium Armour (Level 38)"
CraftStr[1][213]="Medium Armour (Level 41)"
CraftStr[1][214]="Medium Armour (Level 42)"
CraftStr[1][215]="Medium Armour (Level 45)"
CraftStr[1][216]="Medium Armour (Level 48)"
CraftStr[1][217]="Medium Armour (Level 50)"
CraftStr[1][218]="Medium Armour (Level 51)"
CraftStr[1][219]="Medium Armour (Level 54)"
CraftStr[1][220]="Medium Armour (Level 56)"
CraftStr[1][221]="Medium Armour (Level 58)"
CraftStr[1][222]="Medium Armour (Level 60, Galadhrim)"
CraftStr[1][223]="Medium Armour (Level 65, Malledhrim)"
CraftStr[1][224]="Medium Armour (Lossoth)"
CraftStr[1][225]="Melee Weapons (Guild)"
CraftStr[1][226]="Melee Weapons (Level 7)"
CraftStr[1][227]="Melee Weapons (Level 12)"
CraftStr[1][228]="Melee Weapons (Level 14)"
CraftStr[1][229]="Melee Weapons (Level 16)"
CraftStr[1][230]="Melee Weapons (Level 18)"
CraftStr[1][231]="Melee Weapons (Level 20)"
CraftStr[1][232]="Melee Weapons (Level 22)"
CraftStr[1][233]="Melee Weapons (Level 25)"
CraftStr[1][234]="Melee Weapons (Level 28)"
CraftStr[1][235]="Melee Weapons (Level 31)"
CraftStr[1][236]="Melee Weapons (Level 32)"
CraftStr[1][237]="Melee Weapons (Level 35)"
CraftStr[1][238]="Melee Weapons (Level 38)"
CraftStr[1][239]="Melee Weapons (Level 41)"
CraftStr[1][240]="Melee Weapons (Level 42)"
CraftStr[1][241]="Melee Weapons (Level 45)"
CraftStr[1][242]="Melee Weapons (Level 48)"
CraftStr[1][243]="Melee Weapons (Level 50)"
CraftStr[1][244]="Melee Weapons (Level 51)"
CraftStr[1][245]="Melee Weapons (Level 54)"
CraftStr[1][246]="Melee Weapons (Level 56)"
CraftStr[1][247]="Melee Weapons (Level 58)"
CraftStr[1][248]="Melee Weapons (Level 60, Galadhrim)"
CraftStr[1][249]="Melee Weapons (Level 65, Malledhrim)"
CraftStr[1][250]="Melee Weapons (Level 66)"
CraftStr[1][251]="Melee Weapons (Level 68)"
CraftStr[1][252]="Melee Weapons (Level 72)"
CraftStr[1][253]="Melee Weapons (Lossoth)"
CraftStr[1][254]="Melee Weapons (Men of Dunland)"
CraftStr[1][255]="Melee Weapons (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][256]="Men of Bree"
CraftStr[1][257]="Metalsmith's Guild"
CraftStr[1][258]="Minstrel Instruments"
CraftStr[1][259]="Minstrel Instruments (Galadhrim)"
CraftStr[1][260]="Minstrel Instruments (Lossoth)"
CraftStr[1][261]="Minstrel Lute Strings"
CraftStr[1][262]="Minstrel Sheet Music"
CraftStr[1][263]="Paints"
CraftStr[1][264]="Pipe-weed"
CraftStr[1][265]="Pocket"
CraftStr[1][266]="Pocket (Guild)"
CraftStr[1][267]="Potions"
CraftStr[1][268]="Potions (Guild)"
CraftStr[1][269]="Quest"
CraftStr[1][270]="Quivers"
CraftStr[1][271]="Ranged Weapons (Guild)"
CraftStr[1][272]="Ranged Weapons (Level 7)"
CraftStr[1][273]="Ranged Weapons (Level 12)"
CraftStr[1][274]="Ranged Weapons (Level 14)"
CraftStr[1][275]="Ranged Weapons (Level 16)"
CraftStr[1][276]="Ranged Weapons (Level 18)"
CraftStr[1][277]="Ranged Weapons (Level 20)"
CraftStr[1][278]="Ranged Weapons (Level 22)"
CraftStr[1][279]="Ranged Weapons (Level 25)"
CraftStr[1][280]="Ranged Weapons (Level 28)"
CraftStr[1][281]="Ranged Weapons (Level 31)"
CraftStr[1][282]="Ranged Weapons (Level 32)"
CraftStr[1][283]="Ranged Weapons (Level 35)"
CraftStr[1][284]="Ranged Weapons (Level 38)"
CraftStr[1][285]="Ranged Weapons (Level 41)"
CraftStr[1][286]="Ranged Weapons (Level 42)"
CraftStr[1][287]="Ranged Weapons (Level 45)"
CraftStr[1][288]="Ranged Weapons (Level 48)"
CraftStr[1][289]="Ranged Weapons (Level 50)"
CraftStr[1][290]="Ranged Weapons (Level 51)"
CraftStr[1][291]="Ranged Weapons (Level 54)"
CraftStr[1][292]="Ranged Weapons (Level 56)"
CraftStr[1][293]="Ranged Weapons (Level 57)"
CraftStr[1][294]="Ranged Weapons (Level 60, Galadhrim)"
CraftStr[1][295]="Ranged Weapons (Level 65, Malledhrim)"
CraftStr[1][296]="Ranged Weapons (Level 66)"
CraftStr[1][297]="Ranged Weapons (Level 72)"
CraftStr[1][298]="Ranged Weapons (Lossoth)"
CraftStr[1][299]="Ranged Weapons (Men of Dunland)"
CraftStr[1][300]="Ranged Weapons (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][301]="Rangers of Esteldin"
CraftStr[1][302]="Refining"
CraftStr[1][303]="Refining (Bulk)"
CraftStr[1][304]="Repair Anvil"
CraftStr[1][305]="Research"
CraftStr[1][306]="Research (Guild)"
CraftStr[1][307]="Rune-keeper Chisels"
CraftStr[1][308]="Rune-keeper Parchments"
CraftStr[1][309]="Rune-keeper Rune-satchels"
CraftStr[1][310]="Rune-keeper Rune-stones"
CraftStr[1][311]="Rune-keeper Rune-stones (Galadhrim)"
CraftStr[1][312]="Rune-keeper Rune-stones (Guild)"
CraftStr[1][313]="Rune-keeper Rune-stones (Malledhrim)"
CraftStr[1][314]="Rune-keeper Rune-tools"
CraftStr[1][315]="Scholar's Guild"
CraftStr[1][316]="Shields"
CraftStr[1][317]="Shields (Guild)"
CraftStr[1][318]="Shields (Lossoth)"
CraftStr[1][319]="Smelting"
CraftStr[1][320]="Smelting (Bulk)"
CraftStr[1][321]="Strong Drinks"
CraftStr[1][322]="Tailor's Guild"
CraftStr[1][323]="Textile"
CraftStr[1][324]="The Mathom Society"
CraftStr[1][325]="The Wardens of Annuminas"
CraftStr[1][326]="Thorin's Hall"
CraftStr[1][327]="Tokens"
CraftStr[1][328]="Trail Food"
CraftStr[1][329]="Trail Food (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][330]="Vegetables"
CraftStr[1][331]="Warden Battle Hymns"
CraftStr[1][332]="Warden Carvings"
CraftStr[1][333]="Weaponsmith's Guild"
CraftStr[1][334]="Wood"
CraftStr[1][335]="Wood (Bulk)"
CraftStr[1][336]="Woodworker's Guild"
CraftStr[1][337]="Heavy Armour (Level 66)"
CraftStr[1][338]="Heavy Armour (Level 68)"
CraftStr[1][339]="Heavy Armour (Level 72)"
CraftStr[1][340]="Heavy Armour (Level 75)" -- use for Scroched Armour until we know where it really belongs
CraftStr[1][341]="Heavy Armour (Men of Dunland)"
CraftStr[1][342]="Heavy Armour (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][343]="Shields (Men of Dunland)"
CraftStr[1][344]="Shields (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][345]="Crafting Expertise"
CraftStr[1][346]="Medium Armour"
CraftStr[1][347]="Medium Armour (Men of Dunland)"
CraftStr[1][348]="Medium Armour (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][349]="Potions (Malledhrim)"
CraftStr[1][350]="Weapons (Lossoth)"
CraftStr[1][351]="Ranged Weapons (Level 68)"
CraftStr[1][352]="Light Armour (Level 66)"
CraftStr[1][353]="Light Armour (Level 68)"
CraftStr[1][354]="Light Armour (Level 72)"
CraftStr[1][355]="Medium Armour (Level 66)"
CraftStr[1][356]="Medium Armour (Level 68)"
CraftStr[1][357]="Medium Armour (Level 72)"
CraftStr[1][358]="Westfold Parables"
CraftStr[1][359]="Light Armour (Level 75)"
CraftStr[1][360]="Medium Armour (Level 75)"
CraftStr[1][361]="Melee Weapons (Level 75)"
CraftStr[1][362]="Ranged Weapons (Level 75)"
CraftStr[1][363]="Cloaks (Men of Dunland)"
CraftStr[1][364]="Cloaks (Th"..string.char(195)..string.char(169).."odred's Riders)"
CraftStr[1][365]="Lore-master Parables"

-- highest category=365

local tmpIndex;
for tmpIndex=1,#CraftStr[1] do
	if CraftStr[2][tmpIndex]==nil then CraftStr[2][tmpIndex]=CraftStr[1][tmpIndex] end
	if CraftStr[3][tmpIndex]==nil then CraftStr[3][tmpIndex]=CraftStr[1][tmpIndex] end
end

Categories={}
for tmpIndex=1,10 do
	Categories[tmpIndex]={{},{},{},{},{},{},{}}
end

-- cook
Categories[1][1]={8,22,40,78,261,321,328} -- ,269
Categories[1][2]={8,22,31,40,78,196,261,321,328}
Categories[1][3]={8,21,22,23,31,40,78,79,196,321,324,328} -- ,269
Categories[1][4]={8,21,22,23,31,40,78,79,196,321,324,328}
Categories[1][5]={8,21,22,23,40,78,79,196,321,328}
Categories[1][6]={8,21,22,24,23,27,37,40,78,79,196,328}
Categories[1][7]={8,21,22,23,25,37,40,78,79,196,328,329}

-- farmer
Categories[2][1]={31,39,43,72,264,330}
Categories[2][2]={31,39,43,72,264,330}
Categories[2][3]={31,39,72,264,330}
Categories[2][4]={31,39,43,72,264,330}
Categories[2][5]={31,39,72,264,330}
Categories[2][6]={264,330}
Categories[2][7]={20,39,264,43,330}

-- forester
Categories[3][1]={115,116,334,335}
Categories[3][2]={31,115,116,334,335}
Categories[3][3]={115,116,334,335}
Categories[3][4]={115,116,334,335}
Categories[3][5]={115,116,323,334,335}
Categories[3][6]={115,116,334,335}
Categories[3][7]={36,115,334}

-- jeweller
Categories[4][1]={41,85,86,84,197,310,327}
Categories[4][2]={14,41,87,88,89,90,197,269,310,327}
Categories[4][3]={14,31,41,42,80,83,91,92,93,94,197,310,312,327}
Categories[4][4]={14,31,41,42,80,83,95,96,97,98,198,269,310,312,326,327}
Categories[4][5]={41,42,80,83,99,100,101,102,197,310,312,326,327}
--Categories[4][6]={27,41,42,80,107,83,103,104,105,106,107,129,130,159,160,197,310,311,312,313,327}
Categories[4][6]={27,41,42,80,83,103,104,105,106,107,112,129,130,159,160,197,310,311,312,313,327}
Categories[4][7]={41,42,80,83,108,109,110,111,113,114,131,161,327}

-- metalsmith
Categories[5][1]={18,30,47,48,316}
Categories[5][2]={18,30,49,50,51,52,307,316}
Categories[5][3]={18,19,30,46,53,54,55,56,257,307,316,317}
Categories[5][4]={18,19,26,30,31,46,57,58,59,60,257,269,304,307,316,317}
Categories[5][5]={18,19,26,30,46,61,62,63,64,71,257,307,316,317,318}
Categories[5][6]={18,19,27,30,46,65,66,67,68,69,70,123,124,135,136,257,307,316,317}
Categories[5][7]={46,337,338,339,340,341,342,125,137,257,307,316,317,343,344} -- need to get Tress to Westfold proficiency and guild kindred

-- prospector
Categories[6][1]={302,303,319,320}
Categories[6][2]={302,303,319,320}
Categories[6][3]={302,303,319,320}
Categories[6][4]={302,303,319,320}
Categories[6][5]={302,303,319,320}
Categories[6][6]={302,303,319,320}
Categories[6][7]={36,302,319}

-- scholar
Categories[7][1]={3,29,32,263,267}
Categories[7][2]={3,13,28,29,32,44,73,75,77,195,365,262,267,269,314}
Categories[7][3]={3,11,13,28,29,32,33,44,73,74,75,77,195,365,262,263,267,268,314,315}
Categories[7][4]={3,11,13,28,29,31,32,33,34,44,73,74,75,77,195,365,262,263,267,268,269,314,315}
Categories[7][5]={3,11,13,28,29,32,33,34,44,73,74,75,77,365,262,263,267,268,314,315}
Categories[7][6]={3,11,13,27,28,29,32,33,44,73,74,75,77,144,145,150,151,365,262,263,267,268,349,314,315}
Categories[7][7]={3,11,13,28,29,35,44,73,74,75,77,146,152,365,262,265,266,267,268,305,306,314,315}

-- tailor
Categories[8][1]={15,18,31,167,168,200,201}
Categories[8][2]={6,9,15,18,31,193,169,170,171,172,202,203,204,205,270,309}
Categories[8][3]={2,6,9,15,16,18,19,31,166,173,174,175,176,199,206,207,208,209,309,322}
Categories[8][4]={4,6,9,15,16,17,18,19,31,193,166,177,178,179,180,199,210,211,212,213,301,309,322}
Categories[8][5]={4,9,15,16,17,18,19,31,166,181,182,183,184,191,199,214,215,216,217,224,301,322}
Categories[8][6]={4,9,15,16,18,19,27,117,118,156,157,166,185,186,187,188,189,190,199,218,219,220,221,222,223,322}
Categories[8][7]={1,4,9,363,364,16,119,158,166,352,353,354,359 ,192,194,199,355,356,357,347,348,322}
--CraftStr[1][363]="Cloaks (Men of Dunland)"
--CraftStr[1][364]="Cloaks (Th"..string.char(195)..string.char(169).."odred's Riders)"


-- weaponsmith
Categories[9][1]={18,226,227,272}
Categories[9][2]={5,7,18,45,76,228,229,230,231,269,274,275}
Categories[9][3]={5,7,18,19,45,76,225,232,233,234,235,278,279,333}
Categories[9][4]={5,7,18,19,31,45,76,225,236,237,238,239,269,282,283,304,325,333}
Categories[9][5]={5,7,18,19,45,76,225,240,241,242,243,286,287,325,350,333}
Categories[9][6]={5,7,18,19,27,45,76,120,121,126,127,132,133,138,139,141,142,153,154,162,163,225,244,245,246,247,248,249,333}
Categories[9][7]={5,7,45,76,122,128,134,140,143,155,164,225,250,251,252,361, 254,255,333} -- missing all of the guild categories :(

-- woodworker
Categories[10][1]={18,31,226,227,272,273}
Categories[10][2]={12,18,31,228,229,230,231,258,269,274,275,276,277,308,331,332}
Categories[10][3]={10,12,18,19,31,38,225,232,233,234,235,258,271,278,279,280,281,308,332,336}
Categories[10][4]={10,12,18,19,31,38,225,236,237,238,239,256,258,269,271,282,283,284,285,308,331,332,336}
Categories[10][5]={10,12,18,19,225,240,241,242,243,253,256,258,260,271,286,287,288,289,298,308,332,336}
Categories[10][6]={10,12,18,19,27,120,121,126,127,132,133,138,139,141,142,147,148,153,154,162,163,225,244,245,246,247,248,249,259,271,290,291,292,293,294,295,308,331,332,336}
Categories[10][7]={10,12,122,128,134,140,143,149,155,164,225,250,251,252,361,254,255,258,271,296,351,297,362,299,300,308,332,336} -- may be missing some "drop" recipes

Recipe={};
local tmpProfession,tmpTier
for tmpProfession=1,#Categories do
	Recipe[tmpProfession]={}
	for tmpTier=1,#Categories[tmpProfession] do
		Recipe[tmpProfession][tmpTier]={}
		for tmpIndex=1,#Categories[tmpProfession][tmpTier] do
			Recipe[tmpProfession][tmpTier][tmpIndex]={}
		end
	end
end

--  = "..string.char(195)..string.char(186).."
--  = "..string.char(195)..string.char(162).."
--  = "..string.char(195)..string.char(164).."
--  = "..string.char(195)..string.char(169).."
--  = "..string.char(195)..string.char(179).."
--  = "..string.char(195)..string.char(187).."
-- max db ID = 3367
-- see bottom of file for max lua ID

--Recipe[1][1][#Recipe[1][1]+1]={666,"Apprentice Cook Expertise",false,false,1879184441};
Recipe[1][1][6][#Recipe[1][1][6]+1]={87,"Apprentice's Ale",false,false,1879089608};
Recipe[1][1][2][#Recipe[1][1][2]+1]={149,"Barley Bread",false,false,1879205382};
Recipe[1][1][3][#Recipe[1][1][3]+1]={150,"Barley Soup",false,false,1879150194};
Recipe[1][1][6][#Recipe[1][1][6]+1]={233,"Bold Stout Beer",false,false,1879089594};
Recipe[1][1][4][#Recipe[1][1][4]+1]={273,"Bowl of Pork Stock",false,false,1879150176};
Recipe[1][1][4][#Recipe[1][1][4]+1]={314,"Bucket of Spring Barley Mash",false,false,1879089575};
Recipe[1][1][3][#Recipe[1][1][3]+1]={355,"Carrot Soup",false,false,1879150195};
Recipe[1][1][7][#Recipe[1][1][7]+1]={357,"Carrot Sticks",false,true,1879182096};
Recipe[1][1][7][#Recipe[1][1][7]+1]={429,"Cooked Carrots",false,true,1879061270};
Recipe[1][1][4][#Recipe[1][1][4]+1]={609,"Cup of Spring Barley Flour",false,true,1879182212};
Recipe[1][1][7][#Recipe[1][1][7]+1]={784,"Eggs and Onions",false,true,1879061269};
Recipe[1][1][7][#Recipe[1][1][7]+1]={1136,"Fried Dace with Mushrooms",false,false,1879110360};
Recipe[1][1][7][#Recipe[1][1][7]+1]={1137,"Fried Mushrooms",false,true,1879061268};
Recipe[1][1][2][#Recipe[1][1][2]+1]={1270,"Hard Biscuits",false,true,1879061265};
Recipe[1][1][5][#Recipe[1][1][5]+1]={1669,"Lute Strings of Minor Subtlety",false,false,1879088821};
Recipe[1][1][5][#Recipe[1][1][5]+1]={1670,"Lute Strings of Subtlety",false,false,1879088820};
Recipe[1][1][2][#Recipe[1][1][2]+1]={1901,"Mushroom Pie",false,true,1879061266};
Recipe[1][1][3][#Recipe[1][1][3]+1]={1902,"Mushroom Soup",false,false,1879150148};
Recipe[1][1][3][#Recipe[1][1][3]+1]={1936,"Onion Soup",false,false,1879150186};
Recipe[1][1][4][#Recipe[1][1][4]+1]={2009,"Pie Crust",false,true,1879061271};
Recipe[1][1][4][#Recipe[1][1][4]+1]={2147,"Prepared North Downs Hops",false,false,1879089565};
Recipe[1][1][2][#Recipe[1][1][2]+1]={2507,"Roast Pork",false,true,1879061267};
Recipe[1][1][1][#Recipe[1][1][1]+1]={2541,"Rowan Campfire Kit",false,false,1879066684};
Recipe[1][1][2][#Recipe[1][1][2]+1]={2568,"Sandson's Famous Hardboiled Eggs",false,false,1879088164};
Recipe[1][1][7][#Recipe[1][1][7]+1]={2713,"Shire Pudding",false,true,1879182091};

Recipe[1][2][1][#Recipe[1][2][1]+1]={106,"Ash Campfire Kit",false,false,1879182441};
Recipe[1][2][6][#Recipe[1][2][6]+1]={129,"Bag of Crude Crumbs",false,false,1879197211};
Recipe[1][2][4][#Recipe[1][2][4]+1]={151,"Barley Stew",false,false,1879150188};
Recipe[1][2][8][#Recipe[1][2][8]+1]={223,"Blue Bock Beer",false,false,1879089591};
Recipe[1][2][8][#Recipe[1][2][8]+1]={225,"Blueberry Ale",false,false,1879089584};
Recipe[1][2][2][#Recipe[1][2][2]+1]={227,"Blueberry Muffins",false,true,1879061277};
Recipe[1][2][5][#Recipe[1][2][5]+1]={228,"Blueberry Pie Filling",false,true,1879182268};
Recipe[1][2][2][#Recipe[1][2][2]+1]={229,"Blueberry Tart",false,false,1879103661};
Recipe[1][2][5][#Recipe[1][2][5]+1]={263,"Bowl of Coney Stock",false,false,1879150199};
Recipe[1][2][9][#Recipe[1][2][9]+1]={272,"Bowl of Oatmeal",false,true,1879182089};
Recipe[1][2][3][#Recipe[1][2][3]+1]={281,"Breakfast Table",false,false,1879102048};
Recipe[1][2][4][#Recipe[1][2][4]+1]={356,"Carrot Stew",false,false,1879150177};
Recipe[1][2][9][#Recipe[1][2][9]+1]={383,"Catfish Cakes",false,false,1879110368};
Recipe[1][2][9][#Recipe[1][2][9]+1]={420,"Complete Hobbit Breakfast",false,true,1879061281};
Recipe[1][2][2][#Recipe[1][2][2]+1]={425,"Coney Pie",false,true,1879061276};
Recipe[1][2][9][#Recipe[1][2][9]+1]={426,"Coney Stew",false,true,1879061280};
Recipe[1][2][2][#Recipe[1][2][2]+1]={1426,"Hornblower's Pie",false,false,1879083989};
--Recipe[1][2][#Recipe[1][2]+1]={687,"Journeyman Cook Expertise",false,false,1879184439};
Recipe[1][2][7][#Recipe[1][2][7]+1]={1668,"Lute Strings of Greater Subtlety",false,false,1879088818};
Recipe[1][2][5][#Recipe[1][2][5]+1]={1753,"Marinated Coney",false,true,1879061282};
Recipe[1][2][4][#Recipe[1][2][4]+1]={1903,"Mushroom Stew",false,false,1879150232};
Recipe[1][2][4][#Recipe[1][2][4]+1]={1937,"Onion Stew",false,false,1879150185};
Recipe[1][2][9][#Recipe[1][2][9]+1]={2094,"Pork Sausage",false,true,1879061279};
Recipe[1][2][6][#Recipe[1][2][6]+1]={2095,"Pot of Crude Honey and Oats",false,false,1879089699};
Recipe[1][2][5][#Recipe[1][2][5]+1]={2145,"Prepared Golding Hops",false,false,1879089573};
Recipe[1][2][9][#Recipe[1][2][9]+1]={2573,"Sausages and Mash",false,true,1879182090};
Recipe[1][2][2][#Recipe[1][2][2]+1]={2703,"Serene Stew",true,false,1879061243};
Recipe[1][2][2][#Recipe[1][2][2]+1]={2712,"Shire Porridge",false,false,1879205380};
Recipe[1][2][5][#Recipe[1][2][5]+1]={2838,"Spiced Potatoes",false,true,1879061283};
Recipe[1][2][2][#Recipe[1][2][2]+1]={2942,"Stuffed Cabbage",false,true,1879061278};

Recipe[1][3][9][#Recipe[1][3][9]+1]={130,"Bag of Crumbs",false,false,1879197252};
Recipe[1][3][3][#Recipe[1][3][3]+1]={167,"Beef Stew",false,true,1879061290};
Recipe[1][3][3][#Recipe[1][3][3]+1]={168,"Beef Turnover",false,false,1879205383};
Recipe[1][3][7][#Recipe[1][3][7]+1]={265,"Bowl of Hearty Stock",false,true,1879061294};
Recipe[1][3][7][#Recipe[1][3][7]+1]={618,"Cut of Marinated Beef",false,true,1879061295};
Recipe[1][3][12][#Recipe[1][3][12]+1]={662,"Delicious Crispy Bacon",false,true,1879061291};
--Recipe[1][3][13][#Recipe[1][3][13]+1]={680,"Expert Cook Expertise",false,false,1879184444};
Recipe[1][3][12][#Recipe[1][3][12]+1]={1139,"Full Breakfast",false,true,1879182085};
Recipe[1][3][3][#Recipe[1][3][3]+1]={1271,"Hard Tack Ration",false,true,1879061289};
Recipe[1][3][6][#Recipe[1][3][6]+1]={1276,"Hearty Barley Soup",false,false,1879150193};
Recipe[1][3][6][#Recipe[1][3][6]+1]={1277,"Hearty Carrot Soup",false,false,1879150161};
Recipe[1][3][6][#Recipe[1][3][6]+1]={1278,"Hearty Mushroom Soup",false,false,1879150183};
Recipe[1][3][6][#Recipe[1][3][6]+1]={1279,"Hearty Onion Soup",false,false,1879150200};
Recipe[1][3][8][#Recipe[1][3][8]+1]={266,"Hearty Stock (x5)",false,false,1879137627};
Recipe[1][3][10][#Recipe[1][3][10]+1]={1424,"Honeybrew Beer",false,false,1879089602};
Recipe[1][3][8][#Recipe[1][3][8]+1]={619,"Marinated Beef (x5)",false,false,1879137569};
Recipe[1][3][2][#Recipe[1][3][2]+1]={1822,"Medium Expert Repast",false,false,1879125928};
Recipe[1][3][12][#Recipe[1][3][12]+1]={2000,"Perch Fillet",false,false,1879110366};
Recipe[1][3][12][#Recipe[1][3][12]+1]={2093,"Pork Chops",false,true,1879061292};
Recipe[1][3][9][#Recipe[1][3][9]+1]={2097,"Pot of Honey and Oats",false,false,1879089700};
Recipe[1][3][7][#Recipe[1][3][7]+1]={2148,"Prepared Pride of Chetwood Hops",false,false,1879089559};
Recipe[1][3][12][#Recipe[1][3][12]+1]={2505,"Roast Beef",false,true,1879182093};
Recipe[1][3][11][#Recipe[1][3][11]+1]={2676,"Seasoned Beef with Cauliflower",false,false,1879092697};
Recipe[1][3][10][#Recipe[1][3][10]+1]={2715,"Shire Spice Ale",false,false,1879089595};
Recipe[1][3][2][#Recipe[1][3][2]+1]={2765,"Small Expert Repast",false,false,1879125870};
Recipe[1][3][5][#Recipe[1][3][5]+1]={2768,"Small Feasting Table",false,false,1879102062};
Recipe[1][3][3][#Recipe[1][3][3]+1]={2858,"Steak and Kidney Pie",false,true,1879061288};
Recipe[1][3][8][#Recipe[1][3][8]+1]={2906,"Strawberry Filling (x5)",false,false,1879182275};
Recipe[1][3][7][#Recipe[1][3][7]+1]={2905,"Strawberry Pie Filling",false,true,1879182269};
Recipe[1][3][3][#Recipe[1][3][3]+1]={2909,"Strawberry Tart",false,false,1879103664};
Recipe[1][3][4][#Recipe[1][3][4]+1]={3021,"Superior Beef Stew (x25)",false,false,1879137277};
Recipe[1][3][4][#Recipe[1][3][4]+1]={3051,"Superior Hard Tack Rations (x25)",false,false,1879137512};
Recipe[1][3][4][#Recipe[1][3][4]+1]={3062,"Superior Steak and Kidney Pie (x25)",false,false,1879137278};
Recipe[1][3][12][#Recipe[1][3][12]+1]={3214,"Vegetable Medley",false,true,1879061293};
Recipe[1][3][1][#Recipe[1][3][1]+1]={3356,"Yew Campfire Kit",false,false,1879182459};

Recipe[1][4][7][#Recipe[1][4][7]+1]={84,"Apple Pie Filling",false,true,1879061307};
Recipe[1][4][8][#Recipe[1][4][8]+1]={85,"Apple Pie Filling (x5)",false,false,1879137668};
Recipe[1][4][12][#Recipe[1][4][12]+1]={86,"Apple Sauce",false,true,1879182088};
--Recipe[1][4][#Recipe[1][4]+1]={673,"Artisan Cook Expertise",false,false,1879184442};
Recipe[1][4][9][#Recipe[1][4][9]+1]={131,"Bag of Crunchy Crumbs",false,false,1879197253};
Recipe[1][4][7][#Recipe[1][4][7]+1]={262,"Bowl of Chicken Stock",false,false,1879150164};
Recipe[1][4][12][#Recipe[1][4][12]+1]={280,"Breakfast Barley with Fruit",false,true,1879182097};
Recipe[1][4][7][#Recipe[1][4][7]+1]={315,"Bucket of Winter Barley Mash",false,false,1879089582};
Recipe[1][4][6][#Recipe[1][4][6]+1]={411,"Chicken Barley Soup",false,false,1879150178};
Recipe[1][4][6][#Recipe[1][4][6]+1]={412,"Chicken Carrot Soup",false,false,1879150229};
Recipe[1][4][6][#Recipe[1][4][6]+1]={413,"Chicken Mushroom Soup",false,false,1879150196};
Recipe[1][4][6][#Recipe[1][4][6]+1]={414,"Chicken Onion Soup",false,false,1879150201};
Recipe[1][4][7][#Recipe[1][4][7]+1]={613,"Cup of Winter Barley Flour",false,true,1879182211};
Recipe[1][4][9][#Recipe[1][4][9]+1]={622,"Cut of Tender Meat",false,false,1879197226};
Recipe[1][4][12][#Recipe[1][4][12]+1]={1213,"Golden Mullet Chowder",false,false,1879110376};
Recipe[1][4][12][#Recipe[1][4][12]+1]={1413,"Hobbiton Omelet",false,true,1879061304};
Recipe[1][4][11][#Recipe[1][4][11]+1]={1423,"Honey-roasted Chicken",false,false,1879092693};
Recipe[1][4][5][#Recipe[1][4][5]+1]={1556,"Large Feasting Table",false,false,1879102054};
Recipe[1][4][1][#Recipe[1][4][1]+1]={1597,"Lebethron Campfire Kit",false,false,1879182460};
Recipe[1][4][7][#Recipe[1][4][7]+1]={1751,"Marinated Chicken Cutlet",false,true,1879061306};
Recipe[1][4][8][#Recipe[1][4][8]+1]={1752,"Marinated Chicken Cutlets (x5)",false,false,1879137236};
Recipe[1][4][2][#Recipe[1][4][2]+1]={1815,"Medium Artisan Repast",false,false,1879125866};
Recipe[1][4][9][#Recipe[1][4][9]+1]={2099,"Pot of Smooth Honey and Oats",false,false,1879089685};
Recipe[1][4][7][#Recipe[1][4][7]+1]={2146,"Prepared Green Hill Hops",false,false,1879089577};
Recipe[1][4][8][#Recipe[1][4][8]+1]={2202,"Raspberry Filling (x5)",false,false,1879182271};
Recipe[1][4][7][#Recipe[1][4][7]+1]={2201,"Raspberry Pie Filling",false,true,1879182265};
Recipe[1][4][3][#Recipe[1][4][3]+1]={2203,"Raspberry Tart",false,false,1879103658};
Recipe[1][4][12][#Recipe[1][4][12]+1]={2509,"Roasted Chicken",false,true,1879061305};
Recipe[1][4][12][#Recipe[1][4][12]+1]={2567,"Salted Beef Delights",false,true,1879061303};
Recipe[1][4][3][#Recipe[1][4][3]+1]={2714,"Shire Rations",false,true,1879061300};
Recipe[1][4][2][#Recipe[1][4][2]+1]={2758,"Small Artisan Repast",false,false,1879125780};
Recipe[1][4][3][#Recipe[1][4][3]+1]={2836,"Spiced Apple Pie",false,true,1879061301};
Recipe[1][4][3][#Recipe[1][4][3]+1]={2893,"Stew of Kings",false,true,1879061302};
Recipe[1][4][11][#Recipe[1][4][11]+1]={2903,"Strawberry Dessert-wine",false,false,1879092716};
Recipe[1][4][3][#Recipe[1][4][3]+1]={2907,"Strawberry Scone",false,false,1879205379};
Recipe[1][4][10][#Recipe[1][4][10]+1]={2908,"Strawberry Stout Beer",false,false,1879089571};
Recipe[1][4][4][#Recipe[1][4][4]+1]={3060,"Superior Shire Rations (x25)",false,false,1879137661};
Recipe[1][4][4][#Recipe[1][4][4]+1]={3061,"Superior Spiced Apple Pie (x25)",false,false,1879137353};
Recipe[1][4][4][#Recipe[1][4][4]+1]={3063,"Superior Stew of Kings (x25)",false,false,1879137704};
Recipe[1][4][8][#Recipe[1][4][8]+1]={614,"Winter Barley Flour (x5)",false,false,1879182276};
Recipe[1][4][10][#Recipe[1][4][10]+1]={3343,"Winterberry Ale",false,false,1879089585};
Recipe[1][4][5][#Recipe[1][4][5]+1]={3346,"Wooden Keg",false,false,1879101792}; -- not sure on itemID

Recipe[1][5][8][#Recipe[1][5][8]+1]={134,"Bag of Tasty Crumbs",false,false,1879197250};
Recipe[1][5][10][#Recipe[1][5][10]+1]={135,"Baked Flounder",false,false,1879110367};
Recipe[1][5][10][#Recipe[1][5][10]+1]={162,"Bass with Carrots and Onions",false,false,1879110361};
Recipe[1][5][1][#Recipe[1][5][1]+1]={184,"Black Ash Campfire Kit",false,false,1879182458};
Recipe[1][5][9][#Recipe[1][5][9]+1]={198,"Blackberry Ale",false,false,1879089562};
Recipe[1][5][6][#Recipe[1][5][6]+1]={200,"Blackberry Pie Filling",false,true,0};
Recipe[1][5][7][#Recipe[1][5][7]+1]={201,"Blackberry Pie Filling (x5)",false,false,1879137605};
Recipe[1][5][3][#Recipe[1][5][3]+1]={202,"Blackberry Tart",false,false,1879103663};
Recipe[1][5][6][#Recipe[1][5][6]+1]={261,"Bowl of Beef Stock",false,false,1879150180};
Recipe[1][5][5][#Recipe[1][5][5]+1]={591,"Cream of Barley Soup",false,false,1879150184};
Recipe[1][5][5][#Recipe[1][5][5]+1]={592,"Cream of Carrot Soup",false,false,1879150227};
Recipe[1][5][5][#Recipe[1][5][5]+1]={593,"Cream of Mushroom Soup",false,false,1879150171};
Recipe[1][5][5][#Recipe[1][5][5]+1]={594,"Cream of Onion Soup",false,false,1879150198};
Recipe[1][5][6][#Recipe[1][5][6]+1]={610,"Cup of Tasty Frosting",false,true,0};
Recipe[1][5][8][#Recipe[1][5][8]+1]={621,"Cut of Tasty Meat",false,false,1879197254};
Recipe[1][5][10][#Recipe[1][5][10]+1]={663,"Delicious Steak",false,true,0};
Recipe[1][5][10][#Recipe[1][5][10]+1]={1056,"Feast of Rohan",false,true,0};
Recipe[1][5][10][#Recipe[1][5][10]+1]={1096,"Flounder Fillet",false,false,1879110375};
Recipe[1][5][10][#Recipe[1][5][10]+1]={1097,"Flounder with Bacon",false,false,1879110372};
Recipe[1][5][10][#Recipe[1][5][10]+1]={1138,"Fruit Roll",false,true,0};
Recipe[1][5][10][#Recipe[1][5][10]+1]={1214,"Golden Roast Potatoes",false,true,0};
Recipe[1][5][2][#Recipe[1][5][2]+1]={1561,"Large Master Repast",false,false,1879125830};
Recipe[1][5][3][#Recipe[1][5][3]+1]={1609,"Lembas",false,true,0};
--Recipe[1][5][#Recipe[1][5]+1]={694,"Master Cook Expertise",false,false,1879184440};
Recipe[1][5][10][#Recipe[1][5][10]+1]={1810,"Masterful Mash",false,true,0};
Recipe[1][5][2][#Recipe[1][5][2]+1]={1829,"Medium Master Repast",false,false,1879125795};
Recipe[1][5][3][#Recipe[1][5][3]+1]={2004,"Perfect Pie",false,true,0};
Recipe[1][5][8][#Recipe[1][5][8]+1]={2101,"Pot of Tasty Honey and Oats",false,false,1879143143};
Recipe[1][5][3][#Recipe[1][5][3]+1]={2102,"Potage of Chicken and Onions",false,false,1879205384};
Recipe[1][5][6][#Recipe[1][5][6]+1]={2149,"Prepared Umbel Hops",false,false,1879089570};
Recipe[1][5][3][#Recipe[1][5][3]+1]={2506,"Roast of Heroes",true,false,1879076382};
Recipe[1][5][2][#Recipe[1][5][2]+1]={2773,"Small Master Repast",false,false,1879125894};
Recipe[1][5][4][#Recipe[1][5][4]+1]={3053,"Superior Lembas (x25)",false,false,1879137694};
Recipe[1][5][4][#Recipe[1][5][4]+1]={3056,"Superior Perfect Pie (x25)",false,false,1879137242};
Recipe[1][5][4][#Recipe[1][5][4]+1]={3066,"Superior Ultimate Carrot Cake (x25)",false,false,1879137573};
Recipe[1][5][7][#Recipe[1][5][7]+1]={611,"Tasty Frosting (x5)",false,false,1879137252};
Recipe[1][5][3][#Recipe[1][5][3]+1]={3207,"Ultimate Carrot Cake",false,true,0};
Recipe[1][5][9][#Recipe[1][5][9]+1]={3208,"Ultimate Honeybrew Beer",false,false,1879089599};

Recipe[1][6][11][#Recipe[1][6][11]+1]={132,"Bag of Delicious Crumbs",false,false,1879197238};
Recipe[1][6][12][#Recipe[1][6][12]+1]={133,"Bag of Hearty Crumbs",false,false,1879197215};
Recipe[1][6][9][#Recipe[1][6][9]+1]={145,"Ball of Dough",false,true,0};
Recipe[1][6][10][#Recipe[1][6][10]+1]={146,"Ball of Dough (x5)",false,false,1879137754};
Recipe[1][6][10][#Recipe[1][6][10]+1]={1491,"Blackberry Jam (x5)",false,false,1879137418};
Recipe[1][6][11][#Recipe[1][6][11]+1]={264,"Bowl of Fresh Water",false,false,1879197234};
Recipe[1][6][9][#Recipe[1][6][9]+1]={267,"Bowl of Lamb Stock",false,false,1879150160};
Recipe[1][6][9][#Recipe[1][6][9]+1]={270,"Bowl of Mashed Royal Taters",false,true,0};
Recipe[1][6][11][#Recipe[1][6][11]+1]={275,"Bowl of Water",false,false,1879197209};
Recipe[1][6][3][#Recipe[1][6][3]+1]={278,"Bread and Jam",false,true,0};
Recipe[1][6][12][#Recipe[1][6][12]+1]={313,"Bubble and Squeak",false,true,0};
Recipe[1][6][12][#Recipe[1][6][12]+1]={336,"Buttered Scone and Jam",false,true,0};
Recipe[1][6][12][#Recipe[1][6][12]+1]={385,"Cauliflower Cheese",false,false,1879182100};
Recipe[1][6][7][#Recipe[1][6][7]+1]={602,"Cup of Black Tea",false,false,1879145214};
Recipe[1][6][7][#Recipe[1][6][7]+1]={605,"Cup of Green Tea",false,false,1879145209};
Recipe[1][6][12][#Recipe[1][6][12]+1]={608,"Cup of Red Tea",false,true,0};
Recipe[1][6][7][#Recipe[1][6][7]+1]={612,"Cup of White Tea",false,false,1879145206};
Recipe[1][6][11][#Recipe[1][6][11]+1]={616,"Cut of Delicious Meat",false,false,1879197255};
Recipe[1][6][11][#Recipe[1][6][11]+1]={617,"Cut of Lean Meat",false,false,1879197210};
Recipe[1][6][6][#Recipe[1][6][6]+1]={1053,"Feast of Ethuilwereth",false,false,1879166092};
Recipe[1][6][6][#Recipe[1][6][6]+1]={1054,"Feast of Harvestmath",false,false,1879166086};
Recipe[1][6][6][#Recipe[1][6][6]+1]={1055,"Feast of Lithe",false,false,1879166112};
Recipe[1][6][4][#Recipe[1][6][4]+1]={1149,"Galadhrim Ration",false,false,1879154541};
Recipe[1][6][4][#Recipe[1][6][4]+1]={1223,"Golden Wood Roast",false,false,1879154535};
Recipe[1][6][12][#Recipe[1][6][12]+1]={1262,"Green Pea Soup",false,true,0};
Recipe[1][6][12][#Recipe[1][6][12]+1]={1264,"Green Peas with Mint",false,false,1879182086};
Recipe[1][6][12][#Recipe[1][6][12]+1]={1422,"Honey-cake",false,true,0};
Recipe[1][6][9][#Recipe[1][6][9]+1]={1490,"Jar of Blackberry Jam",false,true,0};
Recipe[1][6][9][#Recipe[1][6][9]+1]={1492,"Jar of Mint Sauce",false,true,0};
Recipe[1][6][8][#Recipe[1][6][8]+1]={1550,"Lamb and Barley Soup",false,false,1879150202};
Recipe[1][6][8][#Recipe[1][6][8]+1]={1551,"Lamb and Carrot Soup",false,false,1879150228};
Recipe[1][6][8][#Recipe[1][6][8]+1]={1552,"Lamb and Mushroom Soup",false,false,1879150216};
Recipe[1][6][8][#Recipe[1][6][8]+1]={1553,"Lamb and Onion Soup",false,false,1879150213};
Recipe[1][6][12][#Recipe[1][6][12]+1]={1554,"Lamb Hotpot",false,false,1879182099};
Recipe[1][6][2][#Recipe[1][6][2]+1]={1568,"Large Supreme Repast",false,false,1879125921};
Recipe[1][6][4][#Recipe[1][6][4]+1]={1664,"Lothl"..string.char(195)..string.char(179).."rien Waybread",false,false,1879154511};
Recipe[1][6][1][#Recipe[1][6][1]+1]={1731,"Mallorn Campfire Kit",false,false,1879182461};
Recipe[1][6][10][#Recipe[1][6][10]+1]={271,"Mashed Royal Taters (x5)",false,false,1879137314};
Recipe[1][6][2][#Recipe[1][6][2]+1]={1836,"Medium Supreme Repast",false,false,1879125758};
Recipe[1][6][10][#Recipe[1][6][10]+1]={1493,"Mint Sauce (x5)",false,false,1879137319};
Recipe[1][6][12][#Recipe[1][6][12]+1]={1904,"Mushy Green Peas",false,false,1879182102};
Recipe[1][6][12][#Recipe[1][6][12]+1]={1935,"Onion and Mushroom Omelet",false,false,1879182101};
Recipe[1][6][3][#Recipe[1][6][3]+1]={1983,"Pan-seared Potatoes and Lamb",false,false,1879205381};
Recipe[1][6][11][#Recipe[1][6][11]+1]={2096,"Pot of Delicious Honey and Oats",false,false,1879143144};
Recipe[1][6][11][#Recipe[1][6][11]+1]={2100,"Pot of Sweet Honey and Oats",false,false,1879173703};
Recipe[1][6][3][#Recipe[1][6][3]+1]={2183,"Rack of Lamb with Mint Sauce",false,true,0};
Recipe[1][6][12][#Recipe[1][6][12]+1]={2508,"Roasted Carp",false,false,1879196470};
Recipe[1][6][3][#Recipe[1][6][3]+1]={2706,"Shepherd's Pie",false,true,0};
Recipe[1][6][2][#Recipe[1][6][2]+1]={2780,"Small Supreme Repast",false,false,1879125904};
Recipe[1][6][5][#Recipe[1][6][5]+1]={3028,"Superior Bread and Jam (x25)",false,false,1879137501};
Recipe[1][6][5][#Recipe[1][6][5]+1]={3049,"Superior Galadhrim Ration (x25)",false,false,1879157216};
Recipe[1][6][5][#Recipe[1][6][5]+1]={3050,"Superior Golden Wood Roast (x25)",false,false,1879157201};
Recipe[1][6][5][#Recipe[1][6][5]+1]={3054,"Superior Lothl"..string.char(195)..string.char(179).."rien Waybread (x25)",false,false,1879157211};
Recipe[1][6][5][#Recipe[1][6][5]+1]={3057,"Superior Rack of Lamb with Mint Sauce (x25)",false,false,1879137372};
Recipe[1][6][5][#Recipe[1][6][5]+1]={3059,"Superior Shepherd\'s Pie (x25)",false,false,1879137479};
--Recipe[1][6][#Recipe[1][6]+1]={701,"Supreme Cook Expertise",false,false,1879184443};

Recipe[1][7][5][#Recipe[1][7][5]+1]={83,"Apple and Cheese Pie",false,false,1879210962};
Recipe[1][7][10][#Recipe[1][7][10]+1]={128,"Bag of Crispy Crumbs",false,false,1879210929};
Recipe[1][7][8][#Recipe[1][7][8]+1]={3377,"Bag of Roasted Coffee Grounds",false,true,1879225756}; 
Recipe[1][7][11][#Recipe[1][7][11]+1]={148,"Bannock",false,false,1879211022};
Recipe[1][7][3][#Recipe[1][7][3]+1]={176,"Bilberry Pie",false,true,1879211419};
Recipe[1][7][1][#Recipe[1][7][1]+1]={177,"Birch Campfire Kit",false,false,1879211418}; --1879211418 why is this ID not valid?
Recipe[1][7][11][#Recipe[1][7][11]+1]={196,"Black Pudding",false,false,1879211098};
Recipe[1][7][8][#Recipe[1][7][8]+1]={268,"Bowl of Leek Stock",false,true,1879215445};
Recipe[1][7][9][#Recipe[1][7][9]+1]={269,"Bowl of Leek Stock (x5)",false,false,1879216177};
Recipe[1][7][10][#Recipe[1][7][10]+1]={274,"Bowl of Spring Water",false,false,1879211117};
Recipe[1][7][11][#Recipe[1][7][11]+1]={277,"Bread and Butter Pudding",false,true,1879211421};
Recipe[1][7][3][#Recipe[1][7][3]+1]={279,"Breaded Oxtail",false,false,1879210892};
Recipe[1][7][12][#Recipe[1][7][12]+1]={384,"Cauliflower and Chicken",false,false,1879210922};
Recipe[1][7][12][#Recipe[1][7][12]+1]={415,"Chicken Pie",false,false,1879210980};
Recipe[1][7][7][#Recipe[1][7][7]+1]={417,"Cock-a-Leekie Soup",false,false,1879211054};
Recipe[1][7][11][#Recipe[1][7][11]+1]={437,"Cottage Pie",false,false,1879210912};
Recipe[1][7][8][#Recipe[1][7][8]+1]={600,"Cup of Black Barley Flour",false,true,1879211414};
Recipe[1][7][9][#Recipe[1][7][9]+1]={601,"Cup of Black Barley Flour (x5)",false,false,1879216172};
Recipe[1][7][8][#Recipe[1][7][8]+1]={603,"Cup of Bread-crumbs",false,true,1879211415};
Recipe[1][7][9][#Recipe[1][7][9]+1]={604,"Cup of Bread-crumbs (x5)",false,false,1879216174};
Recipe[1][7][8][#Recipe[1][7][8]+1]={606,"Cup of Oatmeal",false,true,1879211416};
Recipe[1][7][9][#Recipe[1][7][9]+1]={607,"Cup of Oatmeal (x5)",false,false,1879216182};
Recipe[1][7][11][#Recipe[1][7][11]+1]={3422,"Cup of Second Breakfast Blend Coffee",false,false,1879225820};
Recipe[1][7][6][#Recipe[1][7][6]+1]={3374,"Cup of Westfold Bold Coffee",false,false,1879225823};
Recipe[1][7][6][#Recipe[1][7][6]+1]={3375,"Cup of Westfold Medium Coffee",false,false,1879225818};
Recipe[1][7][6][#Recipe[1][7][6]+1]={3376,"Cup of Westfold Mild Coffee",false,false,1879225822};
Recipe[1][7][10][#Recipe[1][7][10]+1]={620,"Cut of Spicy Meat",false,false,1879211032};
Recipe[1][7][2][#Recipe[1][7][2]+1]={1575,"Large Westfold Repast",false,false,1879216175};
Recipe[1][7][8][#Recipe[1][7][8]+1]={1634,"Loaf of Barley Bread",false,true,1879211417};
Recipe[1][7][9][#Recipe[1][7][9]+1]={1635,"Loaf of Barley Bread (x5)",false,false,1879216178};
Recipe[1][7][2][#Recipe[1][7][2]+1]={1843,"Medium Westfold Repast",false,false,1879216180};
Recipe[1][7][12][#Recipe[1][7][12]+1]={1919,"Oaty Beef",false,false,1879211019};
Recipe[1][7][7][#Recipe[1][7][7]+1]={1967,"Oxtail Stew",false,false,1879211094};
Recipe[1][7][10][#Recipe[1][7][10]+1]={2098,"Pot of Scrumptious Honey and Oats",false,false,1879211093};
Recipe[1][7][12][#Recipe[1][7][12]+1]={2103,"Potato Scone",false,false,1879210888};
Recipe[1][7][11][#Recipe[1][7][11]+1]={2199,"Rarebit Muffin",false,true,1879211420};
Recipe[1][7][12][#Recipe[1][7][12]+1]={2518,"Rohan Hotpot",false,false,1879210938};
Recipe[1][7][5][#Recipe[1][7][5]+1]={2519,"Rohan Pasty",false,false,1879210884};
Recipe[1][7][3][#Recipe[1][7][3]+1]={2677,"Seed Cake",false,false,1879210880};
Recipe[1][7][2][#Recipe[1][7][2]+1]={2787,"Small Westfold Repast",false,false,1879216181};
Recipe[1][7][7][#Recipe[1][7][7]+1]={2837,"Spiced Beef Stew",false,false,1879211001};
Recipe[1][7][4][#Recipe[1][7][4]+1]={3019,"Superior Apple and Cheese Pies (x25)",false,false,1879216179};
Recipe[1][7][4][#Recipe[1][7][4]+1]={3058,"Superior Rohan Pasty (x25)",false,false,1879216173};
Recipe[1][7][4][#Recipe[1][7][4]+1]={3065,"Superior Toad in the Hole (x25)",false,false,1879216176};
Recipe[1][7][5][#Recipe[1][7][5]+1]={3168,"Toad-in-the-Hole",false,false,1879210937};
Recipe[1][7][7][#Recipe[1][7][7]+1]={3339,"Wild Mushroom Soup",false,false,1879211034};

Recipe[2][1][1][#Recipe[2][1][1]+1]={899,"Black Mushroom Field",true,false,1879088558};
Recipe[2][1][4][#Recipe[2][1][4]+1]={322,"Bunch of North Downs Hops",false,false,1879089075};
Recipe[2][1][3][#Recipe[2][1][3]+1]={330,"Bundle of Spring Barley",false,true,0};
Recipe[2][1][6][#Recipe[2][1][6]+1]={354,"Carrot Field",false,false,1879076498};
Recipe[2][1][6][#Recipe[2][1][6]+1]={1135,"Fresh Carrot",false,false,1879076499};
Recipe[2][1][2][#Recipe[2][1][2]+1]={1629,"Lily-of-the-Valley",false,false,1879115455};
Recipe[2][1][1][#Recipe[2][1][1]+1]={1630,"Lily-of-the-valley Arrangement",false,false,1879151801};
Recipe[2][1][2][#Recipe[2][1][2]+1]={1631,"Lily-of-the-Valley Field",false,false,1879115433};
Recipe[2][1][5][#Recipe[2][1][5]+1]={1639,"Longbottom Leaf Field",false,true,0};
Recipe[2][1][6][#Recipe[2][1][6]+1]={1899,"Mushroom",false,false,1879076496};
Recipe[2][1][6][#Recipe[2][1][6]+1]={1900,"Mushroom Field",false,false,1879076495};
Recipe[2][1][4][#Recipe[2][1][4]+1]={1916,"North Downs Hops Field",false,false,1879089116};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2122,"Pouch of Longbottom Leaf Pipe-weed",false,true,0};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2126,"Pouch of Rushlight Pipe-weed",false,false,1879076512};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2129,"Pouch of Southlinch Pipe-weed",false,true,0};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2130,"Pouch of Stonecrop Leaf Pipe-weed",false,false,1879088113};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2133,"Pouch of Sweet Lobelia Pipe-weed",false,false,1879076515};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2557,"Rushlight Field",false,false,1879076510};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2833,"Southlinch Field",false,true,0};
Recipe[2][1][3][#Recipe[2][1][3]+1]={2839,"Spring Barley Field",false,true,0};
Recipe[2][1][5][#Recipe[2][1][5]+1]={2894,"Stonecrop Leaf Field",false,false,1879088122};
Recipe[2][1][5][#Recipe[2][1][5]+1]={3104,"Sweet Lobelia Field",false,false,1879076513};
Recipe[2][1][6][#Recipe[2][1][6]+1]={3351,"Yellow Onion",false,true,0};
Recipe[2][1][6][#Recipe[2][1][6]+1]={3352,"Yellow Onion Field",false,true,0};

Recipe[2][2][6][#Recipe[2][2][6]+1]={226,"Blueberry Field",false,false,1879076504};
Recipe[2][2][6][#Recipe[2][2][6]+1]={318,"Bunch of Blueberries",false,false,1879076505};
Recipe[2][2][4][#Recipe[2][2][4]+1]={319,"Bunch of Golding Hops",false,false,1879089082};
Recipe[2][2][3][#Recipe[2][2][3]+1]={323,"Bunch of Oats",false,false,1879089682};
Recipe[2][2][6][#Recipe[2][2][6]+1]={337,"Cabbage",false,true,0};
Recipe[2][2][6][#Recipe[2][2][6]+1]={338,"Cabbage Field",false,true,0};
Recipe[2][2][4][#Recipe[2][2][4]+1]={1226,"Golding Hops Field",false,false,1879089072};
Recipe[2][2][5][#Recipe[2][2][5]+1]={1425,"Hornblower Field",false,false,1879076519};
Recipe[2][2][2][#Recipe[2][2][2]+1]={1462,"Iris",false,false,1879115389};
Recipe[2][2][1][#Recipe[2][2][1]+1]={1463,"Iris Arrangement",false,false,1879151802};
Recipe[2][2][2][#Recipe[2][2][2]+1]={1464,"Iris Field",false,false,1879115357};
Recipe[2][2][5][#Recipe[2][2][5]+1]={1898,"Muddy Foot Field",false,false,1879076522};
Recipe[2][2][3][#Recipe[2][2][3]+1]={1918,"Oat Field",false,false,1879089688};
Recipe[2][2][5][#Recipe[2][2][5]+1]={2120,"Pouch of Hornblower Pipe-weed",false,false,1879076521};
Recipe[2][2][5][#Recipe[2][2][5]+1]={2123,"Pouch of Muddy Foot Pipe-weed",false,false,1879076524};
Recipe[2][2][5][#Recipe[2][2][5]+1]={2128,"Pouch of Southern Star Pipe-weed",false,true,0};
Recipe[2][2][5][#Recipe[2][2][5]+1]={2134,"Pouch of Tighfield Choice Pipe-weed",false,false,1879076518};
Recipe[2][2][5][#Recipe[2][2][5]+1]={2832,"Southern Star Field",false,true,0};
Recipe[2][2][6][#Recipe[2][2][6]+1]={3145,"Tater",false,false,1879076502};
Recipe[2][2][6][#Recipe[2][2][6]+1]={3146,"Tater Field",false,false,1879076501};
Recipe[2][2][5][#Recipe[2][2][5]+1]={3165,"Tighfield Choice Field",false,false,1879076516};

Recipe[2][3][2][#Recipe[2][3][2]+1]={230,"Bluebottle",false,false,1879115353};
Recipe[2][3][1][#Recipe[2][3][1]+1]={231,"Bluebottle Arrangement",false,false,1879151806};
Recipe[2][3][2][#Recipe[2][3][2]+1]={232,"Bluebottle Field",false,false,1879115423};
Recipe[2][3][3][#Recipe[2][3][3]+1]={324,"Bunch of Pride of Chetwood Hops",false,false,1879089107};
Recipe[2][3][5][#Recipe[2][3][5]+1]={386,"Cauliflower Field",false,false,1879076507};
Recipe[2][3][4][#Recipe[2][3][4]+1]={718,"Dragon's Breath Field",false,false,1879076531};
Recipe[2][3][5][#Recipe[2][3][5]+1]={1259,"Green Onion",false,true,0};
Recipe[2][3][5][#Recipe[2][3][5]+1]={1260,"Green Onion Field",false,true,0};
Recipe[2][3][5][#Recipe[2][3][5]+1]={1275,"Head of Cauliflower",false,false,1879076508};
Recipe[2][3][4][#Recipe[2][3][4]+1]={1610,"Lengalenas Field",false,false,1879088091};
Recipe[2][3][4][#Recipe[2][3][4]+1]={1932,"Old Toby Field",false,false,1879076528};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2115,"Pouch of Dragon's Breath Pipe-weed",false,false,1879076533};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2121,"Pouch of Lengalenas Pipe-weed",false,false,1879088119};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2124,"Pouch of Old Toby Pipe-weed",false,false,1879076530};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2125,"Pouch of Roper's Twist Pipe-weed",false,false,1879076527};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2127,"Pouch of Shire Sweet-leaf Pipe-weed",false,false,1879098351};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2132,"Pouch of Sweet Galenas Pipe-weed",false,true,0};
Recipe[2][3][3][#Recipe[2][3][3]+1]={2150,"Pride of Chetwood Hops Field",false,false,1879089110};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2527,"Roper's Twist Field",false,false,1879076525};
Recipe[2][3][4][#Recipe[2][3][4]+1]={2716,"Shire Sweet-leaf Field",false,false,1879098341};
Recipe[2][3][4][#Recipe[2][3][4]+1]={3103,"Sweet Galenas Field",false,true,0};

Recipe[2][4][2][#Recipe[2][4][2]+1]={16,"Amaranth",false,false,1879115413};
Recipe[2][4][1][#Recipe[2][4][1]+1]={17,"Amaranth Arrangement",false,false,1879151798};
Recipe[2][4][2][#Recipe[2][4][2]+1]={18,"Amaranth Field",false,false,1879115363};
Recipe[2][4][4][#Recipe[2][4][4]+1]={320,"Bunch of Green Hill Hops",false,false,1879089032};
Recipe[2][4][6][#Recipe[2][4][6]+1]={325,"Bunch of Raspberries",false,false,1879076705};
Recipe[2][4][6][#Recipe[2][4][6]+1]={326,"Bunch of Strawberries",false,true,0};
Recipe[2][4][3][#Recipe[2][4][3]+1]={332,"Bundle of Winter Barley",false,true,0};
Recipe[2][4][5][#Recipe[2][4][5]+1]={783,"Eagle's Nest Field",false,false,1879076710};
Recipe[2][4][5][#Recipe[2][4][5]+1]={1151,"Gamwich Braid Field",false,false,1879076707};
Recipe[2][4][4][#Recipe[2][4][4]+1]={1258,"Green Hill Hops Field",false,false,1879089055};
Recipe[2][4][5][#Recipe[2][4][5]+1]={2116,"Pouch of Eagle's Nest Pipe-weed",false,false,1879076712};
Recipe[2][4][5][#Recipe[2][4][5]+1]={2118,"Pouch of Gamwich Braid Pipe-weed",false,false,1879076709};
Recipe[2][4][6][#Recipe[2][4][6]+1]={2200,"Raspberry Field",false,false,1879076704};
Recipe[2][4][2][#Recipe[2][4][2]+1]={2560,"Saffron",false,false,1879115400};
Recipe[2][4][1][#Recipe[2][4][1]+1]={2561,"Saffron Arrangement",false,false,1879151796};
Recipe[2][4][2][#Recipe[2][4][2]+1]={2562,"Saffron Field",false,false,1879115415};
Recipe[2][4][6][#Recipe[2][4][6]+1]={2710,"Shire Apple",false,true,0};
Recipe[2][4][6][#Recipe[2][4][6]+1]={2711,"Shire Apple Tree",false,true,0};
Recipe[2][4][6][#Recipe[2][4][6]+1]={2904,"Strawberry Field",false,true,0};
Recipe[2][4][3][#Recipe[2][4][3]+1]={3342,"Winter Barley Field",false,true,0};

Recipe[2][5][5][#Recipe[2][5][5]+1]={199,"Blackberry Field",false,true,0};
Recipe[2][5][2][#Recipe[2][5][2]+1]={220,"Bloodwort",false,false,1879115452};
Recipe[2][5][1][#Recipe[2][5][1]+1]={221,"Bloodwort Arrangement",false,false,1879151804};
Recipe[2][5][2][#Recipe[2][5][2]+1]={222,"Bloodwort Field",false,false,1879115354};
Recipe[2][5][5][#Recipe[2][5][5]+1]={317,"Bunch of Blackberries",false,true,0};
Recipe[2][5][3][#Recipe[2][5][3]+1]={327,"Bunch of Umbel Hops",false,false,1879089054};
Recipe[2][5][2][#Recipe[2][5][2]+1]={785,"Elder",false,false,1879115468};
Recipe[2][5][1][#Recipe[2][5][1]+1]={786,"Elder Arrangement",false,false,1879151794};
Recipe[2][5][2][#Recipe[2][5][2]+1]={787,"Elder Field",false,false,1879115384};
Recipe[2][5][5][#Recipe[2][5][5]+1]={1215,"Golden Shire Tater",false,true,0};
Recipe[2][5][5][#Recipe[2][5][5]+1]={1216,"Golden Shire Tater Field",false,true,0};
Recipe[2][5][4][#Recipe[2][5][4]+1]={2131,"Pouch of Summer Green-weed Pipe-weed",false,false,1879088086};
Recipe[2][5][4][#Recipe[2][5][4]+1]={2135,"Pouch of Wizard's Fire Pipe-weed",false,false,1879076715};
Recipe[2][5][4][#Recipe[2][5][4]+1]={2959,"Summer Green-weed Field",false,false,1879088123};
Recipe[2][5][3][#Recipe[2][5][3]+1]={3209,"Umbel Hops Field",false,false,1879089090};
Recipe[2][5][4][#Recipe[2][5][4]+1]={3344,"Wizard's Fire Field",false,false,1879076713};

Recipe[2][6][2][#Recipe[2][6][2]+1]={329,"Bundle of Mint Leaves",false,true,0};
Recipe[2][6][2][#Recipe[2][6][2]+1]={331,"Bundle of Tea Leaves",false,true,0};
Recipe[2][6][1][#Recipe[2][6][1]+1]={1140,"Fungo's Fuzzy-leaf Pipe-weed Field",false,true,0};
Recipe[2][6][1][#Recipe[2][6][1]+1]={1198,"Gold-fire Pipe-weed Field",false,false,1879109072};
Recipe[2][6][2][#Recipe[2][6][2]+1]={1261,"Green Pea Field",false,true,0};
Recipe[2][6][2][#Recipe[2][6][2]+1]={1263,"Green Peas",false,true,0};
Recipe[2][6][2][#Recipe[2][6][2]+1]={1866,"Mint Field",false,true,0};
Recipe[2][6][1][#Recipe[2][6][1]+1]={2117,"Pouch of Fungo's Fuzzy-leaf Pipe-weed",false,true,0};
Recipe[2][6][1][#Recipe[2][6][1]+1]={2119,"Pouch of Gold-fire Pipe-weed",false,false,1879109082};
Recipe[2][6][2][#Recipe[2][6][2]+1]={2552,"Royal Tater",false,true,0};
Recipe[2][6][2][#Recipe[2][6][2]+1]={2553,"Royal Tater Field",false,true,0};
Recipe[2][6][2][#Recipe[2][6][2]+1]={3153,"Tea Field",false,true,0};

Recipe[2][7][5][#Recipe[2][7][5]+1]={3379,"Bag of Coffee Beans (x2)",false,false,1879226946}; 
Recipe[2][7][5][#Recipe[2][7][5]+1]={3380,"Bag of Coffee Beans (x10)",false,false,1879226947}; 
Recipe[2][7][5][#Recipe[2][7][5]+1]={3370,"Billberry Field",false,true,0}; 
Recipe[2][7][4][#Recipe[2][7][4]+1]={3368,"Black Barley Field",false,true,0}; 
Recipe[2][7][5][#Recipe[2][7][5]+1]={316,"Bunch of Bilberries (x2)",false,true,0};
Recipe[2][7][5][#Recipe[2][7][5]+1]={3371,"Bunch of Bilberries (x10)",false,true,0}; 
Recipe[2][7][5][#Recipe[2][7][5]+1]={321,"Bunch of Leeks (x2)",false,true,0};
Recipe[2][7][5][#Recipe[2][7][5]+1]={3372,"Bunch of Leeks (x10)",false,true,0}; 
Recipe[2][7][4][#Recipe[2][7][4]+1]={328,"Bundle of Black Barley (x2)",false,true,0};
Recipe[2][7][4][#Recipe[2][7][4]+1]={3373,"Bundle of Black Barley (x10)",false,true,0}; 
Recipe[2][7][1][#Recipe[2][7][1]+1]={416,"Clump of Peat",false,true,0};
Recipe[2][7][5][#Recipe[2][7][5]+1]={3382,"Coffee Field",false,false,1879226945}; 
Recipe[2][7][5][#Recipe[2][7][5]+1]={3369,"Leek Field",false,true,0};
Recipe[2][7][2][#Recipe[2][7][2]+1]={3338,"Wild Flower Field",false,false,1879210906};
Recipe[2][7][3][#Recipe[2][7][3]+1]={3340,"Wild Pipe-weed Field",false,false,1879211047};

Recipe[3][1][2][#Recipe[3][1][2]+1]={2018,"Bulk Light Leather",false,false,1879184462};
Recipe[3][1][4][#Recipe[3][1][4]+1]={2041,"Bulk Treated Rowan",false,false,1879184466};
Recipe[3][1][1][#Recipe[3][1][1]+1]={2017,"Piece of Light Leather",false,true,0};
Recipe[3][1][3][#Recipe[3][1][3]+1]={2040,"Plank of Treated Rowan",false,true,0};

Recipe[3][2][3][#Recipe[3][2][3]+1]={2022,"Bulk Medium Leather",false,false,1879184483};
Recipe[3][2][4][#Recipe[3][2][4]+1]={2031,"Bulk Treated Ash",false,false,1879184473};
Recipe[3][2][1][#Recipe[3][2][1]+1]={1636,"Log-holder",false,false,1879101779};
Recipe[3][2][2][#Recipe[3][2][2]+1]={2021,"Piece of Medium Leather",false,true,0};
Recipe[3][2][4][#Recipe[3][2][4]+1]={2030,"Plank of Treated Ash",false,true,0};

Recipe[3][3][2][#Recipe[3][3][2]+1]={2026,"Bulk Sturdy Leather",false,false,1879184458};
Recipe[3][3][4][#Recipe[3][3][4]+1]={2043,"Bulk Treated Yew",false,false,1879184475};
Recipe[3][3][1][#Recipe[3][3][1]+1]={2025,"Piece of Sturdy Leather",false,true,0};
Recipe[3][3][3][#Recipe[3][3][3]+1]={2042,"Plank of Treated Yew",false,true,0};

Recipe[3][4][2][#Recipe[3][4][2]+1]={2024,"Bulk Pristine Leather",false,false,1879184456};
Recipe[3][4][4][#Recipe[3][4][4]+1]={2037,"Bulk Treated Lebethron",false,false,1879184479};
Recipe[3][4][1][#Recipe[3][4][1]+1]={2023,"Piece of Pristine Leather",false,true,0};
Recipe[3][4][3][#Recipe[3][4][3]+1]={2036,"Plank of Treated Lebethron",false,true,0};

Recipe[3][5][2][#Recipe[3][5][2]+1]={2012,"Bulk Exceptional Leather",false,false,1879184488};
Recipe[3][5][5][#Recipe[3][5][5]+1]={2033,"Bulk Treated Black Ash",false,false,1879184463};
Recipe[3][5][3][#Recipe[3][5][3]+1]={1233,"Gossamer Thread",false,true,0};
Recipe[3][5][1][#Recipe[3][5][1]+1]={2011,"Piece of Exceptional Leather",false,true,0};
Recipe[3][5][4][#Recipe[3][5][4]+1]={2032,"Plank of Treated Black Ash",false,true,0};
Recipe[3][5][4][#Recipe[3][5][4]+1]={3194,"Treated Black Ash Heartwood",false,true,1879092713};

Recipe[3][6][2][#Recipe[3][6][2]+1]={2014,"Bulk Extraordinary Leather",false,false,1879184480};
Recipe[3][6][2][#Recipe[3][6][2]+1]={2020,"Bulk Magnificent Leather",false,false,1879184486};
Recipe[3][6][4][#Recipe[3][6][4]+1]={2035,"Bulk Treated Ilex",false,false,1879184474};
Recipe[3][6][4][#Recipe[3][6][4]+1]={2039,"Bulk Treated Mallorn",false,false,1879184487};
Recipe[3][6][3][#Recipe[3][6][3]+1]={1896,"Mithril-inlaid Treated Mallorn Plank",false,true,0};
Recipe[3][6][1][#Recipe[3][6][1]+1]={1897,"Mithril-reinforced Extraordinary Leather",false,true,0};
Recipe[3][6][1][#Recipe[3][6][1]+1]={2013,"Piece of Extraordinary Leather",false,true,0};
Recipe[3][6][1][#Recipe[3][6][1]+1]={2019,"Piece of Magnificent Leather",false,true,0};
Recipe[3][6][3][#Recipe[3][6][3]+1]={2034,"Plank of Treated Ilex",false,true,0};
Recipe[3][6][3][#Recipe[3][6][3]+1]={2038,"Plank of Treated Mallorn",false,true,0};

Recipe[3][7][1][#Recipe[3][7][1]+1]={721,"Drop of Birch-tar",false,true,0};
Recipe[3][7][3][#Recipe[3][7][3]+1]={3616,"Improved Reinforced Birch Board",false,false,1879211031}; -- need correct category
Recipe[3][7][2][#Recipe[3][7][2]+1]={2010,"Piece of Brushed Leather",false,true,0};
Recipe[3][7][2][#Recipe[3][7][2]+1]={2015,"Piece of Finished Leather",false,true,1879210992};
Recipe[3][7][2][#Recipe[3][7][2]+1]={3757,"Improved Finished Leather",false,false,0};
Recipe[3][7][2][#Recipe[3][7][2]+1]={2016,"Piece of Glazed Leather",false,true,0};
Recipe[3][7][3][#Recipe[3][7][3]+1]={2365,"Reinforced Birch Board",false,true,1879211021};
Recipe[3][7][3][#Recipe[3][7][3]+1]={2815,"Solid Birch Board",false,true,0};
Recipe[3][7][3][#Recipe[3][7][3]+1]={3164,"Thin Birch Board",false,true,0};

Recipe[4][1][3][#Recipe[4][1][3]+1]={13,"Agate Bracelet",false,false,1879092893};
Recipe[4][1][6][#Recipe[4][1][6]+1]={14,"Agate Flint Rune-stone",false,false,1879113349};
Recipe[4][1][3][#Recipe[4][1][3]+1]={15,"Agate Necklace",false,false,1879067182};
Recipe[4][1][3][#Recipe[4][1][3]+1]={23,"Amethyst Earring",false,false,1879092913};
Recipe[4][1][3][#Recipe[4][1][3]+1]={24,"Amethyst Ring",false,false,1879067181};
Recipe[4][1][4][#Recipe[4][1][4]+1]={25,"Amethyst Ring of Tactics",false,false,1879152616};
--Recipe[4][1][#Recipe[4][1]+1]={668,"Apprentice Jeweller Expertise",false,false,1879184334};
Recipe[4][1][4][#Recipe[4][1][4]+1]={430,"Copper Bracelet",false,true,0};
Recipe[4][1][4][#Recipe[4][1][4]+1]={431,"Copper Earring",false,true,0};
Recipe[4][1][6][#Recipe[4][1][6]+1]={432,"Copper Flint Rune-stone",false,true,0};
Recipe[4][1][4][#Recipe[4][1][4]+1]={435,"Copper Necklace",false,true,0};
Recipe[4][1][4][#Recipe[4][1][4]+1]={436,"Copper Ring",false,true,0};
Recipe[4][1][7][#Recipe[4][1][7]+1]={722,"Dull Edhelharn Token",false,false,1879067171};
Recipe[4][1][2][#Recipe[4][1][2]+1]={1157,"Glittering Copper Bracelet",false,false,1879092900};
Recipe[4][1][2][#Recipe[4][1][2]+1]={1158,"Glittering Copper Earring",false,false,1879092926};
Recipe[4][1][2][#Recipe[4][1][2]+1]={1159,"Glittering Copper Necklace",false,false,1879181367};
Recipe[4][1][2][#Recipe[4][1][2]+1]={1160,"Glittering Copper Ring",false,false,1879181365};
Recipe[4][1][1][#Recipe[4][1][1]+1]={2052,"Polished Agate",false,true,0};
Recipe[4][1][1][#Recipe[4][1][1]+1]={2053,"Polished Amethyst",false,true,0};
Recipe[4][1][5][#Recipe[4][1][5]+1]={3116,"Talisman of the Blood-raven",true,false,1879098681};
Recipe[4][1][5][#Recipe[4][1][5]+1]={3119,"Talisman of the Frost-raven",true,false,1879098703};
Recipe[4][1][5][#Recipe[4][1][5]+1]={3121,"Talisman of the Raven",true,false,1879198690};

Recipe[4][2][5][#Recipe[4][2][5]+1]={217,"Bloodstone Earring",false,false,1879092934};
Recipe[4][2][5][#Recipe[4][2][5]+1]={218,"Bloodstone Ring",false,false,1879068137};
Recipe[4][2][5][#Recipe[4][2][5]+1]={219,"Bloodstone Ring of Tactics",false,false,1879152590};
Recipe[4][2][6][#Recipe[4][2][6]+1]={912,"Engraved Bloodstone Earring",true,false,1879092921};
Recipe[4][2][9][#Recipe[4][2][9]+1]={913,"Engraved Bloodstone Flint Rune-stone",true,false,1879113441};
Recipe[4][2][6][#Recipe[4][2][6]+1]={914,"Engraved Bloodstone Ring",true,false,1879068139};
Recipe[4][2][6][#Recipe[4][2][6]+1]={3773,"Engraved Bloodstone Ring",true,false,1879091034};
-- some of these old version recipes may still exist
Recipe[4][2][6][#Recipe[4][2][6]+1]={915,"Engraved Bloodstone Ring of Tactics",true,false,1879152587};
Recipe[4][2][6][#Recipe[4][2][6]+1]={917,"Engraved Opal Bracelet",true,false,1879092918};
Recipe[4][2][6][#Recipe[4][2][6]+1]={918,"Engraved Opal Necklace",true,false,1879068140};
Recipe[4][2][6][#Recipe[4][2][6]+1]={3772,"Engraved Opal Necklace",true,false,1879091288};
Recipe[4][2][10][#Recipe[4][2][10]+1]={1024,"Faint Edhelharn Token",false,false,1879069429};
Recipe[4][2][4][#Recipe[4][2][4]+1]={1169,"Glittering Silver Bracelet",false,false,1879092883};
Recipe[4][2][4][#Recipe[4][2][4]+1]={1170,"Glittering Silver Earring",false,false,1879092924};
Recipe[4][2][9][#Recipe[4][2][9]+1]={1171,"Glittering Silver Flint Rune-stone",false,false,1879113449};
Recipe[4][2][4][#Recipe[4][2][4]+1]={1172,"Glittering Silver Necklace",false,false,1879181366};
Recipe[4][2][4][#Recipe[4][2][4]+1]={1173,"Glittering Silver Ring",false,false,1879181371};
--Recipe[4][2][#Recipe[4][2]+1]={689,"Journeyman Jeweller Expertise",false,false,1879184333};
Recipe[4][2][1][#Recipe[4][2][1]+1]={1863,"Minor Striking Rune",false,false,1879068117};
Recipe[4][2][1][#Recipe[4][2][1]+1]={1865,"Minor Vanquishing Rune",false,false,1879068118};
Recipe[4][2][5][#Recipe[4][2][5]+1]={1938,"Opal Bracelet",false,false,1879092912};
Recipe[4][2][9][#Recipe[4][2][9]+1]={1939,"Opal Flint Rune-stone",false,false,1879113327};
Recipe[4][2][5][#Recipe[4][2][5]+1]={1940,"Opal Necklace",false,false,1879068138};
Recipe[4][2][2][#Recipe[4][2][2]+1]={2066,"Polished Bloodstone",false,true,0};
Recipe[4][2][2][#Recipe[4][2][2]+1]={2080,"Polished Opal",false,true,0};
Recipe[4][2][3][#Recipe[4][2][3]+1]={2720,"Silver Bracelet",false,true,0};
Recipe[4][2][3][#Recipe[4][2][3]+1]={2722,"Silver Earring",false,true,0};
Recipe[4][2][9][#Recipe[4][2][9]+1]={2723,"Silver Flint Rune-stone",false,true,0};
Recipe[4][2][3][#Recipe[4][2][3]+1]={2735,"Silver Necklace",false,true,0};
Recipe[4][2][3][#Recipe[4][2][3]+1]={2736,"Silver Ring",false,true,0};
Recipe[4][2][7][#Recipe[4][2][7]+1]={3142,"Talisman of the Bear",true,false,1879198692};
Recipe[4][2][7][#Recipe[4][2][7]+1]={3115,"Talisman of the Black Bear",true,false,1879098688};
Recipe[4][2][7][#Recipe[4][2][7]+1]={3117,"Talisman of the Blood-raven",true,false,1879098695};
Recipe[4][2][7][#Recipe[4][2][7]+1]={3619,"Talisman of the Frost-raven",true,false,1879098686};
Recipe[4][2][7][#Recipe[4][2][7]+1]={3122,"Talisman of the Mottled-raven",true,false,1879098685};
Recipe[4][2][7][#Recipe[4][2][7]+1]={3621,"Talisman of the Mottled-raven",true,false,1879098702}; -- this isn't really a duplicate entry, there are TWO of the same recipe
Recipe[4][2][7][#Recipe[4][2][7]+1]={3141,"Talisman of the Wildpaw-bear",true,false,1879098713};
Recipe[4][2][8][#Recipe[4][2][8]+1]={3337,"White Tree Trinket",true,false,1879062438};

Recipe[4][3][10][#Recipe[4][3][10]+1]={919,"Engraved Ruby Earring",true,false,1879092886};
Recipe[4][3][12][#Recipe[4][3][12]+1]={920,"Engraved Ruby Obsidian Rune-stone",true,false,1879113401};
Recipe[4][3][10][#Recipe[4][3][10]+1]={921,"Engraved Ruby Ring",true,false,1879069931};
Recipe[4][3][10][#Recipe[4][3][10]+1]={3626,"Engraved Ruby Ring",true,false,1879091105};
Recipe[4][3][10][#Recipe[4][3][10]+1]={922,"Engraved Ruby Ring of Tactics",true,false,1879152604};
Recipe[4][3][10][#Recipe[4][3][10]+1]={923,"Engraved Sapphire Bracelet",true,false,1879092910};
Recipe[4][3][10][#Recipe[4][3][10]+1]={924,"Engraved Sapphire Necklace",true,false,1879069932};
Recipe[4][3][10][#Recipe[4][3][10]+1]={3627,"Engraved Sapphire Necklace",true,false,1879091046};
Recipe[4][3][6][#Recipe[4][3][6]+1]={937,"Etched Ruby Earring",false,false,1879137285};
Recipe[4][3][13][#Recipe[4][3][13]+1]={938,"Etched Ruby Obsidian Rune-stone",false,false,1879137574};
Recipe[4][3][6][#Recipe[4][3][6]+1]={939,"Etched Ruby Ring",false,false,1879137401};
Recipe[4][3][6][#Recipe[4][3][6]+1]={940,"Etched Sapphire Bracelet",false,false,1879137529};
Recipe[4][3][6][#Recipe[4][3][6]+1]={941,"Etched Sapphire Necklace",false,false,1879137736};
--Recipe[4][3][#Recipe[4][3]+1]={682,"Expert Jeweller Expertise",false,false}; -- this one was not found in XML
Recipe[4][3][8][#Recipe[4][3][8]+1]={1161,"Glittering Gold Bracelet",false,false,1879092897};
Recipe[4][3][8][#Recipe[4][3][8]+1]={1162,"Glittering Gold Earring",false,false,1879092941};
Recipe[4][3][12][#Recipe[4][3][12]+1]={1163,"Glittering Gold Flint Rune-stone",false,false,1879113380};
Recipe[4][3][8][#Recipe[4][3][8]+1]={1164,"Glittering Gold Necklace",false,false,1879181368};
Recipe[4][3][8][#Recipe[4][3][8]+1]={1165,"Glittering Gold Ring",false,false,1879181369};
Recipe[4][3][14][#Recipe[4][3][14]+1]={1182,"Glossy Edhelharn Token",false,false,1879069910};
Recipe[4][3][7][#Recipe[4][3][7]+1]={1187,"Gold Bracelet",false,true,0};
Recipe[4][3][7][#Recipe[4][3][7]+1]={1190,"Gold Earring",false,true,0};
Recipe[4][3][12][#Recipe[4][3][12]+1]={1191,"Gold Flint Rune-stone",false,true,0};
Recipe[4][3][7][#Recipe[4][3][7]+1]={1195,"Gold Necklace",false,true,0};
Recipe[4][3][12][#Recipe[4][3][12]+1]={1196,"Gold Obsidian Rune-stone",false,true,0};
Recipe[4][3][7][#Recipe[4][3][7]+1]={1197,"Gold Ring",false,true,0};
Recipe[4][3][5][#Recipe[4][3][5]+1]={1824,"Medium Expert Symbol",false,false,1879125841};
Recipe[4][3][3][#Recipe[4][3][3]+1]={2081,"Polished Ruby",false,true,0};
Recipe[4][3][4][#Recipe[4][3][4]+1]={2082,"Polished Ruby (x5)",false,false,1879137653};
Recipe[4][3][3][#Recipe[4][3][3]+1]={2083,"Polished Sapphire",false,true,0};
Recipe[4][3][4][#Recipe[4][3][4]+1]={2084,"Polished Sapphire (x5)",false,false,1879137533};
Recipe[4][3][9][#Recipe[4][3][9]+1]={2554,"Ruby Earring",false,false,1879092908};
Recipe[4][3][9][#Recipe[4][3][9]+1]={2555,"Ruby Ring",false,false,1879069929};
Recipe[4][3][9][#Recipe[4][3][9]+1]={2556,"Ruby Ring of Tactics",false,false,1879152577};
Recipe[4][3][9][#Recipe[4][3][9]+1]={2569,"Sapphire Bracelet",false,false,1879092920};
Recipe[4][3][9][#Recipe[4][3][9]+1]={2570,"Sapphire Necklace",false,false,1879069930};
Recipe[4][3][12][#Recipe[4][3][12]+1]={2571,"Sapphire Obsidian Rune-stone",false,false,1879113363};
Recipe[4][3][5][#Recipe[4][3][5]+1]={2767,"Small Expert Symbol",false,false,1879125820};
Recipe[4][3][2][#Recipe[4][3][2]+1]={2841,"Starry Chandelier",false,false,1879101790};
Recipe[4][3][1][#Recipe[4][3][1]+1]={2912,"Striking Rune",false,false,1879069911};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3769,"Talisman of the Black Bear",true,false,1879098680};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3124,"Talisman of the Lynx",true,false,1879198689};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3123,"Talisman of the Onyx Lynx",true,false,1879098667};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3129,"Talisman of the Polar Bear",true,false,1879098691};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3131,"Talisman of the Spotted Lynx",true,false,1879098706};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3137,"Talisman of the Tundra Lynx",true,false,1879098668};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3138,"Talisman of the Tundra Lynx",true,false,1879098677};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3136,"Talisman of the Tundra Lynx",true,false,1879098678};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3618,"Talisman of the Wildpaw-bear",true,false,1879098698};
Recipe[4][3][11][#Recipe[4][3][11]+1]={3624,"Talisman of the Wildpaw-bear",true,false,1879098674};
Recipe[4][3][1][#Recipe[4][3][1]+1]={3213,"Vanquishing Rune",false,false,1879069912};

Recipe[4][4][9][#Recipe[4][4][9]+1]={6,"Adamant Bracelet",false,false,1879092945};
Recipe[4][4][9][#Recipe[4][4][9]+1]={7,"Adamant Earring",false,false,1879092925};
Recipe[4][4][13][#Recipe[4][4][13]+1]={8,"Adamant Flint Rune-stone",false,false,1879113491};
Recipe[4][4][9][#Recipe[4][4][9]+1]={9,"Adamant Necklace",false,false,1879070209};
Recipe[4][4][9][#Recipe[4][4][9]+1]={10,"Adamant Ring",false,false,1879070208};
Recipe[4][4][9][#Recipe[4][4][9]+1]={11,"Adamant Ring of Tactics",false,false,1879152578};
--Recipe[4][4][#Recipe[4][4]+1]={675,"Artisan Jeweller Expertise",false,false,1879184330};
Recipe[4][4][15][#Recipe[4][4][15]+1]={757,"Dwarf-jewel",false,false,1879092200};
Recipe[4][4][10][#Recipe[4][4][10]+1]={900,"Engraved Adamant Bracelet",true,false,1879092914};
Recipe[4][4][10][#Recipe[4][4][10]+1]={901,"Engraved Adamant Earring",true,false,1879092891};
Recipe[4][4][13][#Recipe[4][4][13]+1]={902,"Engraved Adamant Icy Rune-stone",true,false,1879113351};
Recipe[4][4][10][#Recipe[4][4][10]+1]={903,"Engraved Adamant Necklace",true,false,1879070211};
Recipe[4][4][10][#Recipe[4][4][10]+1]={3628,"Engraved Adamant Necklace",true,false,1879091195};
Recipe[4][4][10][#Recipe[4][4][10]+1]={904,"Engraved Adamant Ring",true,false,1879070210};
Recipe[4][4][10][#Recipe[4][4][10]+1]={3629,"Engraved Adamant Ring",true,false,1879091129};
Recipe[4][4][10][#Recipe[4][4][10]+1]={905,"Engraved Adamant Ring of Tactics",true,false,1879152596};
Recipe[4][4][6][#Recipe[4][4][6]+1]={927,"Etched Adamant Bracelet",false,false,1879137487};
Recipe[4][4][6][#Recipe[4][4][6]+1]={928,"Etched Adamant Earring",false,false,1879137395};
Recipe[4][4][14][#Recipe[4][4][14]+1]={929,"Etched Adamant Icy Rune-stone",false,false,1879137367};
Recipe[4][4][6][#Recipe[4][4][6]+1]={930,"Etched Adamant Necklace",false,false,1879137288};
Recipe[4][4][6][#Recipe[4][4][6]+1]={931,"Etched Adamant Ring",false,false,1879137698};
Recipe[4][4][8][#Recipe[4][4][8]+1]={1166,"Glittering Platinum Earring",false,false,1879092899};
Recipe[4][4][13][#Recipe[4][4][13]+1]={1167,"Glittering Platinum Obsidian Rune-stone",false,false,1879113316};
Recipe[4][4][8][#Recipe[4][4][8]+1]={1168,"Glittering Platinum Ring",false,false,1879181373};
Recipe[4][4][8][#Recipe[4][4][8]+1]={1174,"Glittering White Gold Bracelet",false,false,1879092911};
Recipe[4][4][8][#Recipe[4][4][8]+1]={1175,"Glittering White Gold Necklace",false,false,1879181374};
Recipe[4][4][1][#Recipe[4][4][1]+1]={1709,"Major Striking Rune",false,false,1879070384};
Recipe[4][4][1][#Recipe[4][4][1]+1]={1711,"Major Vanquishing Rune",false,false,1879070385};
Recipe[4][4][5][#Recipe[4][4][5]+1]={1817,"Medium Artisan Symbol",false,false,1879125848};
Recipe[4][4][12][#Recipe[4][4][12]+1]={1847,"Memorium Ring",true,false,1879062473};
Recipe[4][4][7][#Recipe[4][4][7]+1]={2044,"Platinum Bracelet",false,true,0};
Recipe[4][4][7][#Recipe[4][4][7]+1]={2048,"Platinum Necklace",false,true,0};
Recipe[4][4][2][#Recipe[4][4][2]+1]={2049,"Pointed Chandelier",false,false,1879102068};
Recipe[4][4][3][#Recipe[4][4][3]+1]={2050,"Polished Adamant",false,true,0};
Recipe[4][4][4][#Recipe[4][4][4]+1]={2051,"Polished Adamant (x5)",false,false,1879137623};
Recipe[4][4][16][#Recipe[4][4][16]+1]={2709,"Shining Edhelharn Token",false,false,1879070207};
Recipe[4][4][2][#Recipe[4][4][2]+1]={2721,"Silver Candlestand",false,false,1879102056};
Recipe[4][4][5][#Recipe[4][4][5]+1]={2760,"Small Artisan Symbol",false,false,1879125915};
Recipe[4][4][11][#Recipe[4][4][11]+1]={3617,"Talisman of the Blood-raven",true,false,1879098709};
Recipe[4][4][11][#Recipe[4][4][11]+1]={3125,"Talisman of the Onyx Lynx",true,false,1879098696};
Recipe[4][4][11][#Recipe[4][4][11]+1]={3132,"Talisman of the Spotted Lynx",true,false,1879098666};
Recipe[4][4][11][#Recipe[4][4][11]+1]={3135,"Talisman of the Tundra Cub",true,false,1879198686};
Recipe[4][4][11][#Recipe[4][4][11]+1]={3139,"Talisman of the Tundra Lynx",true,false,1879098676};
Recipe[4][4][7][#Recipe[4][4][7]+1]={3330,"White Gold Earring",false,true,0};
Recipe[4][4][13][#Recipe[4][4][13]+1]={3331,"White Gold Flint Rune-stone",false,true,0};
Recipe[4][4][13][#Recipe[4][4][13]+1]={3332,"White Gold Icy Rune-stone",false,true,0};
Recipe[4][4][13][#Recipe[4][4][13]+1]={3335,"White Gold Obsidian Rune-stone",false,true,0};
Recipe[4][4][7][#Recipe[4][4][7]+1]={3336,"White Gold Ring",false,true,0};

Recipe[4][5][5][#Recipe[4][5][5]+1]={40,"Ancient Silver Bracelet",false,true,0};
Recipe[4][5][5][#Recipe[4][5][5]+1]={41,"Ancient Silver Earring",false,true,0};
Recipe[4][5][10][#Recipe[4][5][10]+1]={42,"Ancient Silver Flint Rune-stone",false,true,0};
Recipe[4][5][10][#Recipe[4][5][10]+1]={43,"Ancient Silver Icy Rune-stone",false,true,0};
Recipe[4][5][5][#Recipe[4][5][5]+1]={47,"Ancient Silver Necklace",false,true,0};
Recipe[4][5][10][#Recipe[4][5][10]+1]={48,"Ancient Silver Obsidian Rune-stone",false,true,0};
Recipe[4][5][5][#Recipe[4][5][5]+1]={49,"Ancient Silver Ring",false,true,0};
Recipe[4][5][7][#Recipe[4][5][7]+1]={169,"Beryl Bracelet",false,false,1879092887};
Recipe[4][5][7][#Recipe[4][5][7]+1]={170,"Beryl Earring",false,false,1879092895};
Recipe[4][5][10][#Recipe[4][5][10]+1]={171,"Beryl Icy Rune-stone",false,false,1879113373};
Recipe[4][5][7][#Recipe[4][5][7]+1]={172,"Beryl Necklace",false,false,1879054897};
Recipe[4][5][7][#Recipe[4][5][7]+1]={174,"Beryl Ring",false,false,1879054896};
Recipe[4][5][7][#Recipe[4][5][7]+1]={175,"Beryl Ring of Tactics",false,false,1879152583};
Recipe[4][5][13][#Recipe[4][5][13]+1]={290,"Brilliant Edhelharn Token",false,false,1879054895};
Recipe[4][5][12][#Recipe[4][5][12]+1]={764,"Dwarf-necklace",false,false,1879092201};
Recipe[4][5][12][#Recipe[4][5][12]+1]={765,"Dwarf-ring",false,false,1879092222};
Recipe[4][5][8][#Recipe[4][5][8]+1]={906,"Engraved Beryl Bracelet",true,false,1879092909};
Recipe[4][5][8][#Recipe[4][5][8]+1]={907,"Engraved Beryl Earring",true,false,1879092944};
Recipe[4][5][10][#Recipe[4][5][10]+1]={908,"Engraved Beryl Flint Rune-stone",true,false,1879113422};
Recipe[4][5][8][#Recipe[4][5][8]+1]={909,"Engraved Beryl Necklace",true,false,1879054899};
Recipe[4][5][8][#Recipe[4][5][8]+1]={3630,"Engraved Beryl Necklace",true,false,1879091226};
Recipe[4][5][8][#Recipe[4][5][8]+1]={910,"Engraved Beryl Ring",true,false,1879054898};
Recipe[4][5][8][#Recipe[4][5][8]+1]={3631,"Engraved Beryl Ring",true,false,1879091115};
Recipe[4][5][8][#Recipe[4][5][8]+1]={911,"Engraved Beryl Ring of Tactics",true,false,1879152593};
Recipe[4][5][4][#Recipe[4][5][4]+1]={932,"Etched Beryl Bracelet",false,false,1879137476};
Recipe[4][5][4][#Recipe[4][5][4]+1]={933,"Etched Beryl Earring",false,false,1879137651};
Recipe[4][5][11][#Recipe[4][5][11]+1]={934,"Etched Beryl Flint Rune-stone",false,false,1879137424};
Recipe[4][5][4][#Recipe[4][5][4]+1]={935,"Etched Beryl Necklace",false,false,1879137549};
Recipe[4][5][4][#Recipe[4][5][4]+1]={936,"Etched Beryl Ring",false,false,1879137237};
Recipe[4][5][6][#Recipe[4][5][6]+1]={1152,"Glittering Ancient Silver Bracelet",false,false,1879092905};
Recipe[4][5][6][#Recipe[4][5][6]+1]={1153,"Glittering Ancient Silver Earring",false,false,1879092927};
Recipe[4][5][6][#Recipe[4][5][6]+1]={1154,"Glittering Ancient Silver Necklace",false,false,1879181370};
Recipe[4][5][10][#Recipe[4][5][10]+1]={1155,"Glittering Ancient Silver Obsidian Rune-stone",false,false,1879113465};
Recipe[4][5][6][#Recipe[4][5][6]+1]={1156,"Glittering Ancient Silver Ring",false,false,1879181372};
Recipe[4][5][3][#Recipe[4][5][3]+1]={1563,"Large Master Symbol",false,false,1879125896};
--Recipe[4][5][#Recipe[4][5]+1]={696,"Master Jeweller Expertise",false,false,1879184335};
Recipe[4][5][3][#Recipe[4][5][3]+1]={1831,"Medium Master Symbol",false,false,1879125871};
Recipe[4][5][1][#Recipe[4][5][1]+1]={2064,"Polished Beryl",false,true,0};
Recipe[4][5][2][#Recipe[4][5][2]+1]={2065,"Polished Beryl (x5)",false,false,1879137410};
Recipe[4][5][1][#Recipe[4][5][1]+1]={2079,"Polished Moonstone",false,true,0};
Recipe[4][5][3][#Recipe[4][5][3]+1]={2775,"Small Master Symbol",false,false,1879125855};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3114,"Talisman of the Ashen-eagle",true,false,1879098699};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3118,"Talisman of the Eagle",true,false,1879198691};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3126,"Talisman of the Onyx Lynx",true,false,1879098684};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3127,"Talisman of the Onyx Lynx",true,false,1879098707};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3130,"Talisman of the Snowcrest-eagle",true,false,1879098673};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3133,"Talisman of the Spotted Lynx",true,false,1879098712};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3625,"Talisman of the Tundra Cub",true,false,1879109633};
Recipe[4][5][9][#Recipe[4][5][9]+1]={3140,"Talisman of the Tundra Lynx",true,false,1879098670};

Recipe[4][6][7][#Recipe[4][6][7]+1]={88,"Aquamarine Bracelet",false,false,1879106889};
Recipe[4][6][7][#Recipe[4][6][7]+1]={89,"Aquamarine Earring",false,false,1879106874};
Recipe[4][6][17][#Recipe[4][6][17]+1]={90,"Aquamarine Flint Rune-stone",false,false,1879113330};
Recipe[4][6][7][#Recipe[4][6][7]+1]={91,"Aquamarine Necklace",false,false,1879106899};
Recipe[4][6][7][#Recipe[4][6][7]+1]={92,"Aquamarine Ring",false,false,1879106876};
Recipe[4][6][7][#Recipe[4][6][7]+1]={93,"Aquamarine Ring of Tactics",false,false,1879152611};
Recipe[4][6][10][#Recipe[4][6][10]+1]={123,"Aureate Armlet",true,false,1879161535};
Recipe[4][6][10][#Recipe[4][6][10]+1]={124,"Aureate Band",true,false,1879161613};
Recipe[4][6][10][#Recipe[4][6][10]+1]={125,"Aureate Band of Tactics",true,false,1879161573};
Recipe[4][6][10][#Recipe[4][6][10]+1]={126,"Aureate Hoop",true,false,1879161548};
Recipe[4][6][10][#Recipe[4][6][10]+1]={127,"Aureate Strand",true,false,1879161589};
Recipe[4][6][1][#Recipe[4][6][1]+1]={173,"Beryl Pendant",false,false,1879166150};
Recipe[4][6][12][#Recipe[4][6][12]+1]={493,"Crafted Champion's Rune of the Third Age",false,false,1879144918};
Recipe[4][6][13][#Recipe[4][6][13]+1]={494,"Crafted Champion's Rune of the Third Age",false,false,1879165357};
Recipe[4][6][14][#Recipe[4][6][14]+1]={506,"Crafted Flint Rune-stone of the Third Age",false,false,1879144991};
Recipe[4][6][15][#Recipe[4][6][15]+1]={507,"Crafted Flint Rune-stone of the Third Age",false,false,1879165346};
Recipe[4][6][14][#Recipe[4][6][14]+1]={553,"Crafted Icy Rune-stone of the Third Age",false,false,1879144973};
Recipe[4][6][15][#Recipe[4][6][15]+1]={552,"Crafted Icy Rune-stone of the Third Age",false,false,1879165351};
Recipe[4][6][14][#Recipe[4][6][14]+1]={569,"Crafted Obsidian Rune-stone of the Third Age",false,false,1879145029};
Recipe[4][6][15][#Recipe[4][6][15]+1]={570,"Crafted Obsidian Rune-stone of the Third Age",false,false,1879165360};
Recipe[4][6][9][#Recipe[4][6][9]+1]={641,"Dawn-rose Bracelet",true,false,1879106884};
Recipe[4][6][9][#Recipe[4][6][9]+1]={642,"Dawn-rose Earring",true,false,1879106903};
Recipe[4][6][9][#Recipe[4][6][9]+1]={643,"Dawn-rose Necklace",true,false,1879106894};
Recipe[4][6][17][#Recipe[4][6][17]+1]={644,"Dawn-rose Obsidian Rune-stone",true,false,1879113285};
Recipe[4][6][9][#Recipe[4][6][9]+1]={645,"Dawn-rose Ring",true,false,1879106887};
Recipe[4][6][9][#Recipe[4][6][9]+1]={646,"Dawn-rose Ring of Tactics",true,false,1879152582};
Recipe[4][6][1][#Recipe[4][6][1]+1]={723,"D"..string.char(195)..string.char(186).."nedain Star",false,false,1879166145};
Recipe[4][6][18][#Recipe[4][6][18]+1]={1094,"Flint Rune-stone of the Galadhrim",true,false,1879154543};
Recipe[4][6][20][#Recipe[4][6][20]+1]={1095,"Flint Rune-stone of the Golden Host",false,false,1879166718};
Recipe[4][6][5][#Recipe[4][6][5]+1]={1183,"Glowing Aureate Armlet",false,false,1879161836};
Recipe[4][6][5][#Recipe[4][6][5]+1]={1184,"Glowing Aureate Band",false,false,1879161862};
Recipe[4][6][5][#Recipe[4][6][5]+1]={1185,"Glowing Aureate Hoop",false,false,1879161838};
Recipe[4][6][5][#Recipe[4][6][5]+1]={1186,"Glowing Aureate Strand",false,false,1879161841};
Recipe[4][6][11][#Recipe[4][6][11]+1]={2005,"Greenwood Bracelet",false,false,1879163281};
Recipe[4][6][11][#Recipe[4][6][11]+1]={2006,"Greenwood Earring",false,false,1879163251};
Recipe[4][6][11][#Recipe[4][6][11]+1]={2007,"Greenwood Necklace",false,false,1879163276};
Recipe[4][6][11][#Recipe[4][6][11]+1]={2008,"Greenwood Ring",false,false,1879163269};
Recipe[4][6][18][#Recipe[4][6][18]+1]={1428,"Icy Rune-stone of the Galadhrim",true,false,1879154512};
Recipe[4][6][20][#Recipe[4][6][20]+1]={1429,"Icy Rune-stone of the Golden Host",false,false,1879166714};
Recipe[4][6][6][#Recipe[4][6][6]+1]={1503,"Khaz"..string.char(195)..string.char(162).."d-copper Bracelet",false,true,0};
Recipe[4][6][6][#Recipe[4][6][6]+1]={1504,"Khaz"..string.char(195)..string.char(162).."d-copper Earring",false,true,0};
Recipe[4][6][17][#Recipe[4][6][17]+1]={1505,"Khaz"..string.char(195)..string.char(162).."d-copper Flint Rune-stone",false,true,0};
Recipe[4][6][17][#Recipe[4][6][17]+1]={1506,"Khaz"..string.char(195)..string.char(162).."d-copper Icy Rune-stone",false,true,0};
Recipe[4][6][6][#Recipe[4][6][6]+1]={1509,"Khaz"..string.char(195)..string.char(162).."d-copper Necklace",false,true,0};
Recipe[4][6][17][#Recipe[4][6][17]+1]={1510,"Khaz"..string.char(195)..string.char(162).."d-copper Obsidian Rune-stone",false,true,0};
Recipe[4][6][6][#Recipe[4][6][6]+1]={1511,"Khaz"..string.char(195)..string.char(162).."d-copper Ring",false,true,0};
Recipe[4][6][8][#Recipe[4][6][8]+1]={1512,"Khaz"..string.char(195)..string.char(162).."d-gold Bracelet",false,false,1879106902};
Recipe[4][6][8][#Recipe[4][6][8]+1]={1513,"Khaz"..string.char(195)..string.char(162).."d-gold Earring",false,false,1879106895};
Recipe[4][6][17][#Recipe[4][6][17]+1]={1514,"Khaz"..string.char(195)..string.char(162).."d-gold Icy Rune-stone",false,false,1879113470};
Recipe[4][6][8][#Recipe[4][6][8]+1]={1518,"Khaz"..string.char(195)..string.char(162).."d-gold Necklace",false,false,1879106883};
Recipe[4][6][8][#Recipe[4][6][8]+1]={1519,"Khaz"..string.char(195)..string.char(162).."d-gold Ring",false,false,1879106882};
Recipe[4][6][4][#Recipe[4][6][4]+1]={1570,"Large Supreme Symbol",false,false,1879125764};
Recipe[4][6][4][#Recipe[4][6][4]+1]={1838,"Medium Supreme Symbol",false,false,1879125935};
Recipe[4][6][18][#Recipe[4][6][18]+1]={1920,"Obsidian Rune-stone of the Galadhrim",true,false,1879154524};
Recipe[4][6][20][#Recipe[4][6][20]+1]={1921,"Obsidian Rune-stone of the Golden Host",false,false,1879166721};
Recipe[4][6][19][#Recipe[4][6][19]+1]={2001,"Perfect Flint Rune-stone of the Galadhrim",false,false,1879157199};
Recipe[4][6][19][#Recipe[4][6][19]+1]={2002,"Perfect Icy Rune-stone of the Galadhrim",false,false,1879157209};
Recipe[4][6][19][#Recipe[4][6][19]+1]={2003,"Perfect Obsidian Rune-stone of the Galadhrim",false,false,1879157206};
Recipe[4][6][2][#Recipe[4][6][2]+1]={2062,"Polished Aquamarine",false,true,0};
Recipe[4][6][3][#Recipe[4][6][3]+1]={2063,"Polished Aquamarine (x5)",false,false,1879137538};
Recipe[4][6][2][#Recipe[4][6][2]+1]={2067,"Polished Dawn-rose",false,true,0};
Recipe[4][6][3][#Recipe[4][6][3]+1]={2068,"Polished Dawn-rose (x5)",false,false,1879137263};
Recipe[4][6][12][#Recipe[4][6][12]+1]={2279,"Reforged Champion's Rune of the Second Age",false,false,1879162090}; 
Recipe[4][6][13][#Recipe[4][6][13]+1]={2280,"Reforged Champion's Rune of the Second Age",false,false,1879165352}; 
Recipe[4][6][14][#Recipe[4][6][14]+1]={2286,"Reforged Flint Rune-stone of the Second Age",false,false,1879162134}; 
Recipe[4][6][15][#Recipe[4][6][15]+1]={2285,"Reforged Flint Rune-stone of the Second Age",false,false,1879165359}; 
Recipe[4][6][14][#Recipe[4][6][14]+1]={2330,"Reforged Icy Rune-stone of the Second Age",false,false,1879162084}; 
Recipe[4][6][15][#Recipe[4][6][15]+1]={2329,"Reforged Icy Rune-stone of the Second Age",false,false,1879165348}; 
Recipe[4][6][14][#Recipe[4][6][14]+1]={2346,"Reforged Obsidian Rune-stone of the Second Age",false,false,1879162238};
Recipe[4][6][15][#Recipe[4][6][15]+1]={2345,"Reforged Obsidian Rune-stone of the Second Age",false,false,1879165356};
Recipe[4][6][13][#Recipe[4][6][13]+1]={2421,"Reshaped Champion's Rune of the First Age",false,false,1879181522};
Recipe[4][6][15][#Recipe[4][6][15]+1]={2424,"Reshaped Flint Rune-stone of the First Age",false,false,1879181503}; 
Recipe[4][6][15][#Recipe[4][6][15]+1]={2446,"Reshaped Icy Rune-stone of the First Age",false,false,1879181540}; 
Recipe[4][6][15][#Recipe[4][6][15]+1]={2454,"Reshaped Obsidian Rune-stone of the First Age",false,false,1879181529}; 
Recipe[4][6][1][#Recipe[4][6][1]+1]={2550,"Royal Circlet",false,false,1879166155};
Recipe[4][6][4][#Recipe[4][6][4]+1]={2782,"Small Supreme Symbol",false,false,1879125880};
Recipe[4][6][21][#Recipe[4][6][21]+1]={2834,"Sparkling Edhelharn Token",false,false,1879106878};
Recipe[4][6][5][#Recipe[4][6][5]+1]={2954,"Sublime Dawn-rose Bracelet",false,false,1879137482};
Recipe[4][6][5][#Recipe[4][6][5]+1]={2955,"Sublime Dawn-rose Earring",false,false,1879137638};
Recipe[4][6][5][#Recipe[4][6][5]+1]={2956,"Sublime Dawn-rose Necklace",false,false,1879137726};
Recipe[4][6][19][#Recipe[4][6][19]+1]={2957,"Sublime Dawn-rose Obsidian Rune-stone",false,false,1879137657};
Recipe[4][6][5][#Recipe[4][6][5]+1]={2958,"Sublime Dawn-rose Ring",false,false,1879137369};
--Recipe[4][6][#Recipe[4][6]+1]={703,"Supreme Jeweller Expertise",false,false,1879184331};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3620,"Talisman of the Ashen-eagle",true,false,1879143174};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3134,"Talisman of the Bog-guardian",true,false,1879198687};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3128,"Talisman of the Onyx Lynx",true,false,1879143163};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3622,"Talisman of the Onyx Lynx",true,false,1879143173};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3120,"Talisman of the Sabre-cat",true,false,1879198688};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3614,"Talisman of the Snowcrest-eagle",true,false,1879143159};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3623,"Talisman of the Spotted Lynx",true,false,1879143167};
Recipe[4][6][16][#Recipe[4][6][16]+1]={3403,"Talisman of the Tundra Lynx",true,false,1879143175}; 
Recipe[4][6][8][#Recipe[4][6][8]+1]={3205,"Turtle-shell Bracelet",false,false,1879153826};

Recipe[4][7][10][#Recipe[4][7][10]+1]={3222,"Bracelet of the Rider",true,false,1879211102};
Recipe[4][7][4][#Recipe[4][7][4]+1]={3223,"Bracelet of Th"..string.char(195)..string.char(169).."odred",false,false,1879210960};
Recipe[4][7][5][#Recipe[4][7][5]+1]={1033,"Calenard Necklace",false,true,0};
Recipe[4][7][9][#Recipe[4][7][9]+1]={2849,"Dunlending Earring",false,false,1879210977};
Recipe[4][7][9][#Recipe[4][7][9]+1]={1041,"Dunlending Ring",false,false,1879210897};
Recipe[4][7][10][#Recipe[4][7][10]+1]={2481,"Earring of the Rider",true,false,1879210952};
Recipe[4][7][4][#Recipe[4][7][4]+1]={2482,"Earring of Th"..string.char(195)..string.char(169).."odred",false,false,1879211038};
Recipe[4][7][7][#Recipe[4][7][7]+1]={2484,"Green Garnet Bracelet",false,false,1879211059};
Recipe[4][7][7][#Recipe[4][7][7]+1]={1257,"Green Garnet Necklace",false,false,1879210875};
Recipe[4][7][8][#Recipe[4][7][8]+1]={3426,"Jewelled Cuff",true,false,1879225826}; 
Recipe[4][7][8][#Recipe[4][7][8]+1]={3427,"Jewelled Stud",true,false,1879225817}; 
Recipe[4][7][3][#Recipe[4][7][3]+1]={1577,"Large Westfold Symbol",false,false,1879211063};
Recipe[4][7][11][#Recipe[4][7][11]+1]={3392,"Crafted Champion's Rune of the Third Age",false,false,1879219722};
Recipe[4][7][11][#Recipe[4][7][11]+1]={3393,"Reforged Champion's Rune of the Second Age",false,false,1879219808};
Recipe[4][7][11][#Recipe[4][7][11]+1]={3632,"Reshaped Champion's Rune of the First Age",false,false,1879219809};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3394,"Crafted Flint Rune-stone of the Third Age",false,false,1879219676};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3395,"Crafted Icy Rune-stone of the Third Age",false,false,1879219738};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3396,"Crafted Obsidian Rune-stone of the Third Age",false,false,1879219686};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3397,"Reforged Flint Rune-stone of the Second Age",false,false,1879219800};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3398,"Reforged Icy Rune-stone of the Second Age",false,false,1879219729};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3399,"Reforged Obsidian Rune-stone of the Second Age",false,false,1879219753};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3400,"Reshaped Flint Rune-stone of the First Age",false,false,1879219685};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3401,"Reshaped Icy Rune-stone of the First Age",false,false,1879219708};
Recipe[4][7][12][#Recipe[4][7][12]+1]={3402,"Reshaped Obsidian Rune-stone of the First Age",false,false,1879219775};
Recipe[4][7][3][#Recipe[4][7][3]+1]={1845,"Medium Westfold Symbol",false,false,1879211008};
Recipe[4][7][10][#Recipe[4][7][10]+1]={2474,"Necklace of the Rider",true,false,1879210915};
Recipe[4][7][4][#Recipe[4][7][4]+1]={2475,"Necklace of Th"..string.char(195)..string.char(169).."odred",false,false,1879210983};
Recipe[4][7][1][#Recipe[4][7][1]+1]={2077,"Polished Green Garnet",false,true,0};
Recipe[4][7][2][#Recipe[4][7][2]+1]={2078,"Polished Green Garnet (x3)",false,false,1879210958};
Recipe[4][7][8][#Recipe[4][7][8]+1]={3428,"Repaired Cloak Clasp",false,false,1879226681}; 
Recipe[4][7][10][#Recipe[4][7][10]+1]={1044,"Ring of the Rider",true,false,1879211106};
Recipe[4][7][4][#Recipe[4][7][4]+1]={1045,"Ring of Th"..string.char(195)..string.char(169).."odred",false,false,1879211096};
Recipe[4][7][3][#Recipe[4][7][3]+1]={2789,"Small Westfold Symbol",false,false,1879211107};
Recipe[4][7][13][#Recipe[4][7][13]+1]={3245,"Vitreous Edhelharn Token",false,false,1879211041};
Recipe[4][7][6][#Recipe[4][7][6]+1]={3237,"Westfold Bracelet",false,false,1879210908};
Recipe[4][7][8][#Recipe[4][7][8]+1]={3341,"Winged Necklace",true,false,1879220263};

--Recipe[5][1][#Recipe[5][1]+1]={670,"Apprentice Metalsmith Expertise",false,false,1879184384};
Recipe[5][1][5][#Recipe[5][1][5]+1]={136,"Balanced Bronze Warden's Shield",false,false,1879113366};
Recipe[5][1][3][#Recipe[5][1][3]+1]={798,"Bronze Armour",false,true,0};
Recipe[5][1][3][#Recipe[5][1][3]+1]={799,"Bronze Boots",false,true,0};
Recipe[5][1][5][#Recipe[5][1][5]+1]={293,"Bronze Buckler",false,true,0};
Recipe[5][1][1][#Recipe[5][1][1]+1]={294,"Bronze Chain Link",false,true,0};
Recipe[5][1][2][#Recipe[5][1][2]+1]={295,"Bronze Cooking Supplies",false,false,1879067176};
Recipe[5][1][2][#Recipe[5][1][2]+1]={297,"Bronze Farming Tools",false,false,1879067180};
Recipe[5][1][2][#Recipe[5][1][2]+1]={298,"Bronze Forester's Axe",false,false,1879067175};
Recipe[5][1][3][#Recipe[5][1][3]+1]={800,"Bronze Gloves",false,true,0};
Recipe[5][1][3][#Recipe[5][1][3]+1]={801,"Bronze Helm",false,true,0};
Recipe[5][1][2][#Recipe[5][1][2]+1]={303,"Bronze Jeweller's Tools",false,false,1879067178};
Recipe[5][1][3][#Recipe[5][1][3]+1]={802,"Bronze Leggings",false,true,0};
Recipe[5][1][1][#Recipe[5][1][1]+1]={304,"Bronze Plate",false,true,0};
Recipe[5][1][2][#Recipe[5][1][2]+1]={305,"Bronze Prospector's Tools",false,false,1879067174};
Recipe[5][1][2][#Recipe[5][1][2]+1]={306,"Bronze Scholar's Glass",false,false,1879067177};
Recipe[5][1][3][#Recipe[5][1][3]+1]={803,"Bronze Shoulder Guards",false,true,0};
Recipe[5][1][2][#Recipe[5][1][2]+1]={307,"Bronze Smithing Hammer",false,false,1879067172};
Recipe[5][1][2][#Recipe[5][1][2]+1]={309,"Bronze Tailor's Tools",false,false,1879067179};
Recipe[5][1][5][#Recipe[5][1][5]+1]={311,"Bronze Warden's Shield",false,true,0};
Recipe[5][1][2][#Recipe[5][1][2]+1]={312,"Bronze Woodworking Tools",false,false,1879067173};
Recipe[5][1][4][#Recipe[5][1][4]+1]={1314,"Heavy Bronze Armour",false,false,1879067185};
Recipe[5][1][4][#Recipe[5][1][4]+1]={1315,"Heavy Bronze Boots",false,false,1879067186};
Recipe[5][1][4][#Recipe[5][1][4]+1]={1316,"Heavy Bronze Gloves",false,false,1879067184};
Recipe[5][1][4][#Recipe[5][1][4]+1]={1317,"Heavy Bronze Helm",false,false,1879067183};
Recipe[5][1][4][#Recipe[5][1][4]+1]={1318,"Heavy Bronze Leggings",false,false,1879067188};
Recipe[5][1][4][#Recipe[5][1][4]+1]={1319,"Heavy Bronze Shoulder Guards",false,false,1879067187};
Recipe[5][1][5][#Recipe[5][1][5]+1]={1621,"Light Bronze Buckler",false,false,1879066687};

Recipe[5][2][7][#Recipe[5][2][7]+1]={19,"Amateur\'s Chisel",false,false,1879153416};
Recipe[5][2][7][#Recipe[5][2][7]+1]={20,"Amateur\'s Riffler",false,false,1879199803};
Recipe[5][2][7][#Recipe[5][2][7]+1]={21,"Amateur\'s Sharp Chisel",false,false,1879153448};
Recipe[5][2][7][#Recipe[5][2][7]+1]={22,"Amateur\'s Sharp Riffler",false,false,1879199804};
Recipe[5][2][8][#Recipe[5][2][8]+1]={138,"Balanced Iron Warden's Shield",false,false,1879113409};
Recipe[5][2][4][#Recipe[5][2][4]+1]={500,"Crafted Armour",false,false,1879062074};
Recipe[5][2][4][#Recipe[5][2][4]+1]={501,"Crafted Boots",false,false,1879062076};
Recipe[5][2][8][#Recipe[5][2][8]+1]={440,"Crafted Buckler",false,false,1879062078};
Recipe[5][2][4][#Recipe[5][2][4]+1]={502,"Crafted Gloves",false,false,1879062073};
Recipe[5][2][4][#Recipe[5][2][4]+1]={503,"Crafted Helm",false,false,1879062072};
Recipe[5][2][4][#Recipe[5][2][4]+1]={504,"Crafted Leggings",false,false,1879062075};
Recipe[5][2][4][#Recipe[5][2][4]+1]={505,"Crafted Shoulder Guards",false,false,1879062077};
Recipe[5][2][8][#Recipe[5][2][8]+1]={586,"Crafted Warden's Shield",false,false,1879113384};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1057,"Featherweight Shield",true,false,1879062149};
Recipe[5][2][6][#Recipe[5][2][6]+1]={1106,"Forge-crafted Armour",true,false,1879068143};
Recipe[5][2][6][#Recipe[5][2][6]+1]={3633,"Forge-crafted Armour",true,false,1879091224};
Recipe[5][2][6][#Recipe[5][2][6]+1]={1107,"Forge-crafted Boots",true,false,1879068144};
Recipe[5][2][6][#Recipe[5][2][6]+1]={3634,"Forge-crafted Boots",true,false,1879091095};
Recipe[5][2][6][#Recipe[5][2][6]+1]={1108,"Forge-crafted Gloves",true,false,1879068142};
Recipe[5][2][6][#Recipe[5][2][6]+1]={3635,"Forge-crafted Gloves",true,false,1879091142};
Recipe[5][2][6][#Recipe[5][2][6]+1]={1109,"Forge-crafted Helm",true,false,1879068141};
Recipe[5][2][6][#Recipe[5][2][6]+1]={3636,"Forge-crafted Helm",true,false,1879091212};
Recipe[5][2][6][#Recipe[5][2][6]+1]={1110,"Forge-crafted Leggings",true,false,1879068146};
Recipe[5][2][6][#Recipe[5][2][6]+1]={3637,"Forge-crafted Leggings",true,false,1879091309};
Recipe[5][2][6][#Recipe[5][2][6]+1]={1111,"Forge-crafted Shoulder Guards",true,false,1879068145};
Recipe[5][2][6][#Recipe[5][2][6]+1]={3638,"Forge-crafted Shoulder Guards",true,false,1879091203};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1112,"Forge-Crafted Warden's Shield",true,false,1879113480};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1344,"Heavy Forge-Crafted Kite Shield",true,false,1879068148};
Recipe[5][2][8][#Recipe[5][2][8]+1]={3639,"Heavy Forge-Crafted Kite Shield",true,false,1879091117};
Recipe[5][2][5][#Recipe[5][2][5]+1]={1326,"Heavy Iron Armour",false,false,1879067191};
Recipe[5][2][5][#Recipe[5][2][5]+1]={1327,"Heavy Iron Boots",false,false,1879067192};
Recipe[5][2][5][#Recipe[5][2][5]+1]={1328,"Heavy Iron Gloves",false,false,1879067190};
Recipe[5][2][5][#Recipe[5][2][5]+1]={1329,"Heavy Iron Helm",false,false,1879067189};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1350,"Heavy Iron Kite Shield",false,false,1879067196};
Recipe[5][2][5][#Recipe[5][2][5]+1]={1330,"Heavy Iron Leggings",false,false,1879067194};
Recipe[5][2][5][#Recipe[5][2][5]+1]={1331,"Heavy Iron Shoulder Guards",false,false,1879067193};
Recipe[5][2][3][#Recipe[5][2][3]+1]={835,"Iron Armour",false,true,0};
Recipe[5][2][1][#Recipe[5][2][1]+1]={1466,"Iron Band",false,true,0};
Recipe[5][2][3][#Recipe[5][2][3]+1]={836,"Iron Boots",false,true,0};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1468,"Iron Buckler",false,true,0};
Recipe[5][2][1][#Recipe[5][2][1]+1]={1470,"Iron Chain Link",false,true,0};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1471,"Iron Cooking Supplies",false,false,1879068122};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1473,"Iron Farming Tools",false,false,1879068126};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1474,"Iron Forester's Axe",false,false,1879068127};
Recipe[5][2][3][#Recipe[5][2][3]+1]={837,"Iron Gloves",false,true,0};
Recipe[5][2][3][#Recipe[5][2][3]+1]={838,"Iron Helm",false,true,0};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1477,"Iron Jeweller's Tools",false,false,1879068124};
Recipe[5][2][3][#Recipe[5][2][3]+1]={839,"Iron Leggings",false,true,0};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1478,"Iron Prospector's Tools",false,false,1879068121};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1479,"Iron Scholar's Glass",false,false,1879068123};
Recipe[5][2][3][#Recipe[5][2][3]+1]={840,"Iron Shoulder Guards",false,true,0};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1480,"Iron Smithing Hammer",false,false,1879068119};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1482,"Iron Tailor's Tools",false,false,1879068125};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1485,"Iron Warden's Shield",false,true,0};
Recipe[5][2][2][#Recipe[5][2][2]+1]={1489,"Iron Woodworking Tools",false,false,1879068120};
--Recipe[5][2][#Recipe[5][2]+1]={691,"Journeyman Metalsmith Expertise",false,false,1879184392};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1623,"Light Forge-Crafted Kite Shield",true,false,1879068147};
Recipe[5][2][8][#Recipe[5][2][8]+1]={3640,"Light Forge-Crafted Kite Shield",true,false,1879091207};
Recipe[5][2][8][#Recipe[5][2][8]+1]={1624,"Light Iron Kite Shield",false,false,1879067195};
Recipe[5][2][1][#Recipe[5][2][1]+1]={2861,"Steel Brace",false,true,0};

Recipe[5][3][11][#Recipe[5][3][11]+1]={140,"Balanced Steel Warden's Shield",false,false,1879113458};
Recipe[5][3][11][#Recipe[5][3][11]+1]={141,"Balanced Warden's Shield of the Defender",true,false,1879113452};
Recipe[5][3][6][#Recipe[5][3][6]+1]={816,"Defender\'s Armour",false,false,1879062103};
Recipe[5][3][6][#Recipe[5][3][6]+1]={817,"Defender\'s Boots",false,false,1879062105};
Recipe[5][3][6][#Recipe[5][3][6]+1]={818,"Defender\'s Gloves",false,false,1879062102};
Recipe[5][3][6][#Recipe[5][3][6]+1]={819,"Defender\'s Helm",false,false,1879062101};
Recipe[5][3][6][#Recipe[5][3][6]+1]={820,"Defender\'s Leggings",false,false,1879062104};
Recipe[5][3][6][#Recipe[5][3][6]+1]={821,"Defender\'s Shoulder Guards",false,false,1879062106};
Recipe[5][3][11][#Recipe[5][3][11]+1]={655,"Defender's Heavy Kite Shield",true,false,1879069940};
Recipe[5][3][11][#Recipe[5][3][11]+1]={3641,"Defender's Heavy Kite Shield",true,false,1879091047};
Recipe[5][3][11][#Recipe[5][3][11]+1]={656,"Defender's Kite Shield",false,false,1879062100};
Recipe[5][3][11][#Recipe[5][3][11]+1]={657,"Defender's Light Kite Shield",true,false,1879069939};
Recipe[5][3][11][#Recipe[5][3][11]+1]={3642,"Defender's Light Kite Shield",true,false,1879091051};
--Recipe[5][3][#Recipe[5][3]+1]={684,"Expert Metalsmith Expertise",false,false,1879184391};
Recipe[5][3][1][#Recipe[5][3][1]+1]={1063,"Finely Polished Scale",false,true,0};
Recipe[5][3][2][#Recipe[5][3][2]+1]={1064,"Finely Polished Scale (x5)",false,false,1879137622};
Recipe[5][3][12][#Recipe[5][3][12]+1]={1272,"Hardened Defender's Heavy Kite Shield",false,false,1879137489};
Recipe[5][3][7][#Recipe[5][3][7]+1]={1338,"Heavy Steel Armour",false,false,1879069435};
Recipe[5][3][7][#Recipe[5][3][7]+1]={1339,"Heavy Steel Boots",false,false,1879069436};
Recipe[5][3][7][#Recipe[5][3][7]+1]={1340,"Heavy Steel Gloves",false,false,1879069434};
Recipe[5][3][7][#Recipe[5][3][7]+1]={1341,"Heavy Steel Helm",false,false,1879069433};
Recipe[5][3][7][#Recipe[5][3][7]+1]={1342,"Heavy Steel Leggings",false,false,1879069438};
Recipe[5][3][11][#Recipe[5][3][11]+1]={1382,"Heavy Steel Round Shield",false,false,1879069440};
Recipe[5][3][7][#Recipe[5][3][7]+1]={1343,"Heavy Steel Shoulder Guards",false,false,1879069437};
Recipe[5][3][11][#Recipe[5][3][11]+1]={1626,"Light Steel Round Shield",false,false,1879069439};
Recipe[5][3][9][#Recipe[5][3][9]+1]={1819,"Medium Expert Crest",false,false,1879125792};
Recipe[5][3][9][#Recipe[5][3][9]+1]={2762,"Small Expert Crest",false,false,1879125879};
Recipe[5][3][12][#Recipe[5][3][12]+1]={2814,"Solid Balanced Warden's Shield of the Defender",false,false,1879154139};
Recipe[5][3][4][#Recipe[5][3][4]+1]={2817,"Solid Defender\'s Armour",false,false,1879137343};
Recipe[5][3][4][#Recipe[5][3][4]+1]={2818,"Solid Defender\'s Boots",false,false,1879137257};
Recipe[5][3][4][#Recipe[5][3][4]+1]={2819,"Solid Defender\'s Gloves",false,false,1879137686};
Recipe[5][3][4][#Recipe[5][3][4]+1]={2820,"Solid Defender\'s Helm",false,false,1879137671};
Recipe[5][3][4][#Recipe[5][3][4]+1]={2821,"Solid Defender\'s Leggings",false,false,1879137753};
Recipe[5][3][4][#Recipe[5][3][4]+1]={2822,"Solid Defender\'s Shoulder Guards",false,false,1879137685};
Recipe[5][3][12][#Recipe[5][3][12]+1]={2816,"Solid Defender's Light Kite Shield",false,false,1879137645};
Recipe[5][3][5][#Recipe[5][3][5]+1]={878,"Steel Armour",false,true,0};
Recipe[5][3][5][#Recipe[5][3][5]+1]={879,"Steel Boots",false,true,0};
Recipe[5][3][1][#Recipe[5][3][1]+1]={2862,"Steel Chain Link",false,true,0};
Recipe[5][3][2][#Recipe[5][3][2]+1]={2863,"Steel Chain Link (x5)",false,false,1879137284};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2864,"Steel Cooking Supplies",false,false,1879069916};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2866,"Steel Farming Tools",false,false,1879069920};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2867,"Steel Forester's Axe",false,false,1879069921};
Recipe[5][3][5][#Recipe[5][3][5]+1]={880,"Steel Gloves",false,true,0};
Recipe[5][3][5][#Recipe[5][3][5]+1]={881,"Steel Helm",false,true,0};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2871,"Steel Jeweller's Tools",false,false,1879069918};
Recipe[5][3][5][#Recipe[5][3][5]+1]={882,"Steel Leggings",false,true,0};
Recipe[5][3][1][#Recipe[5][3][1]+1]={2872,"Steel Plate",false,true,0};
Recipe[5][3][2][#Recipe[5][3][2]+1]={2873,"Steel Plate (x5)",false,false,1879137262};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2876,"Steel Prospector's Tools",false,false,1879069915};
Recipe[5][3][2][#Recipe[5][3][2]+1]={2878,"Steel Rivet (x5)",false,false,1879137654};
Recipe[5][3][1][#Recipe[5][3][1]+1]={2877,"Steel Rivets",false,true,0};
Recipe[5][3][11][#Recipe[5][3][11]+1]={2879,"Steel Round Shield",false,true,0};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2880,"Steel Scholar's Glass",false,false,1879069917};
Recipe[5][3][5][#Recipe[5][3][5]+1]={883,"Steel Shoulder Guards",false,true,0};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2881,"Steel Smithing Hammer",false,false,1879069913};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2883,"Steel Tailor's Tools",false,false,1879069919};
Recipe[5][3][11][#Recipe[5][3][11]+1]={2885,"Steel Warden's Shield",false,true,0};
Recipe[5][3][3][#Recipe[5][3][3]+1]={2886,"Steel Woodworking Tools",false,false,1879069914};
Recipe[5][3][8][#Recipe[5][3][8]+1]={2918,"Strong Defender\'s Armour",true,false,1879069935};
Recipe[5][3][8][#Recipe[5][3][8]+1]={3770,"Strong Defender\'s Armour",true,false,1879091036};
Recipe[5][3][8][#Recipe[5][3][8]+1]={2919,"Strong Defender\'s Boots",true,false,1879069936};
Recipe[5][3][8][#Recipe[5][3][8]+1]={3764,"Strong Defender\'s Boots",true,false,1879091238};
Recipe[5][3][8][#Recipe[5][3][8]+1]={2920,"Strong Defender\'s Gloves",true,false,1879069934};
Recipe[5][3][8][#Recipe[5][3][8]+1]={3765,"Strong Defender\'s Gloves",true,false,1879091090};
Recipe[5][3][8][#Recipe[5][3][8]+1]={2921,"Strong Defender\'s Helm",true,false,1879069933};
Recipe[5][3][8][#Recipe[5][3][8]+1]={3766,"Strong Defender\'s Helm",true,false,1879091280};
Recipe[5][3][8][#Recipe[5][3][8]+1]={2922,"Strong Defender\'s Leggings",true,false,1879069938};
Recipe[5][3][8][#Recipe[5][3][8]+1]={3767,"Strong Defender\'s Leggings",true,false,1879091143};
Recipe[5][3][8][#Recipe[5][3][8]+1]={2923,"Strong Defender\'s Shoulder Guards",true,false,1879069937};
Recipe[5][3][8][#Recipe[5][3][8]+1]={3768,"Strong Defender\'s Shoulder Guards",true,false,1879091005};
Recipe[5][3][10][#Recipe[5][3][10]+1]={2934,"Student\'s Chisel",false,false,1879153453};
Recipe[5][3][10][#Recipe[5][3][10]+1]={2935,"Student\'s Riffler",false,false,1879199784};
Recipe[5][3][10][#Recipe[5][3][10]+1]={2939,"Student\'s Sharp Chisel",false,false,1879153388};
Recipe[5][3][10][#Recipe[5][3][10]+1]={2940,"Student\'s Sharp Riffler",false,false,1879199788};
Recipe[5][3][11][#Recipe[5][3][11]+1]={3248,"Warden's Shield of the Defender",false,false,1879113390};

--Recipe[5][4][#Recipe[5][4]+1]={677,"Artisan Metalsmith Expertise",false,false,1879184395};
Recipe[5][4][15][#Recipe[5][4][15]+1]={137,"Balanced Dwarf-iron Warden's Shield",false,false,1879113489};
Recipe[5][4][15][#Recipe[5][4][15]+1]={144,"Balanced Westernesse Warden's Shield",true,false,1879113464};
Recipe[5][4][5][#Recipe[5][4][5]+1]={353,"Candlestand",false,false,1879101785};
Recipe[5][4][3][#Recipe[5][4][3]+1]={596,"Crest of Vigilance",false,false,1879092220};
Recipe[5][4][1][#Recipe[5][4][1]+1]={728,"Dwarf-iron Chain Link",false,true,0};
Recipe[5][4][2][#Recipe[5][4][2]+1]={729,"Dwarf-iron Chain Link (x5)",false,false,1879137525};
Recipe[5][4][7][#Recipe[5][4][7]+1]={738,"Dwarf-iron Armour",false,true,0};
Recipe[5][4][7][#Recipe[5][4][7]+1]={740,"Dwarf-iron Boots",false,true,0};
Recipe[5][4][7][#Recipe[5][4][7]+1]={742,"Dwarf-iron Gloves",false,true,0};
Recipe[5][4][7][#Recipe[5][4][7]+1]={743,"Dwarf-iron Helm",false,true,0};
Recipe[5][4][7][#Recipe[5][4][7]+1]={746,"Dwarf-iron Leggings",false,true,0};
Recipe[5][4][15][#Recipe[5][4][15]+1]={750,"Dwarf-iron Shield",false,true,0};
Recipe[5][4][7][#Recipe[5][4][7]+1]={751,"Dwarf-iron Shoulder Guards",false,true,0};
Recipe[5][4][15][#Recipe[5][4][15]+1]={756,"Dwarf-iron Warden's Shield",false,true,0};
Recipe[5][4][9][#Recipe[5][4][9]+1]={778,"Dwarf-steel Armour",false,false,1879070214};
Recipe[5][4][9][#Recipe[5][4][9]+1]={773,"Dwarf-steel Boots",false,false,1879070215};
Recipe[5][4][4][#Recipe[5][4][4]+1]={766,"Dwarf-Steel Cooking Supplies",false,false,1879070389};
Recipe[5][4][4][#Recipe[5][4][4]+1]={767,"Dwarf-Steel Farming Tools",false,false,1879070393};
Recipe[5][4][4][#Recipe[5][4][4]+1]={768,"Dwarf-Steel Forester's Axe",false,false,1879070394};
Recipe[5][4][9][#Recipe[5][4][9]+1]={775,"Dwarf-steel Gloves",false,false,1879070213};
Recipe[5][4][9][#Recipe[5][4][9]+1]={779,"Dwarf-steel Helm",false,false,1879070212};
Recipe[5][4][4][#Recipe[5][4][4]+1]={771,"Dwarf-Steel Jeweller's Tools",false,false,1879070391};
Recipe[5][4][9][#Recipe[5][4][9]+1]={774,"Dwarf-steel Leggings",false,false,1879070217};
Recipe[5][4][4][#Recipe[5][4][4]+1]={772,"Dwarf-Steel Prospector's Tools",false,false,1879070388};
Recipe[5][4][4][#Recipe[5][4][4]+1]={776,"Dwarf-Steel Scholar's Glass",false,false,1879070390};
Recipe[5][4][9][#Recipe[5][4][9]+1]={780,"Dwarf-steel Shoulder Guards",false,false,1879070216};
Recipe[5][4][4][#Recipe[5][4][4]+1]={777,"Dwarf-Steel Smithing Hammer",false,false,1879070386};
Recipe[5][4][4][#Recipe[5][4][4]+1]={781,"Dwarf-Steel Tailor's Tools",false,false,1879070392};
Recipe[5][4][4][#Recipe[5][4][4]+1]={782,"Dwarf-Steel Woodworking Tools",false,false,1879070387};
Recipe[5][4][16][#Recipe[5][4][16]+1]={1274,"Hardened Heavy Westernesse Shield",false,false,1879137541};
Recipe[5][4][15][#Recipe[5][4][15]+1]={1311,"Heavy Dwarf-iron Shield",false,false,1879070219};
Recipe[5][4][1][#Recipe[5][4][1]+1]={1312,"Heavy Dwarf-steel Plate",false,true,0};
Recipe[5][4][2][#Recipe[5][4][2]+1]={1313,"Heavy Dwarf-steel Plate (x5)",false,false,1879137516};
Recipe[5][4][15][#Recipe[5][4][15]+1]={1383,"Heavy Westernesse Shield",true,false,1879070409};
Recipe[5][4][15][#Recipe[5][4][15]+1]={3643,"Heavy Westernesse Shield",true,false,1879091237};
Recipe[5][4][5][#Recipe[5][4][5]+1]={1469,"Iron Candlestand",false,false,1879102055};
Recipe[5][4][15][#Recipe[5][4][15]+1]={1622,"Light Dwarf-iron Shield",false,false,1879070218};
Recipe[5][4][15][#Recipe[5][4][15]+1]={1627,"Light Westernesse Shield",true,false,1879070408};
Recipe[5][4][15][#Recipe[5][4][15]+1]={3644,"Light Westernesse Shield",true,false,1879091040};
Recipe[5][4][11][#Recipe[5][4][11]+1]={1812,"Medium Artisan Crest",false,false,1879125927};
Recipe[5][4][13][#Recipe[5][4][13]+1]={3404,"Repair Anvil",false,false,1879090271};
Recipe[5][4][14][#Recipe[5][4][14]+1]={2581,"Scholar\'s Chisel",false,false,1879153405};
Recipe[5][4][14][#Recipe[5][4][14]+1]={2585,"Scholar\'s Riffler",false,false,1879199777};
Recipe[5][4][14][#Recipe[5][4][14]+1]={2591,"Scholar\'s Sharp Chisel",false,false,1879153474};
Recipe[5][4][14][#Recipe[5][4][14]+1]={2592,"Scholar\'s Sharp Riffler",false,false,1879199780};
Recipe[5][4][11][#Recipe[5][4][11]+1]={2755,"Small Artisan Crest",false,false,1879125775};
Recipe[5][4][6][#Recipe[5][4][6]+1]={2823,"Solid Westernesse Armour",false,false,1879137722};
Recipe[5][4][6][#Recipe[5][4][6]+1]={2824,"Solid Westernesse Boots",false,false,1879137590};
Recipe[5][4][6][#Recipe[5][4][6]+1]={2825,"Solid Westernesse Gloves",false,false,1879137276};
Recipe[5][4][6][#Recipe[5][4][6]+1]={2826,"Solid Westernesse Helm",false,false,1879137408};
Recipe[5][4][6][#Recipe[5][4][6]+1]={2827,"Solid Westernesse Leggings",false,false,1879137628};
Recipe[5][4][6][#Recipe[5][4][6]+1]={2828,"Solid Westernesse Shoulder Guards",false,false,1879137689};
Recipe[5][4][12][#Recipe[5][4][12]+1]={2850,"Steadfast Helm",true,false,1879062170};
Recipe[5][4][16][#Recipe[5][4][16]+1]={2960,"Superb Balanced Westernesse Warden's Shield",false,false,1879154143};
Recipe[5][4][16][#Recipe[5][4][16]+1]={2997,"Superb Light Westernesse Shield",false,false,1879137519};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3278,"Westernesse Armour",true,false,1879070404};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3645,"Westernesse Armour",true,false,1879091032};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3282,"Westernesse Boots",true,false,1879070405};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3646,"Westernesse Boots",true,false,1879091200};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3284,"Westernesse Gloves",true,false,1879070403};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3647,"Westernesse Gloves",true,false,1879091202};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3286,"Westernesse Helm",true,false,1879070402};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3648,"Westernesse Helm",true,false,1879091099};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3287,"Westernesse Leggings",true,false,1879070407};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3649,"Westernesse Leggings",true,false,1879091277};
Recipe[5][4][1][#Recipe[5][4][1]+1]={3288,"Westernesse Mesh",false,true,0};
Recipe[5][4][2][#Recipe[5][4][2]+1]={3289,"Westernesse Mesh (x5)",false,false,1879137422};
Recipe[5][4][1][#Recipe[5][4][1]+1]={3296,"Westernesse Scale",false,true,0};
Recipe[5][4][2][#Recipe[5][4][2]+1]={3297,"Westernesse Scale (x5)",false,false,1879137463};
Recipe[5][4][15][#Recipe[5][4][15]+1]={3298,"Westernesse Shield",false,false,1879083990};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3299,"Westernesse Shoulder Guards",true,false,1879070406};
Recipe[5][4][10][#Recipe[5][4][10]+1]={3650,"Westernesse Shoulder Guards",true,false,1879091011};
Recipe[5][4][15][#Recipe[5][4][15]+1]={3304,"Westernesse Warden's Shield",false,false,1879113376};
Recipe[5][4][8][#Recipe[5][4][8]+1]={3272,"West-land Armour",false,false,1879062182};
Recipe[5][4][8][#Recipe[5][4][8]+1]={3273,"West-land Boots",false,false,1879062184};
Recipe[5][4][8][#Recipe[5][4][8]+1]={3274,"West-land Gloves",false,false,1879062181};
Recipe[5][4][8][#Recipe[5][4][8]+1]={3275,"West-land Helm",false,false,1879062180};
Recipe[5][4][8][#Recipe[5][4][8]+1]={3276,"West-land Leggings",false,false,1879062183};
Recipe[5][4][8][#Recipe[5][4][8]+1]={3277,"West-land Shoulder Guards",false,false,1879062185};

Recipe[5][5][1][#Recipe[5][5][1]+1]={26,"Ancient Armour Plate",false,true,0};
Recipe[5][5][2][#Recipe[5][5][2]+1]={27,"Ancient Armour Plate (x5)",false,false,1879137567};
Recipe[5][5][4][#Recipe[5][5][4]+1]={28,"Ancient Iron Cooking Supplies",false,false,1879054889};
Recipe[5][5][4][#Recipe[5][5][4]+1]={29,"Ancient Iron Farming Tools",false,false,1879054893};
Recipe[5][5][4][#Recipe[5][5][4]+1]={30,"Ancient Iron Forester's Axe",false,false,1879054894};
Recipe[5][5][4][#Recipe[5][5][4]+1]={33,"Ancient Iron Jeweller's Tools",false,false,1879054891};
Recipe[5][5][4][#Recipe[5][5][4]+1]={34,"Ancient Iron Prospector's Tools",false,false,1879054888};
Recipe[5][5][4][#Recipe[5][5][4]+1]={35,"Ancient Iron Scholar's Glass",false,false,1879054890};
Recipe[5][5][4][#Recipe[5][5][4]+1]={36,"Ancient Iron Smithing Hammer",false,false,1879054886};
Recipe[5][5][4][#Recipe[5][5][4]+1]={37,"Ancient Iron Tailor's Tools",false,false,1879054892};
Recipe[5][5][4][#Recipe[5][5][4]+1]={38,"Ancient Iron Woodworking Tools",false,false,1879054887};
Recipe[5][5][1][#Recipe[5][5][1]+1]={53,"Ancient Steel Chain Link",false,true,0};
Recipe[5][5][2][#Recipe[5][5][2]+1]={54,"Ancient Steel Chain Link (x5)",false,false,1879137606};
Recipe[5][5][4][#Recipe[5][5][4]+1]={55,"Ancient Steel Cooking Supplies",true,false,1879054935};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3651,"Ancient Steel Cooking Supplies",true,false,1879091205};
Recipe[5][5][4][#Recipe[5][5][4]+1]={57,"Ancient Steel Farming Tools",true,false,1879054939};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3652,"Ancient Steel Farming Tools",true,false,1879091230};
Recipe[5][5][4][#Recipe[5][5][4]+1]={58,"Ancient Steel Forester's Axe",true,false,1879054940};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3653,"Ancient Steel Forester's Axe",true,false,1879091190};
Recipe[5][5][4][#Recipe[5][5][4]+1]={62,"Ancient Steel Jeweller's Tools",true,false,1879054937};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3654,"Ancient Steel Jeweller's Tools",true,false,1879091004};
Recipe[5][5][4][#Recipe[5][5][4]+1]={63,"Ancient Steel Prospector's Tools",true,false,1879054934};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3655,"Ancient Steel Prospector's Tools",true,false,1879091272};
Recipe[5][5][1][#Recipe[5][5][1]+1]={64,"Elf-steel Scale",false,true,0};
Recipe[5][5][2][#Recipe[5][5][2]+1]={65,"Elf-steel Scale (x5)",false,false,1879137557};
Recipe[5][5][4][#Recipe[5][5][4]+1]={66,"Ancient Steel Scholar's Glass",true,false,1879054936};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3656,"Ancient Steel Scholar's Glass",true,false,1879091211};
Recipe[5][5][4][#Recipe[5][5][4]+1]={68,"Ancient Steel Smithing Hammer",true,false,1879054932};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3657,"Ancient Steel Smithing Hammer",true,false,1879091009};
Recipe[5][5][4][#Recipe[5][5][4]+1]={70,"Ancient Steel Tailor's Tools",true,false,1879054938};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3658,"Ancient Steel Tailor's Tools",true,false,1879091016};
Recipe[5][5][4][#Recipe[5][5][4]+1]={73,"Ancient Steel Woodworking Tools",true,false,1879054933};
Recipe[5][5][4][#Recipe[5][5][4]+1]={3659,"Ancient Steel Woodworking Tools",true,false,1879091154};
Recipe[5][5][13][#Recipe[5][5][13]+1]={142,"Balanced Warden's Shield of the Elven Knight",true,false,1879113371};
Recipe[5][5][13][#Recipe[5][5][13]+1]={143,"Balanced Warden's Shield of the Elven Soldier",false,false,1879113407};
Recipe[5][5][3][#Recipe[5][5][3]+1]={595,"Crest of Valour",false,false,1879092225};
Recipe[5][5][1][#Recipe[5][5][1]+1]={794,"Elf-craft Brace",false,true,0};
Recipe[5][5][2][#Recipe[5][5][2]+1]={795,"Elf-craft Brace (x5)",false,false,1879137468};
Recipe[5][5][13][#Recipe[5][5][13]+1]={841,"Elven Knight's Heavy Shield",true,false,1879054907};
Recipe[5][5][13][#Recipe[5][5][13]+1]={3660,"Elven Knight's Heavy Shield",true,false,1879091216};
Recipe[5][5][13][#Recipe[5][5][13]+1]={842,"Elven Knight's Light Shield",true,false,1879054906};
Recipe[5][5][13][#Recipe[5][5][13]+1]={3661,"Elven Knight's Light Shield",true,false,1879091250};
Recipe[5][5][13][#Recipe[5][5][13]+1]={843,"Elven Knight's Shield",false,false,1879083991};
Recipe[5][5][6][#Recipe[5][5][6]+1]={869,"Elven Soldier's Armour",false,true,0};
Recipe[5][5][6][#Recipe[5][5][6]+1]={870,"Elven Soldier's Boots",false,true,0};
Recipe[5][5][6][#Recipe[5][5][6]+1]={871,"Elven Soldier's Gloves",false,true,0};
Recipe[5][5][13][#Recipe[5][5][13]+1]={872,"Elven Soldier's Heavy Shield",false,false,1879071328};
Recipe[5][5][6][#Recipe[5][5][6]+1]={873,"Elven Soldier's Helm",false,true,0};
Recipe[5][5][6][#Recipe[5][5][6]+1]={874,"Elven Soldier's Leggings",false,true,0};
Recipe[5][5][13][#Recipe[5][5][13]+1]={875,"Elven Soldier's Light Shield",false,false,1879071327};
Recipe[5][5][13][#Recipe[5][5][13]+1]={876,"Elven Soldier's Shield",false,true,0};
Recipe[5][5][6][#Recipe[5][5][6]+1]={877,"Elven Soldier's Shoulder Guards",false,true,0};
Recipe[5][5][14][#Recipe[5][5][14]+1]={1273,"Hardened Elven Knight's Heavy Shield",false,false,1879137588};
Recipe[5][5][3][#Recipe[5][5][3]+1]={1427,"Icon of Heroes",false,false,1879092214};
Recipe[5][5][9][#Recipe[5][5][9]+1]={1544,"Knight\'s Armour",true,false,1879054902};
Recipe[5][5][9][#Recipe[5][5][9]+1]={3662,"Knight\'s Armour",true,false,1879091164};
Recipe[5][5][9][#Recipe[5][5][9]+1]={1545,"Knight\'s Boots",true,false,1879054903};
Recipe[5][5][9][#Recipe[5][5][9]+1]={3663,"Knight\'s Boots",true,false,1879091297};
Recipe[5][5][9][#Recipe[5][5][9]+1]={1546,"Knight\'s Gloves",true,false,1879054901};
Recipe[5][5][9][#Recipe[5][5][9]+1]={3664,"Knight\'s Gloves",true,false,1879091110};
Recipe[5][5][9][#Recipe[5][5][9]+1]={1547,"Knight\'s Helm",true,false,1879054900};
Recipe[5][5][9][#Recipe[5][5][9]+1]={3665,"Knight\'s Helm",true,false,1879091141};
Recipe[5][5][9][#Recipe[5][5][9]+1]={1548,"Knight\'s Leggings",true,false,1879054905};
Recipe[5][5][9][#Recipe[5][5][9]+1]={3666,"Knight\'s Leggings",true,false,1879091176};
Recipe[5][5][9][#Recipe[5][5][9]+1]={1549,"Knight\'s Shoulder Guards",true,false,1879054904};
Recipe[5][5][9][#Recipe[5][5][9]+1]={3667,"Knight\'s Shoulder Guards",true,false,1879091131};
Recipe[5][5][11][#Recipe[5][5][11]+1]={1558,"Large Master Crest",false,false,1879125785};
Recipe[5][5][10][#Recipe[5][5][10]+1]={404,"Mammutti Armour",true,false,1879108477};
Recipe[5][5][10][#Recipe[5][5][10]+1]={405,"Mammutti Boots",true,false,1879108481};
Recipe[5][5][10][#Recipe[5][5][10]+1]={406,"Mammutti Gloves",true,false,1879108476};
Recipe[5][5][10][#Recipe[5][5][10]+1]={407,"Mammutti Helm",true,false,1879108479};
Recipe[5][5][10][#Recipe[5][5][10]+1]={408,"Mammutti Leggings",true,false,1879108482};
Recipe[5][5][10][#Recipe[5][5][10]+1]={409,"Mammutti Shoulder Guards",true,false,1879108471};
--Recipe[5][5][#Recipe[5][5]+1]={698,"Master Metalsmith Expertise",false,false,1879184394};
Recipe[5][5][12][#Recipe[5][5][12]+1]={1784,"Master\'s Chisel",false,false,1879153459};
Recipe[5][5][12][#Recipe[5][5][12]+1]={1789,"Master\'s Riffler",false,false,1879199800};
Recipe[5][5][12][#Recipe[5][5][12]+1]={1794,"Master\'s Sharp Chisel",false,false,1879153443};
Recipe[5][5][12][#Recipe[5][5][12]+1]={1795,"Master\'s Sharp Riffler",false,false,1879199805};
Recipe[5][5][11][#Recipe[5][5][11]+1]={1826,"Medium Master Crest",false,false,1879125816};
Recipe[5][5][5][#Recipe[5][5][5]+1]={1881,"Mirrored Knight\'s Armour",false,false,1879137435};
Recipe[5][5][5][#Recipe[5][5][5]+1]={1882,"Mirrored Knight\'s Boots",false,false,1879137438};
Recipe[5][5][5][#Recipe[5][5][5]+1]={1883,"Mirrored Knight\'s Gloves",false,false,1879137568};
Recipe[5][5][5][#Recipe[5][5][5]+1]={1884,"Mirrored Knight\'s Helm",false,false,1879137304};
Recipe[5][5][5][#Recipe[5][5][5]+1]={1885,"Mirrored Knight\'s Leggings",false,false,1879137565};
Recipe[5][5][5][#Recipe[5][5][5]+1]={1886,"Mirrored Knight\'s Shoulder Guards",false,false,1879137734};
Recipe[5][5][8][#Recipe[5][5][8]+1]={844,"Officer\'s Armour",false,false,1879071323};
Recipe[5][5][8][#Recipe[5][5][8]+1]={849,"Officer\'s Boots",false,false,1879071324};
Recipe[5][5][8][#Recipe[5][5][8]+1]={847,"Officer\'s Gloves",false,false,1879071322};
Recipe[5][5][8][#Recipe[5][5][8]+1]={846,"Officer\'s Helm",false,false,1879071321};
Recipe[5][5][8][#Recipe[5][5][8]+1]={845,"Officer\'s Leggings",false,false,1879071326};
Recipe[5][5][8][#Recipe[5][5][8]+1]={848,"Officer\'s Shoulder Guards",false,false,1879071325};
Recipe[5][5][11][#Recipe[5][5][11]+1]={2770,"Small Master Crest",false,false,1879125813};
Recipe[5][5][14][#Recipe[5][5][14]+1]={3020,"Superior Balanced Warden's Shield of the Elven Knight",false,false,1879154134};
Recipe[5][5][14][#Recipe[5][5][14]+1]={3047,"Superior Elven Knight's Light Shield",false,false,1879137349};
Recipe[5][5][15][#Recipe[5][5][15]+1]={3154,"Ter"..string.char(195)..string.char(164).."s-syd"..string.char(195)..string.char(164).."n",true,false,1879109637};
Recipe[5][5][13][#Recipe[5][5][13]+1]={3249,"Warden's Shield of the Elven Knight",false,false,1879113369};
Recipe[5][5][13][#Recipe[5][5][13]+1]={3250,"Warden's Shield of the Elven Soldier",false,true,0};
Recipe[5][5][7][#Recipe[5][5][7]+1]={3257,"Warrior\'s Armour",false,false,1879062206};
Recipe[5][5][7][#Recipe[5][5][7]+1]={3259,"Warrior\'s Boots",false,false,1879062208};
Recipe[5][5][7][#Recipe[5][5][7]+1]={3263,"Warrior\'s Gloves",false,false,1879062205};
Recipe[5][5][7][#Recipe[5][5][7]+1]={3267,"Warrior\'s Helm",false,false,1879062204};
Recipe[5][5][7][#Recipe[5][5][7]+1]={3268,"Warrior\'s Leggings",false,false,1879062207};
Recipe[5][5][7][#Recipe[5][5][7]+1]={3270,"Warrior\'s Shoulder Guards",false,false,1879062209};

Recipe[5][6][1][#Recipe[5][6][1]+1]={203,"Blackened Bronze Band",false,true,0};
Recipe[5][6][2][#Recipe[5][6][2]+1]={204,"Blackened Bronze Band (x5)",false,false,1879137223};
Recipe[5][6][1][#Recipe[5][6][1]+1]={205,"Blackened Bronze Chain Link",false,true,0};
Recipe[5][6][2][#Recipe[5][6][2]+1]={206,"Blackened Bronze Chain Link (x5)",false,false,1879137224};
Recipe[5][6][1][#Recipe[5][6][1]+1]={207,"Blackened Bronze Plate",false,true,0};
Recipe[5][6][2][#Recipe[5][6][2]+1]={208,"Blackened Bronze Plate (x5)",false,false,1879137511};
Recipe[5][6][1][#Recipe[5][6][1]+1]={209,"Blackened Iron Mesh",false,true,0};
Recipe[5][6][2][#Recipe[5][6][2]+1]={210,"Blackened Iron Mesh (x5)",false,false,1879137320};
Recipe[5][6][1][#Recipe[5][6][1]+1]={211,"Blackened Iron Plate",false,true,0};
Recipe[5][6][2][#Recipe[5][6][2]+1]={212,"Blackened Iron Plate (x5)",false,false,1879137589};
Recipe[5][6][1][#Recipe[5][6][1]+1]={213,"Blackened Steel Brace",false,true,0};
Recipe[5][6][2][#Recipe[5][6][2]+1]={214,"Blackened Steel Brace (x5)",false,false,1879137486};
Recipe[5][6][10][#Recipe[5][6][10]+1]={3220,"Boots of the Galadhrim",true,false,1879161560};
Recipe[5][6][12][#Recipe[5][6][12]+1]={458,"Crafted Captain's Emblem of the Third Age",false,false,1879145004};
Recipe[5][6][13][#Recipe[5][6][13]+1]={457,"Crafted Captain's Emblem of the Third Age",false,false,1879165719};
Recipe[5][6][14][#Recipe[5][6][14]+1]={512,"Crafted Guardian's Belt of the Third Age",false,false,1879145031};
Recipe[5][6][15][#Recipe[5][6][15]+1]={511,"Crafted Guardian's Belt of the Third Age",false,false,1879165769};
Recipe[5][6][3][#Recipe[5][6][3]+1]={719,"Dragon-helm",false,false,1879166116};
Recipe[5][6][18][#Recipe[5][6][18]+1]={997,"Exquisite Lothl"..string.char(195)..string.char(179).."rien Heavy Shield",true,false,1879150792};
Recipe[5][6][18][#Recipe[5][6][18]+1]={998,"Exquisite Lothl"..string.char(195)..string.char(179).."rien Light Shield",true,false,1879150790};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1011,"Exquisite Warden's Shield of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879150794};
Recipe[5][6][10][#Recipe[5][6][10]+1]={2483,"Gauntlets of the Galadhrim",true,false,1879161596};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1180,"Glorious Boots of the Galadhrim",false,false,1879161872};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1177,"Glorious Gauntlets of the Galadhrim",false,false,1879161863};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1181,"Glorious Hauberk of the Galadhrim",false,false,1879161839};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1178,"Glorious Helmet of the Galadhrim",false,false,1879161857};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1179,"Glorious Leggings of the Galadhrim",false,false,1879161854};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1176,"Glorious Pauldrons of the Galadhrim",false,false,1879161865};
Recipe[5][6][10][#Recipe[5][6][10]+1]={3230,"Hauberk of the Galadhrim",true,false,1879161601};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1381,"Heavy Shield of the Golden Host",false,false,1879163261};
Recipe[5][6][10][#Recipe[5][6][10]+1]={2486,"Helmet of the Galadhrim",true,false,1879161585};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1402,"Heroic Noble\'s Armour",false,false,1879137739};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1404,"Heroic Noble\'s Boots",false,false,1879137346};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1405,"Heroic Noble\'s Gloves",false,false,1879137481};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1406,"Heroic Noble\'s Helm",false,false,1879137609};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1403,"Heroic Noble\'s Leggings",false,false,1879137547};
Recipe[5][6][5][#Recipe[5][6][5]+1]={1407,"Heroic Noble\'s Shoulder Guards",false,false,1879137634};
Recipe[5][6][19][#Recipe[5][6][19]+1]={1399,"Heroic Noble's Heavy Shield",false,false,1879137378};
Recipe[5][6][19][#Recipe[5][6][19]+1]={1401,"Heroic Noble's Light Shield",false,false,1879137735};
Recipe[5][6][16][#Recipe[5][6][16]+1]={1565,"Large Supreme Crest",false,false,1879125811};
Recipe[5][6][10][#Recipe[5][6][10]+1]={3102,"Leggings of the Galadhrim",true,false,1879161547};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1625,"Light Shield of the Golden Host",false,false,1879163271};
Recipe[5][6][11][#Recipe[5][6][11]+1]={1714,"Malledhrim Boots",false,false,1879163199};
Recipe[5][6][11][#Recipe[5][6][11]+1]={1716,"Malledhrim Gauntlets",false,false,1879163280};
Recipe[5][6][11][#Recipe[5][6][11]+1]={1720,"Malledhrim Hauberk",false,false,1879163279};
Recipe[5][6][11][#Recipe[5][6][11]+1]={1721,"Malledhrim Helmet",false,false,1879163208};
Recipe[5][6][11][#Recipe[5][6][11]+1]={1722,"Malledhrim Leggings",false,false,1879163228};
Recipe[5][6][11][#Recipe[5][6][11]+1]={1724,"Malledhrim Pauldrons",false,false,1879163213};
Recipe[5][6][16][#Recipe[5][6][16]+1]={1833,"Medium Supreme Crest",false,false,1879125774};
Recipe[5][6][9][#Recipe[5][6][9]+1]={1910,"Noble\'s Armour",true,false,1879107144};
Recipe[5][6][9][#Recipe[5][6][9]+1]={1912,"Noble\'s Boots",true,false,1879107288};
Recipe[5][6][9][#Recipe[5][6][9]+1]={1913,"Noble\'s Gloves",true,false,1879107192};
Recipe[5][6][9][#Recipe[5][6][9]+1]={1914,"Noble\'s Helm",true,false,1879107279};
Recipe[5][6][9][#Recipe[5][6][9]+1]={1911,"Noble\'s Leggings",true,false,1879107202};
Recipe[5][6][9][#Recipe[5][6][9]+1]={1915,"Noble\'s Shoulder Guards",true,false,1879107132};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1908,"Noble's Heavy Shield",true,false,1879107252};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1909,"Noble's Light Shield",true,false,1879107164};
Recipe[5][6][8][#Recipe[5][6][8]+1]={1923,"Officer's Armour",false,false,1879107268};
Recipe[5][6][8][#Recipe[5][6][8]+1]={1924,"Officer's Boots",false,false,1879107121};
Recipe[5][6][8][#Recipe[5][6][8]+1]={1926,"Officer's Gloves",false,false,1879107231};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1927,"Officer's Heavy Shield",false,false,1879107263};
Recipe[5][6][8][#Recipe[5][6][8]+1]={1928,"Officer's Helm",false,false,1879107203};
Recipe[5][6][8][#Recipe[5][6][8]+1]={1929,"Officer's Leggings",false,false,1879107124};
Recipe[5][6][18][#Recipe[5][6][18]+1]={1930,"Officer's Light Shield",false,false,1879107293};
Recipe[5][6][8][#Recipe[5][6][8]+1]={1931,"Officer's Shoulder Guards",false,false,1879107143};
Recipe[5][6][10][#Recipe[5][6][10]+1]={2113,"Pauldrons of the Galadhrim",true,false,1879161550};
Recipe[5][6][12][#Recipe[5][6][12]+1]={2244,"Reforged Captain's Emblem of the Second Age",false,false,1879162091};
Recipe[5][6][13][#Recipe[5][6][13]+1]={2243,"Reforged Captain's Emblem of the Second Age",false,false,1879165770};
Recipe[5][6][14][#Recipe[5][6][14]+1]={2289,"Reforged Guardian's Belt of the Second Age",false,false,1879162103};
Recipe[5][6][15][#Recipe[5][6][15]+1]={2290,"Reforged Guardian's Belt of the Second Age",false,false,1879165964};
Recipe[5][6][13][#Recipe[5][6][13]+1]={2403,"Reshaped Captain's Emblem of the First Age",false,false,1879181499};
Recipe[5][6][15][#Recipe[5][6][15]+1]={2426,"Reshaped Guardian's Belt of the First Age",false,false,1879181534};
Recipe[5][6][3][#Recipe[5][6][3]+1]={2551,"Royal Crown",false,false,1879166123};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2563,"Sage\'s Chisel",true,false,1879199786};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2564,"Sage\'s Riffler",true,false,1879199797};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2565,"Sage\'s Sharp Chisel",true,false,1879199789};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2566,"Sage\'s Sharp Riffler",true,false,1879199802};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2574,"Savant\'s Chisel",false,false,1879153394};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2575,"Savant\'s Honed Chisel",true,false,1879153408};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2576,"Savant\'s Honed Riffler",true,false,1879199794};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2577,"Savant\'s Riffler",false,false,1879199787};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2578,"Savant\'s Sharp Chisel",false,false,1879153423};
Recipe[5][6][17][#Recipe[5][6][17]+1]={2579,"Savant\'s Sharp Riffler",false,false,1879199790};
Recipe[5][6][6][#Recipe[5][6][6]+1]={2678,"Sellsword's Armour",false,true,1879107125};
Recipe[5][6][6][#Recipe[5][6][6]+1]={2680,"Sellsword's Boots",false,true,1879107183};
Recipe[5][6][6][#Recipe[5][6][6]+1]={2682,"Sellsword's Gloves",false,true,1879107298};
Recipe[5][6][18][#Recipe[5][6][18]+1]={2686,"Sellsword's Heavy Shield",false,true,1879107276};
Recipe[5][6][6][#Recipe[5][6][6]+1]={2687,"Sellsword's Helm",false,true,1879107157};
Recipe[5][6][6][#Recipe[5][6][6]+1]={2688,"Sellsword's Leggings",false,true,1879107156};
Recipe[5][6][18][#Recipe[5][6][18]+1]={2689,"Sellsword's Light Shield",false,true,1879107265};
Recipe[5][6][6][#Recipe[5][6][6]+1]={2692,"Sellsword's Shoulder Guards",false,true,1879107167};
Recipe[5][6][7][#Recipe[5][6][7]+1]={2695,"Sentinel's Armour",false,false,1879107108};
Recipe[5][6][7][#Recipe[5][6][7]+1]={2696,"Sentinel's Boots",false,false,1879107254};
Recipe[5][6][7][#Recipe[5][6][7]+1]={2697,"Sentinel's Gloves",false,false,1879107133};
Recipe[5][6][18][#Recipe[5][6][18]+1]={2698,"Sentinel's Heavy Shield",false,false,1879107128};
Recipe[5][6][7][#Recipe[5][6][7]+1]={2699,"Sentinel's Helm",false,false,1879107267};
Recipe[5][6][7][#Recipe[5][6][7]+1]={2700,"Sentinel's Leggings",false,false,1879107111};
Recipe[5][6][18][#Recipe[5][6][18]+1]={2701,"Sentinel's Light Shield",false,false,1879107266};
Recipe[5][6][7][#Recipe[5][6][7]+1]={2702,"Sentinel's Shoulder Guards",false,false,1879107262};
Recipe[5][6][3][#Recipe[5][6][3]+1]={2719,"Silver Basin",false,false,1879166160};
Recipe[5][6][16][#Recipe[5][6][16]+1]={2777,"Small Supreme Crest",false,false,1879125791};
Recipe[5][6][19][#Recipe[5][6][19]+1]={2998,"Superb Lothl"..string.char(195)..string.char(179).."rien Heavy Shield",false,false,1879157205};
Recipe[5][6][19][#Recipe[5][6][19]+1]={2999,"Superb Lothl"..string.char(195)..string.char(179).."rien Light Shield",false,false,1879157200};
Recipe[5][6][19][#Recipe[5][6][19]+1]={3012,"Superb Warden's Shield of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879157186};
--Recipe[5][6][#Recipe[5][6]+1]={705,"Supreme Metalsmith Expertise",false,false,1879184393};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3171,"Tools of the Armourer",true,false,1879147473};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3172,"Tools of the Armsman",true,false,1879147467};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3173,"Tools of the Explorer",true,false,1879147462};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3174,"Tools of the Historian",true,false,1879147457};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3175,"Tools of the Tinker",true,false,1879147454};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3176,"Tools of the Woodsman",true,false,1879147463};
Recipe[5][6][4][#Recipe[5][6][4]+1]={3177,"Tools of the Yeoman",true,false,1879147474};
Recipe[5][6][18][#Recipe[5][6][18]+1]={3251,"Warden's Shield of the Golden Host",false,false,1879163235};
Recipe[5][6][19][#Recipe[5][6][19]+1]={3252,"Warden's Shield of the Heroic Noble",false,false,1879154142};
Recipe[5][6][18][#Recipe[5][6][18]+1]={3253,"Warden's Shield of the Noble",true,false,1879113461};
Recipe[5][6][18][#Recipe[5][6][18]+1]={3254,"Warden's Shield of the Officer",false,false,1879113286};
Recipe[5][6][18][#Recipe[5][6][18]+1]={3255,"Warden's Shield of the Sellsword",false,true,1879113447};
Recipe[5][6][18][#Recipe[5][6][18]+1]={3256,"Warden's Shield of the Sentinel",false,false,1879113456};

Recipe[5][7][7][#Recipe[5][7][7]+1]={3215,"Armour of the Rider",true,false,1879210994};
Recipe[5][7][1][#Recipe[5][7][1]+1]={3216,"Armour of Th"..string.char(195)..string.char(169).."odred",false,false,1879211088};
Recipe[5][7][7][#Recipe[5][7][7]+1]={1029,"Boots of the Rider",true,false,1879211089};
Recipe[5][7][1][#Recipe[5][7][1]+1]={1030,"Boots of Th"..string.char(195)..string.char(169).."odred",false,false,1879211073};
Recipe[5][7][11][#Recipe[5][7][11]+1]={341,"Calenard Chisel",false,false,1879211029};
Recipe[5][7][11][#Recipe[5][7][11]+1]={346,"Calenard Riffler",false,false,1879211123};
Recipe[5][7][2][#Recipe[5][7][2]+1]={2914,"Calenard War Gauntlets",false,true,0};
Recipe[5][7][2][#Recipe[5][7][2]+1]={3224,"Calenard War Pauldrons",false,true,0};
Recipe[5][7][15][#Recipe[5][7][15]+1]={3227,"Campaign Shield of the Rider",true,false,1879210986};
-- is this theodred's or guild?
Recipe[5][7][15][#Recipe[5][7][15]+1]={3219,"Campaign Shield of Th"..string.char(195)..string.char(169).."odred",false,false,1879211114};
Recipe[5][7][12][#Recipe[5][7][12]+1]={3429,"Combat Shield",true,false,1879225830};
Recipe[5][7][8][#Recipe[5][7][8]+1]={3385,"Crafted Captain's Emblem of the Third Age",false,false,1879219776}; 
Recipe[5][7][9][#Recipe[5][7][9]+1]={3386,"Crafted Guardian's Belt of the Third Age",false,false,1879219709}; 
Recipe[5][7][14][#Recipe[5][7][14]+1]={660,"Dunlending Campaign Shield",false,false,1879211016};
Recipe[5][7][14][#Recipe[5][7][14]+1]={2917,"Dunlending Skirmish Shield",false,false,1879211085};
Recipe[5][7][6][#Recipe[5][7][6]+1]={3107,"Dunlending War Armour",false,false,1879210979};
Recipe[5][7][14][#Recipe[5][7][14]+1]={2108,"Dunlending War Shield",false,false,1879210940};
Recipe[5][7][5][#Recipe[5][7][5]+1]={3430,"Full Helm",true,false,1879225824};
Recipe[5][7][7][#Recipe[5][7][7]+1]={2924,"Gauntlets of the Rider",true,false,1879211013};
Recipe[5][7][1][#Recipe[5][7][1]+1]={2925,"Gauntlets of Th"..string.char(195)..string.char(169).."odred",false,false,1879211081};
Recipe[5][7][7][#Recipe[5][7][7]+1]={1042,"Helmet of the Rider",true,false,1879210997};
Recipe[5][7][1][#Recipe[5][7][1]+1]={1043,"Helmet of Th"..string.char(195)..string.char(169).."odred",false,false,1879211074};
Recipe[5][7][10][#Recipe[5][7][10]+1]={1572,"Large Westfold Crest",false,false,1879210911};
Recipe[5][7][7][#Recipe[5][7][7]+1]={3231,"Leggings of the Rider",true,false,1879210982};
Recipe[5][7][1][#Recipe[5][7][1]+1]={3232,"Leggings of Th"..string.char(195)..string.char(169).."odred",false,false,1879211026};
Recipe[5][7][10][#Recipe[5][7][10]+1]={1840,"Medium Westfold Crest",false,false,1879210959};
Recipe[5][7][7][#Recipe[5][7][7]+1]={3233,"Pauldrons of the Rider",true,false,1879211103};
Recipe[5][7][1][#Recipe[5][7][1]+1]={3234,"Pauldrons of Th"..string.char(195)..string.char(169).."odred",false,false,1879211071};
Recipe[5][7][8][#Recipe[5][7][8]+1]={3387,"Reforged Captain's Emblem of the Second Age",false,false,1879219810};
Recipe[5][7][9][#Recipe[5][7][9]+1]={3388,"Reforged Guardian's Belt of the Second Age",false,false,1879219739}; 
Recipe[5][7][8][#Recipe[5][7][8]+1]={3389,"Reshaped Captain's Emblem of the First Age",false,false,1879219792}; 
Recipe[5][7][9][#Recipe[5][7][9]+1]={3390,"Reshaped Guardian's Belt of the First Age",false,false,1879219754}; 
Recipe[5][7][5][#Recipe[5][7][5]+1]={2595,"Scorched Armour",true,false,1879220262};
Recipe[5][7][15][#Recipe[5][7][15]+1]={3236,"Skirmish Shield of the Rider",true,false,1879210925};
Recipe[5][7][13][#Recipe[5][7][13]+1]={3229,"Skirmish Shield of Th"..string.char(195)..string.char(169).."odred",false,false,1879211084};
Recipe[5][7][10][#Recipe[5][7][10]+1]={2784,"Small Westfold Crest",false,false,1879211119};
Recipe[5][7][11][#Recipe[5][7][11]+1]={3031,"Superior Calenard Chisel",false,false,1879210968};
Recipe[5][7][11][#Recipe[5][7][11]+1]={3035,"Superior Calenard Riffler",false,false,1879210921};
Recipe[5][7][15][#Recipe[5][7][15]+1]={2931,"War Shield of the Rider",true,false,1879211109};
Recipe[5][7][13][#Recipe[5][7][13]+1]={2913,"War Shield of Th"..string.char(195)..string.char(169).."odred",false,false,1879210905};
Recipe[5][7][3][#Recipe[5][7][3]+1]={2933,"Westfold War Boots",false,false,1879210935};
Recipe[5][7][3][#Recipe[5][7][3]+1]={3241,"Westfold War Helmet",false,false,1879210926};
Recipe[5][7][4][#Recipe[5][7][4]+1]={1052,"Westfold War Leggings",false,false,1879210965};

-- Prospector
Recipe[6][1][1][#Recipe[6][1][1]+1]={301,"Bronze Ingot",false,true,0};
Recipe[6][1][2][#Recipe[6][1][2]+1]={302,"Bulk Bronze Ingot",false,false,1879184461};
Recipe[6][1][4][#Recipe[6][1][4]+1]={434,"Bulk Copper Ingot",false,false,1879184451};
Recipe[6][1][4][#Recipe[6][1][4]+1]={3167,"Bulk Tin Ingot",false,false,1879184484};
Recipe[6][1][3][#Recipe[6][1][3]+1]={433,"Copper Ingot",false,true,0};
Recipe[6][1][3][#Recipe[6][1][3]+1]={3166,"Tin Ingot",false,true,0};
Recipe[6][2][3][#Recipe[6][2][3]+1]={155,"Barrow-iron Ingot",false,true,0};
Recipe[6][2][4][#Recipe[6][2][4]+1]={156,"Bulk Barrow-iron Ingot",false,false,1879184481};
Recipe[6][2][2][#Recipe[6][2][2]+1]={1666,"Bulk Low-grade Steel Ingot",false,false,1879184460};
Recipe[6][2][4][#Recipe[6][2][4]+1]={2725,"Bulk Silver Ingot",false,false,1879184467};
Recipe[6][2][1][#Recipe[6][2][1]+1]={1665,"Low-grade Steel Ingot",false,true,0};
Recipe[6][2][3][#Recipe[6][2][3]+1]={2724,"Silver Ingot",false,true,0};
Recipe[6][3][4][#Recipe[6][3][4]+1]={1193,"Bulk Gold Ingot",false,false,1879184471};
Recipe[6][3][2][#Recipe[6][3][2]+1]={1411,"Bulk High-grade Steel Ingot",false,false,1879184453};
Recipe[6][3][4][#Recipe[6][3][4]+1]={2494,"Bulk Rich Iron Ingot",false,false,1879184459};
Recipe[6][3][2][#Recipe[6][3][2]+1]={3333,"Bulk White Gold Ingot",false,false,1879184478};
Recipe[6][3][3][#Recipe[6][3][3]+1]={1192,"Gold Ingot",false,true,0};
Recipe[6][3][1][#Recipe[6][3][1]+1]={1410,"High-grade Steel Ingot",false,true,0};
Recipe[6][3][3][#Recipe[6][3][3]+1]={2493,"Rich Iron Ingot",false,true,0};
Recipe[6][3][1][#Recipe[6][3][1]+1]={3334,"White Gold Ingot",false,true,0};
Recipe[6][4][4][#Recipe[6][4][4]+1]={745,"Bulk Dwarf-iron Ingot",false,false,1879184454};
Recipe[6][4][2][#Recipe[6][4][2]+1]={770,"Bulk Dwarf-steel Ingot",false,false,1879184452};
Recipe[6][4][4][#Recipe[6][4][4]+1]={2046,"Bulk Platinum Ingot",false,false,1879184476};
Recipe[6][4][2][#Recipe[6][4][2]+1]={3301,"Bulk Westernesse Steel Ingot",false,false,1879184468};
Recipe[6][4][3][#Recipe[6][4][3]+1]={744,"Dwarf-iron Ingot",false,true,0};
Recipe[6][4][1][#Recipe[6][4][1]+1]={769,"Dwarf-steel Ingot",false,true,0};
Recipe[6][4][3][#Recipe[6][4][3]+1]={2045,"Platinum Ingot",false,true,0};
Recipe[6][4][1][#Recipe[6][4][1]+1]={3300,"Westernesse Steel Ingot",false,true,0};
Recipe[6][5][3][#Recipe[6][5][3]+1]={31,"Ancient Iron Ingot",false,true,0};
Recipe[6][5][3][#Recipe[6][5][3]+1]={39,"Ancient Nickel Ingot",false,true,0};
Recipe[6][5][3][#Recipe[6][5][3]+1]={44,"Ancient Silver Ingot",false,true,0};
Recipe[6][5][1][#Recipe[6][5][1]+1]={60,"Ancient Steel Ingot",false,true,0};
Recipe[6][5][4][#Recipe[6][5][4]+1]={32,"Bulk Ancient Iron Ingot",false,false,1879184464};
Recipe[6][5][4][#Recipe[6][5][4]+1]={45,"Bulk Ancient Silver Ingot",false,false,1879184482};
Recipe[6][5][2][#Recipe[6][5][2]+1]={61,"Bulk Ancient Steel Ingot",false,false,1879184455};
Recipe[6][5][2][#Recipe[6][5][2]+1]={894,"Bulk Elf-steel Ingot",false,false,1879184465};
Recipe[6][5][1][#Recipe[6][5][1]+1]={893,"Elf-steel Ingot",false,true,0};
Recipe[6][6][2][#Recipe[6][6][2]+1]={1502,"Bulk Khaz"..string.char(195)..string.char(162).."d-bronze Ingot",false,false,1879184485};
Recipe[6][6][4][#Recipe[6][6][4]+1]={1508,"Bulk Khaz"..string.char(195)..string.char(162).."d-copper Ingot",false,false,1879184477};
Recipe[6][6][4][#Recipe[6][6][4]+1]={1516,"Bulk Khaz"..string.char(195)..string.char(162).."d-gold Ingot",false,false,1879184472};
Recipe[6][6][4][#Recipe[6][6][4]+1]={1523,"Bulk Khaz"..string.char(195)..string.char(162).."d-iron Ingot",false,false,1879184470};
Recipe[6][6][2][#Recipe[6][6][2]+1]={1534,"Bulk Khaz"..string.char(195)..string.char(162).."d-steel Ingot",false,false,1879184457};
Recipe[6][6][4][#Recipe[6][6][4]+1]={1543,"Bulk Khaz"..string.char(195)..string.char(162).."d-tin Ingot",false,false,1879184469};
Recipe[6][6][1][#Recipe[6][6][1]+1]={1501,"Khaz"..string.char(195)..string.char(162).."d-bronze Ingot",false,true,0};
Recipe[6][6][3][#Recipe[6][6][3]+1]={1507,"Khaz"..string.char(195)..string.char(162).."d-copper Ingot",false,true,0};
Recipe[6][6][3][#Recipe[6][6][3]+1]={1515,"Khaz"..string.char(195)..string.char(162).."d-gold Ingot",false,true,0};
Recipe[6][6][3][#Recipe[6][6][3]+1]={1522,"Khaz"..string.char(195)..string.char(162).."d-iron Ingot",false,true,0};
Recipe[6][6][1][#Recipe[6][6][1]+1]={1533,"Khaz"..string.char(195)..string.char(162).."d-steel Ingot",false,true,0};
Recipe[6][6][3][#Recipe[6][6][3]+1]={1542,"Khaz"..string.char(195)..string.char(162).."d-tin Ingot",false,true,0};
Recipe[6][6][1][#Recipe[6][6][1]+1]={1894,"Mithril-infused Khaz"..string.char(195)..string.char(162).."d-gold Ingot",false,true,0};
Recipe[6][6][1][#Recipe[6][6][1]+1]={1895,"Mithril-infused Khaz"..string.char(195)..string.char(162).."d-steel Ingot",false,true,0};
Recipe[6][7][1][#Recipe[6][7][1]+1]={180,"Bit of Pure Calenard",false,true,0};
Recipe[6][7][2][#Recipe[6][7][2]+1]={1412,"High-quality Calenard Ingot",false,true,1879211087};
Recipe[6][7][3][#Recipe[6][7][3]+1]={3391,"High-quality Calenard Ingot",false,false,1879211122}; -- not a duplicate, this is granted from the "Improved" recipe
Recipe[6][7][3][#Recipe[6][7][3]+1]={1667,"Low-quality Calenard Ingot",false,true,0};
Recipe[6][7][2][#Recipe[6][7][2]+1]={1846,"Medium-quality Calenard Ingot",false,true,0};

--Recipe[7][1][#Recipe[7][1]+1]={667,"Apprentice Scholar Expertise",false,false,1879184388};
Recipe[7][1][3][#Recipe[7][1][3]+1]={1188,"Gold Dye",false,false,1879066686};
Recipe[7][1][5][#Recipe[7][1][5]+1]={1611,"Lesser Athelas Essence",false,false,1879086295};
Recipe[7][1][5][#Recipe[7][1][5]+1]={1612,"Lesser Celebrant Salve",false,false,1879086293};
Recipe[7][1][5][#Recipe[7][1][5]+1]={1613,"Lesser Conhuith Draught",false,false,1879149710};
Recipe[7][1][5][#Recipe[7][1][5]+1]={1615,"Lesser Healing Draught",false,false,1879149668};
Recipe[7][1][5][#Recipe[7][1][5]+1]={1616,"Lesser Lhinestad Draught",false,false,1879149703};
Recipe[7][1][5][#Recipe[7][1][5]+1]={1617,"Lesser Milkthistle Draught",false,false,1879149677};
Recipe[7][1][4][#Recipe[7][1][4]+1]={1984,"Pea-green Wall Paint",false,false,1879115513};
Recipe[7][1][1][#Recipe[7][1][1]+1]={2641,"Scroll of Minor Battle Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2642,"Scroll of Minor Cooking Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2643,"Scroll of Minor Jeweller Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2644,"Scroll of Minor Metalworking Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2645,"Scroll of Minor Scholar Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2646,"Scroll of Minor Tailoring Lore",false,true,0};
Recipe[7][1][1][#Recipe[7][1][1]+1]={2647,"Scroll of Minor Warding Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2648,"Scroll of Minor Weaponsmithing Lore",false,true,0};
Recipe[7][1][2][#Recipe[7][1][2]+1]={2649,"Scroll of Minor Woodworking Lore",false,true,0};
Recipe[7][1][3][#Recipe[7][1][3]+1]={2717,"Sienna Dye",false,false,1879066685};

Recipe[7][2][11][#Recipe[7][2][11]+1]={3779,"Journeyman Parables",false,false,1879225109};
Recipe[7][2][14][#Recipe[7][2][14]+1]={147,"Ballad of Aiglos",true,false,1879062453};
Recipe[7][2][9][#Recipe[7][2][9]+1]={1081,"Fire-oil",false,false,1879068173};
Recipe[7][2][5][#Recipe[7][2][5]+1]={1265,"Grey Dye",false,false,1879115504};
Recipe[7][2][15][#Recipe[7][2][15]+1]={1267,"Grey Enamel",false,false,1879153476};
Recipe[7][2][6][#Recipe[7][2][6]+1]={1495,"Journeyman Overpower Tactics",false,false,1879197220};
Recipe[7][2][2][#Recipe[7][2][2]+1]={1496,"Journeyman Potion of Fervour",false,false,1879197217};
Recipe[7][2][8][#Recipe[7][2][8]+1]={1497,"Journeyman Potion of Focus",false,false,1879197257};
--Recipe[7][2][#Recipe[7][2]+1]={688,"Journeyman Scholar Expertise",false,false,1879184386};
Recipe[7][2][12][#Recipe[7][2][12]+1]={1498,"Journeyman Sheet Music",false,false,1879197258};
Recipe[7][2][3][#Recipe[7][2][3]+1]={1767,"Master Journeyman Jeweller's Journal",true,false,1879115108};
Recipe[7][2][3][#Recipe[7][2][3]+1]={1768,"Master Journeyman Metalworker's Journal",true,false,1879115098};
Recipe[7][2][3][#Recipe[7][2][3]+1]={1769,"Master Journeyman Tailor's Journal",true,false,1879115084};
Recipe[7][2][3][#Recipe[7][2][3]+1]={1770,"Master Journeyman Weaponsmith's Journal",true,false,1879115135};
Recipe[7][2][3][#Recipe[7][2][3]+1]={1771,"Master Journeyman Woodworker's Journal",true,false,1879115088};
Recipe[7][2][10][#Recipe[7][2][10]+1]={1849,"Minor Book of Beasts",false,false,1879068132};
Recipe[7][2][10][#Recipe[7][2][10]+1]={1850,"Minor Book of Nature",false,false,1879068133};
Recipe[7][2][10][#Recipe[7][2][10]+1]={1851,"Minor Book of the D"..string.char(195)..string.char(186).."nedain",false,false,1879068134};
Recipe[7][2][7][#Recipe[7][2][7]+1]={1852,"Minor Book of the Whisper-draw",false,false,1879146049};
Recipe[7][2][7][#Recipe[7][2][7]+1]={1853,"Minor Book of the Wind-rider",false,false,1879146036};
Recipe[7][2][5][#Recipe[7][2][5]+1]={1933,"Olive Dye",false,false,1879068135};
Recipe[7][2][1][#Recipe[7][2][1]+1]={2631,"Scroll of Lesser Battle Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2632,"Scroll of Lesser Cooking Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2633,"Scroll of Lesser Jeweller Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2634,"Scroll of Lesser Metalworking Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2635,"Scroll of Lesser Scholar Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2636,"Scroll of Lesser Tailoring Lore",false,true,0};
Recipe[7][2][1][#Recipe[7][2][1]+1]={2637,"Scroll of Lesser Warding Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2638,"Scroll of Lesser Weaponsmithing Lore",false,true,0};
Recipe[7][2][4][#Recipe[7][2][4]+1]={2639,"Scroll of Lesser Woodworking Lore",false,true,0};
Recipe[7][2][15][#Recipe[7][2][15]+1]={2726,"Silver Inlay",false,false,1879153475};
Recipe[7][2][13][#Recipe[7][2][13]+1]={2737,"Simple Athelas Essence",false,false,1879086301};
Recipe[7][2][13][#Recipe[7][2][13]+1]={2738,"Simple Celebrant Salve",false,false,1879086298};
Recipe[7][2][13][#Recipe[7][2][13]+1]={2739,"Simple Conhuith Draught",false,false,1879149694};
Recipe[7][2][13][#Recipe[7][2][13]+1]={2743,"Simple Healing Draught",false,false,1879149695};
Recipe[7][2][13][#Recipe[7][2][13]+1]={2744,"Simple Lhinestad Draught",false,false,1879149697};
Recipe[7][2][13][#Recipe[7][2][13]+1]={2746,"Simple Milkthistle Draught",false,false,1879149692};
Recipe[7][2][5][#Recipe[7][2][5]+1]={3210,"Umber Dye",false,false,1879068136};

Recipe[7][3][14][#Recipe[7][3][14]+1]={3780,"Expert Parables",false,false,1879225107};
Recipe[7][3][19][#Recipe[7][3][19]+1]={224,"Blue Enamel",false,false,1879153471};
Recipe[7][3][13][#Recipe[7][3][13]+1]={234,"Book of Beasts",false,false,1879069926};
Recipe[7][3][13][#Recipe[7][3][13]+1]={238,"Book of Nature",false,false,1879069927};
Recipe[7][3][13][#Recipe[7][3][13]+1]={239,"Book of the D"..string.char(195)..string.char(186).."nedain",false,false,1879069928};
Recipe[7][3][9][#Recipe[7][3][9]+1]={240,"Book of the Whisper-draw",false,false,1879146052};
Recipe[7][3][9][#Recipe[7][3][9]+1]={241,"Book of the Wind-rider",false,false,1879146041};
Recipe[7][3][10][#Recipe[7][3][10]+1]={250,"Bow Chant: Minor Breach-finder",false,false,1879143227};
Recipe[7][3][10][#Recipe[7][3][10]+1]={251,"Bow Chant: Minor Foe-finder",false,false,1879091567};
Recipe[7][3][10][#Recipe[7][3][10]+1]={252,"Bow Chant: Minor Shield-bane",false,false,1879091563};
Recipe[7][3][2][#Recipe[7][3][2]+1]={963,"Expert Battle Tonic",false,false,1879197259};
Recipe[7][3][8][#Recipe[7][3][8]+1]={967,"Expert Overpower Tactics",false,false,1879197231};
Recipe[7][3][3][#Recipe[7][3][3]+1]={968,"Expert Potion of Fervour",false,false,1879197249};
Recipe[7][3][11][#Recipe[7][3][11]+1]={969,"Expert Potion of Focus",false,false,1879197260};
--Recipe[7][3][#Recipe[7][3]+1]={681,"Expert Scholar Expertise",false,false,1879184385};
Recipe[7][3][15][#Recipe[7][3][15]+1]={970,"Expert Sheet Music",false,false,1879197219};
Recipe[7][3][7][#Recipe[7][3][7]+1]={1189,"Gold Dye (x5)",false,false,1879139882};
Recipe[7][3][19][#Recipe[7][3][19]+1]={1194,"Gold Inlay",false,false,1879153383};
Recipe[7][3][17][#Recipe[7][3][17]+1]={1239,"Greater Athelas Essence",false,false,1879086296};
Recipe[7][3][18][#Recipe[7][3][18]+1]={1240,"Greater Athelas Essence (x5)",false,false,1879139855};
Recipe[7][3][18][#Recipe[7][3][18]+1]={1241,"Greater Athelas Extract (x25)",false,false,1879139863};
Recipe[7][3][18][#Recipe[7][3][18]+1]={1244,"Greater Celebrant Ointment (x25)",false,false,1879139858};
Recipe[7][3][17][#Recipe[7][3][17]+1]={1245,"Greater Celebrant Salve",false,false,1879086292};
Recipe[7][3][18][#Recipe[7][3][18]+1]={1246,"Greater Celebrant Salve (x5)",false,false,1879139852};
Recipe[7][3][17][#Recipe[7][3][17]+1]={1247,"Greater Conhuith Draught",false,false,1879149674};
Recipe[7][3][17][#Recipe[7][3][17]+1]={1248,"Greater Healing Draught",false,false,1879149689};
Recipe[7][3][17][#Recipe[7][3][17]+1]={1249,"Greater Lhinestad Draught",false,false,1879149685};
Recipe[7][3][17][#Recipe[7][3][17]+1]={1250,"Greater Milkthistle Draught",false,false,1879149676};
Recipe[7][3][7][#Recipe[7][3][7]+1]={1266,"Grey Dye (x5)",false,false,1879139871};
Recipe[7][3][12][#Recipe[7][3][12]+1]={1628,"Light-oil",false,false,1879069965};
Recipe[7][3][4][#Recipe[7][3][4]+1]={1762,"Master Expert Jeweller's Journal",true,false,1879115119};
Recipe[7][3][4][#Recipe[7][3][4]+1]={1763,"Master Expert Metalworker's Journal",true,false,1879115139};
Recipe[7][3][4][#Recipe[7][3][4]+1]={1764,"Master Expert Tailor's Journal",true,false,1879115100};
Recipe[7][3][4][#Recipe[7][3][4]+1]={1765,"Master Expert Weaponsmith's Journal",true,false,1879115104};
Recipe[7][3][4][#Recipe[7][3][4]+1]={1766,"Master Expert Woodworker's Journal",true,false,1879115103};
Recipe[7][3][20][#Recipe[7][3][20]+1]={1823,"Medium Expert Scroll",false,false,1879125845};
Recipe[7][3][6][#Recipe[7][3][6]+1]={1905,"Navy Dye",false,false,1879070205};
Recipe[7][3][7][#Recipe[7][3][7]+1]={1934,"Olive Dye (x5)",false,false,1879139861};
Recipe[7][3][1][#Recipe[7][3][1]+1]={2613,"Scroll of Battle Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2614,"Scroll of Cooking Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2630,"Scroll of Jeweller Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2640,"Scroll of Metalworking Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2650,"Scroll of Scholar Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2660,"Scroll of Tailoring Lore",false,true,0};
Recipe[7][3][1][#Recipe[7][3][1]+1]={2662,"Scroll of Warding Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2663,"Scroll of Weaponsmithing Lore",false,true,0};
Recipe[7][3][5][#Recipe[7][3][5]+1]={2665,"Scroll of Woodworking Lore",false,true,0};
Recipe[7][3][7][#Recipe[7][3][7]+1]={2718,"Sienna Dye (x5)",false,false,1879139862};
Recipe[7][3][16][#Recipe[7][3][16]+1]={2750,"Sky-blue Wall Paint",false,false,1879115506};
Recipe[7][3][20][#Recipe[7][3][20]+1]={2766,"Small Expert Scroll",false,false,1879125825};
Recipe[7][3][6][#Recipe[7][3][6]+1]={3203,"Turquoise Dye",false,false,1879115518};
Recipe[7][3][7][#Recipe[7][3][7]+1]={3211,"Umber Dye (x5)",false,false,1879139875};
Recipe[7][3][6][#Recipe[7][3][6]+1]={3243,"Violet Dye",false,false,1879070204};

Recipe[7][4][16][#Recipe[7][4][16]+1]={3781,"Artisan Parables",false,false,1879225105};
Recipe[7][4][6][#Recipe[7][4][6]+1]={1,"'Above Weathertop' Painting",false,false,1879101796};
Recipe[7][4][2][#Recipe[7][4][2]+1]={94,"Artisan Battle Tonic",false,false,1879197225};
Recipe[7][4][10][#Recipe[7][4][10]+1]={99,"Artisan Overpower Tactics",false,false,1879197241};
Recipe[7][4][3][#Recipe[7][4][3]+1]={100,"Artisan Potion of Fervour",false,false,1879197261};
Recipe[7][4][13][#Recipe[7][4][13]+1]={101,"Artisan Potion of Focus",false,false,1879197230};
--Recipe[7][4][#Recipe[7][4]+1]={674,"Artisan Scholar Expertise",false,false,1879184389};
Recipe[7][4][17][#Recipe[7][4][17]+1]={102,"Artisan Sheet Music",false,false,1879197248};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2214,"Atharbain\'s Refined Athelas Essences",false,false,1879112145};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2219,"Atharbain\'s Refined Celebrant Salves",false,false,1879112141};
Recipe[7][4][12][#Recipe[7][4][12]+1]={242,"Bow Chant: Breach-finder",false,false,1879143239};
Recipe[7][4][12][#Recipe[7][4][12]+1]={243,"Bow Chant: Foe-finder",false,false,1879143222};
Recipe[7][4][12][#Recipe[7][4][12]+1]={253,"Bow Chant: Shield-bane",false,false,1879143221};
Recipe[7][4][7][#Recipe[7][4][7]+1]={333,"Burgundy Dye",false,false,1879115512};
Recipe[7][4][21][#Recipe[7][4][21]+1]={410,"Chant of the Stalwart",true,false,1879062395};
Recipe[7][4][7][#Recipe[7][4][7]+1]={629,"Dark Green Dye",false,false,1879054885};
Recipe[7][4][7][#Recipe[7][4][7]+1]={956,"Evendim Blue Dye",false,false,1879199806};
Recipe[7][4][7][#Recipe[7][4][7]+1]={1104,"Forest Green Dye",false,false,1879199779};
Recipe[7][4][7][#Recipe[7][4][7]+1]={1447,"Indigo Dye",false,false,1879054884};
Recipe[7][4][15][#Recipe[7][4][15]+1]={1692,"Major Book of Beasts",false,false,1879070399};
Recipe[7][4][15][#Recipe[7][4][15]+1]={1693,"Major Book of Nature",false,false,1879070400};
Recipe[7][4][15][#Recipe[7][4][15]+1]={1694,"Major Book of the D"..string.char(195)..string.char(186).."nedain",false,false,1879070401};
Recipe[7][4][11][#Recipe[7][4][11]+1]={1695,"Major Book of the Whisper-draw",false,false,1879091571};
Recipe[7][4][11][#Recipe[7][4][11]+1]={1696,"Major Book of the Wind-rider",false,false,1879091566};
Recipe[7][4][4][#Recipe[7][4][4]+1]={1754,"Master Artisan Jeweller's Journal",true,false,1879115140};
Recipe[7][4][4][#Recipe[7][4][4]+1]={1755,"Master Artisan Metalworker's Journal",true,false,1879115116};
Recipe[7][4][4][#Recipe[7][4][4]+1]={1756,"Master Artisan Tailor's Journal",true,false,1879115142};
Recipe[7][4][4][#Recipe[7][4][4]+1]={1757,"Master Artisan Weaponsmith's Journal",true,false,1879115083};
Recipe[7][4][4][#Recipe[7][4][4]+1]={1758,"Master Artisan Woodworker's Journal",true,false,1879115085};
Recipe[7][4][23][#Recipe[7][4][23]+1]={1816,"Medium Artisan Scroll",false,false,1879125749};
Recipe[7][4][8][#Recipe[7][4][8]+1]={1906,"Navy Dye (x5)",false,false,1879139880};
Recipe[7][4][18][#Recipe[7][4][18]+1]={1982,"Pale-yellow Wall Paint",false,false,1879115510};
Recipe[7][4][18][#Recipe[7][4][18]+1]={2028,"Pink Wall Paint",false,false,1879115503};
Recipe[7][4][22][#Recipe[7][4][22]+1]={2047,"Platinum Inlay",false,false,1879153397};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2213,"Refined Athelas Essence",false,false,1879086294};
Recipe[7][4][20][#Recipe[7][4][20]+1]={2215,"Refined Athelas Essence (x5)",false,false,1879139876};
Recipe[7][4][20][#Recipe[7][4][20]+1]={2216,"Refined Athelas Extract (x25)",false,false,1879139860};
Recipe[7][4][20][#Recipe[7][4][20]+1]={2217,"Refined Celebrant Ointment (x25)",false,false,1879139866};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2218,"Refined Celebrant Salve",false,false,1879086300};
Recipe[7][4][20][#Recipe[7][4][20]+1]={2220,"Refined Celebrant Salve (x5)",false,false,1879139892};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2221,"Refined Conhuith Draught",false,false,1879149669};
Recipe[7][4][14][#Recipe[7][4][14]+1]={2222,"Refined Fire-oil",false,false,1879054941};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2223,"Refined Healing Draught",false,false,1879149673};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2224,"Refined Lhinestad Draught",false,false,1879149678};
Recipe[7][4][19][#Recipe[7][4][19]+1]={2226,"Refined Milkthistle Draught",false,false,1879149667};
Recipe[7][4][9][#Recipe[7][4][9]+1]={2594,"Scholar's Writ",false,false,1879092210};
Recipe[7][4][1][#Recipe[7][4][1]+1]={2617,"Scroll of Elder Battle Lore",false,false,1879176009};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2618,"Scroll of Elder Cooking Lore",false,true,0};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2619,"Scroll of Elder Jeweller Lore",false,true,0};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2620,"Scroll of Elder Metalworking Lore",false,true,0};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2621,"Scroll of Elder Scholar Lore",false,true,0};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2622,"Scroll of Elder Tailoring Lore",false,true,0};
Recipe[7][4][1][#Recipe[7][4][1]+1]={2623,"Scroll of Elder Warding Lore",false,false,1879175992};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2624,"Scroll of Elder Weaponsmithing Lore",false,true,0};
Recipe[7][4][5][#Recipe[7][4][5]+1]={2625,"Scroll of Elder Woodworking Lore",false,true,0};
Recipe[7][4][6][#Recipe[7][4][6]+1]={4,"'Shore Glimpse' Painting",false,false,1879101778};
Recipe[7][4][23][#Recipe[7][4][23]+1]={2759,"Small Artisan Scroll",false,false,1879125787};
Recipe[7][4][8][#Recipe[7][4][8]+1]={3204,"Turquoise Dye (x5)",false,false,1879139885};
Recipe[7][4][8][#Recipe[7][4][8]+1]={3244,"Violet Dye (x5)",false,false,1879139908};
Recipe[7][4][22][#Recipe[7][4][22]+1]={3350,"Yellow Enamel",false,false,1879153466};

Recipe[7][5][14][#Recipe[7][5][14]+1]={3782,"Master Parables",false,false,1879225108};
Recipe[7][5][19][#Recipe[7][5][19]+1]={46,"Ancient Silver Inlay",false,false,1879153432};
Recipe[7][5][17][#Recipe[7][5][17]+1]={707,"Atharbain\'s Distilled Athelas Essences",false,false,1879112146}; -- not sure of the correct category
Recipe[7][5][17][#Recipe[7][5][17]+1]={712,"Atharbain\'s Distilled Celebrant Salves",false,false,1879112140}; -- not sure of the correct category
Recipe[7][5][11][#Recipe[7][5][11]+1]={247,"Bow Chant: Major Breach-finder",false,false,1879091572};
Recipe[7][5][11][#Recipe[7][5][11]+1]={248,"Bow Chant: Major Foe-finder",false,false,1879143231};
Recipe[7][5][11][#Recipe[7][5][11]+1]={249,"Bow Chant: Major Shield-bane",false,false,1879143219};
Recipe[7][5][7][#Recipe[7][5][7]+1]={334,"Burgundy Dye (x5)",false,false,1879139854};
Recipe[7][5][7][#Recipe[7][5][7]+1]={630,"Dark Green Dye (x5)",false,false,1879139869};
Recipe[7][5][17][#Recipe[7][5][17]+1]={706,"Distilled Athelas Essence",false,false,1879086299};
Recipe[7][5][18][#Recipe[7][5][18]+1]={708,"Distilled Athelas Essence (x5)",false,false,1879139893};
Recipe[7][5][18][#Recipe[7][5][18]+1]={709,"Distilled Athelas Extract (x25)",false,false,1879139878};
Recipe[7][5][18][#Recipe[7][5][18]+1]={710,"Distilled Celebrant Ointment (x25)",false,false,1879139896};
Recipe[7][5][17][#Recipe[7][5][17]+1]={711,"Distilled Celebrant Salve",false,false,1879086297};
Recipe[7][5][18][#Recipe[7][5][18]+1]={713,"Distilled Celebrant Salve (x5)",false,false,1879139859};
Recipe[7][5][17][#Recipe[7][5][17]+1]={714,"Distilled Conhuith Draught",false,false,1879149680};
Recipe[7][5][17][#Recipe[7][5][17]+1]={715,"Distilled Healing Draught",false,false,1879149691};
Recipe[7][5][17][#Recipe[7][5][17]+1]={716,"Distilled Lhinestad Draught",false,false,1879149711};
Recipe[7][5][17][#Recipe[7][5][17]+1]={717,"Distilled Milkthistle Draught",false,false,1879149671};
Recipe[7][5][7][#Recipe[7][5][7]+1]={957,"Evendim Blue Dye (x5)",false,false,1879199801};
Recipe[7][5][7][#Recipe[7][5][7]+1]={1105,"Forest Green Dye (x5)",false,false,1879199808};
Recipe[7][5][4][#Recipe[7][5][4]+1]={1234,"Grand Master Jeweller's Journal",true,false,1879115113};
Recipe[7][5][4][#Recipe[7][5][4]+1]={1235,"Grand Master Metalworker's Journal",true,false,1879115132};
Recipe[7][5][4][#Recipe[7][5][4]+1]={1236,"Grand Master Tailor's Journal",true,false,1879115117};
Recipe[7][5][4][#Recipe[7][5][4]+1]={1237,"Grand Master Weaponsmith's Journal",true,false,1879115131};
Recipe[7][5][4][#Recipe[7][5][4]+1]={1238,"Grand Master Woodworker's Journal",true,false,1879115123};
Recipe[7][5][10][#Recipe[7][5][10]+1]={1242,"Greater Book of the Whisper-draw",false,false,1879205682};
Recipe[7][5][10][#Recipe[7][5][10]+1]={1243,"Greater Book of the Wind-rider",false,false,1879205686};
Recipe[7][5][7][#Recipe[7][5][7]+1]={1448,"Indigo Dye (x5)",false,false,1879139901};
Recipe[7][5][20][#Recipe[7][5][20]+1]={1562,"Large Master Scroll",false,false,1879125898};
Recipe[7][5][16][#Recipe[7][5][16]+1]={1579,"Lavender Wall Paint",false,false,1879115508};
Recipe[7][5][2][#Recipe[7][5][2]+1]={1759,"Master Battle Tonic",false,false,1879197237};
Recipe[7][5][9][#Recipe[7][5][9]+1]={1773,"Master Overpower Tactics",false,false,1879197262};
Recipe[7][5][3][#Recipe[7][5][3]+1]={1774,"Master Potion of Fervour",false,false,1879197229};
Recipe[7][5][12][#Recipe[7][5][12]+1]={1775,"Master Potion of Focus",false,false,1879197214};
--Recipe[7][5][#Recipe[7][5]+1]={695,"Master Scholar Expertise",false,false,1879184387};
Recipe[7][5][15][#Recipe[7][5][15]+1]={1776,"Master Sheet Music",false,false,1879197263};
Recipe[7][5][20][#Recipe[7][5][20]+1]={1830,"Medium Master Scroll",false,false,1879125901};
Recipe[7][5][8][#Recipe[7][5][8]+1]={1922,"Of Mysteries Most Profound",false,false,1879092205};
Recipe[7][5][6][#Recipe[7][6][5]+1]={1941,"Orange Dye",false,false,1879115517};
Recipe[7][5][16][#Recipe[7][5][16]+1]={2163,"Pumpkin-orange Wall Paint",false,false,1879115505};
Recipe[7][5][6][#Recipe[7][5][6]+1]={2209,"Red Dye",false,false,1879054883};
Recipe[7][5][19][#Recipe[7][5][19]+1]={2211,"Red Enamel",false,false,1879153446};
Recipe[7][5][13][#Recipe[7][5][13]+1]={2225,"Refined Light-oil",false,false,1879054942};
Recipe[7][5][6][#Recipe[7][5][6]+1]={2503,"Rivendell Green Dye",false,false,1879199793};
Recipe[7][5][6][#Recipe[7][5][6]+1]={2558,"Rust Dye",false,false,1879054882};
Recipe[7][5][1][#Recipe[7][5][1]+1]={2602,"Scroll of Ancient Battle Lore",false,false,1879115110};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2603,"Scroll of Ancient Cooking Lore",false,true,0};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2604,"Scroll of Ancient Jeweller Lore",false,true,0};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2605,"Scroll of Ancient Metalworking Lore",false,true,0};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2606,"Scroll of Ancient Scholar Lore",false,true,0};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2607,"Scroll of Ancient Tailoring Lore",false,true,0};
Recipe[7][5][1][#Recipe[7][5][1]+1]={2608,"Scroll of Ancient Warding Lore",false,false,1879115092};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2609,"Scroll of Ancient Weaponsmithing Lore",false,true,0};
Recipe[7][5][5][#Recipe[7][5][5]+1]={2610,"Scroll of Ancient Woodworking Lore",false,true,0};
Recipe[7][5][6][#Recipe[7][5][6]+1]={2667,"Sea Blue Dye",false,false,1879199799};
Recipe[7][5][20][#Recipe[7][5][20]+1]={2774,"Small Master Scroll",false,false,1879125937};
Recipe[7][5][8][#Recipe[7][5][8]+1]={2941,"Study of the Unknown",false,false,1879092212};

Recipe[7][6][18][#Recipe[7][6][18]+1]={3783,"Supreme Parables",false,false,1879225106};
Recipe[7][6][8][#Recipe[7][6][8]+1]={195,"Black Dye (x5)",false,false,1879157217};
Recipe[7][6][11][#Recipe[7][6][11]+1]={244,"Bow Chant: Greater Breach-finder",false,false,1879143228};
Recipe[7][6][11][#Recipe[7][6][11]+1]={245,"Bow Chant: Greater Foe-finder",false,false,1879143241};
Recipe[7][6][11][#Recipe[7][6][11]+1]={246,"Bow Chant: Greater Shield-bane",false,false,1879143215};
Recipe[7][6][11][#Recipe[7][6][11]+1]={254,"Bow Chant: Supreme Breach-finder",false,false,1879173704};
Recipe[7][6][11][#Recipe[7][6][11]+1]={255,"Bow Chant: Supreme Foe-finder",false,false,1879173707};
Recipe[7][6][11][#Recipe[7][6][11]+1]={256,"Bow Chant: Supreme Shield-bane",false,false,1879173705};
Recipe[7][6][20][#Recipe[7][6][20]+1]={335,"Burnt Orange Wall Paint",false,false,1879151116};
Recipe[7][6][14][#Recipe[7][6][14]+1]={555,"Crafted Lore-master's Book of the Third Age",false,false,1879144955};
Recipe[7][6][15][#Recipe[7][6][15]+1]={554,"Crafted Lore-master's Book of the Third Age",false,false,1879165833};
Recipe[7][6][16][#Recipe[7][6][16]+1]={566,"Crafted Minstrel's Songbook of the Third Age",false,false,1879144971};
Recipe[7][6][17][#Recipe[7][6][17]+1]={565,"Crafted Minstrel's Songbook of the Third Age",false,false,1879165741};
Recipe[7][6][7][#Recipe[7][6][7]+1]={597,"Crimson Dye",false,false,1879199796};
Recipe[7][6][8][#Recipe[7][6][8]+1]={598,"Crimson Dye (x5)",false,false,1879199782};
Recipe[7][6][7][#Recipe[7][6][7]+1]={925,"Ered Luin Blue Dye",false,false,1879199775};
Recipe[7][6][8][#Recipe[7][6][8]+1]={926,"Ered Luin Blue Dye (x5)",false,false,1879199795};
Recipe[7][6][2][#Recipe[7][6][2]+1]={1251,"Greater Supreme Battle Tonic",false,false,1879197233};
Recipe[7][6][9][#Recipe[7][6][9]+1]={1254,"Greater Supreme Overpower Tactics",false,false,1879200775};
Recipe[7][6][3][#Recipe[7][6][3]+1]={1255,"Greater Supreme Potion of Fervour",false,false,1879200776};
Recipe[7][6][12][#Recipe[7][6][12]+1]={1256,"Greater Supreme Potion of Focus",false,false,1879200773};
Recipe[7][6][21][#Recipe[7][6][21]+1]={1449,"Infused Athelas Essence",false,false,1879106917};
Recipe[7][6][22][#Recipe[7][6][22]+1]={1450,"Infused Athelas Essence (x5)",false,false,1879139872};
Recipe[7][6][22][#Recipe[7][6][22]+1]={1451,"Infused Athelas Extract (x25)",false,false,1879139890};
Recipe[7][6][22][#Recipe[7][6][22]+1]={1452,"Infused Celebrant Ointment (x25)",false,false,1879139905};
Recipe[7][6][21][#Recipe[7][6][21]+1]={1453,"Infused Celebrant Salve",false,false,1879106910};
Recipe[7][6][22][#Recipe[7][6][22]+1]={1454,"Infused Celebrant Salve (x5)",false,false,1879139864};
Recipe[7][6][21][#Recipe[7][6][21]+1]={1455,"Infused Conhuith Draught",false,false,1879149699};
Recipe[7][6][21][#Recipe[7][6][21]+1]={1456,"Infused Healing Draught",false,false,1879149700};
Recipe[7][6][21][#Recipe[7][6][21]+1]={1457,"Infused Lhinestad Draught",false,false,1879149683};
Recipe[7][6][21][#Recipe[7][6][21]+1]={1458,"Infused Milkthistle Draught",false,false,1879149696};
Recipe[7][6][24][#Recipe[7][6][24]+1]={1517,"Khaz"..string.char(195)..string.char(162).."d-gold Inlay",false,false,1879153396};
Recipe[7][6][25][#Recipe[7][6][25]+1]={1569,"Large Supreme Scroll",false,false,1879125763};
Recipe[7][6][25][#Recipe[7][6][25]+1]={1837,"Medium Supreme Scroll",false,false,1879125805};
Recipe[7][6][8][#Recipe[7][6][8]+1]={1942,"Orange Dye (x5)",false,false,1879139883};
Recipe[7][6][21][#Recipe[7][6][21]+1]={2104,"Potent Athelas Essence",false,false,1879154542};
Recipe[7][6][22][#Recipe[7][6][22]+1]={2105,"Potent Athelas Essence (x25)",false,false,1879157213};
Recipe[7][6][21][#Recipe[7][6][21]+1]={2106,"Potent Celebrant Salve",false,false,1879154548};
Recipe[7][6][22][#Recipe[7][6][22]+1]={2107,"Potent Celebrant Salve (x25)",false,false,1879157195};
Recipe[7][6][21][#Recipe[7][6][21]+1]={2164,"Pure Athelas Essence",false,false,1879106916};
Recipe[7][6][22][#Recipe[7][6][22]+1]={2165,"Pure Athelas Essence (x5)",false,false,1879157388};
Recipe[7][6][22][#Recipe[7][6][22]+1]={2166,"Pure Athelas Extract (x25)",false,false,1879157386};
Recipe[7][6][22][#Recipe[7][6][22]+1]={2167,"Pure Celebrant Ointment (x25)",false,false,1879157390};
Recipe[7][6][21][#Recipe[7][6][21]+1]={2168,"Pure Celebrant Salve",false,false,1879106915};
Recipe[7][6][22][#Recipe[7][6][22]+1]={2169,"Pure Celebrant Salve (x5)",false,false,1879157391};
Recipe[7][6][13][#Recipe[7][6][13]+1]={2170,"Pure Fire-oil",false,false,1879143240};
Recipe[7][6][13][#Recipe[7][6][13]+1]={2171,"Pure Light-oil",false,false,1879179499};
Recipe[7][6][7][#Recipe[7][6][7]+1]={2172,"Purple Dye",false,false,1879199776};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2173,"Purple Dye (x5)",false,false,1879199811};
Recipe[7][6][7][#Recipe[7][6][7]+1]={2195,"Ranger Green Dye",false,false,1879199807};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2196,"Ranger Green Dye (x5)",false,false,1879199809};
Recipe[7][6][4][#Recipe[7][6][4]+1]={2204,"Record of Durin",false,false,1879166139};
Recipe[7][6][4][#Recipe[7][6][4]+1]={2205,"Record of the Elf-lords",false,false,1879166153};
Recipe[7][6][4][#Recipe[7][6][4]+1]={2206,"Record of the Race of Man",false,false,1879166117};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2210,"Red Dye (x5)",false,false,1879139868};
Recipe[7][6][14][#Recipe[7][6][14]+1]={2332,"Reforged Lore-master's Book of the Second Age",false,false,1879162221};
Recipe[7][6][15][#Recipe[7][6][15]+1]={2331,"Reforged Lore-master's Book of the Second Age",false,false,1879165875};
Recipe[7][6][16][#Recipe[7][6][16]+1]={2341,"Reforged Minstrel's Songbook of the Second Age",false,false,1879162178};
Recipe[7][6][17][#Recipe[7][6][17]+1]={2342,"Reforged Minstrel's Songbook of the Second Age",false,false,1879165891};
Recipe[7][6][15][#Recipe[7][6][15]+1]={2447,"Reshaped Lore-master's Book of the First Age",false,false,1879181507};
Recipe[7][6][17][#Recipe[7][6][17]+1]={2452,"Reshaped Minstrel's Songbook of the First Age",false,false,1879181496};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2504,"Rivendell Green Dye (x5)",false,false,1879199792};
Recipe[7][6][7][#Recipe[7][6][7]+1]={2528,"Rose Dye",false,false,1879199778};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2529,"Rose Dye (x5)",false,false,1879199810};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2559,"Rust Dye (x5)",false,false,1879139888};
Recipe[7][6][1][#Recipe[7][6][1]+1]={2651,"Scroll of Supreme Battle Lore",false,false,1879176004};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2652,"Scroll of Supreme Cooking Lore",false,true,0};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2653,"Scroll of Supreme Jeweller Lore",false,true,0};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2654,"Scroll of Supreme Metalworking Lore",false,true,0};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2655,"Scroll of Supreme Scholar Lore",false,true,0};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2656,"Scroll of Supreme Tailoring Lore",false,true,0};
Recipe[7][6][1][#Recipe[7][6][1]+1]={2657,"Scroll of Supreme Warding Lore",false,false,1879176008};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2658,"Scroll of Supreme Weaponsmithing Lore",false,true,0};
Recipe[7][6][6][#Recipe[7][6][6]+1]={2659,"Scroll of Supreme Woodworking Lore",false,true,0};
Recipe[7][6][8][#Recipe[7][6][8]+1]={2668,"Sea Blue Dye (x5)",false,false,1879199783};
Recipe[7][6][25][#Recipe[7][6][25]+1]={2781,"Small Supreme Scroll",false,false,1879125925};
Recipe[7][6][23][#Recipe[7][6][23]+1]={2887,"Steeped Athelas Essence",false,false,1879163263};
Recipe[7][6][23][#Recipe[7][6][23]+1]={2888,"Steeped Celebrant Salve",false,false,1879163233};
Recipe[7][6][23][#Recipe[7][6][23]+1]={2889,"Steeped Conhuith Draught",false,false,1879165909};
Recipe[7][6][23][#Recipe[7][6][23]+1]={2890,"Steeped Healing Draught",false,false,1879165792};
Recipe[7][6][23][#Recipe[7][6][23]+1]={2891,"Steeped Lhinestad Draught",false,false,1879165828};
Recipe[7][6][23][#Recipe[7][6][23]+1]={2892,"Steeped Milkthistle Draught",false,false,1879165815};
Recipe[7][6][2][#Recipe[7][6][2]+1]={3073,"Supreme Battle Tonic",false,false,1879197224};
Recipe[7][6][10][#Recipe[7][6][10]+1]={3075,"Supreme Book of the Whisper-draw",false,false,1879205690};
Recipe[7][6][10][#Recipe[7][6][10]+1]={3076,"Supreme Book of the Wind-rider",false,false,1879205689};
Recipe[7][6][5][#Recipe[7][6][5]+1]={3084,"Supreme Master Jeweller's Journal",true,false,1879145331};
Recipe[7][6][5][#Recipe[7][6][5]+1]={3085,"Supreme Master Metalworker's Journal",true,false,1879145329};
Recipe[7][6][5][#Recipe[7][6][5]+1]={3086,"Supreme Master Tailor's Journal",true,false,1879145330};
Recipe[7][6][5][#Recipe[7][6][5]+1]={3087,"Supreme Master Weaponsmith's Journal",true,false,1879145328};
Recipe[7][6][5][#Recipe[7][6][5]+1]={3088,"Supreme Master Woodworker's Journal",true,false,1879145339};
Recipe[7][6][9][#Recipe[7][6][9]+1]={3090,"Supreme Overpower Tactics",false,false,1879197213};
Recipe[7][6][3][#Recipe[7][6][3]+1]={3092,"Supreme Potion of Fervour",false,false,1879197264};
Recipe[7][6][12][#Recipe[7][6][12]+1]={3093,"Supreme Potion of Focus",false,false,1879197265};
--Recipe[7][6][#Recipe[7][6]+1]={702,"Supreme Scholar Expertise",false,false,1879184390};
Recipe[7][6][19][#Recipe[7][6][19]+1]={3094,"Supreme Sheet Music",false,false,1879197232};
Recipe[7][6][7][#Recipe[7][6][7]+1]={3328,"White Dye",false,false,1879149795};
Recipe[7][6][8][#Recipe[7][6][8]+1]={3327,"White Dye (x5)",false,false,1879157182};
Recipe[7][6][24][#Recipe[7][6][24]+1]={3329,"White Enamel",false,false,1879153465};
Recipe[7][6][7][#Recipe[7][6][7]+1]={3348,"Yellow Dye",false,false,1879199791};
Recipe[7][6][8][#Recipe[7][6][8]+1]={3349,"Yellow Dye (x5)",false,false,1879199774};

Recipe[7][7][20][#Recipe[7][7][20]+1]={236,"Book of Knowledge",false,true,0};
Recipe[7][7][21][#Recipe[7][7][21]+1]={237,"Book of Knowledge (x5)",false,false,1879210924};
Recipe[7][7][16][#Recipe[7][7][16]+1]={3423,"Book of Manuevers",true,false,1879225829};
Recipe[7][7][16][#Recipe[7][7][16]+1]={3431,"Book of Techniques",true,false,1879225832};
Recipe[7][7][16][#Recipe[7][7][16]+1]={235,"Book of Truth",true,false,1879220265};
Recipe[7][7][9][#Recipe[7][7][9]+1]={257,"Bow Chant: Westfold Breach-finder",false,false,1879211042};
Recipe[7][7][9][#Recipe[7][7][9]+1]={258,"Bow Chant: Westfold Foe-finder",false,false,1879211023};
Recipe[7][7][9][#Recipe[7][7][9]+1]={259,"Bow Chant: Westfold Shield-bane",false,false,1879211080};
Recipe[7][7][22][#Recipe[7][7][22]+1]={342,"Calenard Inlay",false,false,1879211052};
Recipe[7][7][12][#Recipe[7][7][12]+1]={3405,"Crafted Lore-master's Book of the Third Age",false,false,1879219811};
Recipe[7][7][13][#Recipe[7][7][13]+1]={3406,"Crafted Minstrel's Songbook of the Third Age",false,false,1879219694};
Recipe[7][7][16][#Recipe[7][7][16]+1]={725,"Dunland Book",false,false,1879210885};
Recipe[7][7][18][#Recipe[7][7][18]+1]={724,"Dunland Draughts",false,false,1879210956};
Recipe[7][7][17][#Recipe[7][7][17]+1]={1445,"Illuminated Rohirric Book",false,false,1879211011};
Recipe[7][7][6][#Recipe[7][7][6]+1]={1459,"Inspired Note",false,true,0};
Recipe[7][7][23][#Recipe[7][7][23]+1]={1576,"Large Westfold Scroll",false,false,1879210996};
Recipe[7][7][4][#Recipe[7][7][4]+1]={1778,"Master Westfold Jeweller's Journal",true,false,1879210948};
Recipe[7][7][4][#Recipe[7][7][4]+1]={1779,"Master Westfold Metalsmith's Journal",true,false,1879210920};
Recipe[7][7][4][#Recipe[7][7][4]+1]={1780,"Master Westfold Scholar's Journal",true,false,1879211000};
Recipe[7][7][4][#Recipe[7][7][4]+1]={1781,"Master Westfold Tailor's Journal",true,false,1879210945};
Recipe[7][7][4][#Recipe[7][7][4]+1]={1782,"Master Westfold Weaponsmith's Journal",true,false,1879211076};
Recipe[7][7][4][#Recipe[7][7][4]+1]={1783,"Master Westfold Woodworker's Journal",true,false,1879211079};
Recipe[7][7][23][#Recipe[7][7][23]+1]={1844,"Medium Westfold Scroll",false,false,1879210941};
Recipe[7][7][11][#Recipe[7][7][11]+1]={2109,"Potent Fire-oil",false,false,1879210903};
Recipe[7][7][11][#Recipe[7][7][11]+1]={2112,"Potent Light-oil",false,false,1879210951};
Recipe[7][7][22][#Recipe[7][7][22]+1]={2174,"Purple Enamel",false,false,1879211014};
Recipe[7][7][12][#Recipe[7][7][12]+1]={3407,"Reforged Lore-master's Book of the Second Age",false,false,1879219801};
Recipe[7][7][13][#Recipe[7][7][13]+1]={3408,"Reforged Minstrel's Songbook of the Second Age",false,false,1879219812};
Recipe[7][7][12][#Recipe[7][7][12]+1]={3409,"Reshaped Lore-master's Book of the First Age",false,false,1879219793};
Recipe[7][7][13][#Recipe[7][7][13]+1]={3410,"Reshaped Minstrel's Songbook of the First Age",false,false,1879219746};
Recipe[7][7][18][#Recipe[7][7][18]+1]={2520,"Rohirric Athelas Essence",false,false,1879211004};
Recipe[7][7][19][#Recipe[7][7][19]+1]={2522,"Rohirric Athelas Essence (x25)",false,false,1879211099};
Recipe[7][7][19][#Recipe[7][7][19]+1]={2521,"Rohirric Athelas Essence (x5)",false,false,1879211115};
Recipe[7][7][16][#Recipe[7][7][16]+1]={2526,"Rohirric Book",true,false,1879210909};
Recipe[7][7][18][#Recipe[7][7][18]+1]={2523,"Rohirric Celebrant Salve",false,false,1879211082};
Recipe[7][7][19][#Recipe[7][7][19]+1]={2525,"Rohirric Celebrant Salve (x25)",false,false,1879210954};
Recipe[7][7][19][#Recipe[7][7][19]+1]={2524,"Rohirric Celebrant Salve (x5)",false,false,1879210919};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2611,"Scroll of Armourer's Lore",false,false,1879211057};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2612,"Scroll of Armsman's Lore",false,false,1879210961};
Recipe[7][7][1][#Recipe[7][7][1]+1]={2615,"Scroll of Dunlending Battle Lore",false,false,1879210955};
Recipe[7][7][1][#Recipe[7][7][1]+1]={2616,"Scroll of Dunlending Warding Lore",false,false,1879210881};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2626,"Scroll of Explorer's Lore",false,false,1879210895};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2627,"Scroll of Historian's Lore",false,false,1879210934};
Recipe[7][7][20][#Recipe[7][7][20]+1]={2628,"Scroll of Insight",false,true,0};
Recipe[7][7][21][#Recipe[7][7][21]+1]={2629,"Scroll of Insight (x5)",false,false,1879211113};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2661,"Scroll of Tinker's Lore",false,false,1879211095};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2664,"Scroll of Woodsman's Lore",false,false,1879211009};
Recipe[7][7][5][#Recipe[7][7][5]+1]={2666,"Scroll of Yeoman's Lore",false,false,1879210942};
Recipe[7][7][15][#Recipe[7][7][15]+1]={2705,"Sheet of Westfold Music",false,false,1879211070};
Recipe[7][7][23][#Recipe[7][7][23]+1]={2788,"Small Westfold Scroll",false,false,1879211035};
Recipe[7][7][20][#Recipe[7][7][20]+1]={3169,"Tome of Wisdom",false,true,1879210981};
Recipe[7][7][20][#Recipe[7][7][20]+1]={3771,"Tome of Wisdom",false,true,1879211116};
Recipe[7][7][21][#Recipe[7][7][21]+1]={3170,"Tome of Wisdom (x5)",false,false,1879211039};
Recipe[7][7][18][#Recipe[7][7][18]+1]={3305,"Westfold Athelas Essence",false,false,1879210894};
Recipe[7][7][2][#Recipe[7][7][2]+1]={3306,"Westfold Battle Tonic",false,false,1879210896};
Recipe[7][7][16][#Recipe[7][7][16]+1]={3314,"Westfold Book",false,false,0}; -- not in lorebook yet. not sure if this recipe still exists
Recipe[7][7][8][#Recipe[7][7][8]+1]={3309,"Westfold Book of the Whisper-draw",false,false,1879211043};
Recipe[7][7][8][#Recipe[7][7][8]+1]={3310,"Westfold Book of the Wind-rider",false,false,1879210963};
Recipe[7][7][18][#Recipe[7][7][18]+1]={3311,"Westfold Celebrant Salve",false,false,1879210914};
Recipe[7][7][7][#Recipe[7][7][7]+1]={3317,"Westfold Overpower Tactics",false,false,1879211033};
Recipe[7][7][14][#Recipe[7][7][14]+1]={3424,"Westfold Parable",false,false,1879225110};
Recipe[7][7][3][#Recipe[7][7][3]+1]={3319,"Westfold Potion of Fervour",false,false,1879211105};
Recipe[7][7][10][#Recipe[7][7][10]+1]={3320,"Westfold Potion of Focus",false,false,1879210975};

--Recipe[8][1][#Recipe[8][1]+1]={669,"Apprentice Tailor Expertise",false,false,1879184381};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1301,"Heavy Cloth Armour",false,false,1879066690};
Recipe[8][1][1][#Recipe[8][1][1]+1]={1302,"Heavy Cloth Cloak",false,false,1879086894};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1303,"Heavy Cloth Gloves",false,false,1879066689};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1304,"Heavy Cloth Hat",false,false,1879066688};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1305,"Heavy Cloth Leggings",false,false,1879066693};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1306,"Heavy Cloth Robe",false,false,1879087408};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1307,"Heavy Cloth Shoes",false,false,1879066691};
Recipe[8][1][5][#Recipe[8][1][5]+1]={1308,"Heavy Cloth Shoulder Guards",false,false,1879066692};
Recipe[8][1][7][#Recipe[8][1][7]+1]={1359,"Heavy Padded Armour",false,false,1879066696};
Recipe[8][1][7][#Recipe[8][1][7]+1]={1360,"Heavy Padded Gloves",false,false,1879066695};
Recipe[8][1][7][#Recipe[8][1][7]+1]={1361,"Heavy Padded Helm",false,false,1879066694};
Recipe[8][1][7][#Recipe[8][1][7]+1]={1362,"Heavy Padded Leggings",false,false,1879066699};
Recipe[8][1][7][#Recipe[8][1][7]+1]={1363,"Heavy Padded Shoes",false,false,1879066697};
Recipe[8][1][7][#Recipe[8][1][7]+1]={1364,"Heavy Padded Shoulder Guards",false,false,1879066698};
Recipe[8][1][2][#Recipe[8][1][2]+1]={1585,"Leather Binding",false,true,0};
Recipe[8][1][2][#Recipe[8][1][2]+1]={1591,"Leather Pad",false,true,0};
Recipe[8][1][6][#Recipe[8][1][6]+1]={1968,"Padded Armour",false,true,0};
Recipe[8][1][6][#Recipe[8][1][6]+1]={1969,"Padded Gloves",false,true,0};
Recipe[8][1][6][#Recipe[8][1][6]+1]={1970,"Padded Helm",false,true,0};
Recipe[8][1][6][#Recipe[8][1][6]+1]={1971,"Padded Leggings",false,true,0};
Recipe[8][1][6][#Recipe[8][1][6]+1]={1980,"Padded Shoes",false,true,0};
Recipe[8][1][6][#Recipe[8][1][6]+1]={1981,"Padded Shoulder Guards",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2530,"Rough Cloth Armour",false,true,0};
Recipe[8][1][1][#Recipe[8][1][1]+1]={2531,"Rough Cloth Cloak",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2532,"Rough Cloth Gloves",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2533,"Rough Cloth Hat",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2534,"Rough Cloth Leggings",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2535,"Rough Cloth Robe",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2536,"Rough Cloth Shoes",false,true,0};
Recipe[8][1][4][#Recipe[8][1][4]+1]={2537,"Rough Cloth Shoulder Guards",false,true,0};
Recipe[8][1][3][#Recipe[8][1][3]+1]={2753,"Small 'Tree Shadow' Rug",false,false,1879102046};

Recipe[8][2][1][#Recipe[8][2][1]+1]={599,"Crude Burglar Tools",false,false,1879069922};
Recipe[8][2][6][#Recipe[8][2][6]+1]={661,"Deft Gauntlets",true,false,1879062794};
Recipe[8][2][15][#Recipe[8][2][15]+1]={1025,"Fancy Dwarf-make Quiver",false,false,1879103754};
Recipe[8][2][15][#Recipe[8][2][15]+1]={1059,"Fine Quiver",false,false,1879103855};
Recipe[8][2][13][#Recipe[8][2][13]+1]={1353,"Heavy Leather Armour",false,false,1879067205};
Recipe[8][2][13][#Recipe[8][2][13]+1]={1354,"Heavy Leather Gloves",false,false,1879067204};
Recipe[8][2][13][#Recipe[8][2][13]+1]={1355,"Heavy Leather Helm",false,false,1879067203};
Recipe[8][2][13][#Recipe[8][2][13]+1]={1356,"Heavy Leather Leggings",false,false,1879067208};
Recipe[8][2][13][#Recipe[8][2][13]+1]={1357,"Heavy Leather Shoes",false,false,1879067206};
Recipe[8][2][13][#Recipe[8][2][13]+1]={1358,"Heavy Leather Shoulder Guards",false,false,1879067207};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1365,"Heavy Quilted Armour",false,false,1879067199};
Recipe[8][2][3][#Recipe[8][2][3]+1]={1366,"Heavy Quilted Cloak",false,false,1879086912};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1367,"Heavy Quilted Gloves",false,false,1879067198};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1368,"Heavy Quilted Hood",false,false,1879067197};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1369,"Heavy Quilted Leggings",false,false,1879067202};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1370,"Heavy Quilted Robe",false,false,1879087418};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1371,"Heavy Quilted Shoes",false,false,1879067200};
Recipe[8][2][9][#Recipe[8][2][9]+1]={1372,"Heavy Quilted Shoulder Guards",false,false,1879067201};
--Recipe[8][2][#Recipe[8][2]+1]={690,"Journeyman Tailor Expertise",false,false,1879184377};
Recipe[8][2][5][#Recipe[8][2][5]+1]={1578,"Large White 'Leaf Border' Rug",false,false,1879102061};
Recipe[8][2][11][#Recipe[8][2][11]+1]={1584,"Leather Armour",false,true,0};
Recipe[8][2][4][#Recipe[8][2][4]+1]={1586,"Leather Brace",false,true,0};
Recipe[8][2][11][#Recipe[8][2][11]+1]={1587,"Leather Gloves",false,true,0};
Recipe[8][2][4][#Recipe[8][2][4]+1]={1588,"Leather Guard",false,true,0};
Recipe[8][2][11][#Recipe[8][2][11]+1]={1589,"Leather Helm",false,true,0};
Recipe[8][2][11][#Recipe[8][2][11]+1]={1590,"Leather Leggings",false,true,0};
Recipe[8][2][11][#Recipe[8][2][11]+1]={1592,"Leather Shoes",false,true,0};
Recipe[8][2][11][#Recipe[8][2][11]+1]={1593,"Leather Shoulder Guards",false,true,0};
Recipe[8][2][8][#Recipe[8][2][8]+1]={758,"Linen Armour",false,false,1879062702};
Recipe[8][2][3][#Recipe[8][2][3]+1]={1632,"Linen Cloak",false,false,1879086915};
Recipe[8][2][8][#Recipe[8][2][8]+1]={759,"Linen Gloves",false,false,1879062704};
Recipe[8][2][8][#Recipe[8][2][8]+1]={760,"Linen Hat",false,false,1879062705};
Recipe[8][2][8][#Recipe[8][2][8]+1]={761,"Linen Leggings",false,false,1879062706};
Recipe[8][2][8][#Recipe[8][2][8]+1]={1633,"Linen Robe",false,false,1879087427};
Recipe[8][2][8][#Recipe[8][2][8]+1]={762,"Linen Shoes",false,false,1879062703};
Recipe[8][2][8][#Recipe[8][2][8]+1]={763,"Linen Shoulder Guards",false,false,1879062707};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1640,"Loose Linen Armour",true,false,1879068151};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3668,"Loose Linen Armour",true,false,1879091045};
Recipe[8][2][3][#Recipe[8][2][3]+1]={1654,"Loose Linen Cloak",true,false,1879086897};
Recipe[8][2][3][#Recipe[8][2][3]+1]={3669,"Loose Linen Cloak",true,false,1879091145};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1641,"Loose Linen Gloves",true,false,1879068150};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3670,"Loose Linen Gloves",true,false,1879091261};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1642,"Loose Linen Hood",true,false,1879068149};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3671,"Loose Linen Hood",true,false,1879091076};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1643,"Loose Linen Leggings",true,false,1879068154};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3672,"Loose Linen Leggings",true,false,1879091283};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1655,"Loose Linen Robe",true,false,1879087422};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3673,"Loose Linen Robe",true,false,1879091056};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1644,"Loose Linen Shoes",true,false,1879068152};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3674,"Loose Linen Shoes",true,false,1879091114};
Recipe[8][2][10][#Recipe[8][2][10]+1]={1645,"Loose Linen Shoulder Guards",true,false,1879068153};
Recipe[8][2][10][#Recipe[8][2][10]+1]={3675,"Loose Linen Shoulder Guards",true,false,1879091286};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1854,"Minor Commoner Herald Armaments",false,false,1879084173};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1856,"Minor Maid-at-arms Herald Armaments",false,false,1879094189};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1857,"Minor Man-at-arms Herald Armaments",false,false,1879068128};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1858,"Minor Pilgrim Herald Armaments",false,false,1879068130};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1860,"Minor Shield-maiden Herald Armaments",false,false,1879094130};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1862,"Minor Squire Herald Armaments",false,false,1879068129};
Recipe[8][2][2][#Recipe[8][2][2]+1]={1864,"Minor Swordswoman Herald Armaments",false,false,1879094134};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2175,"Quilted Armour",false,true,0};
Recipe[8][2][3][#Recipe[8][2][3]+1]={2176,"Quilted Cloak",false,true,0};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2177,"Quilted Gloves",false,true,0};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2178,"Quilted Hat",false,true,0};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2179,"Quilted Leggings",false,true,0};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2180,"Quilted Robe",false,true,0};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2181,"Quilted Shoes",false,true,0};
Recipe[8][2][7][#Recipe[8][2][7]+1]={2182,"Quilted Shoulder Guards",false,true,0};
Recipe[8][2][16][#Recipe[8][2][16]+1]={2936,"Student's Rune-satchel of Dagor",false,false,1879148350};
Recipe[8][2][16][#Recipe[8][2][16]+1]={2937,"Student's Rune-satchel of Nestad",false,false,1879148352};
Recipe[8][2][16][#Recipe[8][2][16]+1]={2938,"Student's Rune-satchel of Thalas",false,false,1879148351};
Recipe[8][2][15][#Recipe[8][2][15]+1]={2949,"Sturdy Elven Quiver",false,false,1879103857};
Recipe[8][2][14][#Recipe[8][2][14]+1]={2961,"Superb Leather Armour",true,false,1879068157};
Recipe[8][2][14][#Recipe[8][2][14]+1]={3676,"Superb Leather Armour",true,false,1879091192};
Recipe[8][2][14][#Recipe[8][2][14]+1]={2962,"Superb Leather Footwear",true,false,1879068158};
Recipe[8][2][14][#Recipe[8][2][14]+1]={3677,"Superb Leather Footwear",true,false,1879091138};
Recipe[8][2][14][#Recipe[8][2][14]+1]={2963,"Superb Leather Gloves",true,false,1879068156};
Recipe[8][2][14][#Recipe[8][2][14]+1]={3678,"Superb Leather Gloves",true,false,1879091273};
Recipe[8][2][14][#Recipe[8][2][14]+1]={2964,"Superb Leather Helm",true,false,1879068155};
Recipe[8][2][14][#Recipe[8][2][14]+1]={3679,"Superb Leather Helm",true,false,1879091279};
Recipe[8][2][14][#Recipe[8][2][14]+1]={2965,"Superb Leather Leggings",true,false,1879068160};
Recipe[8][2][14][#Recipe[8][2][14]+1]={3680,"Superb Leather Leggings",true,false,1879091098};
Recipe[8][2][14][#Recipe[8][2][14]+1]={2966,"Superb Leather Shoulder Guards",true,false,1879068159};
Recipe[8][2][14][#Recipe[8][2][14]+1]={3681,"Superb Leather Shoulder Guards",true,false,1879091300};
Recipe[8][2][12][#Recipe[8][2][12]+1]={3179,"Tough Leather Armour",false,false,1879062698};
Recipe[8][2][12][#Recipe[8][2][12]+1]={3180,"Tough Leather Footwear",false,false,1879062700};
Recipe[8][2][12][#Recipe[8][2][12]+1]={3181,"Tough Leather Gloves",false,false,1879062697};
Recipe[8][2][12][#Recipe[8][2][12]+1]={3182,"Tough Leather Helm",false,false,1879062696};
Recipe[8][2][12][#Recipe[8][2][12]+1]={3183,"Tough Leather Leggings",false,false,1879062699};
Recipe[8][2][4][#Recipe[8][2][4]+1]={3185,"Tough Leather Pad",false,true,0};
Recipe[8][2][12][#Recipe[8][2][12]+1]={3184,"Tough Leather Shoulder Guards",false,false,1879062701};

Recipe[8][3][2][#Recipe[8][3][2]+1]={160,"Basic Burglar Tools",false,false,1879070396};
Recipe[8][3][3][#Recipe[8][3][3]+1]={419,"Commoner Herald Armaments",false,false,1879084172};
Recipe[8][3][10][#Recipe[8][3][10]+1]={810,"Cotton Armour",false,true,0};
Recipe[8][3][10][#Recipe[8][3][10]+1]={811,"Cotton Cap",false,true,0};
Recipe[8][3][4][#Recipe[8][3][4]+1]={438,"Cotton Cloak",false,true,0};
Recipe[8][3][10][#Recipe[8][3][10]+1]={812,"Cotton Gloves",false,true,0};
Recipe[8][3][10][#Recipe[8][3][10]+1]={813,"Cotton Leggings",false,true,0};
Recipe[8][3][10][#Recipe[8][3][10]+1]={439,"Cotton Robe",false,true,0};
Recipe[8][3][10][#Recipe[8][3][10]+1]={814,"Cotton Shoes",false,true,0};
Recipe[8][3][10][#Recipe[8][3][10]+1]={815,"Cotton Shoulder Guards",false,true,0};
Recipe[8][3][1][#Recipe[8][3][1]+1]={856,"Elven Prospector's Pack",false,false,1879103748};
Recipe[8][3][6][#Recipe[8][3][6]+1]={897,"Embossed Leather Brace",false,true,0};
Recipe[8][3][7][#Recipe[8][3][7]+1]={898,"Embossed Leather Brace (x5)",false,false,1879137485};
--Recipe[8][3][#Recipe[8][3]+1]={683,"Expert Tailor Expertise",false,false,1879184372};
Recipe[8][3][14][#Recipe[8][3][14]+1]={979,"Exquisite Outrider\'s Armour",false,false,1879137444};
Recipe[8][3][14][#Recipe[8][3][14]+1]={980,"Exquisite Outrider\'s Footwear",false,false,1879137548};
Recipe[8][3][14][#Recipe[8][3][14]+1]={981,"Exquisite Outrider\'s Gloves",false,false,1879137543};
Recipe[8][3][14][#Recipe[8][3][14]+1]={982,"Exquisite Outrider\'s Helm",false,false,1879137741};
Recipe[8][3][14][#Recipe[8][3][14]+1]={983,"Exquisite Outrider\'s Leggings",false,false,1879137366};
Recipe[8][3][14][#Recipe[8][3][14]+1]={984,"Exquisite Outrider\'s Shoulder Guards",false,false,1879137266};
Recipe[8][3][9][#Recipe[8][3][9]+1]={991,"Exquisite Traveller\'s Armour",false,false,1879137316};
Recipe[8][3][9][#Recipe[8][3][9]+1]={992,"Exquisite Traveller\'s Gloves",false,false,1879137279};
Recipe[8][3][9][#Recipe[8][3][9]+1]={993,"Exquisite Traveller\'s Hat",false,false,1879137439};
Recipe[8][3][9][#Recipe[8][3][9]+1]={994,"Exquisite Traveller\'s Leggings",false,false,1879137586};
Recipe[8][3][9][#Recipe[8][3][9]+1]={995,"Exquisite Traveller\'s Shoes",false,false,1879137383};
Recipe[8][3][9][#Recipe[8][3][9]+1]={996,"Exquisite Traveller\'s Shoulder Guards",false,false,1879137564};
Recipe[8][3][5][#Recipe[8][3][5]+1]={1009,"Exquisite Traveller's Cloak",false,false,1879137251};
Recipe[8][3][9][#Recipe[8][3][9]+1]={1010,"Exquisite Traveller's Robe",false,false,1879137365};
Recipe[8][3][1][#Recipe[8][3][1]+1]={1060,"Fine Woodcutter's Pack",false,false,1879103745};
Recipe[8][3][1][#Recipe[8][3][1]+1]={1065,"Finely Stitched Backpack",false,false,1879103852};
Recipe[8][3][3][#Recipe[8][3][3]+1]={1066,"Finely Woven Expert Standard of Hope",false,false,1879094132};
Recipe[8][3][3][#Recipe[8][3][3]+1]={1067,"Finely Woven Expert Standard of Victory",false,false,1879094163};
Recipe[8][3][3][#Recipe[8][3][3]+1]={1068,"Finely Woven Expert Standard of War",false,false,1879094139};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1320,"Heavy Cotton Armour",false,false,1879069443};
Recipe[8][3][4][#Recipe[8][3][4]+1]={1309,"Heavy Cotton Cloak",false,false,1879086927};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1321,"Heavy Cotton Gloves",false,false,1879069442};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1322,"Heavy Cotton Hat",false,false,1879069441};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1323,"Heavy Cotton Leggings",false,false,1879069446};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1310,"Heavy Cotton Robe",false,false,1879087416};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1324,"Heavy Cotton Shoes",false,false,1879069444};
Recipe[8][3][12][#Recipe[8][3][12]+1]={1325,"Heavy Cotton Shoulder Guards",false,false,1879069445};
Recipe[8][3][3][#Recipe[8][3][3]+1]={1685,"Maid-at-arms Herald Armaments",false,false,1879094142};
Recipe[8][3][3][#Recipe[8][3][3]+1]={1744,"Man-at-arms Herald Armaments",false,false,1879069923};
Recipe[8][3][20][#Recipe[8][3][20]+1]={1821,"Medium Expert Pattern",false,false,1879125807};
Recipe[8][3][16][#Recipe[8][3][16]+1]={850,"Outrider\'s Armour",false,false,1879062747};
Recipe[8][3][16][#Recipe[8][3][16]+1]={851,"Outrider\'s Footwear",false,false,1879062749};
Recipe[8][3][16][#Recipe[8][3][16]+1]={852,"Outrider\'s Gloves",false,false,1879062746};
Recipe[8][3][16][#Recipe[8][3][16]+1]={853,"Outrider\'s Helm",false,false,1879062745};
Recipe[8][3][16][#Recipe[8][3][16]+1]={854,"Outrider\'s Leggings",false,false,1879062748};
Recipe[8][3][16][#Recipe[8][3][16]+1]={855,"Outrider\'s Shoulder Guards",false,false,1879062750};
Recipe[8][3][3][#Recipe[8][3][3]+1]={2027,"Pilgrim Herald Armaments",false,false,1879070395};
Recipe[8][3][6][#Recipe[8][3][6]+1]={2374,"Reinforced Leather Pad",false,true,0};
Recipe[8][3][7][#Recipe[8][3][7]+1]={2375,"Reinforced Leather Pad (x5)",false,false,1879137222};
Recipe[8][3][17][#Recipe[8][3][17]+1]={2388,"Reinforced Sturdy Leather Armour",false,false,1879069449};
Recipe[8][3][17][#Recipe[8][3][17]+1]={2389,"Reinforced Sturdy Leather Footwear",false,false,1879069450};
Recipe[8][3][17][#Recipe[8][3][17]+1]={2390,"Reinforced Sturdy Leather Gloves",false,false,1879069448};
Recipe[8][3][17][#Recipe[8][3][17]+1]={2391,"Reinforced Sturdy Leather Helm",false,false,1879069447};
Recipe[8][3][17][#Recipe[8][3][17]+1]={2392,"Reinforced Sturdy Leather Leggings",false,false,1879069452};
Recipe[8][3][17][#Recipe[8][3][17]+1]={2393,"Reinforced Sturdy Leather Shoulder Guards",false,false,1879069451};
Recipe[8][3][19][#Recipe[8][3][19]+1]={2588,"Scholar's Rune-satchel of Dagor",false,false,1879148353};
Recipe[8][3][19][#Recipe[8][3][19]+1]={2589,"Scholar's Rune-satchel of Nestad",false,false,1879148355};
Recipe[8][3][19][#Recipe[8][3][19]+1]={2590,"Scholar's Rune-satchel of Thalas",false,false,1879148354};
Recipe[8][3][3][#Recipe[8][3][3]+1]={2708,"Shield-maiden Herald Armaments",false,false,1879094194};
Recipe[8][3][20][#Recipe[8][3][20]+1]={2764,"Small Expert Pattern",false,false,1879125743};
Recipe[8][3][8][#Recipe[8][3][8]+1]={2752,"Small 'Ring and Leaf' Rug",false,false,1879102051};
Recipe[8][3][3][#Recipe[8][3][3]+1]={2840,"Squire Herald Armaments",false,false,1879069924};
Recipe[8][3][15][#Recipe[8][3][15]+1]={2943,"Sturdy Leather Armour",false,true,0};
Recipe[8][3][6][#Recipe[8][3][6]+1]={2950,"Sturdy Leather Binding",false,true,0};
Recipe[8][3][7][#Recipe[8][3][7]+1]={2951,"Sturdy Leather Binding (x5)",false,false,1879137449};
Recipe[8][3][15][#Recipe[8][3][15]+1]={2944,"Sturdy Leather Footwear",false,true,0};
Recipe[8][3][15][#Recipe[8][3][15]+1]={2945,"Sturdy Leather Gloves",false,true,0};
Recipe[8][3][6][#Recipe[8][3][6]+1]={2952,"Sturdy Leather Guard",false,true,0};
Recipe[8][3][7][#Recipe[8][3][7]+1]={2953,"Sturdy Leather Guard (x5)",false,false,1879137364};
Recipe[8][3][15][#Recipe[8][3][15]+1]={2946,"Sturdy Leather Helm",false,true,0};
Recipe[8][3][15][#Recipe[8][3][15]+1]={2947,"Sturdy Leather Leggings",false,true,0};
Recipe[8][3][15][#Recipe[8][3][15]+1]={2948,"Sturdy Leather Shoulder Guards",false,true,0};
Recipe[8][3][18][#Recipe[8][3][18]+1]={2979,"Superb Outrider\'s Armour",true,false,1879069949};
Recipe[8][3][18][#Recipe[8][3][18]+1]={3682,"Superb Outrider\'s Armour",true,false,1879091247};
Recipe[8][3][18][#Recipe[8][3][18]+1]={2980,"Superb Outrider\'s Footwear",true,false,1879069950};
Recipe[8][3][18][#Recipe[8][3][18]+1]={3683,"Superb Outrider\'s Footwear",true,false,1879091118};
Recipe[8][3][18][#Recipe[8][3][18]+1]={2981,"Superb Outrider\'s Gloves",true,false,1879069948};
Recipe[8][3][18][#Recipe[8][3][18]+1]={3684,"Superb Outrider\'s Gloves",true,false,1879091206};
Recipe[8][3][18][#Recipe[8][3][18]+1]={2982,"Superb Outrider\'s Helm",true,false,1879069947};
Recipe[8][3][18][#Recipe[8][3][18]+1]={3685,"Superb Outrider\'s Helm",true,false,1879091062};
Recipe[8][3][18][#Recipe[8][3][18]+1]={2983,"Superb Outrider\'s Leggings",true,false,1879069952};
Recipe[8][3][18][#Recipe[8][3][18]+1]={3686,"Superb Outrider\'s Leggings",true,false,1879091132};
Recipe[8][3][18][#Recipe[8][3][18]+1]={2984,"Superb Outrider\'s Shoulder Guards",true,false,1879069951};
Recipe[8][3][18][#Recipe[8][3][18]+1]={3687,"Superb Outrider\'s Shoulder Guards",true,false,1879091302};
Recipe[8][3][13][#Recipe[8][3][13]+1]={2991,"Superb Traveller\'s Armour",true,false,1879069943};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3688,"Superb Traveller\'s Armour",true,false,1879091178};
Recipe[8][3][13][#Recipe[8][3][13]+1]={2992,"Superb Traveller\'s Gloves",true,false,1879069942};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3689,"Superb Traveller\'s Gloves",true,false,1879091217};
Recipe[8][3][13][#Recipe[8][3][13]+1]={2993,"Superb Traveller\'s Hat",true,false,1879069941};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3690,"Superb Traveller\'s Hat",true,false,1879091275};
Recipe[8][3][13][#Recipe[8][3][13]+1]={2994,"Superb Traveller\'s Leggings",true,false,1879069946};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3691,"Superb Traveller\'s Leggings",true,false,1879091146};
Recipe[8][3][13][#Recipe[8][3][13]+1]={2995,"Superb Traveller\'s Shoes",true,false,1879069944};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3692,"Superb Traveller\'s Shoes",true,false,1879091155};
Recipe[8][3][13][#Recipe[8][3][13]+1]={2996,"Superb Traveller\'s Shoulder Guards",true,false,1879069945};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3693,"Superb Traveller\'s Shoulder Guards",true,false,1879091128};
Recipe[8][3][4][#Recipe[8][3][4]+1]={3010,"Superb Traveller's Cloak",true,false,1879086887};
Recipe[8][3][4][#Recipe[8][3][4]+1]={3694,"Superb Traveller's Cloak",true,false,1879091296};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3011,"Superb Traveller's Robe",true,false,1879087430};
Recipe[8][3][13][#Recipe[8][3][13]+1]={3695,"Superb Traveller's Robe",true,false,1879091199};
Recipe[8][3][3][#Recipe[8][3][3]+1]={3106,"Swordswoman Herald Armaments",false,false,1879094175};
Recipe[8][3][11][#Recipe[8][3][11]+1]={884,"Traveller\'s Armour",false,false,1879062751};
Recipe[8][3][11][#Recipe[8][3][11]+1]={885,"Traveller\'s Cap",false,false,1879062754};
Recipe[8][3][11][#Recipe[8][3][11]+1]={886,"Traveller\'s Gloves",false,false,1879062753};
Recipe[8][3][11][#Recipe[8][3][11]+1]={887,"Traveller\'s Leggings",false,false,1879062755};
Recipe[8][3][11][#Recipe[8][3][11]+1]={888,"Traveller\'s Shoes",false,false,1879062752};
Recipe[8][3][11][#Recipe[8][3][11]+1]={889,"Traveller\'s Shoulder Guards",false,false,1879062756};
Recipe[8][3][4][#Recipe[8][3][4]+1]={3186,"Traveller's Cloak",false,false,1879086889};
Recipe[8][3][11][#Recipe[8][3][11]+1]={3187,"Traveller's Robe",false,false,1879087407};

Recipe[8][4][2][#Recipe[8][4][2]+1]={12,"Advanced Burglar Tools",false,false,1879070398};
--Recipe[8][4][#Recipe[8][4]+1]={676,"Artisan Tailor Expertise",false,false,1879184367};
Recipe[8][4][1][#Recipe[8][4][1]+1]={427,"Conviction Signal",false,false,1879103000};
Recipe[8][4][9][#Recipe[8][4][9]+1]={615,"Cushioned Bench",false,false,1879101772};
Recipe[8][4][7][#Recipe[8][4][7]+1]={637,"Darkened Leather Binding",false,true,0};
Recipe[8][4][8][#Recipe[8][4][8]+1]={638,"Darkened Leather Binding (x5)",false,false,1879137391};
Recipe[8][4][7][#Recipe[8][4][7]+1]={639,"Darkened Leather Guard",false,true,0};
Recipe[8][4][8][#Recipe[8][4][8]+1]={640,"Darkened Leather Guard (x5)",false,false,1879137513};
Recipe[8][4][10][#Recipe[8][4][10]+1]={720,"Drake-skin Cuirass",true,false,1879076396};
Recipe[8][4][6][#Recipe[8][4][6]+1]={793,"Elegant Long-sleeved Dress",false,false,1879103753};
Recipe[8][4][12][#Recipe[8][4][12]+1]={822,"Explorer\'s Armour",false,true,0};
Recipe[8][4][12][#Recipe[8][4][12]+1]={823,"Explorer\'s Gloves",false,true,0};
Recipe[8][4][12][#Recipe[8][4][12]+1]={824,"Explorer\'s Hat",false,true,0};
Recipe[8][4][12][#Recipe[8][4][12]+1]={825,"Explorer\'s Leggings",false,true,0};
Recipe[8][4][12][#Recipe[8][4][12]+1]={826,"Explorer\'s Shoes",false,true,0};
Recipe[8][4][12][#Recipe[8][4][12]+1]={827,"Explorer\'s Shoulder Guards",false,true,0};
Recipe[8][4][4][#Recipe[8][4][4]+1]={971,"Explorer's Cloak",false,true,0};
Recipe[8][4][12][#Recipe[8][4][12]+1]={972,"Explorer's Robe",false,true,0};
Recipe[8][4][16][#Recipe[8][4][16]+1]={973,"Exquisite Hunter\'s Armour",false,false,1879137752};
Recipe[8][4][16][#Recipe[8][4][16]+1]={974,"Exquisite Hunter\'s Footwear",false,false,1879137748};
Recipe[8][4][16][#Recipe[8][4][16]+1]={975,"Exquisite Hunter\'s Gloves",false,false,1879137402};
Recipe[8][4][16][#Recipe[8][4][16]+1]={976,"Exquisite Hunter\'s Helm",false,false,1879137618};
Recipe[8][4][16][#Recipe[8][4][16]+1]={977,"Exquisite Hunter\'s Leggings",false,false,1879137417};
Recipe[8][4][16][#Recipe[8][4][16]+1]={978,"Exquisite Hunter\'s Shoulder Guards",false,false,1879137308};
Recipe[8][4][11][#Recipe[8][4][11]+1]={985,"Exquisite Scholar\'s Armour",false,false,1879137673};
Recipe[8][4][11][#Recipe[8][4][11]+1]={986,"Exquisite Scholar\'s Gloves",false,false,1879137540};
Recipe[8][4][11][#Recipe[8][4][11]+1]={987,"Exquisite Scholar\'s Hat",false,false,1879137376};
Recipe[8][4][11][#Recipe[8][4][11]+1]={988,"Exquisite Scholar\'s Leggings",false,false,1879137614};
Recipe[8][4][11][#Recipe[8][4][11]+1]={989,"Exquisite Scholar\'s Shoes",false,false,1879137301};
Recipe[8][4][11][#Recipe[8][4][11]+1]={990,"Exquisite Scholar\'s Shoulder Guards",false,false,1879137385};
Recipe[8][4][5][#Recipe[8][4][5]+1]={1007,"Exquisite Scholar's Cloak",false,false,1879137723};
Recipe[8][4][11][#Recipe[8][4][11]+1]={1008,"Exquisite Scholar's Robe",false,false,1879137730};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1072,"Finely Woven Master Standard of Hope",false,false,1879094184};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1073,"Finely Woven Master Standard of Victory",false,false,1879094155};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1074,"Finely Woven Master Standard of War",false,false,1879094133};
Recipe[8][4][1][#Recipe[8][4][1]+1]={1268,"Guile Signal",false,false,1879103008};
Recipe[8][4][19][#Recipe[8][4][19]+1]={1332,"Heavy Skirmisher\'s Armour",false,false,1879070228};
Recipe[8][4][19][#Recipe[8][4][19]+1]={1333,"Heavy Skirmisher\'s Footwear",false,false,1879070229};
Recipe[8][4][19][#Recipe[8][4][19]+1]={1334,"Heavy Skirmisher\'s Gloves",false,false,1879070227};
Recipe[8][4][19][#Recipe[8][4][19]+1]={1335,"Heavy Skirmisher\'s Helm",false,false,1879070226};
Recipe[8][4][19][#Recipe[8][4][19]+1]={1336,"Heavy Skirmisher\'s Leggings",false,false,1879070231};
Recipe[8][4][19][#Recipe[8][4][19]+1]={1337,"Heavy Skirmisher\'s Shoulder Guards",false,false,1879070230};
Recipe[8][4][18][#Recipe[8][4][18]+1]={828,"Hunter\'s Armour",false,false,1879076415};
Recipe[8][4][18][#Recipe[8][4][18]+1]={829,"Hunter\'s Footwear",false,false,1879076417};
Recipe[8][4][18][#Recipe[8][4][18]+1]={830,"Hunter\'s Gloves",false,false,1879076414};
Recipe[8][4][18][#Recipe[8][4][18]+1]={831,"Hunter\'s Helm",false,false,1879076413};
Recipe[8][4][18][#Recipe[8][4][18]+1]={832,"Hunter\'s Leggings",false,false,1879076416};
Recipe[8][4][18][#Recipe[8][4][18]+1]={833,"Hunter\'s Shoulder Guards",false,false,1879076418};
Recipe[8][4][9][#Recipe[8][4][9]+1]={1555,"Large 'Dragon-fly' Rug",false,false,1879102059};
Recipe[8][4][6][#Recipe[8][4][6]+1]={1638,"Long-sleeved Corsair's Tunic and Pants",false,false,1879103746};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1646,"Loose Explorer\'s Armour",false,false,1879070222};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1647,"Loose Explorer\'s Gloves",false,false,1879070221};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1648,"Loose Explorer\'s Hat",false,false,1879070220};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1649,"Loose Explorer\'s Leggings",false,false,1879070225};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1650,"Loose Explorer\'s Shoes",false,false,1879070223};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1651,"Loose Explorer\'s Shoulder Guards",false,false,1879070224};
Recipe[8][4][4][#Recipe[8][4][4]+1]={1652,"Loose Explorer's Cloak",false,false,1879086903};
Recipe[8][4][14][#Recipe[8][4][14]+1]={1653,"Loose Explorer's Robe",false,false,1879087405};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1697,"Major Commoner Herald Armaments",false,false,1879084169};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1698,"Major Defender Herald Armaments",false,false,1879094202};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1700,"Major Footsoldier Herald Armaments",false,false,1879094153};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1702,"Major Maid-at-arms Herald Armaments",false,false,1879094201};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1703,"Major Man-at-arms Herald Armaments",false,false,1879070397};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1704,"Major Pilgrim Herald Armaments",false,false,1879069925};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1706,"Major Shield-maiden Herald Armaments",false,false,1879094173};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1708,"Major Squire Herald Armaments",false,false,1879068131};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1710,"Major Swordswoman Herald Armaments",false,false,1879094156};
Recipe[8][4][3][#Recipe[8][4][3]+1]={1712,"Major Warden Herald Armaments",false,false,1879094143};
Recipe[8][4][22][#Recipe[8][4][22]+1]={1791,"Master's Rune-satchel of Dagor",false,false,1879148356};
Recipe[8][4][22][#Recipe[8][4][22]+1]={1792,"Master's Rune-satchel of Nestad",false,false,1879148358};
Recipe[8][4][22][#Recipe[8][4][22]+1]={1793,"Master's Rune-satchel of Thalas",false,false,1879148357};
Recipe[8][4][23][#Recipe[8][4][23]+1]={1814,"Medium Artisan Pattern",false,false,1879125872};
Recipe[8][4][6][#Recipe[8][4][6]+1]={2029,"Plain Long-sleeved Tunic and Trousers",false,false,1879103786};
Recipe[8][4][7][#Recipe[8][4][7]+1]={2158,"Pristine Leather Brace",false,true,0};
Recipe[8][4][8][#Recipe[8][4][8]+1]={2159,"Pristine Leather Brace (x5)",false,false,1879137433};
Recipe[8][4][7][#Recipe[8][4][7]+1]={2160,"Pristine Leather Plate",false,true,0};
Recipe[8][4][8][#Recipe[8][4][8]+1]={2161,"Pristine Leather Plate (x5)",false,false,1879137313};
Recipe[8][4][21][#Recipe[8][4][21]+1]={2198,"Ranger's Sash",false,false,1879092720};
Recipe[8][4][9][#Recipe[8][4][9]+1]={2208,"Red Canopy Bed",false,false,1879101788};
Recipe[8][4][13][#Recipe[8][4][13]+1]={857,"Scholar\'s Armour",false,false,1879076419};
Recipe[8][4][13][#Recipe[8][4][13]+1]={858,"Scholar\'s Gloves",false,false,1879076421};
Recipe[8][4][13][#Recipe[8][4][13]+1]={859,"Scholar\'s Hat",false,false,1879076422};
Recipe[8][4][13][#Recipe[8][4][13]+1]={860,"Scholar\'s Leggings",false,false,1879076423};
Recipe[8][4][13][#Recipe[8][4][13]+1]={861,"Scholar\'s Shoes",false,false,1879076420};
Recipe[8][4][13][#Recipe[8][4][13]+1]={862,"Scholar\'s Shoulder Guards",false,false,1879076424};
Recipe[8][4][4][#Recipe[8][4][4]+1]={2582,"Scholar's Cloak",false,false,1879086929};
Recipe[8][4][13][#Recipe[8][4][13]+1]={2586,"Scholar's Robe",false,false,1879087411};
Recipe[8][4][17][#Recipe[8][4][17]+1]={863,"Skirmisher\'s Armour",false,true,0};
Recipe[8][4][17][#Recipe[8][4][17]+1]={864,"Skirmisher\'s Footwear",false,true,0};
Recipe[8][4][17][#Recipe[8][4][17]+1]={865,"Skirmisher\'s Gloves",false,true,0};
Recipe[8][4][17][#Recipe[8][4][17]+1]={866,"Skirmisher\'s Helm",false,true,0};
Recipe[8][4][17][#Recipe[8][4][17]+1]={867,"Skirmisher\'s Leggings",false,true,0};
Recipe[8][4][17][#Recipe[8][4][17]+1]={868,"Skirmisher\'s Shoulder Guards",false,true,0};
Recipe[8][4][23][#Recipe[8][4][23]+1]={2757,"Small Artisan Pattern",false,false,1879125770};
Recipe[8][4][1][#Recipe[8][4][1]+1]={2910,"Strength Signal",false,false,1879102994};
Recipe[8][4][20][#Recipe[8][4][20]+1]={2973,"Superb Hunter\'s Armour",true,false,1879070418};
Recipe[8][4][20][#Recipe[8][4][20]+1]={3696,"Superb Hunter\'s Armour",true,false,1879091188};
Recipe[8][4][20][#Recipe[8][4][20]+1]={2974,"Superb Hunter\'s Footwear",true,false,1879070419};
Recipe[8][4][20][#Recipe[8][4][20]+1]={3697,"Superb Hunter\'s Footwear",true,false,1879091066};
Recipe[8][4][20][#Recipe[8][4][20]+1]={2975,"Superb Hunter\'s Gloves",true,false,1879070417};
Recipe[8][4][20][#Recipe[8][4][20]+1]={3698,"Superb Hunter\'s Gloves",true,false,1879091253};
Recipe[8][4][20][#Recipe[8][4][20]+1]={2976,"Superb Hunter\'s Helm",true,false,1879070416};
Recipe[8][4][20][#Recipe[8][4][20]+1]={3699,"Superb Hunter\'s Helm",true,false,1879091236};
Recipe[8][4][20][#Recipe[8][4][20]+1]={2977,"Superb Hunter\'s Leggings",true,false,1879070421};
Recipe[8][4][20][#Recipe[8][4][20]+1]={3700,"Superb Hunter\'s Leggings",true,false,1879091077};
Recipe[8][4][20][#Recipe[8][4][20]+1]={2978,"Superb Hunter\'s Shoulder Guards",true,false,1879070420};
Recipe[8][4][20][#Recipe[8][4][20]+1]={3701,"Superb Hunter\'s Shoulder Guards",true,false,1879091262};
Recipe[8][4][15][#Recipe[8][4][15]+1]={2985,"Superb Scholar\'s Armour",true,false,1879070412};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3702,"Superb Scholar\'s Armour",true,false,1879091220};
Recipe[8][4][15][#Recipe[8][4][15]+1]={2986,"Superb Scholar\'s Gloves",true,false,1879070411};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3703,"Superb Scholar\'s Gloves",true,false,1879091061};
Recipe[8][4][15][#Recipe[8][4][15]+1]={2987,"Superb Scholar\'s Hat",true,false,1879070410};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3704,"Superb Scholar\'s Hat",true,false,1879091185};
Recipe[8][4][15][#Recipe[8][4][15]+1]={2988,"Superb Scholar\'s Leggings",true,false,1879070415};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3705,"Superb Scholar\'s Leggings",true,false,1879091263};
Recipe[8][4][15][#Recipe[8][4][15]+1]={2989,"Superb Scholar\'s Shoes",true,false,1879070413};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3706,"Superb Scholar\'s Shoes",true,false,1879091276};
Recipe[8][4][15][#Recipe[8][4][15]+1]={2990,"Superb Scholar\'s Shoulder Guards",true,false,1879070414};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3707,"Superb Scholar\'s Shoulder Guards",true,false,1879091073};
Recipe[8][4][4][#Recipe[8][4][4]+1]={3008,"Superb Scholar's Cloak",true,false,1879086900};
Recipe[8][4][4][#Recipe[8][4][4]+1]={3708,"Superb Scholar's Cloak",true,false,1879091148};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3009,"Superb Scholar's Robe",true,false,1879087429};
Recipe[8][4][15][#Recipe[8][4][15]+1]={3709,"Superb Scholar's Robe",true,false,1879091175};
Recipe[8][4][1][#Recipe[8][4][1]+1]={3112,"Tactics Signal",false,false,1879103002};

Recipe[8][5][14][#Recipe[8][5][14]+1]={387,"Ajokoira Armour",true,false,1879108640};
Recipe[8][5][14][#Recipe[8][5][14]+1]={388,"Ajokoira Gloves",true,false,1879108637};
Recipe[8][5][14][#Recipe[8][5][14]+1]={389,"Ajokoira Hat",true,false,1879108642};
Recipe[8][5][14][#Recipe[8][5][14]+1]={390,"Ajokoira Leggings",true,false,1879108644};
Recipe[8][5][14][#Recipe[8][5][14]+1]={391,"Ajokoira Shoes",true,false,1879108626};
Recipe[8][5][14][#Recipe[8][5][14]+1]={392,"Ajokoira Shoulder Guards",true,false,1879108641};
Recipe[8][5][6][#Recipe[8][5][6]+1]={215,"Blessed Leather Plate",false,true,0};
Recipe[8][5][7][#Recipe[8][5][7]+1]={216,"Blessed Leather Plate (x5)",false,false,1879137531};
Recipe[8][5][16][#Recipe[8][5][16]+1]={804,"Campaigner\'s Armour",false,true,0};
Recipe[8][5][16][#Recipe[8][5][16]+1]={805,"Campaigner\'s Footwear",false,true,0};
Recipe[8][5][16][#Recipe[8][5][16]+1]={806,"Campaigner\'s Gloves",false,true,0};
Recipe[8][5][16][#Recipe[8][5][16]+1]={807,"Campaigner\'s Helm",false,true,0};
Recipe[8][5][16][#Recipe[8][5][16]+1]={808,"Campaigner\'s Leggings",false,true,0};
Recipe[8][5][16][#Recipe[8][5][16]+1]={809,"Campaigner\'s Shoulder Guards",false,true,0};
Recipe[8][5][5][#Recipe[8][5][5]+1]={395,"Ceremonial Dress",false,false,1879103853};
Recipe[8][5][14][#Recipe[8][5][14]+1]={397,"Great Hoary Aurochs Robe",true,false,1879108697}; -- modified to match game record
Recipe[8][5][1][#Recipe[8][5][1]+1]={428,"Conviction Signal",false,false,1879102997};
Recipe[8][5][6][#Recipe[8][5][6]+1]={958,"Exceptional Leather Binding",false,true,0};
Recipe[8][5][7][#Recipe[8][5][7]+1]={959,"Exceptional Leather Binding (x5)",false,false,1879137375};
Recipe[8][5][6][#Recipe[8][5][6]+1]={960,"Exceptional Leather Pad",false,true,0};
Recipe[8][5][7][#Recipe[8][5][7]+1]={961,"Exceptional Leather Pad (x5)",false,false,1879137570};
Recipe[8][5][15][#Recipe[8][5][15]+1]={1012,"Exquisite Protector\'s Armour",false,false,1879137460};
Recipe[8][5][15][#Recipe[8][5][15]+1]={1013,"Exquisite Protector\'s Footwear",false,false,1879137624};
Recipe[8][5][15][#Recipe[8][5][15]+1]={1014,"Exquisite Protector\'s Gloves",false,false,1879137268};
Recipe[8][5][15][#Recipe[8][5][15]+1]={1015,"Exquisite Protector\'s Helm",false,false,1879137259};
Recipe[8][5][15][#Recipe[8][5][15]+1]={1016,"Exquisite Protector\'s Leggings",false,false,1879137745};
Recipe[8][5][15][#Recipe[8][5][15]+1]={1017,"Exquisite Protector\'s Shoulder Guards",false,false,1879137483};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1001,"Exquisite Radiant Armour",false,false,1879137429};
Recipe[8][5][4][#Recipe[8][5][4]+1]={999,"Exquisite Radiant Cloak",false,false,1879137562};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1002,"Exquisite Radiant Gloves",false,false,1879137318};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1003,"Exquisite Radiant Hat",false,false,1879137220};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1004,"Exquisite Radiant Leggings",false,false,1879137405};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1000,"Exquisite Radiant Robe",false,false,1879137339};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1005,"Exquisite Radiant Shoes",false,false,1879137744};
Recipe[8][5][9][#Recipe[8][5][9]+1]={1006,"Exquisite Radiant Shoulder Guards",false,false,1879137692};
Recipe[8][5][5][#Recipe[8][5][5]+1]={1026,"Fancy Hauberk",false,false,1879103749};
Recipe[8][5][5][#Recipe[8][5][5]+1]={1058,"Fine Hauberk",false,false,1879103752};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1069,"Finely Woven Grand Master Standard of Hope",false,false,1879094174};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1070,"Finely Woven Grand Master Standard of Victory",false,false,1879094152};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1071,"Finely Woven Grand Master Standard of War",false,false,1879094177};
Recipe[8][5][6][#Recipe[8][5][6]+1]={1144,"Galadhrim Guard",false,true,0};
Recipe[8][5][7][#Recipe[8][5][7]+1]={1145,"Galadhrim Guard (x5)",false,false,1879137243};
Recipe[8][5][1][#Recipe[8][5][1]+1]={1269,"Guile Signal",false,false,1879103003};
Recipe[8][5][22][#Recipe[8][5][22]+1]={1560,"Large Master Pattern",false,false,1879125922};
Recipe[8][5][20][#Recipe[8][5][20]+1]={398,"Leijona Armour",true,false,1879108625};
Recipe[8][5][20][#Recipe[8][5][20]+1]={399,"Leijona Boots",true,false,1879108633};
Recipe[8][5][20][#Recipe[8][5][20]+1]={400,"Leijona Gloves",true,false,1879108639};
Recipe[8][5][20][#Recipe[8][5][20]+1]={401,"Leijona Helm",true,false,1879108643};
Recipe[8][5][20][#Recipe[8][5][20]+1]={402,"Leijona Leggings",true,false,1879108636};
Recipe[8][5][20][#Recipe[8][5][20]+1]={403,"Leijona Shoulder Guards",true,false,1879108635};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1701,"Major Lossoth Herald Armaments",true,false,1879109656};
--Recipe[8][5][#Recipe[8][5]+1]={697,"Master Tailor Expertise",false,false,1879184380};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1799,"Masterclass Commoner Herald Armaments",false,false,1879191517};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1800,"Masterclass Defender Herald Armaments",false,false,1879191500};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1801,"Masterclass Footsoldier Herald Armaments",false,false,1879191502};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1802,"Masterclass Lossoth Herald Armaments",true,false,1879199962};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1803,"Masterclass Maid-at-arms Herald Armaments",false,false,1879191506};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1804,"Masterclass Man-at-arms Herald Armaments",false,false,1879191505};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1805,"Masterclass Pilgrim Herald Armaments",false,false,1879191514};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1806,"Masterclass Shield-maiden Herald Armaments",false,false,1879191509};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1807,"Masterclass Squire Herald Armaments",false,false,1879191516};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1808,"Masterclass Swordswoman Herald Armaments",false,false,1879191518};
Recipe[8][5][2][#Recipe[8][5][2]+1]={1809,"Masterclass Warden Herald Armaments",false,false,1879191501};
Recipe[8][5][22][#Recipe[8][5][22]+1]={1828,"Medium Master Pattern",false,false,1879125861};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1973,"Padded Pristine Armour",false,false,1879071331};
Recipe[8][5][3][#Recipe[8][5][3]+1]={1972,"Padded Pristine Cloak",false,false,1879086932};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1974,"Padded Pristine Gloves",false,false,1879071330};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1975,"Padded Pristine Hat",false,false,1879071329};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1976,"Padded Pristine Leggings",false,false,1879071334};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1979,"Padded Pristine Robe",false,false,1879087431};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1977,"Padded Pristine Shoes",false,false,1879071332};
Recipe[8][5][12][#Recipe[8][5][12]+1]={1978,"Padded Pristine Shoulder Guards",false,false,1879071333};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2152,"Pristine Armour",false,true,0};
Recipe[8][5][3][#Recipe[8][5][3]+1]={2151,"Pristine Cloak",false,true,0};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2153,"Pristine Gloves",false,true,0};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2154,"Pristine Hat",false,true,0};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2155,"Pristine Leggings",false,true,0};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2162,"Pristine Robe",false,true,0};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2156,"Pristine Shoes",false,true,0};
Recipe[8][5][10][#Recipe[8][5][10]+1]={2157,"Pristine Shoulder Guards",false,true,0};
Recipe[8][5][17][#Recipe[8][5][17]+1]={3290,"Protector\'s Armour",false,false,1879076439};
Recipe[8][5][17][#Recipe[8][5][17]+1]={3291,"Protector\'s Footwear",false,false,1879076441};
Recipe[8][5][17][#Recipe[8][5][17]+1]={3292,"Protector\'s Gloves",false,false,1879076438};
Recipe[8][5][17][#Recipe[8][5][17]+1]={3293,"Protector\'s Helm",false,false,1879076437};
Recipe[8][5][17][#Recipe[8][5][17]+1]={3294,"Protector\'s Leggings",false,false,1879076440};
Recipe[8][5][17][#Recipe[8][5][17]+1]={3295,"Protector\'s Shoulder Guards",false,false,1879076442};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2186,"Radiant Armour",false,false,1879076443};
Recipe[8][5][3][#Recipe[8][5][3]+1]={2184,"Radiant Cloak",false,false,1879086909};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2187,"Radiant Gloves",false,false,1879076445};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2188,"Radiant Hat",false,false,1879076446};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2189,"Radiant Leggings",false,false,1879076447};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2185,"Radiant Robe",false,false,1879087417};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2190,"Radiant Shoes",false,false,1879076444};
Recipe[8][5][11][#Recipe[8][5][11]+1]={2191,"Radiant Shoulder Guards",false,false,1879076448};
Recipe[8][5][21][#Recipe[8][5][21]+1]={2197,"Ranger's Cloak",false,false,1879092696};
Recipe[8][5][8][#Recipe[8][5][8]+1]={2751,"Small 'High Seas' Rug",false,false,1879102053};
Recipe[8][5][22][#Recipe[8][5][22]+1]={2772,"Small Master Pattern",false,false,1879125784};
Recipe[8][5][1][#Recipe[8][5][1]+1]={2911,"Strength Signal",false,false,1879102999};
Recipe[8][5][18][#Recipe[8][5][18]+1]={2967,"Superb Campaigner\'s Armour",false,false,1879071337};
Recipe[8][5][18][#Recipe[8][5][18]+1]={2968,"Superb Campaigner\'s Footwear",false,false,1879071338};
Recipe[8][5][18][#Recipe[8][5][18]+1]={2969,"Superb Campaigner\'s Gloves",false,false,1879071336};
Recipe[8][5][18][#Recipe[8][5][18]+1]={2970,"Superb Campaigner\'s Helm",false,false,1879071335};
Recipe[8][5][18][#Recipe[8][5][18]+1]={2971,"Superb Campaigner\'s Leggings",false,false,1879071340};
Recipe[8][5][18][#Recipe[8][5][18]+1]={2972,"Superb Campaigner\'s Shoulder Guards",false,false,1879071339};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3013,"Superb Protector\'s Armour",true,false,1879054916};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3710,"Superb Protector\'s Armour",true,false,1879091082};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3014,"Superb Protector\'s Footwear",true,false,1879091080};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3711,"Superb Protector\'s Footwear",true,false,1879054917};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3015,"Superb Protector\'s Gloves",true,false,1879054915};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3712,"Superb Protector\'s Gloves",true,false,1879091189};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3016,"Superb Protector\'s Helm",true,false,1879054914};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3713,"Superb Protector\'s Helm",true,false,1879091291};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3017,"Superb Protector\'s Leggings",true,false,1879054919};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3714,"Superb Protector\'s Leggings",true,false,1879091015};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3018,"Superb Protector\'s Shoulder Guards",true,false,1879054918};
Recipe[8][5][19][#Recipe[8][5][19]+1]={3715,"Superb Protector\'s Shoulder Guards",true,false,1879091214};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3002,"Superb Radiant Armour",true,false,1879054910};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3716,"Superb Radiant Armour",true,false,1879091227};
Recipe[8][5][3][#Recipe[8][5][3]+1]={3000,"Superb Radiant Cloak",true,false,1879086906};
Recipe[8][5][3][#Recipe[8][5][3]+1]={3717,"Superb Radiant Cloak",true,false,1879091218};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3003,"Superb Radiant Gloves",true,false,1879054909};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3718,"Superb Radiant Gloves",true,false,1879091243};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3004,"Superb Radiant Hat",true,false,1879054908};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3719,"Superb Radiant Hat",true,false,1879091182};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3005,"Superb Radiant Leggings",true,false,1879054913};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3720,"Superb Radiant Leggings",true,false,1879091130};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3001,"Superb Radiant Robe",true,false,1879087428};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3721,"Superb Radiant Robe",true,false,1879091014};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3006,"Superb Radiant Shoes",true,false,1879054911};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3722,"Superb Radiant Shoes",true,false,1879091075};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3007,"Superb Radiant Shoulder Guards",true,false,1879054912};
Recipe[8][5][13][#Recipe[8][5][13]+1]={3723,"Superb Radiant Shoulder Guards",true,false,1879091228};
Recipe[8][5][1][#Recipe[8][5][1]+1]={3113,"Tactics Signal",false,false,1879102996};
Recipe[8][5][21][#Recipe[8][5][21]+1]={3144,"Tapestry of Deeds",false,false,1879092706};
Recipe[8][5][3][#Recipe[8][5][3]+1]={3178,"Torahammas' Cloak",true,false,1879108211};

Recipe[8][6][19][#Recipe[8][6][19]+1]={122,"August Boots of the Golden Wood",false,false,1879161868};
Recipe[8][6][19][#Recipe[8][6][19]+1]={121,"August Coat of the Golden Wood",false,false,1879161853};
Recipe[8][6][19][#Recipe[8][6][19]+1]={119,"August Gauntlets of the Golden Wood",false,false,1879161848};
Recipe[8][6][19][#Recipe[8][6][19]+1]={120,"August Helm of the Golden Wood",false,false,1879161874};
Recipe[8][6][19][#Recipe[8][6][19]+1]={118,"August Leggings of the Golden Wood",false,false,1879161847};
Recipe[8][6][19][#Recipe[8][6][19]+1]={117,"August Shoulder Pads of the Golden Wood",false,false,1879161867};
Recipe[8][6][7][#Recipe[8][6][7]+1]={2,"'Battle of Dagorlad' Tapestry",false,false,1879166121};
Recipe[8][6][7][#Recipe[8][6][7]+1]={3,"'Battle of Five Armies' Tapestry",false,false,1879166135};
Recipe[8][6][24][#Recipe[8][6][24]+1]={3221,"Boots of the Golden Wood",true,false,1879161529};
Recipe[8][6][24][#Recipe[8][6][24]+1]={2915,"Coat of the Golden Wood",true,false,1879161559};
Recipe[8][6][1][#Recipe[8][6][1]+1]={3411,"Conviction Signal",false,false,1879154129};
Recipe[8][6][8][#Recipe[8][6][8]+1]={449,"Crafted Burglar's Tools of the Third Age",false,false,1879144945};
Recipe[8][6][9][#Recipe[8][6][9]+1]={450,"Crafted Burglar's Tools of the Third Age",false,false,1879165748};
Recipe[8][6][10][#Recipe[8][6][10]+1]={571,"Crafted Rune-keeper's Rune-satchel of the Third Age",false,false,1879145024};
Recipe[8][6][11][#Recipe[8][6][11]+1]={572,"Crafted Rune-keeper's Rune-satchel of the Third Age",false,false,1879165767};
Recipe[8][6][5][#Recipe[8][6][5]+1]={1018,"Extraordinary Leather Guard",false,true,0};
Recipe[8][6][6][#Recipe[8][6][6]+1]={1019,"Extraordinary Leather Guard (x5)",false,false,1879137398};
Recipe[8][6][5][#Recipe[8][6][5]+1]={1020,"Extraordinary Leather Pad",false,true,0};
Recipe[8][6][6][#Recipe[8][6][6]+1]={1021,"Extraordinary Leather Pad (x5)",false,false,1879137471};
Recipe[8][6][5][#Recipe[8][6][5]+1]={1022,"Extraordinary Leather Plate",false,true,0};
Recipe[8][6][6][#Recipe[8][6][6]+1]={1023,"Extraordinary Leather Plate (x5)",false,false,1879137232};
Recipe[8][6][2][#Recipe[8][6][2]+1]={1075,"Finely Woven Supreme Standard of Hope",false,false,1879148467};
Recipe[8][6][2][#Recipe[8][6][2]+1]={1076,"Finely Woven Supreme Standard of Victory",false,false,1879148466};
Recipe[8][6][2][#Recipe[8][6][2]+1]={1077,"Finely Woven Supreme Standard of War",false,false,1879148476};
Recipe[8][6][2][#Recipe[8][6][2]+1]={1079,"Finely Wrought Standard",false,false,1879192881};
Recipe[8][6][20][#Recipe[8][6][20]+1]={1098,"Footman's Armour",false,true,0};
Recipe[8][6][20][#Recipe[8][6][20]+1]={1099,"Footman's Boots",false,true,0};
Recipe[8][6][20][#Recipe[8][6][20]+1]={1100,"Footman's Gloves",false,true,0};
Recipe[8][6][20][#Recipe[8][6][20]+1]={1101,"Footman's Helm",false,true,0};
Recipe[8][6][20][#Recipe[8][6][20]+1]={1102,"Footman's Leggings",false,true,0};
Recipe[8][6][20][#Recipe[8][6][20]+1]={1103,"Footman's Shoulder Guards",false,true,0};
Recipe[8][6][24][#Recipe[8][6][24]+1]={2473,"Gauntlets of the Golden Wood",true,false,1879161586};
Recipe[8][6][17][#Recipe[8][6][17]+1]={3108,"Gloves of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879161728};
Recipe[8][6][25][#Recipe[8][6][25]+1]={1199,"Golden Host Boots",false,false,1879163220};
Recipe[8][6][25][#Recipe[8][6][25]+1]={1202,"Golden Host Coat",false,false,1879163275};
Recipe[8][6][25][#Recipe[8][6][25]+1]={1204,"Golden Host Gauntlets",false,false,1879163264};
Recipe[8][6][25][#Recipe[8][6][25]+1]={1207,"Golden Host Helmet",false,false,1879163274};
Recipe[8][6][25][#Recipe[8][6][25]+1]={1209,"Golden Host Leggings",false,false,1879163221};
Recipe[8][6][25][#Recipe[8][6][25]+1]={1210,"Golden Host Shoulder Pads",false,false,1879163262};
Recipe[8][6][1][#Recipe[8][6][1]+1]={3412,"Guile Signal",false,false,1879154130};
Recipe[8][6][17][#Recipe[8][6][17]+1]={3109,"Hat of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879161734};
Recipe[8][6][24][#Recipe[8][6][24]+1]={2485,"Helm of the Golden Wood",true,false,1879161561};
Recipe[8][6][22][#Recipe[8][6][22]+1]={1392,"Herald's Armour",false,false,1879107154};
Recipe[8][6][22][#Recipe[8][6][22]+1]={1393,"Herald's Boots",false,false,1879107243};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1394,"Herald's Cloak",true,false,1879148579};
Recipe[8][6][22][#Recipe[8][6][22]+1]={1395,"Herald's Gloves",false,false,1879107235};
Recipe[8][6][22][#Recipe[8][6][22]+1]={1396,"Herald's Helm",false,false,1879107256};
Recipe[8][6][22][#Recipe[8][6][22]+1]={1397,"Herald's Leggings",false,false,1879107119};
Recipe[8][6][22][#Recipe[8][6][22]+1]={1398,"Herald's Shoulder Guards",false,false,1879107206};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1400,"Heroic Noble's Hooded Cloak",false,false,1879148578};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1408,"High Herald's Hooded Cloak",false,false,1879148585};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1409,"High Officer's Hooded Cloak",false,false,1879148581};
Recipe[8][6][26][#Recipe[8][6][26]+1]={1567,"Large Supreme Pattern",false,false,1879125847};
Recipe[8][6][17][#Recipe[8][6][17]+1]={2110,"Leggings of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879161733};
Recipe[8][6][24][#Recipe[8][6][24]+1]={2111,"Leggings of the Golden Wood",true,false,1879161610};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1656,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Ancestor",false,false,1879157188};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1657,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Elder",true,false,1879150929};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1658,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Huntsman",false,false,1879157215};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1659,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Old Guard",false,false,1879157214};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1660,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Overseer",false,false,1879157212};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1661,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Preserver",true,false,1879150914};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1662,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Sentinel",true,false,1879150913};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1663,"Lothl"..string.char(195)..string.char(179).."rien Hooded Cloak of the Stalker",true,false,1879150918};
Recipe[8][6][5][#Recipe[8][6][5]+1]={1671,"Magnificent Leather Binding",false,true,0};
Recipe[8][6][6][#Recipe[8][6][6]+1]={1672,"Magnificent Leather Binding (x5)",false,false,1879137470};
Recipe[8][6][5][#Recipe[8][6][5]+1]={1673,"Magnificent Leather Brace",false,true,0};
Recipe[8][6][6][#Recipe[8][6][6]+1]={1674,"Magnificent Leather Brace (x5)",false,false,1879137377};
Recipe[8][6][5][#Recipe[8][6][5]+1]={1675,"Magnificent Leather Pad",false,true,0};
Recipe[8][6][6][#Recipe[8][6][6]+1]={1676,"Magnificent Leather Pad (x5)",false,false,1879137743};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1683,"Magnificent Master\'s Armour",false,false,1879137329};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1679,"Magnificent Master\'s Gloves",false,false,1879137440};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1680,"Magnificent Master\'s Hat",false,false,1879137644};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1678,"Magnificent Master\'s Leggings",false,false,1879137309};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1684,"Magnificent Master\'s Shoes",false,false,1879137225};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1682,"Magnificent Master\'s Shoulder Guards",false,false,1879137264};
Recipe[8][6][4][#Recipe[8][6][4]+1]={1677,"Magnificent Master's Hooded Cloak",false,false,1879137480};
Recipe[8][6][12][#Recipe[8][6][12]+1]={1681,"Magnificent Master's Robe",false,false,1879137350};
Recipe[8][6][19][#Recipe[8][6][19]+1]={1691,"Majestic Marchwarden\'s Armour",false,false,1879137403};
Recipe[8][6][19][#Recipe[8][6][19]+1]={1686,"Majestic Marchwarden\'s Boots",false,false,1879137404};
Recipe[8][6][19][#Recipe[8][6][19]+1]={1688,"Majestic Marchwarden\'s Gloves",false,false,1879137238};
Recipe[8][6][19][#Recipe[8][6][19]+1]={1689,"Majestic Marchwarden\'s Helm",false,false,1879137551};
Recipe[8][6][19][#Recipe[8][6][19]+1]={1687,"Majestic Marchwarden\'s Leggings",false,false,1879137603};
Recipe[8][6][19][#Recipe[8][6][19]+1]={1690,"Majestic Marchwarden\'s Shoulder Guards",false,false,1879137560};
Recipe[8][6][23][#Recipe[8][6][23]+1]={1750,"Marchwarden\'s Armour",true,false,1879107166};
Recipe[8][6][23][#Recipe[8][6][23]+1]={1745,"Marchwarden\'s Boots",true,false,1879107184};
Recipe[8][6][23][#Recipe[8][6][23]+1]={1747,"Marchwarden\'s Gloves",true,false,1879107177};
Recipe[8][6][23][#Recipe[8][6][23]+1]={1748,"Marchwarden\'s Helm",true,false,1879107283};
Recipe[8][6][23][#Recipe[8][6][23]+1]={1746,"Marchwarden\'s Leggings",true,false,1879107138};
Recipe[8][6][23][#Recipe[8][6][23]+1]={1749,"Marchwarden\'s Shoulder Guards",true,false,1879107137};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1797,"Master\'s Armour",true,false,1879107208};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1787,"Master\'s Gloves",true,false,1879107190};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1788,"Master\'s Hat",true,false,1879107142};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1786,"Master\'s Leggings",true,false,1879107204};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1798,"Master\'s Shoes",true,false,1879107179};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1796,"Master\'s Shoulder Guards",true,false,1879107246};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1785,"Master's Cloak",true,false,1879107211};
Recipe[8][6][16][#Recipe[8][6][16]+1]={1790,"Master's Robe",true,false,1879107295};
Recipe[8][6][26][#Recipe[8][6][26]+1]={1835,"Medium Supreme Pattern",false,false,1879125832};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1907,"Noble's Cloak",true,false,1879148591};
Recipe[8][6][3][#Recipe[8][6][3]+1]={1925,"Officer's Cloak",true,false,1879148576};
Recipe[8][6][8][#Recipe[8][6][8]+1]={2235,"Reforged Burglar's Tools of the Second Age",false,false,1879162149};
Recipe[8][6][9][#Recipe[8][6][9]+1]={2236,"Reforged Burglar's Tools of the Second Age",false,false,1879165960};
Recipe[8][6][10][#Recipe[8][6][10]+1]={2348,"Reforged Rune-keeper's Rune-satchel of the Second Age",false,false,1879162200};
Recipe[8][6][11][#Recipe[8][6][11]+1]={2347,"Reforged Rune-keeper's Rune-satchel of the Second Age",false,false,1879165922};
Recipe[8][6][9][#Recipe[8][6][9]+1]={2399,"Reshaped Burglar's Tools of the First Age",false,false,1879181541};
Recipe[8][6][11][#Recipe[8][6][11]+1]={2455,"Reshaped Rune-keeper's Rune-satchel of the First Age",false,false,1879181533};
Recipe[8][6][12][#Recipe[8][6][12]+1]={2490,"Resplendent Gloves of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879161879};
Recipe[8][6][12][#Recipe[8][6][12]+1]={2491,"Resplendent Hat of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879161850};
Recipe[8][6][12][#Recipe[8][6][12]+1]={2487,"Resplendent Leggings of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879161876};
Recipe[8][6][12][#Recipe[8][6][12]+1]={2488,"Resplendent Robe of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879161843};
Recipe[8][6][12][#Recipe[8][6][12]+1]={2489,"Resplendent Shoes of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879161858};
Recipe[8][6][12][#Recipe[8][6][12]+1]={2492,"Resplendent Shoulder Pads of Lothl"..string.char(195)..string.char(179).."rien",false,false,1879161849};
Recipe[8][6][17][#Recipe[8][6][17]+1]={2854,"Robe of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879161735};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2510,"Rock-climber's Armour",false,true,0};
Recipe[8][6][3][#Recipe[8][6][3]+1]={2511,"Rock-climber's Cloak",false,true,0};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2512,"Rock-climber's Gloves",false,true,0};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2513,"Rock-climber's Hat",false,true,0};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2514,"Rock-climber's Leggings",false,true,0};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2515,"Rock-climber's Robe",false,true,0};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2516,"Rock-climber's Shoes",false,true,0};
Recipe[8][6][13][#Recipe[8][6][13]+1]={2517,"Rock-climber's Shoulder Guards",false,true,0};
Recipe[8][6][21][#Recipe[8][6][21]+1]={2596,"Scout's Armour",false,false,1879107219};
Recipe[8][6][21][#Recipe[8][6][21]+1]={2597,"Scout's Boots",false,false,1879107221};
Recipe[8][6][21][#Recipe[8][6][21]+1]={2598,"Scout's Gloves",false,false,1879107196};
Recipe[8][6][21][#Recipe[8][6][21]+1]={2599,"Scout's Helm",false,false,1879107299};
Recipe[8][6][21][#Recipe[8][6][21]+1]={2600,"Scout's Leggings",false,false,1879107191};
Recipe[8][6][21][#Recipe[8][6][21]+1]={2601,"Scout's Shoulder Guards",false,false,1879107165};
Recipe[8][6][14][#Recipe[8][6][14]+1]={2669,"Searcher's Armour",false,false,1879107258};
Recipe[8][6][14][#Recipe[8][6][14]+1]={2670,"Searcher's Gloves",false,false,1879107209};
Recipe[8][6][14][#Recipe[8][6][14]+1]={2671,"Searcher's Hat",false,false,1879107236};
Recipe[8][6][14][#Recipe[8][6][14]+1]={2672,"Searcher's Leggings",false,false,1879107232};
Recipe[8][6][14][#Recipe[8][6][14]+1]={2673,"Searcher's Shoes",false,false,1879107228};
Recipe[8][6][14][#Recipe[8][6][14]+1]={2674,"Searcher's Shoulder Guards",false,false,1879107274};
Recipe[8][6][17][#Recipe[8][6][17]+1]={3105,"Shoes of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879161737};
Recipe[8][6][17][#Recipe[8][6][17]+1]={3110,"Shoulder Pads of Lothl"..string.char(195)..string.char(179).."rien",true,false,1879161729};
Recipe[8][6][24][#Recipe[8][6][24]+1]={1046,"Shoulder Pads of the Golden Wood",true,false,1879161611};
Recipe[8][6][7][#Recipe[8][6][7]+1]={5,"'Siege of Barad-d"..string.char(195)..string.char(187).."r' Tapestry",false,false,1879166130};
Recipe[8][6][26][#Recipe[8][6][26]+1]={2779,"Small Supreme Pattern",false,false,1879125793};
Recipe[8][6][1][#Recipe[8][6][1]+1]={3413,"Strength Signal",false,false,1879154128};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3077,"Supreme Commoner Herald Armaments",false,false,1879191515};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3079,"Supreme Defender Herald Armaments",false,false,1879191513};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3080,"Supreme Footsoldier Herald Armaments",false,false,1879191508};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3081,"Supreme Lossoth Herald Armaments",true,false,1879200826};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3082,"Supreme Maid-at-arms Herald Armaments",false,false,1879191512};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3083,"Supreme Man-at-arms Herald Armaments",false,false,1879191504};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3091,"Supreme Pilgrim Herald Armaments",false,false,1879191510};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3095,"Supreme Shield-maiden Herald Armaments",false,false,1879191503};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3096,"Supreme Squire Herald Armaments",false,false,1879191511};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3097,"Supreme Swordswoman Herald Armaments",false,false,1879191507};
--Recipe[8][6][#Recipe[8][6]+1]={704,"Supreme Tailor Expertise",false,false,1879184369};
Recipe[8][6][2][#Recipe[8][6][2]+1]={3098,"Supreme Warden Herald Armaments",false,false,1879191519};
Recipe[8][6][1][#Recipe[8][6][1]+1]={3414,"Tactics Signal",false,false,1879154140};
Recipe[8][6][18][#Recipe[8][6][18]+1]={3147,"Tawarwaith Gloves",false,false,1879163240};
Recipe[8][6][18][#Recipe[8][6][18]+1]={3148,"Tawarwaith Hat",false,false,1879163249};
Recipe[8][6][18][#Recipe[8][6][18]+1]={3149,"Tawarwaith Leggings",false,false,1879163223};
Recipe[8][6][18][#Recipe[8][6][18]+1]={3150,"Tawarwaith Robe",false,false,1879163231};
Recipe[8][6][18][#Recipe[8][6][18]+1]={3151,"Tawarwaith Shoes",false,false,1879163250};
Recipe[8][6][18][#Recipe[8][6][18]+1]={3152,"Tawarwaith Shoulder Pads",false,false,1879163201};
Recipe[8][6][15][#Recipe[8][6][15]+1]={3188,"Treasure-hunter's Armour",false,false,1879107215};
Recipe[8][6][15][#Recipe[8][6][15]+1]={3189,"Treasure-hunter's Gloves",false,false,1879107230};
Recipe[8][6][15][#Recipe[8][6][15]+1]={3190,"Treasure-hunter's Hat",false,false,1879107201};
Recipe[8][6][15][#Recipe[8][6][15]+1]={3191,"Treasure-hunter's Leggings",false,false,1879107290};
Recipe[8][6][15][#Recipe[8][6][15]+1]={3192,"Treasure-hunter's Shoes",false,false,1879107207};
Recipe[8][6][15][#Recipe[8][6][15]+1]={3193,"Treasure-hunter's Shoulder Guards",false,false,1879107136};

Recipe[8][7][9][#Recipe[8][7][9]+1]={1027,"Assault Gloves of Th"..string.char(195)..string.char(169).."odred",false,false,1879210877};
Recipe[8][7][9][#Recipe[8][7][9]+1]={3217,"Assault Hat of Th"..string.char(195)..string.char(169).."odred",false,false,1879211121};
Recipe[8][7][9][#Recipe[8][7][9]+1]={2843,"Assault Leggings of Th"..string.char(195)..string.char(169).."odred",false,false,1879210904};
Recipe[8][7][9][#Recipe[8][7][9]+1]={3218,"Assault Pauldrons of Th"..string.char(195)..string.char(169).."odred",false,false,1879211055};
Recipe[8][7][9][#Recipe[8][7][9]+1]={2844,"Assault Robe of Th"..string.char(195)..string.char(169).."odred",false,false,1879210930};
Recipe[8][7][9][#Recipe[8][7][9]+1]={1028,"Assault Shoes of Th"..string.char(195)..string.char(169).."odred",false,false,1879210950};
Recipe[8][7][17][#Recipe[8][7][17]+1]={2466,"Brushed Boots",false,true,0};
Recipe[8][7][10][#Recipe[8][7][10]+1]={1031,"Brushed Shoes",false,true,0};
Recipe[8][7][15][#Recipe[8][7][15]+1]={1034,"Campaign Gloves of the Rider",true,false,1879211124};
Recipe[8][7][15][#Recipe[8][7][15]+1]={3225,"Campaign Hat of the Rider",true,false,1879211101};
Recipe[8][7][15][#Recipe[8][7][15]+1]={2845,"Campaign Leggings of the Rider",true,false,1879210972};
Recipe[8][7][15][#Recipe[8][7][15]+1]={3226,"Campaign Pauldrons of the Rider",true,false,1879211092};
Recipe[8][7][15][#Recipe[8][7][15]+1]={2846,"Campaign Robe of the Rider",true,false,1879210998};
Recipe[8][7][15][#Recipe[8][7][15]+1]={1035,"Campaign Shoes of the Rider",true,false,1879211018};
Recipe[8][7][5][#Recipe[8][7][5]+1]={3260,"Cloak of the Rider",true,false,1879211024};
Recipe[8][7][6][#Recipe[8][7][6]+1]={3261,"Cloak of Th"..string.char(195)..string.char(169).."odred",false,false,1879211020};
Recipe[8][7][16][#Recipe[8][7][16]+1]={2467,"Combat Armour of Th"..string.char(195)..string.char(169).."odred",false,false,1879211069};
Recipe[8][7][16][#Recipe[8][7][16]+1]={2468,"Combat Boots of Th"..string.char(195)..string.char(169).."odred",false,false,1879210936};
Recipe[8][7][16][#Recipe[8][7][16]+1]={1038,"Combat Gauntlets of Th"..string.char(195)..string.char(169).."odred",false,false,1879211017};
Recipe[8][7][16][#Recipe[8][7][16]+1]={2916,"Combat Helmet of Th"..string.char(195)..string.char(169).."odred",false,false,1879210883};
Recipe[8][7][16][#Recipe[8][7][16]+1]={2469,"Combat Leggings of Th"..string.char(195)..string.char(169).."odred",false,false,1879210913};
Recipe[8][7][16][#Recipe[8][7][16]+1]={3228,"Combat Pauldrons of Th"..string.char(195)..string.char(169).."odred",false,false,1879210957};
Recipe[8][7][7][#Recipe[8][7][7]+1]={3415,"Crafted Burglar's Tools of the Third Age",false,false,1879219813};
Recipe[8][7][8][#Recipe[8][7][8]+1]={3416,"Crafted Rune-keeper's Rune-satchel of the Third Age",false,false,1879219778};
Recipe[8][7][3][#Recipe[8][7][3]+1]={1078,"Dunland Standards",false,false,1879211083};
Recipe[8][7][14][#Recipe[8][7][14]+1]={1039,"Dunlending Campaign Armour",false,false,1879210999};
Recipe[8][7][4][#Recipe[8][7][4]+1]={726,"Dunlending Cloak",false,false,1879211062};
Recipe[8][7][20][#Recipe[8][7][20]+1]={2472,"Dunlending Skirmish Armour",false,false,1879211005};
Recipe[8][7][22][#Recipe[8][7][22]+1]={1574,"Large Westfold Pattern",false,false,1879210949};
Recipe[8][7][22][#Recipe[8][7][22]+1]={1842,"Medium Westfold Pattern",false,false,1879210898};
Recipe[8][7][7][#Recipe[8][7][7]+1]={3417,"Reforged Burglar's Tools of the Second Age",false,false,1879219814};
Recipe[8][7][8][#Recipe[8][7][8]+1]={3418,"Reforged Rune-keeper's Rune-satchel of the Second Age",false,false,1879219777};
Recipe[8][7][7][#Recipe[8][7][7]+1]={3419,"Reshaped Burglar's Tools of the First Age",false,false,1879219815};
Recipe[8][7][8][#Recipe[8][7][8]+1]={3420,"Reshaped Rune-keeper's Rune-satchel of the First Age",false,false,1879219816};
Recipe[8][7][13][#Recipe[8][7][13]+1]={2675,"Seared Armour",true,false,1879220264};
Recipe[8][7][21][#Recipe[8][7][21]+1]={2476,"Skirmish Armour of the Rider",true,false,1879210970};
Recipe[8][7][21][#Recipe[8][7][21]+1]={2477,"Skirmish Boots of the Rider",true,false,1879210976};
Recipe[8][7][21][#Recipe[8][7][21]+1]={1047,"Skirmish Gauntlets of the Rider",true,false,1879210907};
Recipe[8][7][21][#Recipe[8][7][21]+1]={2928,"Skirmish Helmet of the Rider",true,false,1879210900};
Recipe[8][7][21][#Recipe[8][7][21]+1]={2478,"Skirmish Leggings of the Rider",true,false,1879211086};
Recipe[8][7][21][#Recipe[8][7][21]+1]={3235,"Skirmish Pauldrons of the Rider",true,false,1879211010};
Recipe[8][7][22][#Recipe[8][7][22]+1]={2786,"Small Westfold Pattern",false,false,1879210990};
Recipe[8][7][13][#Recipe[8][7][13]+1]={3432,"Wayfarer's Helm",true,false,1879225821};
Recipe[8][7][13][#Recipe[8][7][13]+1]={3433,"Wayfarer's Leggings",true,false,1879225831};
Recipe[8][7][3][#Recipe[8][7][3]+1]={3323,"Westfold Armaments (Dwarf)",false,false,1879210974};
Recipe[8][7][3][#Recipe[8][7][3]+1]={3318,"Westfold Armaments (Man)",false,false,1879211060};
Recipe[8][7][3][#Recipe[8][7][3]+1]={3315,"Westfold Armaments (Woman)",false,false,1879210995};
Recipe[8][7][11][#Recipe[8][7][11]+1]={1049,"Westfold Campaign Gloves",false,false,1879211046};
Recipe[8][7][12][#Recipe[8][7][12]+1]={1050,"Westfold Campaign Hat",false,false,1879210878};
Recipe[8][7][12][#Recipe[8][7][12]+1]={2857,"Westfold Campaign Leggings",false,false,1879210887};
Recipe[8][7][11][#Recipe[8][7][11]+1]={3111,"Westfold Campaign Shoulder Pads",false,false,1879210890};
Recipe[8][7][2][#Recipe[8][7][2]+1]={3313,"Westfold Conviction Signals",false,false,1879211075};
Recipe[8][7][18][#Recipe[8][7][18]+1]={3239,"Westfold Skirmish Gauntlets",false,false,1879210991};
Recipe[8][7][19][#Recipe[8][7][19]+1]={3240,"Westfold Skirmish Helmet",false,false,1879210932};
Recipe[8][7][19][#Recipe[8][7][19]+1]={2114,"Westfold Skirmish Leggings",false,false,1879210944};
Recipe[8][7][18][#Recipe[8][7][18]+1]={2932,"Westfold Skirmish Pauldrons",false,false,1879210985};
Recipe[8][7][3][#Recipe[8][7][3]+1]={1080,"Westfold Standards",false,false,1879211027};
Recipe[8][7][1][#Recipe[8][7][1]+1]={3347,"Wyrmscale Cloak",false,false,1879200009};

--Recipe[9][1][#Recipe[9][1]+1]={664,"Apprentice Weaponsmith Expertise",false,false,1879184376};
Recipe[9][1][2][#Recipe[9][1][2]+1]={291,"Bronze Axe",false,true,0};
Recipe[9][1][1][#Recipe[9][1][1]+1]={292,"Bronze Blade",false,true,0};
Recipe[9][1][2][#Recipe[9][1][2]+1]={296,"Bronze Dagger",false,true,0};
Recipe[9][1][2][#Recipe[9][1][2]+1]={299,"Bronze Great Sword",false,true,0};
Recipe[9][1][1][#Recipe[9][1][1]+1]={300,"Bronze Hilt",false,true,0};
Recipe[9][1][2][#Recipe[9][1][2]+1]={308,"Bronze Sword",false,true,0};
Recipe[9][1][4][#Recipe[9][1][4]+1]={310,"Bronze Throwing Axe",false,true,0};
Recipe[9][1][3][#Recipe[9][1][3]+1]={1295,"Heavy Bronze Axe",false,false,1879066702};
Recipe[9][1][3][#Recipe[9][1][3]+1]={1296,"Heavy Bronze Dagger",false,false,1879066701};
Recipe[9][1][3][#Recipe[9][1][3]+1]={1297,"Heavy Bronze Great Sword",false,false,1879066703};
Recipe[9][1][3][#Recipe[9][1][3]+1]={1298,"Heavy Bronze Headsman\'s Axe",false,false,1879066704};
Recipe[9][1][3][#Recipe[9][1][3]+1]={1299,"Heavy Bronze Mace",false,false,1879066705};
Recipe[9][1][3][#Recipe[9][1][3]+1]={1300,"Heavy Bronze Sword",false,false,1879066700};

Recipe[9][2][3][#Recipe[9][2][3]+1]={139,"Balanced Steel Hilt",false,true,0};
Recipe[9][2][5][#Recipe[9][2][5]+1]={152,"Barrow-iron Bear Trap",false,false,1879066683};
Recipe[9][2][2][#Recipe[9][2][2]+1]={153,"Barrow-iron Caltrops",false,false,1879068113};
Recipe[9][2][5][#Recipe[9][2][5]+1]={154,"Barrow-iron Double Trap",false,false,1879068110};
Recipe[9][2][2][#Recipe[9][2][2]+1]={157,"Barrow-iron Marbles",false,false,1879068114};
Recipe[9][2][5][#Recipe[9][2][5]+1]={158,"Barrow-iron Quick Trap",false,false,1879091433};
Recipe[9][2][2][#Recipe[9][2][2]+1]={159,"Barrow-iron Stun Dust",false,false,1879068115};
Recipe[9][2][4][#Recipe[9][2][4]+1]={161,"Basic Shield-spike Kit",false,false,1879068111};
Recipe[9][2][10][#Recipe[9][2][10]+1]={834,"Elven Hunting Dagger",true,false,1879062051};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1127,"Forged Steel Axe",true,false,1879068163};
Recipe[9][2][9][#Recipe[9][2][9]+1]={3724,"Forged Steel Axe",true,false,1879091013};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1128,"Forged Steel Dagger",true,false,1879068162};
Recipe[9][2][9][#Recipe[9][2][9]+1]={3725,"Forged Steel Dagger",true,false,1879091093};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1129,"Forged Steel Great Sword",true,false,1879068164};
Recipe[9][2][9][#Recipe[9][2][9]+1]={3726,"Forged Steel Great Sword",true,false,1879091039};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1130,"Forged Steel Halberd",true,false,1879068166};
Recipe[9][2][9][#Recipe[9][2][9]+1]={3727,"Forged Steel Halberd",true,false,1879091186};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1132,"Forged Steel Headsman\'s Axe",true,false,1879068165};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1131,"Forged Steel Headsman's Axe",true,false,1879091163};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1133,"Forged Steel Mace",true,false,1879068167};
Recipe[9][2][9][#Recipe[9][2][9]+1]={3728,"Forged Steel Mace",true,false,1879091021};
Recipe[9][2][9][#Recipe[9][2][9]+1]={1134,"Forged Steel Sword",true,false,1879068161};
Recipe[9][2][9][#Recipe[9][2][9]+1]={3729,"Forged Steel Sword",true,false,1879091151};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1345,"Heavy Iron Axe",false,false,1879067211};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1346,"Heavy Iron Dagger",false,false,1879067210};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1347,"Heavy Iron Great Sword",false,false,1879067212};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1348,"Heavy Iron Halberd",false,false,1879067214};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1349,"Heavy Iron Headsman\'s Axe",false,false,1879067213};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1351,"Heavy Iron Mace",false,false,1879067215};
Recipe[9][2][8][#Recipe[9][2][8]+1]={1352,"Heavy Iron Sword",false,false,1879067209};
Recipe[9][2][6][#Recipe[9][2][6]+1]={1465,"Iron Axe",false,true,0};
Recipe[9][2][3][#Recipe[9][2][3]+1]={1467,"Iron Blade",false,true,0};
Recipe[9][2][6][#Recipe[9][2][6]+1]={1472,"Iron Dagger",false,true,0};
Recipe[9][2][6][#Recipe[9][2][6]+1]={1475,"Iron Great Sword",false,true,0};
Recipe[9][2][3][#Recipe[9][2][3]+1]={1476,"Iron Hilt",false,true,0};
Recipe[9][2][6][#Recipe[9][2][6]+1]={1481,"Iron Sword",false,true,0};
Recipe[9][2][11][#Recipe[9][2][11]+1]={1483,"Iron Throwing Axe",false,true,0};
Recipe[9][2][1][#Recipe[9][2][1]+1]={1484,"Iron Throwing Hatchet",false,false,1879197251};
--Recipe[9][2][#Recipe[9][2]+1]={685,"Journeyman Weaponsmith Expertise",false,false,1879184373};
Recipe[9][2][4][#Recipe[9][2][4]+1]={1499,"Journeyman Westernesse Shield-spike Kit",false,false,1879068112};
Recipe[9][2][7][#Recipe[9][2][7]+1]={2859,"Steel Axe",false,false,1879062003};
Recipe[9][2][3][#Recipe[9][2][3]+1]={2860,"Steel Blade",false,true,0};
Recipe[9][2][7][#Recipe[9][2][7]+1]={2865,"Steel Dagger",false,false,1879062004};
Recipe[9][2][7][#Recipe[9][2][7]+1]={2868,"Steel Great Sword",false,false,1879062002};
Recipe[9][2][7][#Recipe[9][2][7]+1]={2882,"Steel Sword",false,false,1879062001};
Recipe[9][2][12][#Recipe[9][2][12]+1]={2884,"Steel Throwing Axe",false,false,1879062005};

Recipe[9][3][8][#Recipe[9][3][8]+1]={283,"Bright Steel Axe",false,true,0};
Recipe[9][3][3][#Recipe[9][3][3]+1]={284,"Bright Steel Blade",false,true,0};
Recipe[9][3][4][#Recipe[9][3][4]+1]={285,"Bright Steel Blade (x5)",false,false,1879137545};
Recipe[9][3][8][#Recipe[9][3][8]+1]={286,"Bright Steel Dagger",false,true,0};
Recipe[9][3][8][#Recipe[9][3][8]+1]={287,"Bright Steel Great Sword",false,true,0};
Recipe[9][3][8][#Recipe[9][3][8]+1]={288,"Bright Steel Sword",false,true,0};
Recipe[9][3][12][#Recipe[9][3][12]+1]={289,"Bright Steel Throwing Axe",false,true,0};
Recipe[9][3][3][#Recipe[9][3][3]+1]={942,"Etched Steel Emblem",false,true,0};
Recipe[9][3][4][#Recipe[9][3][4]+1]={943,"Etched Steel Emblem (x5)",false,false,1879137379};
Recipe[9][3][5][#Recipe[9][3][5]+1]={962,"Expert Ancient Dwarf Shield-spike Kit",false,false,1879069902};
--Recipe[9][3][#Recipe[9][3]+1]={678,"Expert Weaponsmith Expertise",false,false,1879184370};
Recipe[9][3][9][#Recipe[9][3][9]+1]={1227,"Gondorian Axe",false,false,1879062023};
Recipe[9][3][9][#Recipe[9][3][9]+1]={1228,"Gondorian Dagger",false,false,1879062024};
Recipe[9][3][9][#Recipe[9][3][9]+1]={1229,"Gondorian Great Sword",false,false,1879062022};
Recipe[9][3][9][#Recipe[9][3][9]+1]={1230,"Gondorian Sword",false,false,1879062021};
Recipe[9][3][13][#Recipe[9][3][13]+1]={1231,"Gondorian Throwing Axe",false,false,1879062025};
Recipe[9][3][1][#Recipe[9][3][1]+1]={1232,"Gondorian Throwing Hatchet",false,false,1879197228};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1288,"Heavy Bright Steel Axe",false,false,1879069455};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1289,"Heavy Bright Steel Dagger",false,false,1879069454};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1290,"Heavy Bright Steel Great Sword",false,false,1879069456};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1291,"Heavy Bright Steel Halberd",false,false,1879069458};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1292,"Heavy Bright Steel Headsman\'s Axe",false,false,1879069457};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1293,"Heavy Bright Steel Mace",false,false,1879069459};
Recipe[9][3][10][#Recipe[9][3][10]+1]={1294,"Heavy Bright Steel Sword",false,false,1879069453};
Recipe[9][3][5][#Recipe[9][3][5]+1]={1446,"Improved Shield-spike Kit",false,false,1879069901};
Recipe[9][3][14][#Recipe[9][3][14]+1]={1820,"Medium Expert Emblem",false,false,1879125783};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1874,"Mirrored Gondorian Axe",false,false,1879137428};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1875,"Mirrored Gondorian Dagger",false,false,1879137448};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1876,"Mirrored Gondorian Great Sword",false,false,1879137315};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1877,"Mirrored Gondorian Halberd",false,false,1879137740};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1878,"Mirrored Gondorian Headsman\'s Axe",false,false,1879137600};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1879,"Mirrored Gondorian Mace",false,false,1879137331};
Recipe[9][3][7][#Recipe[9][3][7]+1]={1880,"Mirrored Gondorian Sword",false,false,1879137334};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2069,"Polished Gondorian Axe",true,false,1879069955};
Recipe[9][3][11][#Recipe[9][3][11]+1]={3730,"Polished Gondorian Axe",true,false,1879091088};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2070,"Polished Gondorian Dagger",true,false,1879069954};
Recipe[9][3][11][#Recipe[9][3][11]+1]={3731,"Polished Gondorian Dagger",true,false,1879091149};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2071,"Polished Gondorian Great Sword",true,false,1879069956};
Recipe[9][3][11][#Recipe[9][3][11]+1]={3732,"Polished Gondorian Great Sword",true,false,1879091158};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2072,"Polished Gondorian Halberd",true,false,1879069958};
Recipe[9][3][11][#Recipe[9][3][11]+1]={3733,"Polished Gondorian Halberd",true,false,1879091285};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2074,"Polished Gondorian Headsman\'s Axe",true,false,1879069957};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2073,"Polished Gondorian Headsman's Axe",true,false,1879091259};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2075,"Polished Gondorian Mace",true,false,1879069959};
Recipe[9][3][11][#Recipe[9][3][11]+1]={3734,"Polished Gondorian Mace",true,false,1879091121};
Recipe[9][3][11][#Recipe[9][3][11]+1]={2076,"Polished Gondorian Sword",true,false,1879069953};
Recipe[9][3][11][#Recipe[9][3][11]+1]={3735,"Polished Gondorian Sword",true,false,1879091208};
Recipe[9][3][6][#Recipe[9][3][6]+1]={2495,"Rich-iron Bear Trap",false,false,1879069428};
Recipe[9][3][2][#Recipe[9][3][2]+1]={2496,"Rich-iron Caltrops",false,false,1879069903};
Recipe[9][3][6][#Recipe[9][3][6]+1]={2497,"Rich-iron Lure Trap",false,false,1879091431};
Recipe[9][3][2][#Recipe[9][3][2]+1]={2498,"Rich-iron Marbles",false,false,1879069904};
Recipe[9][3][6][#Recipe[9][3][6]+1]={2499,"Rich-iron Quick Trap",false,false,1879091432};
Recipe[9][3][6][#Recipe[9][3][6]+1]={2500,"Rich-iron Strong Trap",false,false,1879091423};
Recipe[9][3][2][#Recipe[9][3][2]+1]={2501,"Rich-iron Stun Dust",false,false,1879069905};
Recipe[9][3][6][#Recipe[9][3][6]+1]={2502,"Rich-iron Triple Trap",false,false,1879069900};
Recipe[9][3][14][#Recipe[9][3][14]+1]={2763,"Small Expert Emblem",false,false,1879125769};
Recipe[9][3][3][#Recipe[9][3][3]+1]={2869,"Steel Hilt",false,true,0};
Recipe[9][3][4][#Recipe[9][3][4]+1]={2870,"Steel Hilt (x5)",false,false,1879137414};
Recipe[9][3][3][#Recipe[9][3][3]+1]={2874,"Steel Pommel",false,true,0};
Recipe[9][3][4][#Recipe[9][3][4]+1]={2875,"Steel Pommel (x5)",false,false,1879137521};

Recipe[9][4][6][#Recipe[9][4][6]+1]={95,"Artisan Beleriand Shield-spike Kit",false,false,1879070376};
--Recipe[9][4][#Recipe[9][4]+1]={671,"Artisan Weaponsmith Expertise",false,false,1879184382};
Recipe[9][4][17][#Recipe[9][4][17]+1]={394,"Ceremonial Dagger",false,false,1879092711};
Recipe[9][4][9][#Recipe[9][4][9]+1]={730,"Dwarf-craft Axe",false,true,0};
Recipe[9][4][3][#Recipe[9][4][3]+1]={731,"Dwarf-craft Blade",false,true,0};
Recipe[9][4][4][#Recipe[9][4][4]+1]={732,"Dwarf-craft Blade (x5)",false,false,1879137321};
Recipe[9][4][9][#Recipe[9][4][9]+1]={733,"Dwarf-craft Dagger",false,true,0};
Recipe[9][4][9][#Recipe[9][4][9]+1]={734,"Dwarf-craft Great Sword",false,true,0};
Recipe[9][4][9][#Recipe[9][4][9]+1]={735,"Dwarf-craft Sword",false,true,0};
Recipe[9][4][14][#Recipe[9][4][14]+1]={736,"Dwarf-craft Throwing Axe",false,true,0};
Recipe[9][4][1][#Recipe[9][4][1]+1]={737,"Dwarf-craft Throwing Hatchet",false,false,1879197243};
Recipe[9][4][7][#Recipe[9][4][7]+1]={739,"Dwarf-iron Bear Trap",false,false,1879070206};
Recipe[9][4][2][#Recipe[9][4][2]+1]={741,"Dwarf-iron Caltrops",false,false,1879070377};
Recipe[9][4][7][#Recipe[9][4][7]+1]={747,"Dwarf-iron Lure Trap",false,false,1879091439};
Recipe[9][4][2][#Recipe[9][4][2]+1]={748,"Dwarf-iron Marbles",false,false,1879070378};
Recipe[9][4][7][#Recipe[9][4][7]+1]={749,"Dwarf-iron Quick Trap",false,false,1879091416};
Recipe[9][4][7][#Recipe[9][4][7]+1]={752,"Dwarf-iron Strong Trap",false,false,1879091417};
Recipe[9][4][2][#Recipe[9][4][2]+1]={753,"Dwarf-iron Stun Dust",false,false,1879070379};
Recipe[9][4][7][#Recipe[9][4][7]+1]={754,"Dwarf-iron Triple Trap",false,false,1879091419};
Recipe[9][4][7][#Recipe[9][4][7]+1]={755,"Dwarf-iron Tripwire Trap",false,false,1879091427};
Recipe[9][4][3][#Recipe[9][4][3]+1]={1061,"Finely Balanced Guard",false,true,0};
Recipe[9][4][4][#Recipe[9][4][4]+1]={1062,"Finely Balanced Guard (x5)",false,false,1879137347};
Recipe[9][4][13][#Recipe[9][4][13]+1]={1083,"Fist of the Dwarves",true,false,1879061930};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1113,"Forged Dwarf-craft Axe",false,false,1879070234};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1114,"Forged Dwarf-craft Dagger",false,false,1879070233};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1115,"Forged Dwarf-craft Great Sword",false,false,1879070235};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1116,"Forged Dwarf-craft Halberd",false,false,1879070237};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1117,"Forged Dwarf-craft Headsman\'s Axe",false,false,1879070236};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1118,"Forged Dwarf-craft Mace",false,false,1879070238};
Recipe[9][4][11][#Recipe[9][4][11]+1]={1119,"Forged Dwarf-craft Sword",false,false,1879070232};
Recipe[9][4][5][#Recipe[9][4][5]+1]={1580,"Leaf-blade Candlestand",false,false,1879102049};
Recipe[9][4][5][#Recipe[9][4][5]+1]={1581,"Leaf-blade Chandelier",false,false,1879102072};
Recipe[9][4][18][#Recipe[9][4][18]+1]={1813,"Medium Artisan Emblem",false,false,1879125766};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1887,"Mirrored Westernesse Axe",false,false,1879137515};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1888,"Mirrored Westernesse Dagger",false,false,1879137678};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1889,"Mirrored Westernesse Great Sword",false,false,1879137695};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1890,"Mirrored Westernesse Halberd",false,false,1879137388};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1891,"Mirrored Westernesse Headsman\'s Axe",false,false,1879137323};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1892,"Mirrored Westernesse Mace",false,false,1879137546};
Recipe[9][4][8][#Recipe[9][4][8]+1]={1893,"Mirrored Westernesse Sword",false,false,1879137394};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2085,"Polished Westernesse Axe",true,false,1879070424};
Recipe[9][4][12][#Recipe[9][4][12]+1]={3758,"Polished Westernesse Axe",true,false,1879091122};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2086,"Polished Westernesse Dagger",true,false,1879070423};
Recipe[9][4][12][#Recipe[9][4][12]+1]={3759,"Polished Westernesse Dagger",true,false,1879091265};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2087,"Polished Westernesse Great Sword",true,false,1879070425};
Recipe[9][4][12][#Recipe[9][4][12]+1]={3760,"Polished Westernesse Great Sword",true,false,1879091119};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2088,"Polished Westernesse Halberd",true,false,1879070427};
Recipe[9][4][12][#Recipe[9][4][12]+1]={3761,"Polished Westernesse Halberd",true,false,1879091067};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2090,"Polished Westernesse Headsman\'s Axe",true,false,1879070426};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2089,"Polished Westernesse Headsman's Axe",true,false,1879091260};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2091,"Polished Westernesse Mace",true,false,1879070428};
Recipe[9][4][12][#Recipe[9][4][12]+1]={3762,"Polished Westernesse Mace",true,false,1879091049};
Recipe[9][4][12][#Recipe[9][4][12]+1]={2092,"Polished Westernesse Sword",true,false,1879070422};
Recipe[9][4][12][#Recipe[9][4][12]+1]={3763,"Polished Westernesse Sword",true,false,1879091161};
Recipe[9][4][16][#Recipe[9][4][16]+1]={2394,"Repair Anvil",false,false,1879090270};
Recipe[9][4][6][#Recipe[9][4][6]+1]={2704,"Sharp Shield-spike Kit",false,false,1879070375};
Recipe[9][4][18][#Recipe[9][4][18]+1]={2756,"Small Artisan Emblem",false,false,1879125877};
Recipe[9][4][3][#Recipe[9][4][3]+1]={2929,"Strong Steel Hilt",false,true,0};
Recipe[9][4][4][#Recipe[9][4][4]+1]={2930,"Strong Steel Hilt (x5)",false,false,1879137721};
Recipe[9][4][10][#Recipe[9][4][10]+1]={3279,"Westernesse Axe",false,false,1879061944};
Recipe[9][4][3][#Recipe[9][4][3]+1]={3280,"Westernesse Blade",false,true,0};
Recipe[9][4][4][#Recipe[9][4][4]+1]={3281,"Westernesse Blade (x5)",false,false,1879137265};
Recipe[9][4][10][#Recipe[9][4][10]+1]={3283,"Westernesse Dagger",false,false,1879061945};
Recipe[9][4][10][#Recipe[9][4][10]+1]={3285,"Westernesse Great Sword",false,false,1879061943};
Recipe[9][4][10][#Recipe[9][4][10]+1]={3302,"Westernesse Sword",false,false,1879061942};
Recipe[9][4][15][#Recipe[9][4][15]+1]={3303,"Westernesse Throwing Axe",false,false,1879061946};

Recipe[9][5][9][#Recipe[9][5][9]+1]={50,"Ancient Steel Axe",false,false,1879061964};
Recipe[9][5][3][#Recipe[9][5][3]+1]={51,"Ancient Steel Blade",false,true,0};
Recipe[9][5][4][#Recipe[9][5][4]+1]={52,"Ancient Steel Blade (x5)",false,false,1879137552};
Recipe[9][5][9][#Recipe[9][5][9]+1]={56,"Ancient Steel Dagger",false,false,1879061965};
Recipe[9][5][9][#Recipe[9][5][9]+1]={59,"Ancient Steel Great Sword",false,false,1879061966};
Recipe[9][5][1][#Recipe[9][5][1]+1]={67,"Ancient Steel Serrated Knife",false,false,1879197223};
Recipe[9][5][9][#Recipe[9][5][9]+1]={69,"Ancient Steel Sword",false,false,1879061967};
Recipe[9][5][13][#Recipe[9][5][13]+1]={71,"Ancient Steel Throwing Axe",false,false,1879061968};
Recipe[9][5][1][#Recipe[9][5][1]+1]={72,"Ancient Steel Throwing Hatchet",false,false,1879197269};
Recipe[9][5][6][#Recipe[9][5][6]+1]={74,"Ancient-iron Bear Trap",false,false,1879091441};
Recipe[9][5][2][#Recipe[9][5][2]+1]={75,"Ancient-iron Caltrops",false,false,1879143422};
Recipe[9][5][6][#Recipe[9][5][6]+1]={76,"Ancient-iron Lure Trap",false,false,1879091438};
Recipe[9][5][2][#Recipe[9][5][2]+1]={77,"Ancient-iron Marbles",false,false,1879143414};
Recipe[9][5][6][#Recipe[9][5][6]+1]={78,"Ancient-iron Quick Trap",false,false,1879091424};
Recipe[9][5][6][#Recipe[9][5][6]+1]={79,"Ancient-iron Strong Trap",false,false,1879091426};
Recipe[9][5][2][#Recipe[9][5][2]+1]={80,"Ancient-iron Stun Dust",false,false,1879143457};
Recipe[9][5][6][#Recipe[9][5][6]+1]={81,"Ancient-iron Triple Trap",false,false,1879091434};
Recipe[9][5][6][#Recipe[9][5][6]+1]={82,"Ancient-iron Tripwire Trap",false,false,1879091442};
Recipe[9][5][14][#Recipe[9][5][14]+1]={393,"Ceremonial Blade",false,false,1879092721};
Recipe[9][5][5][#Recipe[9][5][5]+1]={649,"Deadly Shield-spike Kit",false,false,1879143442};
Recipe[9][5][3][#Recipe[9][5][3]+1]={796,"Elven Blade",false,true,0};
Recipe[9][5][4][#Recipe[9][5][4]+1]={797,"Elven Blade (x5)",false,false,1879137632};
Recipe[9][5][8][#Recipe[9][5][8]+1]={890,"Elven-steel Axe",false,true,0};
Recipe[9][5][8][#Recipe[9][5][8]+1]={891,"Elven-steel Dagger",false,true,0};
Recipe[9][5][8][#Recipe[9][5][8]+1]={892,"Elven-steel Great Sword",false,true,0};
Recipe[9][5][8][#Recipe[9][5][8]+1]={895,"Elven-steel Sword",false,true,0};
Recipe[9][5][12][#Recipe[9][5][12]+1]={896,"Elven-steel Throwing Axe",false,true,0};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1120,"Forged Elven-steel Axe",false,false,1879071343};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1121,"Forged Elven-steel Dagger",false,false,1879071342};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1122,"Forged Elven-steel Great Sword",false,false,1879071344};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1123,"Forged Elven-steel Halberd",false,false,1879071346};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1124,"Forged Elven-steel Headsman\'s Axe",false,false,1879071345};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1125,"Forged Elven-steel Mace",false,false,1879071347};
Recipe[9][5][10][#Recipe[9][5][10]+1]={1126,"Forged Elven-steel Sword",false,false,1879071341};
Recipe[9][5][3][#Recipe[9][5][3]+1]={1460,"Intricately Engraved Pommel",false,true,0};
Recipe[9][5][4][#Recipe[9][5][4]+1]={1461,"Intricately Engraved Pommel (x5)",false,false,1879137371};
Recipe[9][5][16][#Recipe[9][5][16]+1]={1559,"Large Master Emblem",false,false,1879125761};
Recipe[9][5][3][#Recipe[9][5][3]+1]={1582,"Leaf-pattern Hilt",false,true,0};
Recipe[9][5][4][#Recipe[9][5][4]+1]={1583,"Leaf-pattern Hilt (x5)",false,false,1879137599};
--Recipe[9][5][#Recipe[9][5]+1]={692,"Master Weaponsmith Expertise",false,false,1879184378};
Recipe[9][5][5][#Recipe[9][5][5]+1]={1777,"Master Westernesse Shield-spike Kit",false,false,1879143435};
Recipe[9][5][16][#Recipe[9][5][16]+1]={1827,"Medium Master Emblem",false,false,1879125903};
Recipe[9][5][15][#Recipe[9][5][15]+1]={1848,"Mestari-vimma",true,false,1879109643};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1867,"Mirrored Ancient Steel Axe",false,false,1879137459};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1868,"Mirrored Ancient Steel Dagger",false,false,1879137583};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1869,"Mirrored Ancient Steel Great Sword",false,false,1879137581};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1870,"Mirrored Ancient Steel Halberd",false,false,1879137255};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1871,"Mirrored Ancient Steel Headsman\'s Axe",false,false,1879137258};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1872,"Mirrored Ancient Steel Mace",false,false,1879137690};
Recipe[9][5][7][#Recipe[9][5][7]+1]={1873,"Mirrored Ancient Steel Sword",false,false,1879137699};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2054,"Polished Ancient Steel Axe",true,false,1879054922};
Recipe[9][5][11][#Recipe[9][5][11]+1]={3736,"Polished Ancient Steel Axe",true,false,1879091008};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2055,"Polished Ancient Steel Dagger",true,false,1879054921};
Recipe[9][5][11][#Recipe[9][5][11]+1]={3737,"Polished Ancient Steel Dagger",true,false,1879091043};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2056,"Polished Ancient Steel Great Sword",true,false,1879054923};
Recipe[9][5][11][#Recipe[9][5][11]+1]={3738,"Polished Ancient Steel Great Sword",true,false,1879091137};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2057,"Polished Ancient Steel Halberd",true,false,1879054925};
Recipe[9][5][11][#Recipe[9][5][11]+1]={3739,"Polished Ancient Steel Halberd",true,false,1879091071};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2059,"Polished Ancient Steel Headsman\'s Axe",true,false,1879054924};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2058,"Polished Ancient Steel Headsman's Axe",true,false,1879091012};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2060,"Polished Ancient Steel Mace",true,false,1879054926};
Recipe[9][5][11][#Recipe[9][5][11]+1]={3740,"Polished Ancient Steel Mace",true,false,1879091258};
Recipe[9][5][11][#Recipe[9][5][11]+1]={2061,"Polished Ancient Steel Sword",true,false,1879054920};
Recipe[9][5][11][#Recipe[9][5][11]+1]={3741,"Polished Ancient Steel Sword",true,false,1879091058};
Recipe[9][5][16][#Recipe[9][5][16]+1]={2771,"Small Master Emblem",false,false,1879125851};
Recipe[9][5][14][#Recipe[9][5][14]+1]={3247,"Warden's Sceptre",false,false,1879092698};

Recipe[9][6][5][#Recipe[9][6][5]+1]={396,"Ceremonial Dwarf-axe",false,false,1879166089};
Recipe[9][6][8][#Recipe[9][6][8]+1]={443,"Crafted Burglar's Dagger of the Third Age",false,false,1879144982};
Recipe[9][6][9][#Recipe[9][6][9]+1]={444,"Crafted Burglar's Dagger of the Third Age",false,false,1879165927};
Recipe[9][6][8][#Recipe[9][6][8]+1]={446,"Crafted Burglar's Mace of the Third Age",false,false,1879145045};
Recipe[9][6][9][#Recipe[9][6][9]+1]={445,"Crafted Burglar's Mace of the Third Age",false,false,1879165832};
Recipe[9][6][8][#Recipe[9][6][8]+1]={447,"Crafted Burglar's Sword of the Third Age",false,false,1879144925};
Recipe[9][6][9][#Recipe[9][6][9]+1]={448,"Crafted Burglar's Sword of the Third Age",false,false,1879165865};
Recipe[9][6][10][#Recipe[9][6][10]+1]={451,"Crafted Captain's Axe of the Third Age",false,false,1879144986};
Recipe[9][6][11][#Recipe[9][6][11]+1]={452,"Crafted Captain's Axe of the Third Age",false,false,1879165932};
Recipe[9][6][10][#Recipe[9][6][10]+1]={455,"Crafted Captain's Dagger of the Third Age",false,false,1879144961};
Recipe[9][6][11][#Recipe[9][6][11]+1]={456,"Crafted Captain's Dagger of the Third Age",false,false,1879165885};
Recipe[9][6][10][#Recipe[9][6][10]+1]={460,"Crafted Captain's Great Axe of the Third Age",false,false,1879145039};
Recipe[9][6][11][#Recipe[9][6][11]+1]={459,"Crafted Captain's Great Axe of the Third Age",false,false,1879165731};
Recipe[9][6][10][#Recipe[9][6][10]+1]={465,"Crafted Captain's Greatsword of the Third Age",false,false,1879144950};
Recipe[9][6][11][#Recipe[9][6][11]+1]={466,"Crafted Captain's Greatsword of the Third Age",false,false,1879165801};
Recipe[9][6][10][#Recipe[9][6][10]+1]={467,"Crafted Captain's Halberd of the Third Age",false,false,1879145028};
Recipe[9][6][11][#Recipe[9][6][11]+1]={468,"Crafted Captain's Halberd of the Third Age",false,false,1879165803};
Recipe[9][6][10][#Recipe[9][6][10]+1]={471,"Crafted Captain's Mace of the Third Age",false,false,1879144938};
Recipe[9][6][11][#Recipe[9][6][11]+1]={472,"Crafted Captain's Mace of the Third Age",false,false,1879165883};
Recipe[9][6][10][#Recipe[9][6][10]+1]={475,"Crafted Captain's Sword of the Third Age",false,false,1879144966};
Recipe[9][6][11][#Recipe[9][6][11]+1]={476,"Crafted Captain's Sword of the Third Age",false,false,1879165855};
Recipe[9][6][12][#Recipe[9][6][12]+1]={477,"Crafted Champion's Axe of the Third Age",false,false,1879144989};
Recipe[9][6][13][#Recipe[9][6][13]+1]={478,"Crafted Champion's Axe of the Third Age",false,false,1879165773};
Recipe[9][6][12][#Recipe[9][6][12]+1]={481,"Crafted Champion's Dagger of the Third Age",false,false,1879144937};
Recipe[9][6][13][#Recipe[9][6][13]+1]={482,"Crafted Champion's Dagger of the Third Age",false,false,1879165974};
Recipe[9][6][12][#Recipe[9][6][12]+1]={483,"Crafted Champion's Great Axe of the Third Age",false,false,1879144962};
Recipe[9][6][13][#Recipe[9][6][13]+1]={484,"Crafted Champion's Great Axe of the Third Age",false,false,1879165881};
Recipe[9][6][12][#Recipe[9][6][12]+1]={488,"Crafted Champion's Greatsword of the Third Age",false,false,1879145044};
Recipe[9][6][13][#Recipe[9][6][13]+1]={487,"Crafted Champion's Greatsword of the Third Age",false,false,1879165949};
Recipe[9][6][12][#Recipe[9][6][12]+1]={491,"Crafted Champion's Mace of the Third Age",false,false,1879144980};
Recipe[9][6][13][#Recipe[9][6][13]+1]={492,"Crafted Champion's Mace of the Third Age",false,false,1879165805};
Recipe[9][6][12][#Recipe[9][6][12]+1]={497,"Crafted Champion's Sword of the Third Age",false,false,1879145033};
Recipe[9][6][13][#Recipe[9][6][13]+1]={498,"Crafted Champion's Sword of the Third Age",false,false,1879165957};
Recipe[9][6][14][#Recipe[9][6][14]+1]={509,"Crafted Guardian's Axe of the Third Age",false,false,1879144936};
Recipe[9][6][15][#Recipe[9][6][15]+1]={510,"Crafted Guardian's Axe of the Third Age",false,false,1879165797};
Recipe[9][6][14][#Recipe[9][6][14]+1]={515,"Crafted Guardian's Dagger of the Third Age",false,false,1879144934};
Recipe[9][6][15][#Recipe[9][6][15]+1]={516,"Crafted Guardian's Dagger of the Third Age",false,false,1879165985};
Recipe[9][6][14][#Recipe[9][6][14]+1]={517,"Crafted Guardian's Great Axe of the Third Age",false,false,1879144954};
Recipe[9][6][15][#Recipe[9][6][15]+1]={518,"Crafted Guardian's Great Axe of the Third Age",false,false,1879165761};
Recipe[9][6][14][#Recipe[9][6][14]+1]={524,"Crafted Guardian's Greatsword of the Third Age",false,false,1879144983};
Recipe[9][6][15][#Recipe[9][6][15]+1]={523,"Crafted Guardian's Greatsword of the Third Age",false,false,1879165904};
Recipe[9][6][14][#Recipe[9][6][14]+1]={527,"Crafted Guardian's Mace of the Third Age",false,false,1879145040};
Recipe[9][6][15][#Recipe[9][6][15]+1]={528,"Crafted Guardian's Mace of the Third Age",false,false,1879165898};
Recipe[9][6][14][#Recipe[9][6][14]+1]={531,"Crafted Guardian's Sword of the Third Age",false,false,1879144922};
Recipe[9][6][15][#Recipe[9][6][15]+1]={532,"Crafted Guardian's Sword of the Third Age",false,false,1879165727};
Recipe[9][6][16][#Recipe[9][6][16]+1]={534,"Crafted Hunter's Axe of the Third Age",false,false,1879144944};
Recipe[9][6][17][#Recipe[9][6][17]+1]={535,"Crafted Hunter's Axe of the Third Age",false,false,1879165763};
Recipe[9][6][16][#Recipe[9][6][16]+1]={542,"Crafted Hunter's Dagger of the Third Age",false,false,1879144956};
Recipe[9][6][17][#Recipe[9][6][17]+1]={543,"Crafted Hunter's Dagger of the Third Age",false,false,1879165894};
Recipe[9][6][16][#Recipe[9][6][16]+1]={546,"Crafted Hunter's Mace of the Third Age",false,false,1879145027};
Recipe[9][6][17][#Recipe[9][6][17]+1]={547,"Crafted Hunter's Mace of the Third Age",false,false,1879165879};
Recipe[9][6][16][#Recipe[9][6][16]+1]={551,"Crafted Hunter's Sword of the Third Age",false,false,1879144970};
Recipe[9][6][17][#Recipe[9][6][17]+1]={550,"Crafted Hunter's Sword of the Third Age",false,false,1879165843};
Recipe[9][6][18][#Recipe[9][6][18]+1]={561,"Crafted Minstrel's Dagger of the Third Age",false,false,1879145015};
Recipe[9][6][19][#Recipe[9][6][19]+1]={562,"Crafted Minstrel's Dagger of the Third Age",false,false,1879165911};
Recipe[9][6][18][#Recipe[9][6][18]+1]={563,"Crafted Minstrel's Mace of the Third Age",false,false,1879144926};
Recipe[9][6][19][#Recipe[9][6][19]+1]={564,"Crafted Minstrel's Mace of the Third Age",false,false,1879165978};
Recipe[9][6][18][#Recipe[9][6][18]+1]={567,"Crafted Minstrel's Sword of the Third Age",false,false,1879144994};
Recipe[9][6][19][#Recipe[9][6][19]+1]={568,"Crafted Minstrel's Sword of the Third Age",false,false,1879165895};
Recipe[9][6][20][#Recipe[9][6][20]+1]={574,"Crafted Warden's Axe of the Third Age",false,false,1879175997};
Recipe[9][6][21][#Recipe[9][6][21]+1]={575,"Crafted Warden's Axe of the Third Age",false,false,1879176005};
Recipe[9][6][20][#Recipe[9][6][20]+1]={578,"Crafted Warden's Dagger of the Third Age",false,false,1879144932};
Recipe[9][6][21][#Recipe[9][6][21]+1]={579,"Crafted Warden's Dagger of the Third Age",false,false,1879165760};
Recipe[9][6][20][#Recipe[9][6][20]+1]={584,"Crafted Warden's Mace of the Third Age",false,false,1879144952};
Recipe[9][6][21][#Recipe[9][6][21]+1]={585,"Crafted Warden's Mace of the Third Age",false,false,1879165819};
Recipe[9][6][20][#Recipe[9][6][20]+1]={590,"Crafted Warden's Sword of the Third Age",false,false,1879145005};
Recipe[9][6][21][#Recipe[9][6][21]+1]={589,"Crafted Warden's Sword of the Third Age",false,false,1879165756};
Recipe[9][6][3][#Recipe[9][6][3]+1]={623,"Dark Bronze Blade",false,true,0};
Recipe[9][6][4][#Recipe[9][6][4]+1]={624,"Dark Bronze Blade (x5)",false,false,1879137719};
Recipe[9][6][3][#Recipe[9][6][3]+1]={625,"Dark Bronze Guard",false,true,0};
Recipe[9][6][4][#Recipe[9][6][4]+1]={626,"Dark Bronze Guard (x5)",false,false,1879137702};
Recipe[9][6][3][#Recipe[9][6][3]+1]={627,"Dark Bronze Hilt",false,true,0};
Recipe[9][6][4][#Recipe[9][6][4]+1]={628,"Dark Bronze Hilt (x5)",false,false,1879137530};
Recipe[9][6][3][#Recipe[9][6][3]+1]={631,"Dark Iron Blade",false,true,0};
Recipe[9][6][4][#Recipe[9][6][4]+1]={632,"Dark Iron Blade (x5)",false,false,1879137254};
Recipe[9][6][3][#Recipe[9][6][3]+1]={633,"Dark Iron Hilt",false,true,0};
Recipe[9][6][4][#Recipe[9][6][4]+1]={634,"Dark Iron Hilt (x5)",false,false,1879137281};
Recipe[9][6][3][#Recipe[9][6][3]+1]={635,"Dark Steel Guard",false,true,0};
Recipe[9][6][4][#Recipe[9][6][4]+1]={636,"Dark Steel Guard (x5)",false,false,1879137535};
Recipe[9][6][24][#Recipe[9][6][24]+1]={650,"Defender's Axe",false,false,1879107395};
Recipe[9][6][24][#Recipe[9][6][24]+1]={651,"Defender's Dagger",false,false,1879107340};
Recipe[9][6][24][#Recipe[9][6][24]+1]={652,"Defender's Great Axe",false,false,1879107414};
Recipe[9][6][24][#Recipe[9][6][24]+1]={653,"Defender's Great Sword",false,false,1879107407};
Recipe[9][6][24][#Recipe[9][6][24]+1]={654,"Defender's Halberd",false,false,1879107427};
Recipe[9][6][24][#Recipe[9][6][24]+1]={658,"Defender's Mace",false,false,1879107403};
Recipe[9][6][24][#Recipe[9][6][24]+1]={659,"Defender's Sword",false,false,1879107353};
Recipe[9][6][5][#Recipe[9][6][5]+1]={916,"Engraved Elf-blade",false,false,1879166106};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1087,"Flawless Galadhrim Axe",false,false,1879157193};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1088,"Flawless Galadhrim Dagger",false,false,1879157196};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1089,"Flawless Galadhrim Great Sword",false,false,1879157187};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1090,"Flawless Galadhrim Halberd",false,false,1879157208};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1091,"Flawless Galadhrim Headsman\'s Axe",false,false,1879157210};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1092,"Flawless Galadhrim Mace",false,false,1879157192};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1093,"Flawless Galadhrim Sword",false,false,1879157183};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1141,"Galadhrim Axe",true,false,1879154521};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1142,"Galadhrim Dagger",true,false,1879154537};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1143,"Galadhrim Great Sword",true,false,1879154552};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1146,"Galadhrim Halberd",true,false,1879154554};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1147,"Galadhrim Headsman\'s Axe",true,false,1879154516};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1148,"Galadhrim Mace",true,false,1879154528};
Recipe[9][6][27][#Recipe[9][6][27]+1]={1150,"Galadhrim Sword",true,false,1879154545};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1520,"Khaz"..string.char(195)..string.char(162).."d-iron Bear Trap",false,false,1879143423};
Recipe[9][6][2][#Recipe[9][6][2]+1]={1521,"Khaz"..string.char(195)..string.char(162).."d-iron Caltrops",false,false,1879143413};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1524,"Khaz"..string.char(195)..string.char(162).."d-iron Lure Trap",false,false,1879143417};
Recipe[9][6][2][#Recipe[9][6][2]+1]={1525,"Khaz"..string.char(195)..string.char(162).."d-iron Marbles",false,false,1879143434};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1526,"Khaz"..string.char(195)..string.char(162).."d-iron Quick Trap",false,false,1879143415};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1527,"Khaz"..string.char(195)..string.char(162).."d-iron Strong Trap",false,false,1879143447};
Recipe[9][6][2][#Recipe[9][6][2]+1]={1528,"Khaz"..string.char(195)..string.char(162).."d-iron Stun Dust",false,false,1879143401};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1529,"Khaz"..string.char(195)..string.char(162).."d-iron Triple Trap",false,false,1879143408};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1530,"Khaz"..string.char(195)..string.char(162).."d-iron Tripwire Trap",false,false,1879143456};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1531,"Khaz"..string.char(195)..string.char(162).."d-steel Bear Trap",false,false,1879182463};
Recipe[9][6][2][#Recipe[9][6][2]+1]={1532,"Khaz"..string.char(195)..string.char(162).."d-steel Caltrops",false,false,1879182439};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1535,"Khaz"..string.char(195)..string.char(162).."d-steel Lure Trap",false,false,1879182442};
Recipe[9][6][2][#Recipe[9][6][2]+1]={1536,"Khaz"..string.char(195)..string.char(162).."d-steel Marbles",false,false,1879182438};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1537,"Khaz"..string.char(195)..string.char(162).."d-steel Quick Trap",false,false,1879182437};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1538,"Khaz"..string.char(195)..string.char(162).."d-steel Strong Trap",false,false,1879182462};
Recipe[9][6][2][#Recipe[9][6][2]+1]={1539,"Khaz"..string.char(195)..string.char(162).."d-steel Stun Dust",false,false,1879182464};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1540,"Khaz"..string.char(195)..string.char(162).."d-steel Triple Trap",false,false,1879182440};
Recipe[9][6][7][#Recipe[9][6][7]+1]={1541,"Khaz"..string.char(195)..string.char(162).."d-steel Tripwire Trap",false,false,1879182443};
Recipe[9][6][29][#Recipe[9][6][29]+1]={1566,"Large Supreme Emblem",false,false,1879125906};
Recipe[9][6][6][#Recipe[9][6][6]+1]={1620,"Lethal Shield-spike Kit",false,false,1879143412};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1713,"Malledhrim Axe",false,false,1879163232};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1715,"Malledhrim Dagger",false,false,1879163202};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1717,"Malledhrim Great Axe",false,false,1879163227};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1718,"Malledhrim Great Sword",false,false,1879163272};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1719,"Malledhrim Halberd",false,false,1879163222};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1723,"Malledhrim Mace",false,false,1879163266};
Recipe[9][6][28][#Recipe[9][6][28]+1]={1725,"Malledhrim Sword",false,false,1879163243};
Recipe[9][6][29][#Recipe[9][6][29]+1]={1834,"Medium Supreme Emblem",false,false,1879125803};
Recipe[9][6][5][#Recipe[9][6][5]+1]={1917,"N"..string.char(195)..string.char(186).."men"..string.char(195)..string.char(179).."rean Sceptre",false,false,1879166099};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1993,"Peerless Thain\'s Axe",false,false,1879137490};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1994,"Peerless Thain\'s Dagger",false,false,1879137283};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1995,"Peerless Thain\'s Great Axe",false,false,1879137660};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1996,"Peerless Thain\'s Great Sword",false,false,1879137249};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1997,"Peerless Thain\'s Halberd",false,false,0};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1998,"Peerless Thain\'s Mace",false,false,1879137494};
Recipe[9][6][22][#Recipe[9][6][22]+1]={1999,"Peerless Thain\'s Sword",false,false,1879137400};
Recipe[9][6][8][#Recipe[9][6][8]+1]={2230,"Reforged Burglar's Dagger of the Second Age",false,false,1879162074};
Recipe[9][6][9][#Recipe[9][6][9]+1]={2229,"Reforged Burglar's Dagger of the Second Age",false,false,1879165847};
Recipe[9][6][8][#Recipe[9][6][8]+1]={2231,"Reforged Burglar's Mace of the Second Age",false,false,1879162157};
Recipe[9][6][9][#Recipe[9][6][9]+1]={2232,"Reforged Burglar's Mace of the Second Age",false,false,1879165744};
Recipe[9][6][8][#Recipe[9][6][8]+1]={2233,"Reforged Burglar's Sword of the Second Age",false,false,1879162212};
Recipe[9][6][9][#Recipe[9][6][9]+1]={2234,"Reforged Burglar's Sword of the Second Age",false,false,1879165837};
Recipe[9][6][10][#Recipe[9][6][10]+1]={2238,"Reforged Captain's Axe of the Second Age",false,false,1879162219};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2237,"Reforged Captain's Axe of the Second Age",false,false,1879165734};
Recipe[9][6][10][#Recipe[9][6][10]+1]={2241,"Reforged Captain's Dagger of the Second Age",false,false,1879162055};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2242,"Reforged Captain's Dagger of the Second Age",false,false,1879165782};
Recipe[9][6][10][#Recipe[9][6][10]+1]={2245,"Reforged Captain's Great Axe of the Second Age",false,false,1879162137};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2246,"Reforged Captain's Great Axe of the Second Age",false,false,1879165930};
Recipe[9][6][10][#Recipe[9][6][10]+1]={2251,"Reforged Captain's Greatsword of the Second Age",false,false,1879162081};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2252,"Reforged Captain's Greatsword of the Second Age",false,false,1879165738};
Recipe[9][6][10][#Recipe[9][6][10]+1]={2254,"Reforged Captain's Halberd of the Second Age",false,false,1879162230};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2253,"Reforged Captain's Halberd of the Second Age",false,false,1879165956};
Recipe[9][6][10][#Recipe[9][6][10]+1]={2257,"Reforged Captain's Mace of the Second Age",false,false,1879162145};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2258,"Reforged Captain's Mace of the Second Age",false,false,0}; -- lvl 65 version missing from lorebook
Recipe[9][6][10][#Recipe[9][6][10]+1]={2262,"Reforged Captain's Sword of the Second Age",false,false,1879162109};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2261,"Reforged Captain's Sword of the Second Age",false,false,1879165876};
Recipe[9][6][12][#Recipe[9][6][12]+1]={2264,"Reforged Champion's Axe of the Second Age",false,false,1879162057};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2263,"Reforged Champion's Axe of the Second Age",false,false,1879165907};
Recipe[9][6][12][#Recipe[9][6][12]+1]={2267,"Reforged Champion's Dagger of the Second Age",false,false,1879162085};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2268,"Reforged Champion's Dagger of the Second Age",false,false,1879165929};
Recipe[9][6][12][#Recipe[9][6][12]+1]={2270,"Reforged Champion's Great Axe of the Second Age",false,false,1879162166};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2269,"Reforged Champion's Great Axe of the Second Age",false,false,1879165733};
Recipe[9][6][12][#Recipe[9][6][12]+1]={2274,"Reforged Champion's Greatsword of the Second Age",false,false,1879162124};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2273,"Reforged Champion's Greatsword of the Second Age",false,false,1879165913};
Recipe[9][6][12][#Recipe[9][6][12]+1]={2277,"Reforged Champion's Mace of the Second Age",false,false,1879162128};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2278,"Reforged Champion's Mace of the Second Age",false,false,1879165800};
Recipe[9][6][12][#Recipe[9][6][12]+1]={2284,"Reforged Champion's Sword of the Second Age",false,false,1879162110};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2283,"Reforged Champion's Sword of the Second Age",false,false,1879165787};
Recipe[9][6][14][#Recipe[9][6][14]+1]={2288,"Reforged Guardian's Axe of the Second Age",false,false,1879162152};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2287,"Reforged Guardian's Axe of the Second Age",false,false,1879165784};
Recipe[9][6][14][#Recipe[9][6][14]+1]={2294,"Reforged Guardian's Dagger of the Second Age",false,false,1879162186};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2293,"Reforged Guardian's Dagger of the Second Age",false,false,1879165948};
Recipe[9][6][14][#Recipe[9][6][14]+1]={2295,"Reforged Guardian's Great Axe of the Second Age",false,false,1879162220};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2296,"Reforged Guardian's Great Axe of the Second Age",false,false,1879165776};
Recipe[9][6][14][#Recipe[9][6][14]+1]={2302,"Reforged Guardian's Greatsword of the Second Age",false,false,1879162058};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2301,"Reforged Guardian's Greatsword of the Second Age",false,false,1879165821};
Recipe[9][6][14][#Recipe[9][6][14]+1]={2306,"Reforged Guardian's Mace of the Second Age",false,false,1879162164};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2305,"Reforged Guardian's Mace of the Second Age",false,false,1879165981};
Recipe[9][6][14][#Recipe[9][6][14]+1]={2309,"Reforged Guardian's Sword of the Second Age",false,false,1879162086};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2310,"Reforged Guardian's Sword of the Second Age",false,false,1879165751};
Recipe[9][6][16][#Recipe[9][6][16]+1]={2312,"Reforged Hunter's Axe of the Second Age",false,false,1879162116};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2311,"Reforged Hunter's Axe of the Second Age",false,false,1879165730};
Recipe[9][6][16][#Recipe[9][6][16]+1]={2319,"Reforged Hunter's Dagger of the Second Age",false,false,1879162062};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2320,"Reforged Hunter's Dagger of the Second Age",false,false,1879165729};
Recipe[9][6][16][#Recipe[9][6][16]+1]={2323,"Reforged Hunter's Mace of the Second Age",false,false,1879162119};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2324,"Reforged Hunter's Mace of the Second Age",false,false,1879165854};
Recipe[9][6][16][#Recipe[9][6][16]+1]={2328,"Reforged Hunter's Sword of the Second Age",false,false,1879162199};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2327,"Reforged Hunter's Sword of the Second Age",false,false,1879165941};
Recipe[9][6][18][#Recipe[9][6][18]+1]={2337,"Reforged Minstrel's Dagger of the Second Age",false,false,1879162123};
Recipe[9][6][19][#Recipe[9][6][19]+1]={2338,"Reforged Minstrel's Dagger of the Second Age",false,false,1879165746};
Recipe[9][6][18][#Recipe[9][6][18]+1]={2340,"Reforged Minstrel's Mace of the Second Age",false,false,1879162144};
Recipe[9][6][19][#Recipe[9][6][19]+1]={2339,"Reforged Minstrel's Mace of the Second Age",false,false,1879165862};
Recipe[9][6][18][#Recipe[9][6][18]+1]={2343,"Reforged Minstrel's Sword of the Second Age",false,false,1879162242};
Recipe[9][6][19][#Recipe[9][6][19]+1]={2344,"Reforged Minstrel's Sword of the Second Age",false,false,1879165947};
Recipe[9][6][20][#Recipe[9][6][20]+1]={2349,"Reforged Warden's Axe of the Second Age",false,false,1879175995};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2350,"Reforged Warden's Axe of the Second Age",false,false,1879176006};
Recipe[9][6][20][#Recipe[9][6][20]+1]={2354,"Reforged Warden's Dagger of the Second Age",false,false,1879162237};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2353,"Reforged Warden's Dagger of the Second Age",false,false,1879165951};
Recipe[9][6][20][#Recipe[9][6][20]+1]={2360,"Reforged Warden's Mace of the Second Age",false,false,1879162122};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2359,"Reforged Warden's Mace of the Second Age",false,false,1879165798};
Recipe[9][6][20][#Recipe[9][6][20]+1]={2363,"Reforged Warden's Sword of the Second Age",false,false,1879162181};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2364,"Reforged Warden's Sword of the Second Age",false,false,1879165917};
Recipe[9][6][9][#Recipe[9][6][9]+1]={2396,"Reshaped Burglar's Dagger of the First Age",false,false,1879181490};
Recipe[9][6][9][#Recipe[9][6][9]+1]={2397,"Reshaped Burglar's Mace of the First Age",false,false,1879181551};
Recipe[9][6][9][#Recipe[9][6][9]+1]={2398,"Reshaped Burglar's Sword of the First Age",false,false,1879181542};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2400,"Reshaped Captain's Axe of the First Age",false,false,1879181546};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2402,"Reshaped Captain's Dagger of the First Age",false,false,1879181495};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2404,"Reshaped Captain's Great Axe of the First Age",false,false,1879181538};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2407,"Reshaped Captain's Greatsword of the First Age",false,false,1879181545};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2408,"Reshaped Captain's Halberd of the First Age",false,false,1879181550};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2410,"Reshaped Captain's Mace of the First Age",false,false,1879181510};
Recipe[9][6][11][#Recipe[9][6][11]+1]={2412,"Reshaped Captain's Sword of the First Age",false,false,1879181520};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2413,"Reshaped Champion's Axe of the First Age",false,false,1879181492};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2415,"Reshaped Champion's Dagger of the First Age",false,false,1879181498};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2416,"Reshaped Champion's Great Axe of the First Age",false,false,1879181516};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2418,"Reshaped Champion's Greatsword of the First Age",false,false,1879181544};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2420,"Reshaped Champion's Mace of the First Age",false,false,1879181514};
Recipe[9][6][13][#Recipe[9][6][13]+1]={2423,"Reshaped Champion's Sword of the First Age",false,false,1879181511};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2425,"Reshaped Guardian's Axe of the First Age",false,false,1879181528};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2428,"Reshaped Guardian's Dagger of the First Age",false,false,1879181524};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2429,"Reshaped Guardian's Great Axe of the First Age",false,false,1879181491};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2432,"Reshaped Guardian's Greatsword of the First Age",false,false,1879181532};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2434,"Reshaped Guardian's Mace of the First Age",false,false,1879181531};
Recipe[9][6][15][#Recipe[9][6][15]+1]={2436,"Reshaped Guardian's Sword of the First Age",false,false,1879181521};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2437,"Reshaped Hunter's Axe of the First Age",false,false,1879181547};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2441,"Reshaped Hunter's Dagger of the First Age",false,false,1879181548};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2443,"Reshaped Hunter's Mace of the First Age",false,false,1879181502};
Recipe[9][6][17][#Recipe[9][6][17]+1]={2445,"Reshaped Hunter's Sword of the First Age",false,false,1879181506};
Recipe[9][6][19][#Recipe[9][6][19]+1]={2450,"Reshaped Minstrel's Dagger of the First Age",false,false,1879181519};
Recipe[9][6][19][#Recipe[9][6][19]+1]={2451,"Reshaped Minstrel's Mace of the First Age",false,false,1879181552};
Recipe[9][6][19][#Recipe[9][6][19]+1]={2453,"Reshaped Minstrel's Sword of the First Age",false,false,1879181505};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2456,"Reshaped Warden's Axe of the First Age",false,false,1879181539};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2458,"Reshaped Warden's Dagger of the First Age",false,false,1879181549};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2461,"Reshaped Warden's Mace of the First Age",false,false,1879181530};
Recipe[9][6][21][#Recipe[9][6][21]+1]={2463,"Reshaped Warden's Sword of the First Age",false,false,1879181543};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2679,"Sellsword's Axe",false,true,0};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2681,"Sellsword's Dagger",false,true,0};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2683,"Sellsword's Great Axe",false,true,0};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2684,"Sellsword's Great Sword",false,true,0};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2685,"Sellsword's Halberd",false,true,0};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2690,"Sellsword's Mace",false,true,0};
Recipe[9][6][1][#Recipe[9][6][1]+1]={2691,"Sellsword's Serrated Knife",false,false,1879197242};
Recipe[9][6][23][#Recipe[9][6][23]+1]={2693,"Sellsword's Sword",false,true,0};
Recipe[9][6][1][#Recipe[9][6][1]+1]={2694,"Sellsword's Throwing Hatchet",false,false,1879197246};
Recipe[9][6][29][#Recipe[9][6][29]+1]={2778,"Small Supreme Emblem",false,false,1879125837};
Recipe[9][6][6][#Recipe[9][6][6]+1]={3072,"Supreme Ancient Dwarf Shield-spike Kit",false,false,1879143448};
--Recipe[9][6][#Recipe[9][6]+1]={699,"Supreme Weaponsmith Expertise",false,false,1879184375};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3155,"Thain\'s Axe",true,false,1879107389};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3156,"Thain\'s Dagger",true,false,1879107358};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3157,"Thain\'s Great Axe",true,false,1879107373};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3158,"Thain\'s Great Sword",true,false,1879107338};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3159,"Thain\'s Halberd",true,false,1879107336};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3160,"Thain\'s Mace",true,false,1879107398};
Recipe[9][6][26][#Recipe[9][6][26]+1]={3162,"Thain\'s Sword",true,false,1879107396};
Recipe[9][6][1][#Recipe[9][6][1]+1]={3161,"Thain's Serrated Knife",false,false,1879200772};
Recipe[9][6][1][#Recipe[9][6][1]+1]={3163,"Thain's Throwing Hatchet",false,false,1879200771};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3258,"Warrior's Axe",false,false,1879107406};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3262,"Warrior's Dagger",false,false,1879107374};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3264,"Warrior's Great Axe",false,false,1879107383};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3265,"Warrior's Great Sword",false,false,1879107339};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3266,"Warrior's Halberd",false,false,1879107334};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3269,"Warrior's Mace",false,false,1879107379};
Recipe[9][6][25][#Recipe[9][6][25]+1]={3271,"Warrior's Sword",false,false,1879107388};

Recipe[9][7][18][#Recipe[9][7][18]+1]={2464,"Axe of the Rider",true,false,1879211028};
Recipe[9][7][12][#Recipe[9][7][12]+1]={2465,"Axe of Th"..string.char(195)..string.char(169).."odred",false,false,1879210901};
Recipe[9][7][4][#Recipe[9][7][4]+1]={339,"Calenard Bear Trap",false,false,1879211025};
Recipe[9][7][2][#Recipe[9][7][2]+1]={340,"Calenard Caltrops",false,false,1879210933};
Recipe[9][7][13][#Recipe[9][7][13]+1]={3099,"Calenard Dagger",false,true,0};
Recipe[9][7][4][#Recipe[9][7][4]+1]={343,"Calenard Lure Trap",false,false,1879210889};
Recipe[9][7][2][#Recipe[9][7][2]+1]={344,"Calenard Marbles",false,false,1879210966};
Recipe[9][7][4][#Recipe[9][7][4]+1]={345,"Calenard Quick Trap",false,false,1879210984};
Recipe[9][7][1][#Recipe[9][7][1]+1]={347,"Calenard Serrated Knife",false,false,1879211012};
Recipe[9][7][4][#Recipe[9][7][4]+1]={348,"Calenard Strong Trap",false,false,1879210943};
Recipe[9][7][2][#Recipe[9][7][2]+1]={349,"Calenard Stun Dust",false,false,1879210987};
Recipe[9][7][13][#Recipe[9][7][13]+1]={1032,"Calenard Sword",false,true,0};
Recipe[9][7][1][#Recipe[9][7][1]+1]={350,"Calenard Throwing Hatchet",false,false,1879211110};
Recipe[9][7][4][#Recipe[9][7][4]+1]={351,"Calenard Triple Trap",false,false,1879210928};
Recipe[9][7][4][#Recipe[9][7][4]+1]={352,"Calenard Tripwire Trap",false,false,1879210899};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3437,"Crafted Burglar's Dagger of the Third Age",false,false,1879219825};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3438,"Crafted Burglar's Mace of the Third Age",false,false,1879219827};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3439,"Crafted Burglar's Sword of the Third Age",false,false,1879219750};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3440,"Crafted Captain's Axe of the Third Age",false,false,1879219821};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3441,"Crafted Captain's Dagger of the Third Age",false,false,1879219713};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3442,"Crafted Captain's Great Axe of the Third Age",false,false,1879219680};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3443,"Crafted Captain's Greatsword of the Third Age",false,false,1879219819};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3444,"Crafted Captain's Halberd of the Third Age",false,false,1879219826};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3445,"Crafted Captain's Mace of the Third Age",false,false,1879219828};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3446,"Crafted Captain's Sword of the Third Age",false,false,1879219797};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3447,"Crafted Champion's Axe of the Third Age",false,false,1879219820};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3448,"Crafted Champion's Dagger of the Third Age",false,false,1879219824};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3449,"Crafted Champion's Great Axe of the Third Age",false,false,1879219742};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3450,"Crafted Champion's Greatsword of the Third Age",false,false,1879219715};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3451,"Crafted Champion's Mace of the Third Age",false,false,1879219769};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3452,"Crafted Champion's Sword of the Third Age",false,false,1879219702};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3453,"Crafted Guardian's Axe of the Third Age",false,false,1879219714};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3454,"Crafted Guardian's Dagger of the Third Age",false,false,1879219692};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3455,"Crafted Guardian's Great Axe of the Third Age",false,false,1879219823};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3456,"Crafted Guardian's Greatsword of the Third Age",false,false,1879219818};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3457,"Crafted Guardian's Mace of the Third Age",false,false,1879219724};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3458,"Crafted Guardian's Sword of the Third Age",false,false,1879219682};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3459,"Crafted Hunter's Axe of the Third Age",false,false,1879219822};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3460,"Crafted Hunter's Dagger of the Third Age",false,false,1879219755};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3461,"Crafted Hunter's Mace of the Third Age",false,false,1879219829};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3462,"Crafted Hunter's Sword of the Third Age",false,false,1879219770};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3463,"Crafted Minstrel's Dagger of the Third Age",false,false,1879219671};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3464,"Crafted Minstrel's Mace of the Third Age",false,false,1879219734};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3465,"Crafted Minstrel's Sword of the Third Age",false,false,1879219817};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3466,"Crafted Warden's Axe of the Third Age",false,false,1879219681};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3467,"Crafted Warden's Dagger of the Third Age",false,false,1879219679};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3468,"Crafted Warden's Mace of the Third Age",false,false,1879219784};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3469,"Crafted Warden's Sword of the Third Age",false,false,1879219725};
Recipe[9][7][16][#Recipe[9][7][16]+1]={3425,"Curved Dagger",true,false,1879225833};
Recipe[9][7][18][#Recipe[9][7][18]+1]={2470,"Dagger of the Rider",true,false,1879210910};
Recipe[9][7][12][#Recipe[9][7][12]+1]={2471,"Dagger of Th"..string.char(195)..string.char(169).."odred",false,false,1879210988};
Recipe[9][7][15][#Recipe[9][7][15]+1]={2480,"Decorated Axe",false,false,1879211120};
Recipe[9][7][15][#Recipe[9][7][15]+1]={3100,"Decorated Mace",false,false,1879211100};
Recipe[9][7][17][#Recipe[9][7][17]+1]={1040,"Dunlending Dagger",false,false,1879210993};
Recipe[9][7][17][#Recipe[9][7][17]+1]={3101,"Dunlending Sword",false,false,1879211030};
Recipe[9][7][19][#Recipe[9][7][19]+1]={1573,"Large Westfold Emblem",false,false,1879211067};
Recipe[9][7][18][#Recipe[9][7][18]+1]={647,"Mace of the Rider",true,false,1879211108};
Recipe[9][7][12][#Recipe[9][7][12]+1]={648,"Mace of Th"..string.char(195)..string.char(169).."odred",false,false,1879210947};
Recipe[9][7][19][#Recipe[9][7][19]+1]={1841,"Medium Westfold Emblem",false,false,1879211015};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3470,"Reforged Burglar's Dagger of the Second Age",false,false,1879219690};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3471,"Reforged Burglar's Mace of the Second Age",false,false,1879219748};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3472,"Reforged Burglar's Sword of the Second Age",false,false,1879219678};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3473,"Reforged Captain's Axe of the Second Age",false,false,1879219832};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3474,"Reforged Captain's Dagger of the Second Age",false,false,1879219836};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3475,"Reforged Captain's Great Axe of the Second Age",false,false,1879219691};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3476,"Reforged Captain's Greatsword of the Second Age",false,false,1879219749};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3477,"Reforged Captain's Halberd of the Second Age",false,false,1879219838};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3478,"Reforged Captain's Mace of the Second Age",false,false,1879219840};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3479,"Reforged Captain's Sword of the Second Age",false,false,1879219732};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3480,"Reforged Champion's Axe of the Second Age",false,false,1879219831};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3481,"Reforged Champion's Dagger of the Second Age",false,false,1879219834};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3482,"Reforged Champion's Great Axe of the Second Age",false,false,1879219833};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3483,"Reforged Champion's Greatsword of the Second Age",false,false,1879219830};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3484,"Reforged Champion's Mace of the Second Age",false,false,1879219768};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3485,"Reforged Champion's Sword of the Second Age",false,false,1879219796};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3486,"Reforged Guardian's Axe of the Second Age",false,false,1879219782};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3487,"Reforged Guardian's Dagger of the Second Age",false,false,1879219835};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3488,"Reforged Guardian's Great Axe of the Second Age",false,false,1879219803};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3489,"Reforged Guardian's Greatsword of the Second Age",false,false,1879219783};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3490,"Reforged Guardian's Mace of the Second Age",false,false,1879219839};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3491,"Reforged Guardian's Sword of the Second Age",false,false,1879219733};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3492,"Reforged Hunter's Axe of the Second Age",false,false,1879219781};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3493,"Reforged Hunter's Dagger of the Second Age",false,false,1879219670};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3494,"Reforged Hunter's Mace of the Second Age",false,false,1879219747};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3495,"Reforged Hunter's Sword of the Second Age",false,false,1879219741};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3496,"Reforged Minstrel's Dagger of the Second Age",false,false,1879219701};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3497,"Reforged Minstrel's Mace of the Second Age",false,false,1879219841};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3498,"Reforged Minstrel's Sword of the Second Age",false,false,1879219795};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3499,"Reforged Warden's Axe of the Second Age",false,false,1879219794};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3500,"Reforged Warden's Dagger of the Second Age",false,false,1879219837};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3501,"Reforged Warden's Mace of the Second Age",false,false,1879219767};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3502,"Reforged Warden's Sword of the Second Age",false,false,1879219731};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3503,"Reshaped Burglar's Dagger of the First Age",false,false,1879219668};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3504,"Reshaped Burglar's Mace of the First Age",false,false,1879219695};
Recipe[9][7][5][#Recipe[9][7][5]+1]={3505,"Reshaped Burglar's Sword of the First Age",false,false,1879219697};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3506,"Reshaped Captain's Axe of the First Age",false,false,1879219712};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3507,"Reshaped Captain's Dagger of the First Age",false,false,1879219847};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3508,"Reshaped Captain's Great Axe of the First Age",false,false,1879219688};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3509,"Reshaped Captain's Greatsword of the First Age",false,false,1879219766};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3510,"Reshaped Captain's Halberd of the First Age",false,false,1879219850};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3511,"Reshaped Captain's Mace of the First Age",false,false,1879219802};
Recipe[9][7][6][#Recipe[9][7][6]+1]={3512,"Reshaped Captain's Sword of the First Age",false,false,1879219677};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3513,"Reshaped Champion's Axe of the First Age",false,false,1879219780};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3514,"Reshaped Champion's Dagger of the First Age",false,false,1879219846};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3515,"Reshaped Champion's Great Axe of the First Age",false,false,1879219845};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3516,"Reshaped Champion's Greatsword of the First Age",false,false,1879219842};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3517,"Reshaped Champion's Mace of the First Age",false,false,1879219851};
Recipe[9][7][7][#Recipe[9][7][7]+1]={3518,"Reshaped Champion's Sword of the First Age",false,false,1879219740};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3519,"Reshaped Guardian's Axe of the First Age",false,false,1879219843};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3520,"Reshaped Guardian's Dagger of the First Age",false,false,1879219687};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3521,"Reshaped Guardian's Great Axe of the First Age",false,false,1879219779};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3522,"Reshaped Guardian's Greatsword of the First Age",false,false,1879219696};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3523,"Reshaped Guardian's Mace of the First Age",false,false,1879219711};
Recipe[9][7][8][#Recipe[9][7][8]+1]={3524,"Reshaped Guardian's Sword of the First Age",false,false,1879219669};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3525,"Reshaped Hunter's Axe of the First Age",false,false,1879219700};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3526,"Reshaped Hunter's Dagger of the First Age",false,false,1879219848};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3527,"Reshaped Hunter's Mace of the First Age",false,false,1879219710};
Recipe[9][7][9][#Recipe[9][7][9]+1]={3528,"Reshaped Hunter's Sword of the First Age",false,false,1879219730};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3529,"Reshaped Minstrel's Dagger of the First Age",false,false,1879219765};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3530,"Reshaped Minstrel's Mace of the First Age",false,false,1879219667};
Recipe[9][7][10][#Recipe[9][7][10]+1]={3531,"Reshaped Minstrel's Sword of the First Age",false,false,1879219723};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3532,"Reshaped Warden's Axe of the First Age",false,false,1879219844};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3533,"Reshaped Warden's Dagger of the First Age",false,false,1879219849};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3534,"Reshaped Warden's Mace of the First Age",false,false,1879219852};
Recipe[9][7][11][#Recipe[9][7][11]+1]={3535,"Reshaped Warden's Sword of the First Age",false,false,1879219689};
Recipe[9][7][16][#Recipe[9][7][16]+1]={3434,"Straight Sword",true,false,1879225825};
Recipe[9][7][16][#Recipe[9][7][16]+1]={2748,"Singed Sword",true,false,1879220267};
Recipe[9][7][19][#Recipe[9][7][19]+1]={2785,"Small Westfold Emblem",false,false,1879211058};
Recipe[9][7][4][#Recipe[9][7][4]+1]={3029,"Superior Calenard Bear Trap",false,false,1879210964};
Recipe[9][7][2][#Recipe[9][7][2]+1]={3030,"Superior Calenard Caltrops",false,false,1879211112};
Recipe[9][7][4][#Recipe[9][7][4]+1]={3032,"Superior Calenard Lure Trap",false,false,1879210953};
Recipe[9][7][2][#Recipe[9][7][2]+1]={3033,"Superior Calenard Marbles",false,false,1879211045};
Recipe[9][7][4][#Recipe[9][7][4]+1]={3034,"Superior Calenard Quick Trap",false,false,1879210931};
Recipe[9][7][1][#Recipe[9][7][1]+1]={3036,"Superior Calenard Serrated Knife",false,false,1879211065};
Recipe[9][7][4][#Recipe[9][7][4]+1]={3037,"Superior Calenard Strong Trap",false,false,1879210876};
Recipe[9][7][2][#Recipe[9][7][2]+1]={3038,"Superior Calenard Stun Dust",false,false,1879210917};
Recipe[9][7][4][#Recipe[9][7][4]+1]={3039,"Superior Calenard Triple Trap",false,false,1879210971};
Recipe[9][7][4][#Recipe[9][7][4]+1]={3040,"Superior Calenard Tripwire Trap",false,false,1879211068};
Recipe[9][7][18][#Recipe[9][7][18]+1]={2855,"Sword of the Rider",true,false,1879211118};
Recipe[9][7][12][#Recipe[9][7][12]+1]={2856,"Sword of Th"..string.char(195)..string.char(169).."odred",false,false,1879210946};
Recipe[9][7][14][#Recipe[9][7][14]+1]={3238,"Westfold Axe",false,false,1879210902};
Recipe[9][7][3][#Recipe[9][7][3]+1]={3307,"Westfold Beleriand Shield-spike Kit",false,false,1879211053};
Recipe[9][7][14][#Recipe[9][7][14]+1]={1051,"Westfold Mace",false,false,1879211078};
Recipe[9][7][3][#Recipe[9][7][3]+1]={3321,"Westfold Shield-spike Kit",false,false,1879211002};

--Recipe[10][1][#Recipe[10][1]+1]={665,"Apprentice Woodworker Expertise",false,false,1879184368};
Recipe[10][1][6][#Recipe[10][1][6]+1]={1373,"Heavy Rowan Bow",false,false,1879066706};
Recipe[10][1][4][#Recipe[10][1][4]+1]={1374,"Heavy Rowan Club",false,false,1879114037};
Recipe[10][1][6][#Recipe[10][1][6]+1]={1375,"Heavy Rowan Crossbow",false,false,1879066707};
Recipe[10][1][4][#Recipe[10][1][4]+1]={1376,"Heavy Rowan Great Club",false,false,1879113950};
Recipe[10][1][4][#Recipe[10][1][4]+1]={1377,"Heavy Rowan Hammer",false,false,1879066709};
Recipe[10][1][6][#Recipe[10][1][6]+1]={1378,"Heavy Rowan Javelin",false,false,1879113346};
Recipe[10][1][4][#Recipe[10][1][4]+1]={1379,"Heavy Rowan Spear",false,false,1879067216};
Recipe[10][1][4][#Recipe[10][1][4]+1]={1380,"Heavy Rowan Staff",false,false,1879066708};
Recipe[10][1][2][#Recipe[10][1][2]+1]={1637,"Long Dwarf-make Table",false,false,1879102047};
Recipe[10][1][5][#Recipe[10][1][5]+1]={2538,"Rowan Bow",false,true,0};
Recipe[10][1][1][#Recipe[10][1][1]+1]={2539,"Rowan Bowstaff",false,true,0};
Recipe[10][1][1][#Recipe[10][1][1]+1]={2540,"Rowan Brace",false,true,0};
Recipe[10][1][3][#Recipe[10][1][3]+1]={2542,"Rowan Club",false,true,0};
Recipe[10][1][5][#Recipe[10][1][5]+1]={2543,"Rowan Crossbow",false,true,0};
Recipe[10][1][3][#Recipe[10][1][3]+1]={2544,"Rowan Great Club",false,true,0};
Recipe[10][1][1][#Recipe[10][1][1]+1]={2545,"Rowan Haft",false,true,0};
Recipe[10][1][3][#Recipe[10][1][3]+1]={2546,"Rowan Hammer",false,true,0};
Recipe[10][1][5][#Recipe[10][1][5]+1]={2547,"Rowan Javelin",false,true,0};
Recipe[10][1][3][#Recipe[10][1][3]+1]={2548,"Rowan Spear",false,true,0};
Recipe[10][1][3][#Recipe[10][1][3]+1]={2549,"Rowan Staff",false,true,0};

Recipe[10][2][10][#Recipe[10][2][10]+1]={103,"Ash Bow",false,true,0};
Recipe[10][2][2][#Recipe[10][2][2]+1]={104,"Ash Bowstaff",false,true,0};
Recipe[10][2][2][#Recipe[10][2][2]+1]={105,"Ash Brace",false,true,0};
Recipe[10][2][4][#Recipe[10][2][4]+1]={107,"Ash Club",false,true,0};
Recipe[10][2][10][#Recipe[10][2][10]+1]={108,"Ash Crossbow",false,true,0};
Recipe[10][2][4][#Recipe[10][2][4]+1]={109,"Ash Great Club",false,true,0};
Recipe[10][2][2][#Recipe[10][2][2]+1]={110,"Ash Haft",false,true,0};
Recipe[10][2][4][#Recipe[10][2][4]+1]={111,"Ash Hammer",false,true,0};
Recipe[10][2][1][#Recipe[10][2][1]+1]={112,"Ash Horn",false,false,1879068116};
Recipe[10][2][10][#Recipe[10][2][10]+1]={113,"Ash Javelin",false,true,0};
Recipe[10][2][2][#Recipe[10][2][2]+1]={114,"Ash Shaft",false,true,0};
Recipe[10][2][4][#Recipe[10][2][4]+1]={115,"Ash Spear",false,true,0};
Recipe[10][2][4][#Recipe[10][2][4]+1]={116,"Ash Staff",false,true,0};
Recipe[10][2][15][#Recipe[10][2][15]+1]={165,"Battle Hymn of the Five Armies",false,false,1879197272};
Recipe[10][2][12][#Recipe[10][2][12]+1]={1280,"Heavy Ash Bow",false,false,1879067217};
Recipe[10][2][6][#Recipe[10][2][6]+1]={1281,"Heavy Ash Club",false,false,1879113972};
Recipe[10][2][12][#Recipe[10][2][12]+1]={1282,"Heavy Ash Crossbow",false,false,1879067218};
Recipe[10][2][6][#Recipe[10][2][6]+1]={1283,"Heavy Ash Great Club",false,false,1879114051};
Recipe[10][2][6][#Recipe[10][2][6]+1]={1284,"Heavy Ash Hammer",false,false,1879067221};
Recipe[10][2][12][#Recipe[10][2][12]+1]={1285,"Heavy Ash Javelin",false,false,1879113415};
Recipe[10][2][6][#Recipe[10][2][6]+1]={1286,"Heavy Ash Spear",false,false,1879067220};
Recipe[10][2][6][#Recipe[10][2][6]+1]={1287,"Heavy Ash Staff",false,false,1879067219};
Recipe[10][2][14][#Recipe[10][2][14]+1]={1494,"Journeyman Nestad Infused Parchment",false,false,1879197271};
--Recipe[10][2][#Recipe[10][2]+1]={686,"Journeyman Woodworker Expertise",false,false,1879184383};
Recipe[10][2][16][#Recipe[10][2][16]+1]={1855,"Minor Fist Carving",false,false,1879153391};
Recipe[10][2][16][#Recipe[10][2][16]+1]={1859,"Minor Shield Carving",false,false,1879153440};
Recipe[10][2][16][#Recipe[10][2][16]+1]={1861,"Minor Spear Carving",false,false,1879153422};
Recipe[10][2][15][#Recipe[10][2][15]+1]={2193,"Rallying Hymn of the Five Armies",false,false,1879199781};
Recipe[10][2][3][#Recipe[10][2][3]+1]={2593,"Scholar's Small Bentwood Bookshelf",false,false,1879101791};
Recipe[10][2][8][#Recipe[10][2][8]+1]={2740,"Simple Drum",false,false,1879088778};
Recipe[10][2][8][#Recipe[10][2][8]+1]={2741,"Simple Flute",false,false,1879069432};
Recipe[10][2][8][#Recipe[10][2][8]+1]={2742,"Simple Harp",false,false,1879069431};
Recipe[10][2][8][#Recipe[10][2][8]+1]={2745,"Simple Lute",false,false,1879069430};
Recipe[10][2][8][#Recipe[10][2][8]+1]={2747,"Simple Theorbo",false,false,1879088785};
Recipe[10][2][13][#Recipe[10][2][13]+1]={2790,"Smooth Ash Bow",true,false,1879068168};
Recipe[10][2][13][#Recipe[10][2][13]+1]={3774,"Smooth Ash Bow",true,false,1879091157};
Recipe[10][2][7][#Recipe[10][2][7]+1]={2791,"Smooth Ash Club",true,false,1879114009};
Recipe[10][2][13][#Recipe[10][2][13]+1]={2792,"Smooth Ash Crossbow",true,false,1879068169};
Recipe[10][2][13][#Recipe[10][2][13]+1]={3775,"Smooth Ash Crossbow",true,false,1879091167};
Recipe[10][2][7][#Recipe[10][2][7]+1]={2793,"Smooth Ash Great Club",true,false,1879114010};
Recipe[10][2][7][#Recipe[10][2][7]+1]={2794,"Smooth Ash Hammer",true,false,1879068172};
Recipe[10][2][7][#Recipe[10][2][7]+1]={3776,"Smooth Ash Hammer",true,false,1879091290};
Recipe[10][2][13][#Recipe[10][2][13]+1]={2795,"Smooth Ash Javelin",true,false,1879113397};
Recipe[10][2][7][#Recipe[10][2][7]+1]={2796,"Smooth Ash Spear",true,false,1879068171};
Recipe[10][2][7][#Recipe[10][2][7]+1]={3777,"Smooth Ash Spear",true,false,1879091135};
Recipe[10][2][7][#Recipe[10][2][7]+1]={2797,"Smooth Ash Staff",true,false,1879068170};
Recipe[10][2][7][#Recipe[10][2][7]+1]={3778,"Smooth Ash Staff",true,false,1879091159};
Recipe[10][2][15][#Recipe[10][2][15]+1]={2830,"Soothing Hymn of the Five Armies",false,false,1879199812};
Recipe[10][2][11][#Recipe[10][2][11]+1]={2895,"Stout Ash Bow",false,false,1879062626};
Recipe[10][2][5][#Recipe[10][2][5]+1]={2896,"Stout Ash Club",false,false,1879113985};
Recipe[10][2][11][#Recipe[10][2][11]+1]={2897,"Stout Ash Crossbow",false,false,1879062627};
Recipe[10][2][5][#Recipe[10][2][5]+1]={2898,"Stout Ash Great Club",false,false,1879113987};
Recipe[10][2][5][#Recipe[10][2][5]+1]={2899,"Stout Ash Hammer",false,false,1879062630};
Recipe[10][2][11][#Recipe[10][2][11]+1]={2900,"Stout Ash Javelin",false,false,1879113340};
Recipe[10][2][5][#Recipe[10][2][5]+1]={2901,"Stout Ash Spear",false,false,1879062629};
Recipe[10][2][5][#Recipe[10][2][5]+1]={2902,"Stout Ash Staff",false,false,1879062628};
Recipe[10][2][9][#Recipe[10][2][9]+1]={3206,"Twistwood Staff",true,false,1879062671};

Recipe[10][3][17][#Recipe[10][3][17]+1]={375,"Carved Yew Bow",true,false,1879069960};
Recipe[10][3][17][#Recipe[10][3][17]+1]={3742,"Carved Yew Bow",true,false,1879091223};
Recipe[10][3][11][#Recipe[10][3][11]+1]={376,"Carved Yew Club",true,false,1879114042};
Recipe[10][3][17][#Recipe[10][3][17]+1]={377,"Carved Yew Crossbow",true,false,1879069961};
Recipe[10][3][17][#Recipe[10][3][17]+1]={3743,"Carved Yew Crossbow",true,false,1879091134};
Recipe[10][3][11][#Recipe[10][3][11]+1]={378,"Carved Yew Great Club",true,false,1879113941};
Recipe[10][3][11][#Recipe[10][3][11]+1]={379,"Carved Yew Hammer",true,false,1879069964};
Recipe[10][3][11][#Recipe[10][3][11]+1]={3744,"Carved Yew Hammer",true,false,1879091123};
Recipe[10][3][17][#Recipe[10][3][17]+1]={380,"Carved Yew Javelin",true,false,1879113393};
Recipe[10][3][11][#Recipe[10][3][11]+1]={381,"Carved Yew Spear",true,false,1879069963};
Recipe[10][3][11][#Recipe[10][3][11]+1]={3745,"Carved Yew Spear",true,false,1879091023};
Recipe[10][3][11][#Recipe[10][3][11]+1]={382,"Carved Yew Staff",true,false,1879069962};
Recipe[10][3][11][#Recipe[10][3][11]+1]={3746,"Carved Yew Staff",true,false,1879091028};
Recipe[10][3][12][#Recipe[10][3][12]+1]={499,"Crafted Drum",false,false,1879088779};
Recipe[10][3][12][#Recipe[10][3][12]+1]={508,"Crafted Flute",false,false,1879069908};
Recipe[10][3][12][#Recipe[10][3][12]+1]={533,"Crafted Harp",false,false,1879069907};
Recipe[10][3][12][#Recipe[10][3][12]+1]={558,"Crafted Lute",false,false,1879069906};
Recipe[10][3][12][#Recipe[10][3][12]+1]={573,"Crafted Theorbo",false,false,1879088780};
Recipe[10][3][15][#Recipe[10][3][15]+1]={944,"Etched Yew Bow",false,false,1879062647};
Recipe[10][3][3][#Recipe[10][3][3]+1]={945,"Etched Yew Brace",false,true,0};
Recipe[10][3][4][#Recipe[10][3][4]+1]={946,"Etched Yew Brace (x5)",false,false,1879137649};
Recipe[10][3][9][#Recipe[10][3][9]+1]={947,"Etched Yew Club",false,false,1879114014};
Recipe[10][3][15][#Recipe[10][3][15]+1]={948,"Etched Yew Crossbow",false,false,1879062648};
Recipe[10][3][9][#Recipe[10][3][9]+1]={949,"Etched Yew Great Club",false,false,1879114000};
Recipe[10][3][9][#Recipe[10][3][9]+1]={950,"Etched Yew Hammer",false,false,1879062651};
Recipe[10][3][15][#Recipe[10][3][15]+1]={951,"Etched Yew Javelin",false,false,1879113442};
Recipe[10][3][3][#Recipe[10][3][3]+1]={952,"Etched Yew Shaft",false,true,0};
Recipe[10][3][4][#Recipe[10][3][4]+1]={953,"Etched Yew Shaft (x5)",false,false,1879137652};
Recipe[10][3][9][#Recipe[10][3][9]+1]={954,"Etched Yew Spear",false,false,1879062650};
Recipe[10][3][9][#Recipe[10][3][9]+1]={955,"Etched Yew Staff",false,false,1879062649};
Recipe[10][3][1][#Recipe[10][3][1]+1]={964,"Expert Blazoned Crest",false,false,1879197273};
Recipe[10][3][18][#Recipe[10][3][18]+1]={965,"Expert Dagor Infused Parchment",false,false,1879197245};
Recipe[10][3][18][#Recipe[10][3][18]+1]={966,"Expert Nestad Infused Parchment",false,false,1879197244};
--Recipe[10][3][#Recipe[10][3]+1]={679,"Expert Woodworker Expertise",false,false,1879184379};
Recipe[10][3][16][#Recipe[10][3][16]+1]={1384,"Heavy Yew Bow",false,false,1879069460};
Recipe[10][3][10][#Recipe[10][3][10]+1]={1385,"Heavy Yew Club",false,false,1879113923};
Recipe[10][3][16][#Recipe[10][3][16]+1]={1386,"Heavy Yew Crossbow",false,false,1879069461};
Recipe[10][3][10][#Recipe[10][3][10]+1]={1387,"Heavy Yew Great Club",false,false,1879114032};
Recipe[10][3][10][#Recipe[10][3][10]+1]={1388,"Heavy Yew Hammer",false,false,1879069464};
Recipe[10][3][16][#Recipe[10][3][16]+1]={1389,"Heavy Yew Javelin",false,false,1879113479};
Recipe[10][3][10][#Recipe[10][3][10]+1]={1390,"Heavy Yew Spear",false,false,1879069463};
Recipe[10][3][10][#Recipe[10][3][10]+1]={1391,"Heavy Yew Staff",false,false,1879069462};
Recipe[10][3][19][#Recipe[10][3][19]+1]={1614,"Lesser Fist Carving",false,false,1879153414};
Recipe[10][3][19][#Recipe[10][3][19]+1]={1618,"Lesser Shield Carving",false,false,1879153384};
Recipe[10][3][19][#Recipe[10][3][19]+1]={1619,"Lesser Spear Carving",false,false,1879153419};
Recipe[10][3][20][#Recipe[10][3][20]+1]={1818,"Medium Expert Carving",false,false,1879125753};
Recipe[10][3][13][#Recipe[10][3][13]+1]={1959,"Ornate Yew Bow",false,false,1879137523};
Recipe[10][3][7][#Recipe[10][3][7]+1]={1960,"Ornate Yew Club",false,false,1879137619};
Recipe[10][3][13][#Recipe[10][3][13]+1]={1961,"Ornate Yew Crossbow",false,false,1879137474};
Recipe[10][3][7][#Recipe[10][3][7]+1]={1962,"Ornate Yew Great Club",false,false,1879137341};
Recipe[10][3][7][#Recipe[10][3][7]+1]={1963,"Ornate Yew Hammer",false,false,1879137326};
Recipe[10][3][13][#Recipe[10][3][13]+1]={1964,"Ornate Yew Javelin",false,false,1879137587};
Recipe[10][3][7][#Recipe[10][3][7]+1]={1965,"Ornate Yew Spear",false,false,1879137442};
Recipe[10][3][7][#Recipe[10][3][7]+1]={1966,"Ornate Yew Staff",false,false,1879137522};
Recipe[10][3][5][#Recipe[10][3][5]+1]={2212,"Red Scholar's Bookshelf",false,false,1879101782};
Recipe[10][3][5][#Recipe[10][3][5]+1]={2580,"Scholar's Bentwood Bookshelf",false,false,1879101786};
Recipe[10][3][5][#Recipe[10][3][5]+1]={2584,"Scholar's Pointed Bookshelf",false,false,1879101802};
Recipe[10][3][20][#Recipe[10][3][20]+1]={2761,"Small Expert Carving",false,false,1879125883};
Recipe[10][3][14][#Recipe[10][3][14]+1]={3353,"Yew Bow",false,true,0};
Recipe[10][3][3][#Recipe[10][3][3]+1]={3355,"Yew Bowstaff",false,true,0};
Recipe[10][3][4][#Recipe[10][3][4]+1]={3354,"Yew Bowstaff (x5)",false,false,1879137559};
Recipe[10][3][8][#Recipe[10][3][8]+1]={3357,"Yew Club",false,true,0};
Recipe[10][3][14][#Recipe[10][3][14]+1]={3358,"Yew Crossbow",false,true,0};
Recipe[10][3][6][#Recipe[10][3][6]+1]={3359,"Yew Fishing Rod",false,false,1879110379};
Recipe[10][3][8][#Recipe[10][3][8]+1]={3360,"Yew Great Club",false,true,0};
Recipe[10][3][3][#Recipe[10][3][3]+1]={3361,"Yew Haft",false,true,0};
Recipe[10][3][4][#Recipe[10][3][4]+1]={3362,"Yew Haft (x5)",false,false,1879137282};
Recipe[10][3][8][#Recipe[10][3][8]+1]={3363,"Yew Hammer",false,true,0};
Recipe[10][3][2][#Recipe[10][3][2]+1]={3364,"Yew Horn",false,false,1879069909};
Recipe[10][3][14][#Recipe[10][3][14]+1]={3365,"Yew Javelin",false,true,0};
Recipe[10][3][8][#Recipe[10][3][8]+1]={3366,"Yew Spear",false,true,0};
Recipe[10][3][8][#Recipe[10][3][8]+1]={3367,"Yew Staff",false,true,0};

Recipe[10][4][1][#Recipe[10][4][1]+1]={96,"Artisan Blazoned Crest",false,false,1879197222};
Recipe[10][4][20][#Recipe[10][4][20]+1]={97,"Artisan Dagor Infused Parchment",false,false,1879197227};
Recipe[10][4][20][#Recipe[10][4][20]+1]={98,"Artisan Nestad Infused Parchment",false,false,1879197216};
--Recipe[10][4][#Recipe[10][4]+1]={672,"Artisan Woodworker Expertise",false,false,1879184374};
Recipe[10][4][21][#Recipe[10][4][21]+1]={164,"Battle Hymn of Barad-d"..string.char(195)..string.char(187).."r",false,false,1879197274};
Recipe[10][4][14][#Recipe[10][4][14]+1]={260,"Bow of Shadowy Might",true,false,1879076404};
Recipe[10][4][19][#Recipe[10][4][19]+1]={366,"Carved Lebethron Bow",true,false,1879070429};
Recipe[10][4][19][#Recipe[10][4][19]+1]={3747,"Carved Lebethron Bow",true,false,1879091038};
Recipe[10][4][11][#Recipe[10][4][11]+1]={367,"Carved Lebethron Club",true,false,1879113958};
Recipe[10][4][19][#Recipe[10][4][19]+1]={368,"Carved Lebethron Crossbow",true,false,1879070430};
Recipe[10][4][19][#Recipe[10][4][19]+1]={3748,"Carved Lebethron Crossbow",true,false,1879091044};
Recipe[10][4][11][#Recipe[10][4][11]+1]={369,"Carved Lebethron Great Club",true,false,1879113926};
Recipe[10][4][11][#Recipe[10][4][11]+1]={370,"Carved Lebethron Hammer",true,false,1879070433};
Recipe[10][4][11][#Recipe[10][4][11]+1]={3749,"Carved Lebethron Hammer",true,false,1879091081};
Recipe[10][4][19][#Recipe[10][4][19]+1]={371,"Carved Lebethron Javelin",true,false,1879113391};
Recipe[10][4][11][#Recipe[10][4][11]+1]={372,"Carved Lebethron Spear",true,false,1879070432};
Recipe[10][4][11][#Recipe[10][4][11]+1]={3750,"Carved Lebethron Spear",true,false,1879091204};
Recipe[10][4][11][#Recipe[10][4][11]+1]={373,"Carved Lebethron Staff",true,false,1879070431};
Recipe[10][4][11][#Recipe[10][4][11]+1]={3751,"Carved Lebethron Staff",true,false,1879091181};
Recipe[10][4][22][#Recipe[10][4][22]+1]={1082,"Fist Carving",false,false,1879153412};
Recipe[10][4][16][#Recipe[10][4][16]+1]={1594,"Lebethron Bow",false,true,0};
Recipe[10][4][3][#Recipe[10][4][3]+1]={1595,"Lebethron Bowstaff",false,true,0};
Recipe[10][4][4][#Recipe[10][4][4]+1]={1596,"Lebethron Bowstaff (x5)",false,false,1879137274};
Recipe[10][4][8][#Recipe[10][4][8]+1]={1598,"Lebethron Club",false,true,0};
Recipe[10][4][16][#Recipe[10][4][16]+1]={1599,"Lebethron Crossbow",false,true,0};
Recipe[10][4][6][#Recipe[10][4][6]+1]={1600,"Lebethron Fishing Rod",false,false,1879110377};
Recipe[10][4][8][#Recipe[10][4][8]+1]={1601,"Lebethron Great Club",false,true,0};
Recipe[10][4][3][#Recipe[10][4][3]+1]={1602,"Lebethron Haft",false,true,0};
Recipe[10][4][4][#Recipe[10][4][4]+1]={1603,"Lebethron Haft (x5)",false,false,1879137537};
Recipe[10][4][8][#Recipe[10][4][8]+1]={1604,"Lebethron Hammer",false,true,0};
Recipe[10][4][2][#Recipe[10][4][2]+1]={1605,"Lebethron Horn",false,false,1879070383};
Recipe[10][4][16][#Recipe[10][4][16]+1]={1606,"Lebethron Javelin",false,true,0};
Recipe[10][4][8][#Recipe[10][4][8]+1]={1607,"Lebethron Spear",false,true,0};
Recipe[10][4][8][#Recipe[10][4][8]+1]={1608,"Lebethron Staff",false,true,0};
Recipe[10][4][23][#Recipe[10][4][23]+1]={1811,"Medium Artisan Carving",false,false,1879125744};
Recipe[10][4][15][#Recipe[10][4][15]+1]={1951,"Ornate Lebethron Bow",false,false,1879137596};
Recipe[10][4][7][#Recipe[10][4][7]+1]={1952,"Ornate Lebethron Club",false,false,1879137517};
Recipe[10][4][15][#Recipe[10][4][15]+1]={1953,"Ornate Lebethron Crossbow",false,false,1879137270};
Recipe[10][4][7][#Recipe[10][4][7]+1]={1954,"Ornate Lebethron Great Club",false,false,1879137492};
Recipe[10][4][7][#Recipe[10][4][7]+1]={1955,"Ornate Lebethron Hammer",false,false,1879137637};
Recipe[10][4][15][#Recipe[10][4][15]+1]={1956,"Ornate Lebethron Javelin",false,false,1879137715};
Recipe[10][4][7][#Recipe[10][4][7]+1]={1957,"Ornate Lebethron Spear",false,false,1879137642};
Recipe[10][4][7][#Recipe[10][4][7]+1]={1958,"Ornate Lebethron Staff",false,false,1879137357};
Recipe[10][4][21][#Recipe[10][4][21]+1]={2192,"Rallying Hymn of Barad-d"..string.char(195)..string.char(187).."r",false,false,1879199798};
Recipe[10][4][17][#Recipe[10][4][17]+1]={2376,"Reinforced Lebethron Bow",false,false,1879076464};
Recipe[10][4][3][#Recipe[10][4][3]+1]={2377,"Reinforced Lebethron Brace",false,true,0};
Recipe[10][4][4][#Recipe[10][4][4]+1]={2378,"Reinforced Lebethron Brace (x5)",false,false,1879137244};
Recipe[10][4][9][#Recipe[10][4][9]+1]={2379,"Reinforced Lebethron Club",false,false,1879113984};
Recipe[10][4][17][#Recipe[10][4][17]+1]={2380,"Reinforced Lebethron Crossbow",false,false,1879076465};
Recipe[10][4][9][#Recipe[10][4][9]+1]={2381,"Reinforced Lebethron Great Club",false,false,1879114048};
Recipe[10][4][9][#Recipe[10][4][9]+1]={2382,"Reinforced Lebethron Hammer",false,false,1879076468};
Recipe[10][4][17][#Recipe[10][4][17]+1]={2383,"Reinforced Lebethron Javelin",false,false,1879113296};
Recipe[10][4][3][#Recipe[10][4][3]+1]={2384,"Reinforced Lebethron Shaft",false,true,0};
Recipe[10][4][4][#Recipe[10][4][4]+1]={2385,"Reinforced Lebethron Shaft (x5)",false,false,1879137355};
Recipe[10][4][9][#Recipe[10][4][9]+1]={2386,"Reinforced Lebethron Spear",false,false,1879076467};
Recipe[10][4][9][#Recipe[10][4][9]+1]={2387,"Reinforced Lebethron Staff",false,false,1879076466};
Recipe[10][4][5][#Recipe[10][4][5]+1]={2583,"Scholar's Cupboard",false,false,1879101793};
Recipe[10][4][5][#Recipe[10][4][5]+1]={2587,"Scholar's Round Table",false,false,1879101797};
Recipe[10][4][22][#Recipe[10][4][22]+1]={2707,"Shield Carving",false,false,1879153417};
Recipe[10][4][23][#Recipe[10][4][23]+1]={2754,"Small Artisan Carving",false,false,1879125878};
Recipe[10][4][18][#Recipe[10][4][18]+1]={2806,"Smooth Lebethron Bow",false,false,1879070239};
Recipe[10][4][10][#Recipe[10][4][10]+1]={2807,"Smooth Lebethron Club",false,false,1879114052};
Recipe[10][4][18][#Recipe[10][4][18]+1]={2808,"Smooth Lebethron Crossbow",false,false,1879070240};
Recipe[10][4][10][#Recipe[10][4][10]+1]={2809,"Smooth Lebethron Great Club",false,false,1879113974};
Recipe[10][4][10][#Recipe[10][4][10]+1]={2810,"Smooth Lebethron Hammer",false,false,1879070243};
Recipe[10][4][18][#Recipe[10][4][18]+1]={2811,"Smooth Lebethron Javelin",false,false,1879113410};
Recipe[10][4][10][#Recipe[10][4][10]+1]={2812,"Smooth Lebethron Spear",false,false,1879070242};
Recipe[10][4][10][#Recipe[10][4][10]+1]={2813,"Smooth Lebethron Staff",false,false,1879070241};
Recipe[10][4][21][#Recipe[10][4][21]+1]={2829,"Soothing Hymn of Barad-d"..string.char(195)..string.char(187).."r",false,false,1879199813};
Recipe[10][4][22][#Recipe[10][4][22]+1]={2835,"Spear Carving",false,false,1879153439};
Recipe[10][4][13][#Recipe[10][4][13]+1]={3041,"Superior Drum",false,false,1879088788};
Recipe[10][4][13][#Recipe[10][4][13]+1]={3048,"Superior Flute",false,false,1879070382};
Recipe[10][4][13][#Recipe[10][4][13]+1]={3052,"Superior Harp",false,false,1879070381};
Recipe[10][4][13][#Recipe[10][4][13]+1]={3055,"Superior Lute",false,false,1879070380};
Recipe[10][4][13][#Recipe[10][4][13]+1]={3064,"Superior Theorbo",false,false,1879088782};
Recipe[10][4][12][#Recipe[10][4][12]+1]={3345,"Wood Figurine",false,false,1879092702};

Recipe[10][5][15][#Recipe[10][5][15]+1]={181,"Black Ash Bow",false,true,0};
Recipe[10][5][3][#Recipe[10][5][3]+1]={182,"Black Ash Bowstaff",false,true,0};
Recipe[10][5][4][#Recipe[10][5][4]+1]={183,"Black Ash Bowstaff (x5)",false,false,1879137267};
Recipe[10][5][6][#Recipe[10][5][6]+1]={185,"Black Ash Club",false,true,0};
Recipe[10][5][15][#Recipe[10][5][15]+1]={186,"Black Ash Crossbow",false,true,0};
Recipe[10][5][6][#Recipe[10][5][6]+1]={187,"Black Ash Great Club",false,true,0};
Recipe[10][5][3][#Recipe[10][5][3]+1]={188,"Black Ash Haft",false,true,0};
Recipe[10][5][4][#Recipe[10][5][4]+1]={189,"Black Ash Haft (x5)",false,false,1879137297};
Recipe[10][5][6][#Recipe[10][5][6]+1]={190,"Black Ash Hammer",false,true,0};
Recipe[10][5][2][#Recipe[10][5][2]+1]={191,"Black Ash Horn",false,false,1879143613};
Recipe[10][5][15][#Recipe[10][5][15]+1]={192,"Black Ash Javelin",false,true,0};
Recipe[10][5][6][#Recipe[10][5][6]+1]={193,"Black Ash Spear",false,true,0};
Recipe[10][5][6][#Recipe[10][5][6]+1]={194,"Black Ash Staff",false,true,0};
Recipe[10][5][11][#Recipe[10][5][11]+1]={282,"Bree-spear",false,false,1879092708};
Recipe[10][5][18][#Recipe[10][5][18]+1]={358,"Carved Black Ash Bow",true,false,1879054927};
Recipe[10][5][18][#Recipe[10][5][18]+1]={3752,"Carved Black Ash Bow",true,false,1879091107};
Recipe[10][5][9][#Recipe[10][5][9]+1]={359,"Carved Black Ash Club",true,false,1879113979};
Recipe[10][5][18][#Recipe[10][5][18]+1]={360,"Carved Black Ash Crossbow",true,false,1879054928};
Recipe[10][5][18][#Recipe[10][5][18]+1]={3753,"Carved Black Ash Crossbow",true,false,1879091184};
Recipe[10][5][9][#Recipe[10][5][9]+1]={361,"Carved Black Ash Great Club",true,false,1879113995};
Recipe[10][5][9][#Recipe[10][5][9]+1]={362,"Carved Black Ash Hammer",true,false,1879054931};
Recipe[10][5][9][#Recipe[10][5][9]+1]={3754,"Carved Black Ash Hammer",true,false,1879091281};
Recipe[10][5][18][#Recipe[10][5][18]+1]={363,"Carved Black Ash Javelin",true,false,1879113377};
Recipe[10][5][9][#Recipe[10][5][9]+1]={364,"Carved Black Ash Spear",true,false,1879054930};
Recipe[10][5][9][#Recipe[10][5][9]+1]={3755,"Carved Black Ash Spear",true,false,1879091301};
Recipe[10][5][9][#Recipe[10][5][9]+1]={365,"Carved Black Ash Staff",true,false,1879054929};
Recipe[10][5][9][#Recipe[10][5][9]+1]={3756,"Carved Black Ash Staff",true,false,1879091293};
Recipe[10][5][3][#Recipe[10][5][3]+1]={421,"Composite Black Ash Brace",false,true,0};
Recipe[10][5][4][#Recipe[10][5][4]+1]={422,"Composite Black Ash Brace (x5)",false,false,1879137358};
Recipe[10][5][3][#Recipe[10][5][3]+1]={423,"Composite Black Ash Shaft",false,true,0};
Recipe[10][5][4][#Recipe[10][5][4]+1]={424,"Composite Black Ash Shaft (x5)",false,false,1879137416};
Recipe[10][5][19][#Recipe[10][5][19]+1]={1500,"Keri"..string.char(195)..string.char(164).."-laulu",true,false,1879109635};
Recipe[10][5][22][#Recipe[10][5][22]+1]={1557,"Large Master Carving",false,false,1879125926};
Recipe[10][5][21][#Recipe[10][5][21]+1]={1699,"Major Fist Carving",false,false,1879153477};
Recipe[10][5][21][#Recipe[10][5][21]+1]={1705,"Major Shield Carving",false,false,1879153445};
Recipe[10][5][21][#Recipe[10][5][21]+1]={1707,"Major Spear Carving",false,false,1879153433};
Recipe[10][5][1][#Recipe[10][5][1]+1]={1760,"Master Blazoned Crest",false,false,1879197275};
Recipe[10][5][20][#Recipe[10][5][20]+1]={1761,"Master Dagor Infused Parchment",false,false,1879197236};
Recipe[10][5][20][#Recipe[10][5][20]+1]={1772,"Master Nestad Infused Parchment",false,false,1879197221};
--Recipe[10][5][#Recipe[10][5]+1]={693,"Master Woodworker Expertise",false,false,1879184371};
Recipe[10][5][22][#Recipe[10][5][22]+1]={1825,"Medium Master Carving",false,false,1879125773};
Recipe[10][5][14][#Recipe[10][5][14]+1]={1943,"Ornate Black Ash Bow",false,false,1879137461};
Recipe[10][5][5][#Recipe[10][5][5]+1]={1944,"Ornate Black Ash Club",false,false,1879137507};
Recipe[10][5][14][#Recipe[10][5][14]+1]={1945,"Ornate Black Ash Crossbow",false,false,1879137630};
Recipe[10][5][5][#Recipe[10][5][5]+1]={1946,"Ornate Black Ash Great Club",false,false,1879137361};
Recipe[10][5][5][#Recipe[10][5][5]+1]={1947,"Ornate Black Ash Hammer",false,false,1879137409};
Recipe[10][5][14][#Recipe[10][5][14]+1]={1948,"Ornate Black Ash Javelin",false,false,1879137397};
Recipe[10][5][5][#Recipe[10][5][5]+1]={1949,"Ornate Black Ash Spear",false,false,1879137611};
Recipe[10][5][5][#Recipe[10][5][5]+1]={1950,"Ornate Black Ash Staff",false,false,1879137711};
Recipe[10][5][16][#Recipe[10][5][16]+1]={2366,"Reinforced Black Ash Bow",false,false,1879076474};
Recipe[10][5][7][#Recipe[10][5][7]+1]={2367,"Reinforced Black Ash Club",false,false,1879113932};
Recipe[10][5][16][#Recipe[10][5][16]+1]={2368,"Reinforced Black Ash Crossbow",false,false,1879076475};
Recipe[10][5][7][#Recipe[10][5][7]+1]={2369,"Reinforced Black Ash Great Club",false,false,1879113999};
Recipe[10][5][7][#Recipe[10][5][7]+1]={2370,"Reinforced Black Ash Hammer",false,false,1879076476};
Recipe[10][5][16][#Recipe[10][5][16]+1]={2371,"Reinforced Black Ash Javelin",false,false,1879113313};
Recipe[10][5][7][#Recipe[10][5][7]+1]={2372,"Reinforced Black Ash Spear",false,false,1879076477};
Recipe[10][5][7][#Recipe[10][5][7]+1]={2373,"Reinforced Black Ash Staff",false,false,1879076478};
Recipe[10][5][13][#Recipe[10][5][13]+1]={2572,"Satakieli",true,false,1879109639};
Recipe[10][5][22][#Recipe[10][5][22]+1]={2769,"Small Master Carving",false,false,1879125737};
Recipe[10][5][17][#Recipe[10][5][17]+1]={2798,"Smooth Black Ash Bow",false,false,1879071348};
Recipe[10][5][8][#Recipe[10][5][8]+1]={2799,"Smooth Black Ash Club",false,false,1879113975};
Recipe[10][5][17][#Recipe[10][5][17]+1]={2800,"Smooth Black Ash Crossbow",false,false,1879071349};
Recipe[10][5][8][#Recipe[10][5][8]+1]={2801,"Smooth Black Ash Great Club",false,false,1879113965};
Recipe[10][5][8][#Recipe[10][5][8]+1]={2802,"Smooth Black Ash Hammer",false,false,1879071352};
Recipe[10][5][17][#Recipe[10][5][17]+1]={2803,"Smooth Black Ash Javelin",false,false,1879113436};
Recipe[10][5][8][#Recipe[10][5][8]+1]={2804,"Smooth Black Ash Spear",false,false,1879071351};
Recipe[10][5][8][#Recipe[10][5][8]+1]={2805,"Smooth Black Ash Staff",false,false,1879071350};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3022,"Superior Beleriand Drum",false,false,1879098769};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3023,"Superior Beleriand Flute",false,false,1879098778};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3024,"Superior Beleriand Harp",false,false,1879098781};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3025,"Superior Beleriand Lute",false,false,1879098765};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3026,"Superior Beleriand Theorbo",false,false,1879098791};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3042,"Superior Dwarf-make Drum",false,false,1879098793};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3043,"Superior Dwarf-make Flute",false,false,1879098768};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3044,"Superior Dwarf-make Harp",false,false,1879098776};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3045,"Superior Dwarf-make Lute",false,false,1879098788};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3046,"Superior Dwarf-make Theorbo",false,false,1879098777};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3067,"Superior Westernesse Drum",false,false,1879098789};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3068,"Superior Westernesse Flute",false,false,1879098787};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3069,"Superior Westernesse Harp",false,false,1879098764};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3070,"Superior Westernesse Lute",false,false,1879098785};
Recipe[10][5][12][#Recipe[10][5][12]+1]={3071,"Superior Westernesse Theorbo",false,false,1879098779};
Recipe[10][5][10][#Recipe[10][5][10]+1]={3212,"Vaiti-voima",true,false,1879112553};
Recipe[10][5][11][#Recipe[10][5][11]+1]={3242,"Viol",false,false,1879092700};

Recipe[10][6][38][#Recipe[10][6][38]+1]={166,"Battle Hymn of the White Council",false,false,1879197239};
Recipe[10][6][5][#Recipe[10][6][5]+1]={197,"Black-wood Bow",false,false,1879166154};
Recipe[10][6][6][#Recipe[10][6][6]+1]={441,"Crafted Burglar's Club of the Third Age",false,false,1879154229};
Recipe[10][6][7][#Recipe[10][6][7]+1]={442,"Crafted Burglar's Club of the Third Age",false,false,1879165864};
Recipe[10][6][8][#Recipe[10][6][8]+1]={453,"Crafted Captain's Club of the Third Age",false,false,1879144999};
Recipe[10][6][9][#Recipe[10][6][9]+1]={454,"Crafted Captain's Club of the Third Age",false,false,1879165901};
Recipe[10][6][8][#Recipe[10][6][8]+1]={462,"Crafted Captain's Great Club of the Third Age",false,false,1879144929};
Recipe[10][6][9][#Recipe[10][6][9]+1]={461,"Crafted Captain's Great Club of the Third Age",false,false,1879165967};
Recipe[10][6][8][#Recipe[10][6][8]+1]={464,"Crafted Captain's Great Hammer of the Third Age",false,false,1879144984};
Recipe[10][6][9][#Recipe[10][6][9]+1]={463,"Crafted Captain's Great Hammer of the Third Age",false,false,1879165825};
Recipe[10][6][8][#Recipe[10][6][8]+1]={470,"Crafted Captain's Hammer of the Third Age",false,false,1879145009};
Recipe[10][6][9][#Recipe[10][6][9]+1]={469,"Crafted Captain's Hammer of the Third Age",false,false,1879165869};
Recipe[10][6][8][#Recipe[10][6][8]+1]={474,"Crafted Captain's Spear of the Third Age",false,false,1879144916};
Recipe[10][6][9][#Recipe[10][6][9]+1]={473,"Crafted Captain's Spear of the Third Age",false,false,1879165804};
Recipe[10][6][10][#Recipe[10][6][10]+1]={479,"Crafted Champion's Club of the Third Age",false,false,1879145012};
Recipe[10][6][11][#Recipe[10][6][11]+1]={480,"Crafted Champion's Club of the Third Age",false,false,1879165772};
Recipe[10][6][10][#Recipe[10][6][10]+1]={485,"Crafted Champion's Great Hammer of the Third Age",false,false,1879145023};
Recipe[10][6][11][#Recipe[10][6][11]+1]={486,"Crafted Champion's Great Hammer of the Third Age",false,false,1879165808};
Recipe[10][6][10][#Recipe[10][6][10]+1]={490,"Crafted Champion's Hammer of the Third Age",false,false,1879145014};
Recipe[10][6][11][#Recipe[10][6][11]+1]={489,"Crafted Champion's Hammer of the Third Age",false,false,1879165953};
Recipe[10][6][10][#Recipe[10][6][10]+1]={496,"Crafted Champion's Spear of the Third Age",false,false,1879144930};
Recipe[10][6][11][#Recipe[10][6][11]+1]={495,"Crafted Champion's Spear of the Third Age",false,false,1879165954};
Recipe[10][6][12][#Recipe[10][6][12]+1]={514,"Crafted Guardian's Club of the Third Age",false,false,1879144963};
Recipe[10][6][13][#Recipe[10][6][13]+1]={513,"Crafted Guardian's Club of the Third Age",false,false,1879165779};
Recipe[10][6][12][#Recipe[10][6][12]+1]={519,"Crafted Guardian's Great Club of the Third Age",false,false,1879144969};
Recipe[10][6][13][#Recipe[10][6][13]+1]={520,"Crafted Guardian's Great Club of the Third Age",false,false,1879165958};
Recipe[10][6][12][#Recipe[10][6][12]+1]={521,"Crafted Guardian's Great Hammer of the Third Age",false,false,1879144998};
Recipe[10][6][13][#Recipe[10][6][13]+1]={522,"Crafted Guardian's Great Hammer of the Third Age",false,false,1879165840};
Recipe[10][6][12][#Recipe[10][6][12]+1]={525,"Crafted Guardian's Hammer of the Third Age",false,false,1879145003};
Recipe[10][6][13][#Recipe[10][6][13]+1]={526,"Crafted Guardian's Hammer of the Third Age",false,false,1879165961};
Recipe[10][6][12][#Recipe[10][6][12]+1]={529,"Crafted Guardian's Spear of the Third Age",false,false,1879144935};
Recipe[10][6][13][#Recipe[10][6][13]+1]={530,"Crafted Guardian's Spear of the Third Age",false,false,1879165950};
Recipe[10][6][14][#Recipe[10][6][14]+1]={536,"Crafted Hunter's Bow of the Third Age",false,false,1879144948};
Recipe[10][6][15][#Recipe[10][6][15]+1]={537,"Crafted Hunter's Bow of the Third Age",false,false,1879165829};
Recipe[10][6][14][#Recipe[10][6][14]+1]={539,"Crafted Hunter's Club of the Third Age",false,false,1879144911};
Recipe[10][6][15][#Recipe[10][6][15]+1]={538,"Crafted Hunter's Club of the Third Age",false,false,1879165814};
Recipe[10][6][14][#Recipe[10][6][14]+1]={540,"Crafted Hunter's Crossbow of the Third Age",false,false,1879144927};
Recipe[10][6][15][#Recipe[10][6][15]+1]={541,"Crafted Hunter's Crossbow of the Third Age",false,false,1879165718};
Recipe[10][6][14][#Recipe[10][6][14]+1]={544,"Crafted Hunter's Hammer of the Third Age",false,false,1879162772};
Recipe[10][6][15][#Recipe[10][6][15]+1]={545,"Crafted Hunter's Hammer of the Third Age",false,false,1879165972};
Recipe[10][6][14][#Recipe[10][6][14]+1]={548,"Crafted Hunter's Spear of the Third Age",false,false,1879144995};
Recipe[10][6][15][#Recipe[10][6][15]+1]={549,"Crafted Hunter's Spear of the Third Age",false,false,1879165952};
Recipe[10][6][16][#Recipe[10][6][16]+1]={557,"Crafted Lore-master's Staff of the Third Age",false,false,1879145038};
Recipe[10][6][17][#Recipe[10][6][17]+1]={556,"Crafted Lore-master's Staff of the Third Age",false,false,1879165799};
Recipe[10][6][18][#Recipe[10][6][18]+1]={559,"Crafted Minstrel's Club of the Third Age",false,false,1879144933};
Recipe[10][6][19][#Recipe[10][6][19]+1]={560,"Crafted Minstrel's Club of the Third Age",false,false,1879165982};
Recipe[10][6][20][#Recipe[10][6][20]+1]={577,"Crafted Warden's Club of the Third Age",false,false,1879144979};
Recipe[10][6][21][#Recipe[10][6][21]+1]={576,"Crafted Warden's Club of the Third Age",false,false,1879165838};
Recipe[10][6][20][#Recipe[10][6][20]+1]={581,"Crafted Warden's Hammer of the Third Age",false,false,1879144946};
Recipe[10][6][21][#Recipe[10][6][21]+1]={580,"Crafted Warden's Hammer of the Third Age",false,false,1879165890};
Recipe[10][6][20][#Recipe[10][6][20]+1]={583,"Crafted Warden's Javelin of the Third Age",false,false,1879144949};
Recipe[10][6][21][#Recipe[10][6][21]+1]={582,"Crafted Warden's Javelin of the Third Age",false,false,1879165959};
Recipe[10][6][20][#Recipe[10][6][20]+1]={588,"Crafted Warden's Spear of the Third Age",false,false,1879144996};
Recipe[10][6][21][#Recipe[10][6][21]+1]={587,"Crafted Warden's Spear of the Third Age",false,false,1879165915};
Recipe[10][6][29][#Recipe[10][6][29]+1]={788,"Elegant Bagpipes",true,false,1879151002};
Recipe[10][6][29][#Recipe[10][6][29]+1]={789,"Elegant Clarinet",true,false,1879151011};
Recipe[10][6][29][#Recipe[10][6][29]+1]={790,"Elegant Cowbell",true,false,1879151008};
Recipe[10][6][29][#Recipe[10][6][29]+1]={791,"Elegant Drum",true,false,1879153450};
Recipe[10][6][29][#Recipe[10][6][29]+1]={792,"Elegant Horn",true,false,1879151000};
Recipe[10][6][39][#Recipe[10][6][39]+1]={1084,"Flashing Bane of the Fist Carving",true,false,1879153444};
Recipe[10][6][39][#Recipe[10][6][39]+1]={1085,"Flashing Bane of the Shield Carving",true,false,1879153406};
Recipe[10][6][39][#Recipe[10][6][39]+1]={1086,"Flashing Bane of the Spear Carving",true,false,1879153454};
Recipe[10][6][36][#Recipe[10][6][36]+1]={1200,"Golden Host Bow",false,false,1879163239};
Recipe[10][6][28][#Recipe[10][6][28]+1]={1201,"Golden Host Club",false,false,1879163277};
Recipe[10][6][36][#Recipe[10][6][36]+1]={1203,"Golden Host Crossbow",false,false,1879163210};
Recipe[10][6][28][#Recipe[10][6][28]+1]={1205,"Golden Host Great Club",false,false,1879163253};
Recipe[10][6][28][#Recipe[10][6][28]+1]={1206,"Golden Host Hammer",false,false,1879163247};
Recipe[10][6][36][#Recipe[10][6][36]+1]={1208,"Golden Host Javelin",false,false,1879163260};
Recipe[10][6][28][#Recipe[10][6][28]+1]={1211,"Golden Host Spear",false,false,1879163206};
Recipe[10][6][28][#Recipe[10][6][28]+1]={1212,"Golden Host Staff",false,false,1879163198};
Recipe[10][6][35][#Recipe[10][6][35]+1]={1217,"Golden Wood Bow",true,false,1879154517};
Recipe[10][6][27][#Recipe[10][6][27]+1]={1218,"Golden Wood Club",true,false,1879154534};
Recipe[10][6][35][#Recipe[10][6][35]+1]={1219,"Golden Wood Crossbow",true,false,1879154539};
Recipe[10][6][27][#Recipe[10][6][27]+1]={1220,"Golden Wood Great Club",true,false,1879154523};
Recipe[10][6][27][#Recipe[10][6][27]+1]={1221,"Golden Wood Hammer",true,false,1879154551};
Recipe[10][6][35][#Recipe[10][6][35]+1]={1222,"Golden Wood Javelin",true,false,1879154522};
Recipe[10][6][27][#Recipe[10][6][27]+1]={1224,"Golden Wood Spear",true,false,1879154544};
Recipe[10][6][27][#Recipe[10][6][27]+1]={1225,"Golden Wood Staff",true,false,1879154550};
Recipe[10][6][1][#Recipe[10][6][1]+1]={1252,"Greater Supreme Blazoned Crest",false,false,1879200774};
Recipe[10][6][37][#Recipe[10][6][37]+1]={1253,"Greater Supreme Dagor Infused Parchment",false,false,1879200777};
Recipe[10][6][31][#Recipe[10][6][31]+1]={1414,"Holly Bow",false,true,0};
Recipe[10][6][23][#Recipe[10][6][23]+1]={1415,"Holly Club",false,true,0};
Recipe[10][6][31][#Recipe[10][6][31]+1]={1416,"Holly Crossbow",false,true,0};
Recipe[10][6][23][#Recipe[10][6][23]+1]={1417,"Holly Great Club",false,true,0};
Recipe[10][6][23][#Recipe[10][6][23]+1]={1418,"Holly Hammer",false,true,0};
Recipe[10][6][31][#Recipe[10][6][31]+1]={1419,"Holly Javelin",false,true,0};
Recipe[10][6][23][#Recipe[10][6][23]+1]={1420,"Holly Spear",false,true,0};
Recipe[10][6][23][#Recipe[10][6][23]+1]={1421,"Holly Staff",false,true,0};
Recipe[10][6][32][#Recipe[10][6][32]+1]={1430,"Ilex Bow",false,false,1879107357};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1431,"Ilex Bowstaff",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1432,"Ilex Bowstaff (x5)",false,false,1879137727};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1433,"Ilex Brace",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1434,"Ilex Brace (x5)",false,false,1879137693};
Recipe[10][6][24][#Recipe[10][6][24]+1]={1435,"Ilex Club",false,false,1879134031};
Recipe[10][6][32][#Recipe[10][6][32]+1]={1436,"Ilex Crossbow",false,false,1879107397};
Recipe[10][6][24][#Recipe[10][6][24]+1]={1437,"Ilex Great Club",false,false,1879134034};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1438,"Ilex Haft",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1439,"Ilex Haft (x5)",false,false,1879137705};
Recipe[10][6][24][#Recipe[10][6][24]+1]={1440,"Ilex Hammer",false,false,1879107400};
Recipe[10][6][2][#Recipe[10][6][2]+1]={1441,"Ilex Horn",false,false,1879143614};
Recipe[10][6][32][#Recipe[10][6][32]+1]={1442,"Ilex Javelin",false,false,1879113338};
Recipe[10][6][24][#Recipe[10][6][24]+1]={1443,"Ilex Spear",false,false,1879107424};
Recipe[10][6][24][#Recipe[10][6][24]+1]={1444,"Ilex Staff",false,false,1879107364};
Recipe[10][6][39][#Recipe[10][6][39]+1]={1486,"Iron Will of the Fist Carving",true,false,1879153429};
Recipe[10][6][39][#Recipe[10][6][39]+1]={1487,"Iron Will of the Shield Carving",true,false,1879153447};
Recipe[10][6][39][#Recipe[10][6][39]+1]={1488,"Iron Will of the Spear Carving",true,false,1879153437};
Recipe[10][6][40][#Recipe[10][6][40]+1]={1564,"Large Supreme Carving",false,false,1879125857};
Recipe[10][6][33][#Recipe[10][6][33]+1]={1726,"Mallorn Bow",false,false,1879107402};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1727,"Mallorn Bowstaff",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1728,"Mallorn Bowstaff (x5)",false,false,1879137615};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1729,"Mallorn Brace",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1730,"Mallorn Brace (x5)",false,false,1879137328};
Recipe[10][6][25][#Recipe[10][6][25]+1]={1732,"Mallorn Club",false,false,1879134032};
Recipe[10][6][33][#Recipe[10][6][33]+1]={1733,"Mallorn Crossbow",false,false,1879107346};
Recipe[10][6][25][#Recipe[10][6][25]+1]={1734,"Mallorn Great Club",false,false,1879134030};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1735,"Mallorn Haft",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1736,"Mallorn Haft (x5)",false,false,1879137731};
Recipe[10][6][25][#Recipe[10][6][25]+1]={1737,"Mallorn Hammer",false,false,1879107376};
Recipe[10][6][2][#Recipe[10][6][2]+1]={1738,"Mallorn Horn",false,false,1879182465};
Recipe[10][6][33][#Recipe[10][6][33]+1]={1739,"Mallorn Javelin",false,false,1879113398};
Recipe[10][6][3][#Recipe[10][6][3]+1]={1740,"Mallorn Shaft",false,true,0};
Recipe[10][6][4][#Recipe[10][6][4]+1]={1741,"Mallorn Shaft (x5)",false,false,1879163319};
Recipe[10][6][25][#Recipe[10][6][25]+1]={1742,"Mallorn Spear",false,false,1879107347};
Recipe[10][6][25][#Recipe[10][6][25]+1]={1743,"Mallorn Staff",false,false,1879107355};
Recipe[10][6][40][#Recipe[10][6][40]+1]={1832,"Medium Supreme Carving",false,false,1879125777};
Recipe[10][6][30][#Recipe[10][6][30]+1]={1985,"Peerless Silver Mallorn Bow",false,false,1879137594};
Recipe[10][6][22][#Recipe[10][6][22]+1]={1986,"Peerless Silver Mallorn Club",false,false,1879137221};
Recipe[10][6][30][#Recipe[10][6][30]+1]={1987,"Peerless Silver Mallorn Crossbow",false,false,1879137684};
Recipe[10][6][22][#Recipe[10][6][22]+1]={1988,"Peerless Silver Mallorn Great Club",false,false,1879137473};
Recipe[10][6][22][#Recipe[10][6][22]+1]={1989,"Peerless Silver Mallorn Hammer",false,false,1879137576};
Recipe[10][6][30][#Recipe[10][6][30]+1]={1990,"Peerless Silver Mallorn Javelin",false,false,1879137342};
Recipe[10][6][22][#Recipe[10][6][22]+1]={1991,"Peerless Silver Mallorn Spear",false,false,1879137585};
Recipe[10][6][22][#Recipe[10][6][22]+1]={1992,"Peerless Silver Mallorn Staff",false,false,1879137558};
Recipe[10][6][38][#Recipe[10][6][38]+1]={2194,"Rallying Hymn of the White Council",false,false,1879199785};
Recipe[10][6][5][#Recipe[10][6][5]+1]={2207,"Red Arrow",false,false,1879166142};
Recipe[10][6][6][#Recipe[10][6][6]+1]={2227,"Reforged Burglar's Club of the Second Age",false,false,1879162126};
Recipe[10][6][7][#Recipe[10][6][7]+1]={2228,"Reforged Burglar's Club of the Second Age",false,false,1879165722};
Recipe[10][6][8][#Recipe[10][6][8]+1]={2239,"Reforged Captain's Club of the Second Age",false,false,1879162217};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2240,"Reforged Captain's Club of the Second Age",false,false,1879165791};
Recipe[10][6][8][#Recipe[10][6][8]+1]={2247,"Reforged Captain's Great Club of the Second Age",false,false,1879162076};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2248,"Reforged Captain's Great Club of the Second Age",false,false,1879165774};
Recipe[10][6][8][#Recipe[10][6][8]+1]={2250,"Reforged Captain's Great Hammer of the Second Age",false,false,1879162129};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2249,"Reforged Captain's Great Hammer of the Second Age",false,false,1879165812};
Recipe[10][6][8][#Recipe[10][6][8]+1]={2255,"Reforged Captain's Hammer of the Second Age",false,false,1879162204};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2256,"Reforged Captain's Hammer of the Second Age",false,false,1879165823};
Recipe[10][6][8][#Recipe[10][6][8]+1]={2259,"Reforged Captain's Spear of the Second Age",false,false,1879162197};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2260,"Reforged Captain's Spear of the Second Age",false,false,1879165920};
Recipe[10][6][10][#Recipe[10][6][10]+1]={2265,"Reforged Champion's Club of the Second Age",false,false,1879162201};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2266,"Reforged Champion's Club of the Second Age",false,false,1879165946};
Recipe[10][6][10][#Recipe[10][6][10]+1]={2272,"Reforged Champion's Great Hammer of the Second Age",false,false,1879162098};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2271,"Reforged Champion's Great Hammer of the Second Age",false,false,1879165831};
Recipe[10][6][10][#Recipe[10][6][10]+1]={2276,"Reforged Champion's Hammer of the Second Age",false,false,1879162069};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2275,"Reforged Champion's Hammer of the Second Age",false,false,1879165934};
Recipe[10][6][10][#Recipe[10][6][10]+1]={2282,"Reforged Champion's Spear of the Second Age",false,false,1879162065};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2281,"Reforged Champion's Spear of the Second Age",false,false,1879165888};
Recipe[10][6][12][#Recipe[10][6][12]+1]={2292,"Reforged Guardian's Club of the Second Age",false,false,1879162231};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2291,"Reforged Guardian's Club of the Second Age",false,false,1879165931};
Recipe[10][6][12][#Recipe[10][6][12]+1]={2297,"Reforged Guardian's Great Club of the Second Age",false,false,1879162218};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2298,"Reforged Guardian's Great Club of the Second Age",false,false,1879165945};
Recipe[10][6][12][#Recipe[10][6][12]+1]={2299,"Reforged Guardian's Great Hammer of the Second Age",false,false,1879162236};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2300,"Reforged Guardian's Great Hammer of the Second Age",false,false,1879165835};
Recipe[10][6][12][#Recipe[10][6][12]+1]={2304,"Reforged Guardian's Hammer of the Second Age",false,false,1879162079};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2303,"Reforged Guardian's Hammer of the Second Age",false,false,1879165938};
Recipe[10][6][12][#Recipe[10][6][12]+1]={2308,"Reforged Guardian's Spear of the Second Age",false,false,1879162064};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2307,"Reforged Guardian's Spear of the Second Age",false,false,1879165859};
Recipe[10][6][14][#Recipe[10][6][14]+1]={2314,"Reforged Hunter's Bow of the Second Age",false,false,1879162233};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2313,"Reforged Hunter's Bow of the Second Age",false,false,1879165861};
Recipe[10][6][14][#Recipe[10][6][14]+1]={2315,"Reforged Hunter's Club of the Second Age",false,false,1879162108};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2316,"Reforged Hunter's Club of the Second Age",false,false,1879165818};
Recipe[10][6][14][#Recipe[10][6][14]+1]={2318,"Reforged Hunter's Crossbow of the Second Age",false,false,1879162132};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2317,"Reforged Hunter's Crossbow of the Second Age",false,false,1879165983};
Recipe[10][6][14][#Recipe[10][6][14]+1]={2321,"Reforged Hunter's Hammer of the Second Age",false,false,1879162203};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2322,"Reforged Hunter's Hammer of the Second Age",false,false,1879165937};
Recipe[10][6][14][#Recipe[10][6][14]+1]={2325,"Reforged Hunter's Spear of the Second Age",false,false,1879162099};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2326,"Reforged Hunter's Spear of the Second Age",false,false,1879165908};
Recipe[10][6][16][#Recipe[10][6][16]+1]={2333,"Reforged Lore-master's Staff of the Second Age",false,false,1879162066};
Recipe[10][6][17][#Recipe[10][6][17]+1]={2334,"Reforged Lore-master's Staff of the Second Age",false,false,1879165943};
Recipe[10][6][18][#Recipe[10][6][18]+1]={2336,"Reforged Minstrel's Club of the Second Age",false,false,1879162094};
Recipe[10][6][19][#Recipe[10][6][19]+1]={2335,"Reforged Minstrel's Club of the Second Age",false,false,1879165878};
Recipe[10][6][20][#Recipe[10][6][20]+1]={2352,"Reforged Warden's Club of the Second Age",false,false,1879162234};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2351,"Reforged Warden's Club of the Second Age",false,false,1879165841};
Recipe[10][6][20][#Recipe[10][6][20]+1]={2355,"Reforged Warden's Hammer of the Second Age",false,false,1879162202};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2356,"Reforged Warden's Hammer of the Second Age",false,false,1879165747};
Recipe[10][6][20][#Recipe[10][6][20]+1]={2357,"Reforged Warden's Javelin of the Second Age",false,false,1879162227};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2358,"Reforged Warden's Javelin of the Second Age",false,false,1879165874};
Recipe[10][6][20][#Recipe[10][6][20]+1]={2362,"Reforged Warden's Spear of the Second Age",false,false,1879162141};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2361,"Reforged Warden's Spear of the Second Age",false,false,1879165802};
Recipe[10][6][7][#Recipe[10][6][7]+1]={2395,"Reshaped Burglar's Club of the First Age",false,false,1879181536};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2401,"Reshaped Captain's Club of the First Age",false,false,1879181517};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2405,"Reshaped Captain's Great Club of the First Age",false,false,1879181508};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2406,"Reshaped Captain's Great Hammer of the First Age",false,false,1879181556};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2409,"Reshaped Captain's Hammer of the First Age",false,false,1879181554};
Recipe[10][6][9][#Recipe[10][6][9]+1]={2411,"Reshaped Captain's Spear of the First Age",false,false,1879181527};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2414,"Reshaped Champion's Club of the First Age",false,false,1879181523};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2417,"Reshaped Champion's Great Hammer of the First Age",false,false,1879181504};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2419,"Reshaped Champion's Hammer of the First Age",false,false,1879181526};
Recipe[10][6][11][#Recipe[10][6][11]+1]={2422,"Reshaped Champion's Spear of the First Age",false,false,1879181493};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2427,"Reshaped Guardian's Club of the First Age",false,false,1879181525};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2430,"Reshaped Guardian's Great Club of the First Age",false,false,1879181512};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2431,"Reshaped Guardian's Great Hammer of the First Age",false,false,1879181501};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2433,"Reshaped Guardian's Hammer of the First Age",false,false,1879181535};
Recipe[10][6][13][#Recipe[10][6][13]+1]={2435,"Reshaped Guardian's Spear of the First Age",false,false,1879181553};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2438,"Reshaped Hunter's Bow of the First Age",false,false,1879181513};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2439,"Reshaped Hunter's Club of the First Age",false,false,1879181557};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2440,"Reshaped Hunter's Crossbow of the First Age",false,false,1879181497};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2442,"Reshaped Hunter's Hammer of the First Age",false,false,1879181555};
Recipe[10][6][15][#Recipe[10][6][15]+1]={2444,"Reshaped Hunter's Spear of the First Age",false,false,1879181509};
Recipe[10][6][17][#Recipe[10][6][17]+1]={2448,"Reshaped Lore-master's Staff of the First Age",false,false,1879181494};
Recipe[10][6][19][#Recipe[10][6][19]+1]={2449,"Reshaped Minstrel's Club of the First Age",false,false,1879181537};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2457,"Reshaped Warden's Club of the First Age",false,false,1879181489};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2459,"Reshaped Warden's Hammer of the First Age",false,false,1879181515};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2460,"Reshaped Warden's Javelin of the First Age",false,false,1879181500};
Recipe[10][6][21][#Recipe[10][6][21]+1]={2462,"Reshaped Warden's Spear of the First Age",false,false,1879181518};
Recipe[10][6][34][#Recipe[10][6][34]+1]={2727,"Silver Mallorn Bow",true,false,1879107410};
Recipe[10][6][26][#Recipe[10][6][26]+1]={2728,"Silver Mallorn Club",true,false,1879134033};
Recipe[10][6][34][#Recipe[10][6][34]+1]={2729,"Silver Mallorn Crossbow",true,false,1879107416};
Recipe[10][6][26][#Recipe[10][6][26]+1]={2730,"Silver Mallorn Great Club",true,false,1879134035};
Recipe[10][6][26][#Recipe[10][6][26]+1]={2731,"Silver Mallorn Hammer",true,false,1879107404};
Recipe[10][6][34][#Recipe[10][6][34]+1]={2732,"Silver Mallorn Javelin",true,false,1879113310};
Recipe[10][6][26][#Recipe[10][6][26]+1]={2733,"Silver Mallorn Spear",true,false,1879107365};
Recipe[10][6][26][#Recipe[10][6][26]+1]={2734,"Silver Mallorn Staff",true,false,1879107429};
Recipe[10][6][40][#Recipe[10][6][40]+1]={2776,"Small Supreme Carving",false,false,1879125885};
Recipe[10][6][38][#Recipe[10][6][38]+1]={2831,"Soothing Hymn of the White Council",false,false,1879199814};
Recipe[10][6][5][#Recipe[10][6][5]+1]={2842,"Statue of Elendil",false,false,1879166104};
Recipe[10][6][39][#Recipe[10][6][39]+1]={2851,"Steadfast Protector of the Fist Carving",true,false,1879153427};
Recipe[10][6][39][#Recipe[10][6][39]+1]={2852,"Steadfast Protector of the Shield Carving",true,false,1879153382};
Recipe[10][6][39][#Recipe[10][6][39]+1]={2853,"Steadfast Protector of the Spear Carving",true,false,1879153390};
Recipe[10][6][1][#Recipe[10][6][1]+1]={3074,"Supreme Blazoned Crest",false,false,1879197276};
Recipe[10][6][37][#Recipe[10][6][37]+1]={3078,"Supreme Dagor Infused Parchment",false,false,1879197277};
Recipe[10][6][37][#Recipe[10][6][37]+1]={3089,"Supreme Nestad Infused Parchment",false,false,1879197235};
--Recipe[10][6][#Recipe[10][6]+1]={700,"Supreme Woodworker Expertise",false,false,1879184366};
Recipe[10][6][30][#Recipe[10][6][30]+1]={3195,"True Golden Wood Bow",false,false,1879157190};
Recipe[10][6][22][#Recipe[10][6][22]+1]={3196,"True Golden Wood Club",false,false,1879157185};
Recipe[10][6][30][#Recipe[10][6][30]+1]={3197,"True Golden Wood Crossbow",false,false,1879157184};
Recipe[10][6][22][#Recipe[10][6][22]+1]={3198,"True Golden Wood Great Club",false,false,1879157194};
Recipe[10][6][22][#Recipe[10][6][22]+1]={3199,"True Golden Wood Hammer",false,false,1879157204};
Recipe[10][6][30][#Recipe[10][6][30]+1]={3200,"True Golden Wood Javelin",false,false,1879157191};
Recipe[10][6][22][#Recipe[10][6][22]+1]={3201,"True Golden Wood Spear",false,false,1879157207};
Recipe[10][6][22][#Recipe[10][6][22]+1]={3202,"True Golden Wood Staff",false,false,1879157197};

Recipe[10][7][2][#Recipe[10][7][2]+1]={178,"Birch Horn",false,false,1879210882};
Recipe[10][7][20][#Recipe[10][7][20]+1]={179,"Birch-wood Crossbow",false,true,0};
Recipe[10][7][12][#Recipe[10][7][12]+1]={2479,"Birch-wood Hammer",false,true,0};
Recipe[10][7][25][#Recipe[10][7][25]+1]={2749,"Bow of the Rider",true,false,1879211056};
Recipe[10][7][19][#Recipe[10][7][19]+1]={418,"Bow of Th"..string.char(195)..string.char(169).."odred",false,false,1879211036};
Recipe[10][7][15][#Recipe[10][7][15]+1]={276,"Branded Club",true,false,1879220268};
Recipe[10][7][22][#Recipe[10][7][22]+1]={374,"Carved Bow",false,false,1879211090};
Recipe[10][7][14][#Recipe[10][7][14]+1]={2847,"Carved Club",false,false,1879211037};
Recipe[10][7][17][#Recipe[10][7][17]+1]={1036,"Club of the Rider",true,false,1879210989};
Recipe[10][7][11][#Recipe[10][7][11]+1]={1037,"Club of Th"..string.char(195)..string.char(169).."odred",false,false,1879210923};
Recipe[10][7][3][#Recipe[10][7][3]+1]={3536,"Crafted Burglar's Club of the Third Age",false,false,1879219674};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3537,"Crafted Captain's Club of the Third Age",false,false,1879219790};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3538,"Crafted Captain's Great Club of the Third Age",false,false,1879219860};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3539,"Crafted Captain's Great Hammer of the Third Age",false,false,1879219791};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3540,"Crafted Captain's Hammer of the Third Age",false,false,1879219856};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3541,"Crafted Captain's Spear of the Third Age",false,false,1879219699};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3542,"Crafted Champion's Club of the Third Age",false,false,1879219858};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3543,"Crafted Champion's Great Hammer of the Third Age",false,false,1879219857};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3544,"Crafted Champion's Hammer of the Third Age",false,false,1879219745};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3545,"Crafted Champion's Spear of the Third Age",false,false,1879219855};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3546,"Crafted Guardian's Club of the Third Age",false,false,1879219773};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3547,"Crafted Guardian's Great Club of the Third Age",false,false,1879219761};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3548,"Crafted Guardian's Great Hammer of the Third Age",false,false,1879219706};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3549,"Crafted Guardian's Hammer of the Third Age",false,false,1879219763};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3550,"Crafted Guardian's Spear of the Third Age",false,false,1879219675};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3551,"Crafted Hunter's Bow of the Third Age",false,false,1879219799};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3552,"Crafted Hunter's Club of the Third Age",false,false,1879219859};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3553,"Crafted Hunter's Crossbow of the Third Age",false,false,1879219853};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3554,"Crafted Hunter's Hammer of the Third Age",false,false,1879219762};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3555,"Crafted Hunter's Spear of the Third Age",false,false,1879219774};
Recipe[10][7][8][#Recipe[10][7][8]+1]={3556,"Crafted Lore-master's Staff of the Third Age",false,false,1879219854};
Recipe[10][7][9][#Recipe[10][7][9]+1]={3557,"Crafted Minstrel's Club of the Third Age",false,false,1879219789};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3558,"Crafted Warden's Club of the Third Age",false,false,1879219737};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3559,"Crafted Warden's Hammer of the Third Age",false,false,1879219707};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3560,"Crafted Warden's Javelin of the Third Age",false,false,1879219861};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3561,"Crafted Warden's Spear of the Third Age",false,false,1879219764};
Recipe[10][7][25][#Recipe[10][7][25]+1]={3246,"Crossbow of the Rider",true,false,1879211051};
Recipe[10][7][19][#Recipe[10][7][19]+1]={163,"Crossbow of Th"..string.char(195)..string.char(169).."odred",false,false,1879211077};
Recipe[10][7][24][#Recipe[10][7][24]+1]={727,"Dunlending Crossbow",false,false,1879210891};
Recipe[10][7][16][#Recipe[10][7][16]+1]={2848,"Dunlending Hammer",false,false,1879211072};
Recipe[10][7][23][#Recipe[10][7][23]+1]={3435,"Great Bow",true,false,1879225828};
Recipe[10][7][17][#Recipe[10][7][17]+1]={2926,"Hammer of the Rider",true,false,1879210916};
Recipe[10][7][11][#Recipe[10][7][11]+1]={2927,"Hammer of Th"..string.char(195)..string.char(169).."odred",false,false,1879210886};
Recipe[10][7][15][#Recipe[10][7][15]+1]={3436,"Heavy Club",true,false,1879225819};
Recipe[10][7][28][#Recipe[10][7][28]+1]={1571,"Large Westfold Carving",false,false,1879211061};
Recipe[10][7][28][#Recipe[10][7][28]+1]={1839,"Medium Westfold Carving",false,false,1879211003};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2136,"Premium Bagpipes",false,false,1879222461};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2137,"Premium Clarinet",false,false,1879222455};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2138,"Premium Cowbell",false,false,1879222450};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2139,"Premium Drum",false,false,1879222454};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2140,"Premium Flute",false,false,1879222453};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2141,"Premium Harp",false,false,1879222458};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2142,"Premium Horn",false,false,1879222457};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2143,"Premium Lute",false,false,1879222459};
Recipe[10][7][18][#Recipe[10][7][18]+1]={3421,"Premium Pibgorn",false,false,1879225827};
Recipe[10][7][18][#Recipe[10][7][18]+1]={2144,"Premium Theorbo",false,false,1879222465};
Recipe[10][7][3][#Recipe[10][7][3]+1]={3562,"Reforged Burglar's Club of the Second Age",false,false,1879219866};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3563,"Reforged Captain's Club of the Second Age",false,false,1879219672};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3564,"Reforged Captain's Great Club of the Second Age",false,false,1879219744};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3565,"Reforged Captain's Great Hammer of the Second Age",false,false,1879219719};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3566,"Reforged Captain's Hammer of the Second Age",false,false,1879219787};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3567,"Reforged Captain's Spear of the Second Age",false,false,1879219705};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3568,"Reforged Champion's Club of the Second Age",false,false,1879219703};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3569,"Reforged Champion's Great Hammer of the Second Age",false,false,1879219864};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3570,"Reforged Champion's Hammer of the Second Age",false,false,1879219704};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3571,"Reforged Champion's Spear of the Second Age",false,false,1879219788};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3572,"Reforged Guardian's Club of the Second Age",false,false,1879219735};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3573,"Reforged Guardian's Great Club of the Second Age",false,false,1879219867};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3574,"Reforged Guardian's Great Hammer of the Second Age",false,false,1879219736};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3575,"Reforged Guardian's Hammer of the Second Age",false,false,1879219720};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3576,"Reforged Guardian's Spear of the Second Age",false,false,1879219752};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3577,"Reforged Hunter's Bow of the Second Age",false,false,1879219760};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3578,"Reforged Hunter's Club of the Second Age",false,false,1879219693};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3579,"Reforged Hunter's Crossbow of the Second Age",false,false,1879219759};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3580,"Reforged Hunter's Hammer of the Second Age",false,false,1879219863};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3581,"Reforged Hunter's Spear of the Second Age",false,false,1879219673};
Recipe[10][7][8][#Recipe[10][7][8]+1]={3582,"Reforged Lore-master's Staff of the Second Age",false,false,1879219721};
Recipe[10][7][9][#Recipe[10][7][9]+1]={3583,"Reforged Minstrel's Club of the Second Age",false,false,1879219865};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3584,"Reforged Warden's Club of the Second Age",false,false,1879219786};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3585,"Reforged Warden's Hammer of the Second Age",false,false,1879219862};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3586,"Reforged Warden's Javelin of the Second Age",false,false,1879219758};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3587,"Reforged Warden's Spear of the Second Age",false,false,1879219728};
Recipe[10][7][3][#Recipe[10][7][3]+1]={3588,"Reshaped Burglar's Club of the First Age",false,false,1879219804};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3589,"Reshaped Captain's Club of the First Age",false,false,1879219805};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3590,"Reshaped Captain's Great Club of the First Age",false,false,1879219772};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3591,"Reshaped Captain's Great Hammer of the First Age",false,false,1879219683};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3592,"Reshaped Captain's Hammer of the First Age",false,false,1879219870};
Recipe[10][7][4][#Recipe[10][7][4]+1]={3593,"Reshaped Captain's Spear of the First Age",false,false,1879219868};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3594,"Reshaped Champion's Club of the First Age",false,false,1879219698};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3595,"Reshaped Champion's Great Hammer of the First Age",false,false,1879219871};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3596,"Reshaped Champion's Hammer of the First Age",false,false,1879219717};
Recipe[10][7][5][#Recipe[10][7][5]+1]={3597,"Reshaped Champion's Spear of the First Age",false,false,1879219757};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3598,"Reshaped Guardian's Club of the First Age",false,false,1879219872};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3599,"Reshaped Guardian's Great Club of the First Age",false,false,1879219798};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3600,"Reshaped Guardian's Great Hammer of the First Age",false,false,1879219743};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3601,"Reshaped Guardian's Hammer of the First Age",false,false,1879219869};
Recipe[10][7][6][#Recipe[10][7][6]+1]={3602,"Reshaped Guardian's Spear of the First Age",false,false,1879219751};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3603,"Reshaped Hunter's Bow of the First Age",false,false,1879219684};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3604,"Reshaped Hunter's Club of the First Age",false,false,1879219873};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3605,"Reshaped Hunter's Crossbow of the First Age",false,false,1879219718};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3606,"Reshaped Hunter's Hammer of the First Age",false,false,1879219716};
Recipe[10][7][7][#Recipe[10][7][7]+1]={3607,"Reshaped Hunter's Spear of the First Age",false,false,1879219785};
Recipe[10][7][8][#Recipe[10][7][8]+1]={3608,"Reshaped Lore-master's Staff of the First Age",false,false,1879219807};
Recipe[10][7][9][#Recipe[10][7][9]+1]={3609,"Reshaped Minstrel's Club of the First Age",false,false,1879219756};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3610,"Reshaped Warden's Club of the First Age",false,false,1879219726};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3611,"Reshaped Warden's Hammer of the First Age",false,false,1879219806};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3612,"Reshaped Warden's Javelin of the First Age",false,false,1879219771};
Recipe[10][7][10][#Recipe[10][7][10]+1]={3613,"Reshaped Warden's Spear of the First Age",false,false,1879219727};
Recipe[10][7][28][#Recipe[10][7][28]+1]={2783,"Small Westfold Carving",false,false,1879211048};
Recipe[10][7][2][#Recipe[10][7][2]+1]={3027,"Superior Birch Horn",false,false,1879211066};
Recipe[10][7][1][#Recipe[10][7][1]+1]={3308,"Westfold Blazoned Crest",false,false,1879211040};
Recipe[10][7][21][#Recipe[10][7][21]+1]={3322,"Westfold Bow",false,false,1879210969};
Recipe[10][7][13][#Recipe[10][7][13]+1]={1048,"Westfold Club",false,false,1879210879};
Recipe[10][7][26][#Recipe[10][7][26]+1]={3312,"Westfold Dagor Infused Parchment",false,false,1879211111};
Recipe[10][7][27][#Recipe[10][7][27]+1]={3324,"Westfold Fist Carving",false,false,1879211091};
Recipe[10][7][26][#Recipe[10][7][26]+1]={3316,"Westfold Nestad Infused Parchment",false,false,1879211064};
Recipe[10][7][27][#Recipe[10][7][27]+1]={3325,"Westfold Shield Carving",false,false,1879210967};
Recipe[10][7][27][#Recipe[10][7][27]+1]={3326,"Westfold Spear Carving",false,false,1879211050};

-- there are 3720 actual recipes as of 2/16
-- highest recipe ID=3783

function validateRecipes()
	local tmpRecipe={};
	local tmpClass,tmpTier,tmpGroup,tmpIndex;
	local tmpNewIndex=1;
	local count=0;
	for tmpClass=1,10 do
		for tmpTier=1,#Recipe[tmpClass] do
			for tmpGroup=1,#Recipe[tmpClass][tmpTier] do
				for tmpIndex=1,#Recipe[tmpClass][tmpTier][tmpGroup] do
					tmpRecipe[tmpNewIndex]={Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][1],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][2],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][3],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][4],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][5],tmpClass,tmpTier,tmpGroup,tmpIndex};
					tmpNewIndex=tmpNewIndex+1;
				end
			end
		end
	end
	Turbine.Shell.WriteLine("#tmpRecipe:"..tostring(tmpNewIndex-1));
	-- sort by LuaID
	Turbine.Shell.WriteLine("Searching for duplicate Lua IDs");
	table.sort(tmpRecipe,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end );
	local oldValue=0;
	for tmpIndex=1,#tmpRecipe do
		if tmpRecipe[tmpIndex][1]==oldValue then
			Turbine.Shell.WriteLine("duplicate Lua ID found:"..tostring(oldValue));
			count=count+1;
		end
		oldValue=tmpRecipe[tmpIndex][1];
	end
	Turbine.Shell.WriteLine(tostring(count).." duplicate Lua IDs found.");
	count=0;
	-- sort by Resource ID
	Turbine.Shell.WriteLine("Searching for duplicate Resource IDs");
	table.sort(tmpRecipe,function(arg1,arg2) if arg2[5]==nil then return(false) else if arg1[5]==nil or arg1[5]<arg2[5] then return(true) end end end );
	local oldValue=0;
	for tmpIndex=1,#tmpRecipe do
		if oldValue~=nil and tmpRecipe[tmpIndex][5]~=nil and tmpRecipe[tmpIndex][5]>0 and tmpRecipe[tmpIndex][5]==oldValue then
			Turbine.Shell.WriteLine("duplicate Game ID found:"..tostring(oldValue));
			count=count+1;
		end
		oldValue=tmpRecipe[tmpIndex][5];
	end
	Turbine.Shell.WriteLine(tostring(count).." duplicate Resource IDs found.");
end
function exportRecipes()
	-- writes the recipes to the "standard" channel as CSV records
	local tmpRecipe={}
	local tmpClass,tmpTier,tmpGroup,tmpIndex
	local tmpNewIndex=1
	for tmpClass=1,10 do
		for tmpTier=1,#Recipe[tmpClass] do
			for tmpGroup=1,#Recipe[tmpClass][tmpTier] do
				for tmpIndex=1,#Recipe[tmpClass][tmpTier][tmpGroup] do
					tmpRecipe[tmpNewIndex]={Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][1],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][2],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][3],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][4],Recipe[tmpClass][tmpTier][tmpGroup][tmpIndex][5],tmpClass,tmpTier,tmpGroup,tmpIndex}
					tmpNewIndex=tmpNewIndex+1;
				end
			end
		end
	end
	Turbine.Shell.WriteLine("#tmpRecipe:"..tostring(tmpNewIndex-1))
	-- sort by LuaID
	table.sort(tmpRecipe,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end )
	Turbine.Shell.WriteLine("Index, LuaID, Name, IsOneShot, IsDefault, ResourceID, ClassID, TierID, GroupID")
	for tmpIndex=1,#tmpRecipe do
		Turbine.Shell.WriteLine(tostring(tmpIndex)..","..tostring(tmpRecipe[tmpIndex][1])..", \""..tostring(tmpRecipe[tmpIndex][2]).."\", "..tostring(tmpRecipe[tmpIndex][3])..","..tostring(tmpRecipe[tmpIndex][4])..","..tostring(tmpRecipe[tmpIndex][5])..","..tostring(tmpRecipe[tmpIndex][6])..","..tostring(tmpRecipe[tmpIndex][7])..","..tostring(tmpRecipe[tmpIndex][8]))
	end
end